module Ceta : sig
  val id : 'a -> 'a
  type 'a eq = {eq : 'a -> 'a -> bool}
  val eq : 'a eq -> 'a -> 'a -> bool
  type nat = Zero_nat | Suc of nat
  type rat = Frct of (Big_int.big_int * Big_int.big_int)
  type ('a, 'b) scg = Null | Scg of 'a * 'a * ('b * 'b) list * ('b * 'b) list
  type 'a shp = Sharp of 'a | Plain of 'a
  val eqa : 'a eq -> 'a -> 'a -> bool
  val leta : 'a -> ('a -> 'b) -> 'b
  val nat_aux : Big_int.big_int -> nat -> nat
  val nat : Big_int.big_int -> nat
  val hd : 'a list -> 'a
  val tl : 'a list -> 'a list
  type ('a, 'b) sum = Inl of 'a | Inr of 'b
  type nibble = Nibble0 | Nibble1 | Nibble2 | Nibble3 | Nibble4 | Nibble5 |
    Nibble6 | Nibble7 | Nibble8 | Nibble9 | NibbleA | NibbleB | NibbleC |
    NibbleD | NibbleE | NibbleF
  val append : 'a list -> 'a list -> 'a list
  val digit2int : char -> ((char list), Big_int.big_int) sum
  val sum_case : ('a -> 'b) -> ('c -> 'b) -> ('a, 'c) sum -> 'b
  val bind : ('a, 'b) sum -> ('b -> ('a, 'c) sum) -> ('a, 'c) sum
  val string2int_aux :
    Big_int.big_int -> char list -> ((char list), Big_int.big_int) sum
  val one_nat : nat
  val nat_case : 'a -> (nat -> 'a) -> nat -> 'a
  val take : nat -> 'a list -> 'a list
  val eq_char : char eq
  val eq_list : 'a eq -> 'a list -> 'a list -> bool
  val null : 'a list -> bool
  val string2int : char list -> ((char list), Big_int.big_int) sum
  val newline : char
  val the : 'a option -> 'a
  val replicate : nat -> 'a -> 'a list
  val comp : ('a -> 'b) -> ('c -> 'a) -> 'c -> 'b
  val shows_map :
    ('a -> char list -> char list) -> 'a list -> char list -> char list
  val is_none : 'a option -> bool
  val snd : 'a * 'b -> 'b
  val dquote : char list
  val shows_string : char list -> char list -> char list
  val fst : 'a * 'b -> 'a
  val shows_list_char : char list -> char list -> char list
  type 'a show =
    {shows_prec : nat -> 'a -> char list -> char list;
      shows_list : 'a list -> char list -> char list}
  val shows_prec : 'a show -> nat -> 'a -> char list -> char list
  val shows_list : 'a show -> 'a list -> char list -> char list
  val shows_prec_char : nat -> char -> char list -> char list
  val show_char : char show
  val shows_prec_list : 'a show -> nat -> 'a list -> char list -> char list
  val shows_attr : char list * char list -> char list -> char list
  val shows_attrs : (char list * char list) list -> char list -> char list
  type xml =
    Xml of
      char list * (char list * char list) list * xml list * (char list) option
  val shows_XML_indent : char list -> nat -> xml -> char list -> char list
  val shows_prec_xml : nat -> xml -> char list -> char list
  val concat : ('a list) list -> 'a list
  val text : char list -> xml -> ((char list), (char list)) sum
  val int : char list -> xml -> ((char list), Big_int.big_int) sum
  val map : ('a -> 'b) -> 'a list -> 'b list
  val sequence : ('a, 'b) sum list -> ('a, ('b list)) sum
  val mapm : ('a -> ('b, 'c) sum) -> 'a list -> ('b, ('c list)) sum
  val mapa :
    (xml -> ((char list), 'a) sum) -> xml list -> ((char list), ('a list)) sum
  val nata : char list -> xml -> ((char list), nat) sum
  val no_transform : char list -> xml -> ((char list), 'a) sum
  val nth : 'a list -> nat -> 'a
  val plus_nat : nat -> nat -> nat
  val size_list : 'a list -> nat
  val eq_nat : nat -> nat -> bool
  val xml2elements :
    char list ->
      (xml -> ((char list), 'a) sum) ->
        (xml -> ((char list), 'b) sum) ->
          ('a -> 'b -> 'c) -> xml -> ((char list), 'c) sum
  val abs_int : Big_int.big_int -> Big_int.big_int
  val split : ('a -> 'b -> 'c) -> 'a * 'b -> 'c
  val sgn_int : Big_int.big_int -> Big_int.big_int
  val apsnd : ('a -> 'b) -> 'c * 'a -> 'c * 'b
  val divmod_int :
    Big_int.big_int -> Big_int.big_int -> Big_int.big_int * Big_int.big_int
  val div_int : Big_int.big_int -> Big_int.big_int -> Big_int.big_int
  val mod_int : Big_int.big_int -> Big_int.big_int -> Big_int.big_int
  val gcd_int : Big_int.big_int -> Big_int.big_int -> Big_int.big_int
  val normalize :
    Big_int.big_int * Big_int.big_int -> Big_int.big_int * Big_int.big_int
  val fract : Big_int.big_int -> Big_int.big_int -> rat
  val xml_change :
    (xml -> ((char list), 'a) sum) -> ('a -> 'b) -> xml -> ((char list), 'b) sum
  val get_name : xml -> char list
  val eq_lista : 'a eq -> ('a list) eq
  val lookup : 'a eq -> 'a -> ('a * 'b) list -> 'b option
  val concat_map : ('a -> 'b list) -> 'a list -> 'b list
  val option_case : 'a -> ('b -> 'a) -> 'b option -> 'a
  val xml_options :
    (char list * (xml -> ((char list), 'a) sum)) list ->
      xml -> ((char list), 'a) sum
  val rat : xml -> ((char list), rat) sum
  type ('a, 'b) term = Var of 'b | Fun of 'a * ('a, 'b) term list
  val decomp : 'a list -> 'b list -> (('a * 'b) list) option
  type ('a, 'b) hterm = HHole | HFun of 'a * ('a, 'b) hterm list
  val gcMatchList :
    'a eq ->
      (('a, 'b) hterm * ('a, 'b) term) list ->
        ((('a, 'b) hterm * 'b) list) option
  val mergeHTerms :
    'a eq ->
      ('a, 'b) hterm list -> ('a, 'b) hterm list -> (('a, 'b) hterm list) option
  val merge : 'a eq -> ('a, 'b) hterm -> ('a, 'b) hterm -> ('a, 'b) hterm option
  val mergeX :
    'a eq -> 'b eq ->
      'a -> ('b, 'a) hterm ->
              (('b, 'a) hterm * 'a) list -> ((('b, 'a) hterm * 'a) list) option
  val mergeAll : 'a eq -> 'b eq -> (('a, 'b) hterm * 'b) list -> bool
  val gcMatchI : 'a eq -> 'b eq -> ('a, 'b) hterm -> ('a, 'b) term -> bool
  val list_ex : ('a -> bool) -> 'a list -> bool
  val capI :
    'a eq -> 'b eq ->
      (('a, 'b) term * ('a, 'b) term) list -> ('a, 'b) term -> ('a, 'b) hterm
  val foldl : ('a -> 'b -> 'a) -> 'a -> 'b list -> 'a
  val rev : 'a list -> 'a list
  val less_nat : nat -> nat -> bool
  val less_eq_nat : nat -> nat -> bool
  val upt : nat -> nat -> nat list
  val zip : 'a list -> 'b list -> ('a * 'b) list
  val prod_case : ('a -> 'b -> 'c) -> 'a * 'b -> 'c
  val eqb : 'a eq -> 'b eq -> 'a * 'b -> 'a * 'b -> bool
  val eqc : 'a eq -> 'b eq -> ('a * 'b) eq
  val member : 'a eq -> 'a list -> 'a -> bool
  val remdups : 'a eq -> 'a list -> 'a list
  val compa : 'a eq -> ('a * 'a) list -> ('a * 'a) list -> ('a * 'a) list
  val shows_paren : (char list -> char list) -> char list -> char list
  val shows_preca :
    'a show -> 'b show -> nat -> 'a * 'b -> char list -> char list
  val shows_sep :
    ('a -> char list -> char list) ->
      (char list -> char list) -> 'a list -> char list -> char list
  val shows_between :
    (char list -> char list) ->
      (char list -> char list) ->
        (char list -> char list) -> char list -> char list
  val shows_list_gen :
    ('a -> char list -> char list) ->
      char list ->
        char list -> char list -> char list -> 'a list -> char list -> char list
  val shows_list_aux :
    ('a -> char list -> char list) -> 'a list -> char list -> char list
  val shows_lista :
    'a show -> 'b show -> ('a * 'b) list -> char list -> char list
  val show : 'a show -> 'b show -> ('a * 'b) show
  type ('a, 'b) ctxt = Hole |
    More of 'a * ('a, 'b) term list * ('a, 'b) ctxt * ('a, 'b) term list
  val string2bool : char list -> ((char list), bool) sum
  val boola : char list -> xml -> ((char list), bool) sum
  val capRM2 :
    'a eq -> 'b eq ->
      ('a * nat -> (('a, 'b) term * ('a, 'b) term) list) ->
        ('a, 'b) term -> ('a, 'b) hterm
  val capRM :
    'a eq -> 'b eq ->
      ('a * nat -> (('a, 'b) term * ('a, 'b) term) list) option ->
        ('a, 'b) term -> ('a, 'b) hterm
  val eq_int : Big_int.big_int eq
  val drop : nat -> 'a list -> 'a list
  val last : 'a list -> 'a
  val eq_nata : nat eq
  val quotient_of : rat -> Big_int.big_int * Big_int.big_int
  val eq_rat : rat -> rat -> bool
  val eq_rata : rat eq
  type 'a times = {times : 'a -> 'a -> 'a}
  val times : 'a times -> 'a -> 'a -> 'a
  type 'a dvd = {times_dvd : 'a times}
  val combine : 'b eq -> ('a, 'b) scg -> ('a, 'b) scg -> ('a, 'b) scg
  val list_all : ('a -> bool) -> 'a list -> bool
  val subsumes : 'a eq -> 'b eq -> ('a, 'b) scg -> ('a, 'b) scg -> bool
  val filter : ('a -> bool) -> 'a list -> 'a list
  val subtract_list : 'a eq -> 'a list -> 'a list -> 'a list
  val scg_comp :
    'b eq -> ('a -> 'a -> bool) -> ('a, 'b) scg -> ('a, 'b) scg -> ('a, 'b) scg
  val in_situ : 'b eq -> ('a, 'b) scg -> bool
  val sagiv : 'a eq -> 'b eq -> ('a -> 'a -> bool) -> ('a, 'b) scg -> bool
  val args : ('a, 'b) term -> ('a, 'b) term list
  val root : ('a, 'b) term -> 'a option
  type ('a, 'b) subst = Subst of ('b -> ('a, 'b) term)
  val eq_shp : 'a eq -> 'a shp -> 'a shp -> bool
  val eq_shpa : 'a eq -> 'a shp eq
  type 'a one = {one : 'a}
  val one : 'a one -> 'a
  val times_int : Big_int.big_int times
  val dvd_int : Big_int.big_int dvd
  val one_int : Big_int.big_int
  val one_inta : Big_int.big_int one
  type 'a ord = {less_eq : 'a -> 'a -> bool; less : 'a -> 'a -> bool}
  val less_eq : 'a ord -> 'a -> 'a -> bool
  val less : 'a ord -> 'a -> 'a -> bool
  val ord_int : Big_int.big_int ord
  val foldr : ('a -> 'b -> 'b) -> 'a list -> 'b -> 'b
  val vec : nat -> 'a list -> bool
  val mat : nat -> nat -> ('a list) list -> bool
  val ord_nat : nat ord
  val times_rat : rat -> rat -> rat
  val times_rata : rat times
  val dvd_rat : rat dvd
  val one_rat : rat
  val one_rata : rat one
  val less_rat : rat -> rat -> bool
  val less_eq_rat : rat -> rat -> bool
  val ord_rat : rat ord
  val eq_scg : 'a eq -> 'b eq -> ('a, 'b) scg -> ('a, 'b) scg -> bool
  val list_all2 : ('a -> 'b -> bool) -> 'a list -> 'b list -> bool
  val eq_term : 'a eq -> 'b eq -> ('a, 'b) term -> ('a, 'b) term -> bool
  val eq_terma : 'a eq -> 'b eq -> ('a, 'b) term eq
  val term_case :
    ('a -> 'b) -> ('c -> ('c, 'a) term list -> 'b) -> ('c, 'a) term -> 'b
  val suptp : 'a eq -> 'b eq -> ('a, 'b) term -> ('a, 'b) term -> bool
  val plaina : ('a, 'b) term -> ('a shp, 'b) term
  val sharpa : ('a, 'b) term -> ('a shp, 'b) term
  val debug : char list -> char list -> 'a -> 'a
  val eq_hterm : 'a eq -> ('a, 'b) hterm eq
  val eq_hterma : 'a eq -> ('a, 'b) hterm -> ('a, 'b) hterm -> bool
  val fun_upd : 'a eq -> ('a -> 'b) -> 'a -> 'b -> 'a -> 'b
  type 'a plus = {plus : 'a -> 'a -> 'a}
  val plus : 'a plus -> 'a -> 'a -> 'a
  type 'a zero = {zero : 'a}
  val zero : 'a zero -> 'a
  val implies : bool -> bool -> bool
  val plus_int : Big_int.big_int plus
  val zero_int : Big_int.big_int
  val zero_inta : Big_int.big_int zero
  type pos = Empty | PCons of nat * pos
  type 'a power = {one_power : 'a one; times_power : 'a times}
  val powera : 'a -> ('a -> 'a -> 'a) -> 'a -> nat -> 'a
  val power : 'a power -> 'a -> nat -> 'a
  val plus_rat : rat -> rat -> rat
  val plus_rata : rat plus
  val zero_rat : rat
  val zero_rata : rat zero
  val is_var : ('a, 'b) term -> bool
  val shows_shp : 'a show -> 'a shp -> char list -> char list
  val shows_prec_shp : 'a show -> nat -> 'a shp -> char list -> char list
  val shows_list_shp : 'a show -> 'a shp list -> char list -> char list
  val show_shp : 'a show -> 'a shp show
  val shows_nl : char list -> char list
  val shows_term : 'a show -> 'b show -> ('a, 'b) term -> char list -> char list
  val shows_prec_term :
    'a show -> 'b show -> nat -> ('a, 'b) term -> char list -> char list
  val shows_rule :
    'a show -> 'b show ->
      ('a, 'b) term * ('a, 'b) term -> char list -> char list
  val shows_rules :
    'a show -> 'b show ->
      (('a, 'b) term * ('a, 'b) term) list -> char list -> char list
  val shows_p :
    'a show -> 'b show ->
      (('a, 'b) term * ('a, 'b) term) list -> char list -> char list
  val power_int : Big_int.big_int power
  val vec0I : 'a -> nat -> 'a list
  val mat0I : 'a -> nat -> nat -> ('a list) list
  val minus_nat : nat -> nat -> nat
  val vec1I : 'a -> 'a -> nat -> nat -> 'a list
  val mat1I : 'a -> 'a -> nat -> ('a list) list
  val power_rat : rat power
  type 'a non_strict_order = {ge : 'a -> 'a -> bool}
  val ge : 'a non_strict_order -> 'a -> 'a -> bool
  val divmod_nat : nat -> nat -> nat * nat
  val mod_nat : nat -> nat -> nat
  val div_nat : nat -> nat -> nat
  val digit2string : nat -> char list
  val shows_nat : nat -> char list -> char list
  val shows_prec_nat : nat -> nat -> char list -> char list
  val shows_prec_int : nat -> Big_int.big_int -> char list -> char list
  val shows_list_int : Big_int.big_int list -> char list -> char list
  val show_int : Big_int.big_int show
  val shows_list_nat : nat list -> char list -> char list
  val show_nat : nat show
  val show_rat : rat -> char list
  val shows_prec_rat : nat -> rat -> char list -> char list
  val shows_list_rat : rat list -> char list -> char list
  val show_rata : rat show
  val eq_ctxt : 'a eq -> 'b eq -> ('a, 'b) ctxt -> ('a, 'b) ctxt -> bool
  val subt_at : ('a, 'b) term -> pos -> ('a, 'b) term
  val supteqp : 'a eq -> 'b eq -> ('a, 'b) term -> ('a, 'b) term -> bool
  val the_var : ('a, 'b) term -> 'b
  val map_term : ('a -> 'b) -> ('a, 'c) term -> ('b, 'c) term
  val map_rule :
    ('a -> 'b) -> ('a, 'c) term * ('a, 'c) term -> ('b, 'c) term * ('b, 'c) term
  val map_trsI :
    ('a -> 'b) ->
      (('a, 'c) term * ('a, 'c) term) list ->
        (('b, 'c) term * ('b, 'c) term) list
  val extract : ('a -> bool) -> 'a list -> ('a list * ('a * 'a list)) option
  val distinct : 'a eq -> 'a list -> bool
  val vec_comp_all : ('a -> 'a -> bool) -> 'a list -> 'a list -> bool
  val mat_comp_all :
    ('a -> 'a -> bool) -> ('a list) list -> ('a list) list -> bool
  val mat_ge : 'a non_strict_order -> ('a list) list -> ('a list) list -> bool
  val times_nat : nat -> nat -> nat
  type 'a preorder = {ord_preorder : 'a ord}
  type 'a bot = {preorder_bot : 'a preorder; bot : 'a}
  val bot : 'a bot -> 'a
  val maxa : ('a -> 'a -> bool) -> 'a -> 'a -> 'a
  val max : 'a ord -> 'a -> 'a -> 'a
  val mina : ('a -> 'a -> bool) -> 'a -> 'a -> 'a
  val min : 'a ord -> 'a -> 'a -> 'a
  val minus_rat : rat -> rat -> rat
  val insert_scg :
    'a eq -> 'b eq ->
      ('a, 'b) scg -> ('a, 'b) scg list -> (('a, 'b) scg list) option
  val mk_trancl :
    'a eq -> 'b eq ->
      ('a -> 'a -> bool) ->
        ('a, 'b) scg list -> ('a, 'b) scg list -> ('a, 'b) scg list
  val check_SCT :
    'a eq -> 'b eq -> ('a -> 'a -> bool) -> ('a, 'b) scg list -> bool
  val shows_list_list : 'a show -> ('a list) list -> char list -> char list
  val show_list : 'a show -> ('a list) show
  val num_args : ('a, 'b) term -> nat
  val shows_list_term :
    'a show -> 'b show -> ('a, 'b) term list -> char list -> char list
  val show_term : 'a show -> 'b show -> ('a, 'b) term show
  val defs_list :
    'a eq -> (('a, 'b) term * ('a, 'b) term) list -> ('a * nat) list
  val shows_trs :
    'a show -> 'b show ->
      (('a, 'b) term * ('a, 'b) term) list -> char list -> char list
  val shows_dpp :
    'a show -> 'b show ->
      (('a, 'b) term * ('a, 'b) term) list ->
        (('a, 'b) term * ('a, 'b) term) list -> char list -> char list
  val rev_append : 'a list -> 'a list -> 'a list
  val flat_map_aux : ('a -> 'b list) -> 'a list -> 'b list -> 'b list
  val flat_map : ('a -> 'b list) -> 'a list -> 'b list
  val quote : (char list -> char list) -> char list -> char list
  val expecting :
    'a show -> char list -> 'a list -> ((char list), ('b * 'a list)) sum
  val eoi : 'a show -> 'a list -> ((char list), (unit * 'a list)) sum
  type af_entry = Collapse of nat | AFList of nat list
  val position : xml -> ((char list), nat) sum
  val xml3elements :
    char list ->
      (xml -> ((char list), 'a) sum) ->
        (xml -> ((char list), 'b) sum) ->
          (xml -> ((char list), 'c) sum) ->
            ('a -> 'b -> 'c -> 'd) -> xml -> ((char list), 'd) sum
  val xml_many_elements :
    char list ->
      (xml -> ((char list), 'a) sum) ->
        ('a list -> 'b) -> xml -> ((char list), 'b) sum
  val afs :
    (xml -> ((char list), 'a) sum) ->
      xml -> ((char list), ((('a * nat) * af_entry) list)) sum
  val list2position : nat list -> pos
  val pos : xml -> ((char list), pos) sum
  val scg_position : xml -> ((char list), nat) sum
  val xml1element :
    char list ->
      (xml -> ((char list), 'a) sum) ->
        ('a -> 'b) -> xml -> ((char list), 'b) sum
  val xml1many_elements_gen :
    char list ->
      (xml -> ((char list), 'a) sum) ->
        ('a -> xml -> ((char list), 'b) sum) ->
          ('a -> 'b list -> 'c) -> xml -> ((char list), 'c) sum
  val xml1many_elements :
    char list ->
      (xml -> ((char list), 'a) sum) ->
        (xml -> ((char list), 'b) sum) ->
          ('a -> 'b list -> 'c) -> xml -> ((char list), 'c) sum
  val var : xml -> ((char list), ('a, (char list)) term) sum
  val term :
    (xml -> ((char list), 'a) sum) ->
      xml -> ((char list), ('a, (char list)) term) sum
  val rule :
    (xml -> ((char list), 'a) sum) ->
      xml ->
        ((char list), (('a, (char list)) term * ('a, (char list)) term)) sum
  val scg :
    (xml -> ((char list), 'a) sum) ->
      xml ->
        ((char list),
          ((('a, (char list)) term * ('a, (char list)) term) *
            ((nat * nat) list * (nat * nat) list)))
          sum
  val list_case : 'a -> ('b -> 'b list -> 'a) -> 'b list -> 'a
  val partition : ('a -> bool) -> 'a list -> 'a list * 'a list
  val sub_vec : nat -> 'a list -> 'a list
  val sub_mat : nat -> nat -> ('a list) list -> ('a list) list
  val vec_pre_gtI : ('a -> 'a -> bool) -> 'a list -> 'a list -> bool
  val mat_pre_gtI :
    ('a -> 'a -> bool) -> ('a list) list -> ('a list) list -> bool
  val mat_gtI :
    'a non_strict_order ->
      ('a -> 'a -> bool) -> nat -> ('a list) list -> ('a list) list -> bool
  val vec_map : ('a -> 'a) -> 'a list -> 'a list
  val mat_map : ('a -> 'a) -> ('a list) list -> ('a list) list
  val eq_pos : pos -> pos -> bool
  val eq_posa : pos eq
  type 'a semigroup_mult = {times_semigroup_mult : 'a times}
  type 'a semigroup_add = {plus_semigroup_add : 'a plus}
  type 'a ab_semigroup_add = {semigroup_add_ab_semigroup_add : 'a semigroup_add}
  type 'a semiring =
    {ab_semigroup_add_semiring : 'a ab_semigroup_add;
      semigroup_mult_semiring : 'a semigroup_mult}
  type 'a ordered_ab_semigroup =
    {ab_semigroup_add_ordered_ab_semigroup : 'a ab_semigroup_add;
      non_strict_order_ordered_ab_semigroup : 'a non_strict_order}
  type 'a monoid_add =
    {semigroup_add_monoid_add : 'a semigroup_add; zero_monoid_add : 'a zero}
  type 'a max_ordered_monoid_add =
    {monoid_add_max_ordered_monoid_add : 'a monoid_add;
      ordered_ab_semigroup_max_ordered_monoid_add : 'a ordered_ab_semigroup;
      max0 : 'a -> 'a}
  val max0 : 'a max_ordered_monoid_add -> 'a -> 'a
  val ctxt_case :
    'a -> ('b ->
            ('b, 'c) term list -> ('b, 'c) ctxt -> ('b, 'c) term list -> 'a) ->
            ('b, 'c) ctxt -> 'a
  val get_subst : ('a, 'b) subst -> 'b -> ('a, 'b) term
  val poss_list : ('a, 'b) term -> pos list
  val list_diff : 'a eq -> 'a list -> 'a list -> 'a list
  val binda :
    ('a list -> ((char list), ('b * 'a list)) sum) ->
      ('b -> 'a list -> ((char list), ('c * 'a list)) sum) ->
        'a list -> ((char list), ('c * 'a list)) sum
  val many :
    (char -> bool) -> char list -> ((char list), (char list * char list)) sum
  val wspace : char list
  val trim : char list -> char list
  type ('a, 'b, 'c, 'd, 'e, 'f, 'g, 'h, 'i, 'j) alter = Alter1 of 'a |
    Alter2 of 'b | Alter3 of 'c | Alter4 of 'd | Alter5 of 'e | Alter6 of 'f |
    Alter7 of 'g | Alter8 of 'h | Alter9 of 'i | Alter10 of 'j
  val xml4elements :
    char list ->
      (xml -> ((char list), 'a) sum) ->
        (xml -> ((char list), 'b) sum) ->
          (xml -> ((char list), 'c) sum) ->
            (xml -> ((char list), 'd) sum) ->
              ('a -> 'b -> 'c -> 'd -> 'e) -> xml -> ((char list), 'e) sum
  val xml0elements : char list -> 'a -> xml -> ((char list), 'a) sum
  val ctxt :
    (xml -> ((char list), 'a) sum) ->
      xml -> ((char list), ('a, (char list)) ctxt) sum
  val subst :
    (xml -> ((char list), 'a) sum) ->
      xml -> ((char list), ((char list * ('a, (char list)) term) list)) sum
  val xml3to4elements :
    char list ->
      (xml -> ((char list), 'a) sum) ->
        (xml -> ((char list), 'b) sum) ->
          (xml -> ((char list), 'c) sum) ->
            (xml -> ((char list), 'd) sum) ->
              ('a -> 'b -> 'c option -> 'd -> 'e) ->
                xml -> ((char list), 'e) sum
  val rstep :
    (xml -> ((char list), 'a) sum) ->
      xml ->
        ((char list),
          (pos *
            ((('a, (char list)) term * ('a, (char list)) term) *
              (bool * ('a, (char list)) term))))
          sum
  val rsteps :
    (xml -> ((char list), 'a) sum) ->
      xml ->
        ((char list),
          (('a, (char list)) term *
            (pos *
              ((('a, (char list)) term * ('a, (char list)) term) *
                (bool * ('a, (char list)) term))) list))
          sum
  val loop :
    (xml -> ((char list), 'a) sum) ->
      xml ->
        ((char list),
          (('a, (char list)) term *
            ((pos *
               ((('a, (char list)) term * ('a, (char list)) term) *
                 (bool * ('a, (char list)) term))) list *
              ((char list * ('a, (char list)) term) list *
                ('a, (char list)) ctxt))))
          sum
  val af_entry_case : (nat -> 'a) -> (nat list -> 'a) -> af_entry -> 'a
  type 'a projL = Projection of ('a * nat) list
  val proj :
    (xml -> ((char list), 'a) sum) -> xml -> ((char list), 'a projL) sum
  val proj_term : ('a -> nat) -> ('a, 'b) term -> ('a, 'b) term
  val start_term :
    'a eq ->
      (xml -> ((char list), 'a) sum) ->
        ('a, (char list)) term ->
          xml -> ((char list), ('a, (char list)) term) sum
  val rseq :
    'a eq ->
      (xml -> ((char list), 'a) sum) ->
        ('a -> nat) ->
          ('a, (char list)) term * ('a, (char list)) term ->
            xml ->
              ((char list),
                ((('a, (char list)) term * ('a, (char list)) term) *
                  (pos *
                    ((('a, (char list)) term * ('a, (char list)) term) *
                      ('a, (char list)) term)) list))
                sum
  val semigroup_mult_int : Big_int.big_int semigroup_mult
  val semigroup_add_int : Big_int.big_int semigroup_add
  val ab_semigroup_add_int : Big_int.big_int ab_semigroup_add
  val semiring_int : Big_int.big_int semiring
  val list_inter : 'a eq -> 'a list -> 'a list -> 'a list
  val mat_max0 : 'a max_ordered_monoid_add -> ('a list) list -> ('a list) list
  val semigroup_mult_rat : rat semigroup_mult
  val semigroup_add_rat : rat semigroup_add
  val ab_semigroup_add_rat : rat ab_semigroup_add
  val semiring_rat : rat semiring
  type arctic_rat = MinInfty_rat | Num_arc_rat of rat
  type arctic = MinInfty | Num_arc of Big_int.big_int
  type 'a redpair =
    Int_carrier of (('a * nat) * (Big_int.big_int * Big_int.big_int list)) list
    | Int_nl_carrier of
        (('a * nat) * ((nat * nat) list * Big_int.big_int) list) list
    | Rat_carrier of rat * (('a * nat) * (rat * rat list)) list |
    Rat_nl_carrier of rat * (('a * nat) * ((nat * nat) list * rat) list) list |
    Arctic_carrier of (('a * nat) * (arctic * arctic list)) list |
    Arctic_rat_carrier of
      rat * (('a * nat) * (arctic_rat * arctic_rat list)) list
    | Int_mat_carrier of
        nat * nat *
          (('a * nat) *
            ((Big_int.big_int list) list *
              ((Big_int.big_int list) list) list)) list
    | Rat_mat_carrier of
        rat * nat * nat *
          (('a * nat) * ((rat list) list * ((rat list) list) list)) list
    | Arc_mat_carrier of
        nat * (('a * nat) *
                ((arctic list) list * ((arctic list) list) list)) list
    | Arc_rat_mat_carrier of
        rat * nat *
          (('a * nat) *
            ((arctic_rat list) list * ((arctic_rat list) list) list)) list
    | Lpo of (('a * nat) * nat) list * (('a * nat) * af_entry) list
  type 'a mult_zero = {times_mult_zero : 'a times; zero_mult_zero : 'a zero}
  val ctxt_apply : ('a, 'b) ctxt -> ('a, 'b) term -> ('a, 'b) term
  val shows_ctxt : 'a show -> 'b show -> ('a, 'b) ctxt -> char list -> char list
  val rp_af :
    ((char list -> char list), unit) sum *
      ((('a, 'b) term * ('a, 'b) term -> ((char list -> char list), unit) sum) *
        ((('a, 'b) term * ('a, 'b) term ->
           ((char list -> char list), unit) sum) *
          (('a -> nat -> nat -> bool) *
            (((char list -> char list), unit) sum *
              (char list -> char list))))) ->
      'a -> nat -> nat -> bool
  val unsharp_fun : 'a shp -> 'a
  val list_union : 'a eq -> 'a list -> 'a list -> 'a list
  val oneof_aux :
    (char list) list ->
      (char list) list ->
        char list -> ((char list), (char list * char list)) sum
  val oneof :
    (char list) list -> char list -> ((char list), (char list * char list)) sum
  type xmldoc = Xmldoc of char list * xml
  type domain = Natural of nat | Arctic | Arctic_rat of rat |
    Int_mat of nat * nat | Arc_mat of nat | Arc_rat_mat of rat * nat |
    Rational of rat * nat | Rat_mat of rat * nat * nat
  val label :
    (xml -> ((char list), 'a) sum) ->
      xml -> ((char list), ((nat list), ('a list)) sum) sum
  val rules :
    (xml -> ((char list), 'a) sum) ->
      xml ->
        ((char list), ((('a, (char list)) term * ('a, (char list)) term) list))
          sum
  val isOK : ('a, 'b) sum -> bool
  val mult_zero_int : Big_int.big_int mult_zero
  val mat_monoI : ('a -> bool) -> nat -> ('a list) list -> bool
  val transpose : nat -> ('a list) list -> ('a list) list
  val scalar_prodI :
    'a -> ('a -> 'a -> 'a) -> ('a -> 'a -> 'a) -> 'a list -> 'a list -> 'a
  val matT_vec_multI :
    'a -> ('a -> 'a -> 'a) ->
            ('a -> 'a -> 'a) -> ('a list) list -> 'a list -> 'a list
  val mat_multI :
    'a -> ('a -> 'a -> 'a) ->
            ('a -> 'a -> 'a) ->
              nat -> ('a list) list -> ('a list) list -> ('a list) list
  val vec_plusI : ('a -> 'a -> 'a) -> 'a list -> 'a list -> 'a list
  val mat_plusI :
    ('a -> 'a -> 'a) -> ('a list) list -> ('a list) list -> ('a list) list
  val mul_pvarsI :
    'a eq -> 'a -> ('a -> 'a -> 'a) -> 'a -> ('b * 'a) list -> ('b * 'a) list
  type ('a, 'b) l_poly = LPoly of 'b * ('a * 'b) list
  val mul_lpolyI :
    'a eq -> 'a -> ('a -> 'a -> 'a) -> 'a -> ('b, 'a) l_poly -> ('b, 'a) l_poly
  val list_sumI : 'a -> ('a -> 'a -> 'a) -> 'a list -> 'a
  val add_varI :
    'a eq -> 'b eq ->
      'a -> ('a -> 'a -> 'a) -> 'b -> 'a -> ('b * 'a) list -> ('b * 'a) list
  val sum_pvarsI :
    'a eq -> 'b eq ->
      'a -> ('a -> 'a -> 'a) ->
              ('b * 'a) list -> ('b * 'a) list -> ('b * 'a) list
  val sum_lpolyI :
    'a eq -> 'b eq ->
      'a -> ('a -> 'a -> 'a) ->
              ('b, 'a) l_poly -> ('b, 'a) l_poly -> ('b, 'a) l_poly
  val l_poly_case : ('a -> ('b * 'a) list -> 'c) -> ('b, 'a) l_poly -> 'c
  val pleftI :
    'a eq -> 'c eq ->
      'a -> 'a -> ('a -> 'a -> 'a) ->
                    ('a -> 'a -> 'a) ->
                      ('a -> 'a) ->
                        ('b -> nat -> 'a * 'a list) ->
                          ('b, 'c) term -> ('c, 'a) l_poly
  type arithFun = Arg of nat | Const of nat | Sum of arithFun list |
    Max of arithFun list | Min of arithFun list | Prod of arithFun list
  type ('a, 'b) lab = Lab of ('a, 'b) lab * 'b |
    FunLab of ('a, 'b) lab * ('a, 'b) lab list | UnLab of 'a
  type ('a, 'b) sl_inter =
    SL_Inter of nat * ((('a, 'b) lab * nat) * arithFun) list
  type ('a, 'b, 'c) dPProof = PisEmpty |
    RedPairProc of
      ('a, 'b) lab redpair *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ('a, 'b, 'c) dPProof
    | RedPairUrProc of
        ('a, 'b) lab redpair *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ('a, 'b, 'c) dPProof
    | DepGraphProc of
        (('a, 'b, 'c) dPProof option *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list) list
    | MonoRedPairProc of
        ('a, 'b) lab redpair *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ('a, 'b, 'c) dPProof
    | MonoRedPairUrProc of
        ('a, 'b) lab redpair *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ('a, 'b, 'c) dPProof
    | UnlabProc of
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ('a, 'b, 'c) dPProof
    | SemlabProc of
        ('a, 'b) sl_inter *
          (('a, 'b) lab -> nat list -> ('b, (('a, 'b) lab list)) sum) *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ('a, 'b, 'c) dPProof
    | RootlabProc of
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ('a, 'b, 'c) dPProof
    | SubtermCriterionProc of
        ('a, 'b) lab projL *
          (((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) *
            (pos *
              (((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) *
                (('a, 'b) lab, 'c) term)) list) list *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ('a, 'b, 'c) dPProof
    | SizeChangeSubTerm of
        (((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) *
          ((nat * nat) list * (nat * nat) list)) list
    | SizeChangeRedPair of
        ('a, 'b) lab redpair *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          (((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) *
            ((nat * nat) list * (nat * nat) list)) list
    | FccProc of
        ('a, 'b) lab * (('a, 'b) lab, 'c) ctxt list *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ('a, 'b, 'c) dPProof
  type ('a, 'b, 'c) tRSProof =
    DPTrans of
      ((('a, 'b) lab shp, 'c) term * (('a, 'b) lab shp, 'c) term) list *
        (('a, 'b) lab shp, 'b, 'c) dPProof
    | RuleRemoval of
        ('a, 'b) lab redpair *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ('a, 'b, 'c) tRSProof
    | Unlab of
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ('a, 'b, 'c) tRSProof
    | Semlab of
        ('a, 'b) sl_inter *
          (('a, 'b) lab -> nat list -> ('b, (('a, 'b) lab list)) sum) *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ('a, 'b, 'c) tRSProof
    | Rootlab of
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ('a, 'b, 'c) tRSProof
    | Fcc of
        (('a, 'b) lab, 'c) ctxt list *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ('a, 'b, 'c) tRSProof
    | StringReversal of
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ('a, 'b, 'c) tRSProof
    | RisEmpty
  val mult_zero_rat : rat mult_zero
  type 'a comm_monoid_add =
    {ab_semigroup_add_comm_monoid_add : 'a ab_semigroup_add;
      monoid_add_comm_monoid_add : 'a monoid_add}
  type 'a semiring_0 =
    {comm_monoid_add_semiring_0 : 'a comm_monoid_add;
      mult_zero_semiring_0 : 'a mult_zero; semiring_semiring_0 : 'a semiring}
  type 'a zero_neq_one =
    {one_zero_neq_one : 'a one; zero_zero_neq_one : 'a zero}
  type 'a monoid_mult =
    {semigroup_mult_monoid_mult : 'a semigroup_mult;
      power_monoid_mult : 'a power}
  type 'a semiring_1 =
    {monoid_mult_semiring_1 : 'a monoid_mult;
      semiring_0_semiring_1 : 'a semiring_0;
      zero_neq_one_semiring_1 : 'a zero_neq_one}
  val linear_term_impl : 'a eq -> 'a list -> ('b, 'a) term -> ('a list) option
  val linear_term : 'b eq -> ('a, 'b) term -> bool
  val subst_empty : ('a, 'b) subst
  val xml5elements :
    char list ->
      (xml -> ((char list), 'a) sum) ->
        (xml -> ((char list), 'b) sum) ->
          (xml -> ((char list), 'c) sum) ->
            (xml -> ((char list), 'd) sum) ->
              (xml -> ((char list), 'e) sum) ->
                ('a -> 'b -> 'c -> 'd -> 'e -> 'f) ->
                  xml -> ((char list), 'f) sum
  val manyof :
    char list -> char list -> ((char list), (char list * char list)) sum
  val spaces : char list -> ((char list), (unit * char list)) sum
  val store : ('a * 'b) list -> 'a -> 'b -> ('a * 'b) list
  val lex_extE :
    ('a -> 'b -> 'b -> (bool * bool) * 'a) ->
      'a -> 'b list -> 'b list -> (bool * bool) * 'a
  val forAllStriE :
    ('a -> 'b -> (bool * bool) * 'a) -> 'a -> 'b list -> bool * 'a
  val anyNstriE : ('a -> 'b -> (bool * bool) * 'a) -> 'a -> 'b list -> bool * 'a
  val lpoE :
    'a eq -> 'b eq ->
      ((('a, 'b) term * ('a, 'b) term) * (bool * bool)) list ->
        ('a -> nat -> nat) ->
          ('a, 'b) term ->
            ('a, 'b) term ->
              (bool * bool) *
                ((('a, 'b) term * ('a, 'b) term) * (bool * bool)) list
  val catch : ('a, 'b) sum -> ('a -> ('c, 'b) sum) -> ('c, 'b) sum
  val check : bool -> 'a -> ('a, unit) sum
  val forallm : ('a -> ('b, unit) sum) -> 'a list -> (('a * 'b), unit) sum
  val check_edges :
    ('a -> char list -> char list) ->
      ('a * 'a -> bool) ->
        'a list -> 'a list -> ((char list -> char list), unit) sum
  val monoid_add_int : Big_int.big_int monoid_add
  val comm_monoid_add_int : Big_int.big_int comm_monoid_add
  val semiring_0_int : Big_int.big_int semiring_0
  val zero_neq_one_int : Big_int.big_int zero_neq_one
  val monoid_mult_int : Big_int.big_int monoid_mult
  val semiring_1_int : Big_int.big_int semiring_1
  type ('a, 'b) tpoly = PVar of 'a | PNum of 'b | PSum of ('a, 'b) tpoly list |
    PMult of ('a, 'b) tpoly list
  val bot_bool : bool
  val less_bool : bool -> bool -> bool
  val less_eq_bool : bool -> bool -> bool
  val ord_bool : bool ord
  val preorder_bool : bool preorder
  val bot_boola : bool bot
  val bot_fun : 'b bot -> 'a -> 'b
  val prightI :
    'a eq -> 'c eq ->
      'a -> 'a -> ('a -> 'a -> 'a) ->
                    ('a -> 'a -> 'a) ->
                      ('a -> 'a) ->
                        ('b -> nat -> 'a * 'a list) ->
                          ('b, 'c) term -> ('c, 'a) l_poly
  val lpo_E :
    'a eq -> 'b eq ->
      ('a -> nat -> nat) -> ('a, 'b) term -> ('a, 'b) term -> bool * bool
  val lpo_unbounded :
    'a eq -> 'b eq ->
      ('a -> nat -> nat) -> ('a, 'b) term -> ('a, 'b) term -> bool * bool
  val monoid_add_rat : rat monoid_add
  val comm_monoid_add_rat : rat comm_monoid_add
  val semiring_0_rat : rat semiring_0
  val zero_neq_one_rat : rat zero_neq_one
  val monoid_mult_rat : rat monoid_mult
  val semiring_1_rat : rat semiring_1
  val full_af : 'a -> nat -> nat -> bool
  val rp_desc :
    ((char list -> char list), unit) sum *
      ((('a, 'b) term * ('a, 'b) term -> ((char list -> char list), unit) sum) *
        ((('a, 'b) term * ('a, 'b) term ->
           ((char list -> char list), unit) sum) *
          (('a -> nat -> nat -> bool) *
            (((char list -> char list), unit) sum *
              (char list -> char list))))) ->
      char list -> char list
  val rp_mono :
    ((char list -> char list), unit) sum *
      ((('a, 'b) term * ('a, 'b) term -> ((char list -> char list), unit) sum) *
        ((('a, 'b) term * ('a, 'b) term ->
           ((char list -> char list), unit) sum) *
          (('a -> nat -> nat -> bool) *
            (((char list -> char list), unit) sum *
              (char list -> char list))))) ->
      ((char list -> char list), unit) sum
  val funs_term_list : ('a, 'b) term -> 'a list
  val funs_rule_list : ('a, 'b) term * ('a, 'b) term -> 'a list
  val funs_trs_list : 'a eq -> (('a, 'b) term * ('a, 'b) term) list -> 'a list
  val vars_term_lista : ('a, 'b) term -> 'b list
  val vars_rule_list : ('a, 'b) term * ('a, 'b) term -> 'b list
  val vars_trs_list : 'b eq -> (('a, 'b) term * ('a, 'b) term) list -> 'b list
  val xml2nd_choice :
    char list ->
      (xml -> ((char list), 'a) sum) ->
        char list ->
          (xml -> ((char list), 'b) sum) ->
            ('a -> 'b option -> 'c) -> xml -> ((char list), 'c) sum
  val letters : char list
  val alter1a : ('a, 'b, 'c, 'd, 'e, 'f, 'g, 'h, 'i, 'j) alter -> 'a
  val alter2a : ('a, 'b, 'c, 'd, 'e, 'f, 'g, 'h, 'i, 'j) alter -> 'b
  val alter3a : ('a, 'b, 'c, 'd, 'e, 'f, 'g, 'h, 'i, 'j) alter -> 'c
  val alter4a : ('a, 'b, 'c, 'd, 'e, 'f, 'g, 'h, 'i, 'j) alter -> 'd
  val alter5a : ('a, 'b, 'c, 'd, 'e, 'f, 'g, 'h, 'i, 'j) alter -> 'e
  val alter6a : ('a, 'b, 'c, 'd, 'e, 'f, 'g, 'h, 'i, 'j) alter -> 'f
  val alter7a : ('a, 'b, 'c, 'd, 'e, 'f, 'g, 'h, 'i, 'j) alter -> 'g
  val alter8a : ('a, 'b, 'c, 'd, 'e, 'f, 'g, 'h, 'i, 'j) alter -> 'h
  val alter9a : ('a, 'b, 'c, 'd, 'e, 'f, 'g, 'h, 'i, 'j) alter -> 'i
  val precedence :
    (xml -> ((char list), 'a) sum) ->
      xml -> ((char list), ((('a * nat) * nat) list)) sum
  val xml1to2elements :
    char list ->
      (xml -> ((char list), 'a) sum) ->
        (xml -> ((char list), 'b) sum) ->
          ('a -> 'b option -> 'c) -> xml -> ((char list), 'c) sum
  val path_order :
    (xml -> ((char list), 'a) sum) -> xml -> ((char list), 'a redpair) sum
  val alter10a : ('a, 'b, 'c, 'd, 'e, 'f, 'g, 'h, 'i, 'j) alter -> 'j
  val ge_rat : rat -> rat -> bool
  val non_strict_order_rat : rat non_strict_order
  val max0_rat : rat -> rat
  val ordered_ab_semigroup_rat : rat ordered_ab_semigroup
  val max_ordered_monoid_add_rat : rat max_ordered_monoid_add
  type 'a ab_semigroup_mult =
    {semigroup_mult_ab_semigroup_mult : 'a semigroup_mult}
  type 'a comm_semiring =
    {ab_semigroup_mult_comm_semiring : 'a ab_semigroup_mult;
      semiring_comm_semiring : 'a semiring}
  type 'a comm_semiring_0 =
    {comm_semiring_comm_semiring_0 : 'a comm_semiring;
      semiring_0_comm_semiring_0 : 'a semiring_0}
  type 'a comm_monoid_mult =
    {ab_semigroup_mult_comm_monoid_mult : 'a ab_semigroup_mult;
      monoid_mult_comm_monoid_mult : 'a monoid_mult}
  type 'a comm_semiring_1 =
    {comm_monoid_mult_comm_semiring_1 : 'a comm_monoid_mult;
      comm_semiring_0_comm_semiring_1 : 'a comm_semiring_0;
      dvd_comm_semiring_1 : 'a dvd; semiring_1_comm_semiring_1 : 'a semiring_1}
  val ab_semigroup_mult_rat : rat ab_semigroup_mult
  val comm_semiring_rat : rat comm_semiring
  val comm_semiring_0_rat : rat comm_semiring_0
  val comm_monoid_mult_rat : rat comm_monoid_mult
  val comm_semiring_1_rat : rat comm_semiring_1
  val rat_mono : rat -> bool
  val rat_name : char list
  val rat_gt : rat -> rat -> rat -> bool
  val ge_arctic_rat : arctic_rat -> arctic_rat -> bool
  val non_strict_order_arctic_rat : arctic_rat non_strict_order
  val get_comp_apos :
    ('a -> bool) *
      ('a * ('a * ('a * (('a -> 'a -> 'a) *
                          (('a -> 'a -> 'a) *
                            (('a -> 'a) *
                              (('a -> 'a -> bool) *
                                (('a -> 'a -> bool) *
                                  (bool *
                                    (char list *
                                      (('a -> bool) * ('a -> bool)))))))))))) ->
      'a -> bool
  val mat_arc_posI : ('a -> bool) -> ('a list) list -> bool
  val ge_arctic : arctic -> arctic -> bool
  val non_strict_order_arctic : arctic non_strict_order
  val get_comp_check_mono :
    ('a -> bool) *
      ('a * ('a * ('a * (('a -> 'a -> 'a) *
                          (('a -> 'a -> 'a) *
                            (('a -> 'a) *
                              (('a -> 'a -> bool) *
                                (('a -> 'a -> bool) *
                                  (bool *
                                    (char list *
                                      (('a -> bool) * ('a -> bool)))))))))))) ->
      'a -> bool
  val mat_mono : nat -> ('a -> bool) -> ('a list) list -> bool
  val get_comp_description :
    ('a -> bool) *
      ('a * ('a * ('a * (('a -> 'a -> 'a) *
                          (('a -> 'a -> 'a) *
                            (('a -> 'a) *
                              (('a -> 'a -> bool) *
                                (('a -> 'a -> bool) *
                                  (bool *
                                    (char list *
                                      (('a -> bool) * ('a -> bool)))))))))))) ->
      char list
  val get_comp_mono :
    ('a -> bool) *
      ('a * ('a * ('a * (('a -> 'a -> 'a) *
                          (('a -> 'a -> 'a) *
                            (('a -> 'a) *
                              (('a -> 'a -> bool) *
                                (('a -> 'a -> bool) *
                                  (bool *
                                    (char list *
                                      (('a -> bool) * ('a -> bool)))))))))))) ->
      bool
  val get_comp_gt :
    ('a -> bool) *
      ('a * ('a * ('a * (('a -> 'a -> 'a) *
                          (('a -> 'a -> 'a) *
                            (('a -> 'a) *
                              (('a -> 'a -> bool) *
                                (('a -> 'a -> bool) *
                                  (bool *
                                    (char list *
                                      (('a -> bool) * ('a -> bool)))))))))))) ->
      'a -> 'a -> bool
  val ge_int : Big_int.big_int -> Big_int.big_int -> bool
  val non_strict_order_int : Big_int.big_int non_strict_order
  val max0_int : Big_int.big_int -> Big_int.big_int
  val ordered_ab_semigroup_int : Big_int.big_int ordered_ab_semigroup
  val max_ordered_monoid_add_int : Big_int.big_int max_ordered_monoid_add
  val get_comp_def :
    ('a -> bool) *
      ('a * ('a * ('a * (('a -> 'a -> 'a) *
                          (('a -> 'a -> 'a) *
                            (('a -> 'a) *
                              (('a -> 'a -> bool) *
                                (('a -> 'a -> bool) *
                                  (bool *
                                    (char list *
                                      (('a -> bool) * ('a -> bool)))))))))))) ->
      'a
  val vec_coeff :
    (xml -> ((char list), 'a) sum) -> xml -> ((char list), ('a list)) sum
  val mat_coeff :
    'a -> (xml -> ((char list), 'a) sum) ->
            xml -> ((char list), (('a list) list)) sum
  val pos_arctic_rat : arctic_rat -> bool
  val arctic_rat_name : char list
  val gt_arctic_rat : rat -> arctic_rat -> arctic_rat -> bool
  val times_arctic_rat : arctic_rat -> arctic_rat -> arctic_rat
  val plus_arctic_rat : arctic_rat -> arctic_rat -> arctic_rat
  val one_arctic_rat : arctic_rat
  val zero_arctic_rat : arctic_rat
  val eq_arctic_rat : arctic_rat -> arctic_rat -> bool
  val eq_arctic_rata : arctic_rat eq
  val arctic_rat_coeff : xml -> ((char list), arctic_rat) sum
  val pos_arctic : arctic -> bool
  val arctic_name : char list
  val gt_arctic : arctic -> arctic -> bool
  val times_arctic : arctic -> arctic -> arctic
  val plus_arctic : arctic -> arctic -> arctic
  val one_arctic : arctic
  val zero_arctic : arctic
  val eq_arctic : arctic -> arctic -> bool
  val eq_arctica : arctic eq
  val arctic_coeff : xml -> ((char list), arctic) sum
  val ab_semigroup_mult_int : Big_int.big_int ab_semigroup_mult
  val comm_semiring_int : Big_int.big_int comm_semiring
  val comm_semiring_0_int : Big_int.big_int comm_semiring_0
  val comm_monoid_mult_int : Big_int.big_int comm_monoid_mult
  val comm_semiring_1_int : Big_int.big_int comm_semiring_1
  val monom_mult :
    'a eq -> ('a * nat) list -> ('a * nat) list -> ('a * nat) list
  val monom_mult_poly :
    'a eq -> 'b eq * 'b semiring_0 ->
      ('a * nat) list * 'b ->
        (('a * nat) list * 'b) list -> (('a * nat) list * 'b) list
  val eq_monom : 'a eq -> ('a * nat) list -> ('a * nat) list -> bool
  val poly_add :
    'a eq -> 'b eq * 'b semiring_0 ->
      (('a * nat) list * 'b) list ->
        (('a * nat) list * 'b) list -> (('a * nat) list * 'b) list
  val poly_mult :
    'a eq -> 'b eq * 'b semiring_0 ->
      (('a * nat) list * 'b) list ->
        (('a * nat) list * 'b) list -> (('a * nat) list * 'b) list
  val one_poly : 'b semiring_1 -> (('a * nat) list * 'b) list
  val zero_poly : (('a * nat) list * 'b) list
  val poly_of :
    'a eq -> 'b eq * 'b comm_semiring_1 ->
      ('a, 'b) tpoly -> (('a * nat) list * 'b) list
  val fit_length : 'a -> nat -> 'a list -> 'a list
  val get_comp_times :
    ('a -> bool) *
      ('a * ('a * ('a * (('a -> 'a -> 'a) *
                          (('a -> 'a -> 'a) *
                            (('a -> 'a) *
                              (('a -> 'a -> bool) *
                                (('a -> 'a -> bool) *
                                  (bool *
                                    (char list *
                                      (('a -> bool) * ('a -> bool)))))))))))) ->
      'a -> 'a -> 'a
  val get_comp_plus :
    ('a -> bool) *
      ('a * ('a * ('a * (('a -> 'a -> 'a) *
                          (('a -> 'a -> 'a) *
                            (('a -> 'a) *
                              (('a -> 'a -> bool) *
                                (('a -> 'a -> bool) *
                                  (bool *
                                    (char list *
                                      (('a -> bool) * ('a -> bool)))))))))))) ->
      'a -> 'a -> 'a
  val get_comp_1 :
    ('a -> bool) *
      ('a * ('a * ('a * (('a -> 'a -> 'a) *
                          (('a -> 'a -> 'a) *
                            (('a -> 'a) *
                              (('a -> 'a -> bool) *
                                (('a -> 'a -> bool) *
                                  (bool *
                                    (char list *
                                      (('a -> bool) * ('a -> bool)))))))))))) ->
      'a
  val int_mono : Big_int.big_int -> bool
  val int_name : char list
  val get_comp_0 :
    ('a -> bool) *
      ('a * ('a * ('a * (('a -> 'a -> 'a) *
                          (('a -> 'a -> 'a) *
                            (('a -> 'a) *
                              (('a -> 'a -> bool) *
                                (('a -> 'a -> bool) *
                                  (bool *
                                    (char list *
                                      (('a -> bool) * ('a -> bool)))))))))))) ->
      'a
  val sum_lpoly : ('a -> 'a -> 'a) -> 'a list -> 'a list -> 'a list
  val lpoly_of :
    'a eq ->
      'a -> 'a -> ('a -> 'a -> 'a) ->
                    ('a -> 'a -> 'a) ->
                      (nat, 'a) tpoly -> ((char list), ('a * 'a list)) sum
  val int_coeff : xml -> ((char list), Big_int.big_int) sum
  val polynomial :
    (xml -> ((char list), 'a) sum) -> xml -> ((char list), (nat, 'a) tpoly) sum
  val domain_case :
    (nat -> 'a) ->
      'a -> (rat -> 'a) ->
              (nat -> nat -> 'a) ->
                (nat -> 'a) ->
                  (rat -> nat -> 'a) ->
                    (rat -> nat -> 'a) ->
                      (rat -> nat -> nat -> 'a) -> domain -> 'a
  val rat_domain : xml -> ((char list), rat) sum
  val basic_domain : xml -> ((char list), (nat -> domain)) sum
  val interpretation_type : xml -> ((char list), domain) sum
  val interpretation :
    (xml -> ((char list), 'a) sum) -> xml -> ((char list), 'a redpair) sum
  val redpair :
    (xml -> ((char list), 'a) sum) -> xml -> ((char list), 'a redpair) sum
  val length_unique : 'a eq -> 'a list -> nat
  type certificationResult = Certified of char list | Error of char list
  val shows_lpo_repr :
    'a show -> (('a * nat) * nat) list -> char list -> char list
  val vars_term_list : 'b eq -> ('a, 'b) term -> 'b list
  val enum_vectors : 'a list -> 'b list -> (('b * 'a) list) list
  val assign_from_vector : 'a eq -> ('a * 'b) list -> 'a -> 'b
  val eq_lab : 'a eq -> 'b eq -> ('a, 'b) lab -> ('a, 'b) lab -> bool
  val eq_laba : 'a eq -> 'b eq -> ('a, 'b) lab eq
  val shows_lab : 'a show -> 'b show -> ('a, 'b) lab -> char list -> char list
  val shows_prec_lab :
    'a show -> 'b show -> nat -> ('a, 'b) lab -> char list -> char list
  val shows_list_lab :
    'a show -> 'b show -> ('a, 'b) lab list -> char list -> char list
  val show_lab : 'a show -> 'b show -> ('a, 'b) lab show
  val labela : ('a, 'b) lab -> ('b, (('a, 'b) lab list)) sum -> ('a, 'b) lab
  val eval_lab :
    (('a, 'b) lab -> 'c list -> 'c) ->
      (('a, 'b) lab -> 'c list -> ('b, (('a, 'b) lab list)) sum) ->
        ('d -> 'c) -> (('a, 'b) lab, 'd) term -> 'c * (('a, 'b) lab, 'd) term
  val check_sl_rule_ass :
    'a eq * 'a show -> 'b eq * 'b show -> 'c eq * 'c show -> 'd eq * 'd show ->
      bool ->
        (('a, 'b) lab -> 'c list -> 'c) ->
          (('a, 'b) lab -> 'c list -> ('b, (('a, 'b) lab list)) sum) ->
            ((('a, 'b) lab, 'd) term * (('a, 'b) lab, 'd) term) list ->
              ('d -> 'c) ->
                (('a, 'b) lab, 'd) term * (('a, 'b) lab, 'd) term ->
                  ((char list -> char list), unit) sum
  val check_sl_rule :
    'a eq * 'a show -> 'b eq * 'b show -> 'c eq * 'c show -> 'd eq * 'd show ->
      (('a, 'b) lab -> 'c list -> 'c) ->
        (('a, 'b) lab -> 'c list -> ('b, (('a, 'b) lab list)) sum) ->
          'c list ->
            bool ->
              ((('a, 'b) lab, 'd) term * (('a, 'b) lab, 'd) term) list ->
                (('a, 'b) lab, 'd) term * (('a, 'b) lab, 'd) term ->
                  ((char list -> char list), unit) sum
  val check_sl_model_lab_trs :
    'a eq * 'a show -> 'b eq * 'b show -> 'c eq * 'c show -> 'd eq * 'd show ->
      (('a, 'b) lab -> 'c list -> 'c) ->
        (('a, 'b) lab -> 'c list -> ('b, (('a, 'b) lab list)) sum) ->
          'c list ->
            ((('a, 'b) lab, 'd) term * (('a, 'b) lab, 'd) term) list ->
              ((('a, 'b) lab, 'd) term * (('a, 'b) lab, 'd) term) list ->
                ((char list -> char list), unit) sum
  val rl_fun : 'a -> 'b -> ('c, 'b) sum
  val rl_inter_list : 'a eq -> 'a list -> 'a -> 'a -> 'b -> 'a
  val check_sl_lab_trs :
    'a eq * 'a show -> 'b eq * 'b show -> 'c eq * 'c show -> 'd eq * 'd show ->
      (('a, 'b) lab -> 'c list -> 'c) ->
        (('a, 'b) lab -> 'c list -> ('b, (('a, 'b) lab list)) sum) ->
          'c list ->
            ((('a, 'b) lab, 'd) term * (('a, 'b) lab, 'd) term) list ->
              ((('a, 'b) lab, 'd) term * (('a, 'b) lab, 'd) term) list ->
                ((char list -> char list), unit) sum
  val get_lab : ('a, 'b) lab -> ('b, (('a, 'b) lab list)) sum
  val unlab : ('a, 'b) lab -> ('a, 'b) lab
  val check_sl_only_lab_and_decr :
    'a eq * 'a show -> 'b eq * 'b show -> 'c eq * 'c show ->
      (('a, (('b, 'a) lab list)) sum * ('a, (('b, 'a) lab list)) sum -> bool) ->
        ((('b, 'a) lab, 'c) term * (('b, 'a) lab, 'c) term) list ->
          ((('b, 'a) lab, 'c) term * (('b, 'a) lab, 'c) term) list ->
            ((char list -> char list), unit) sum
  val check_sem_lab_tt :
    'a eq * 'a show -> 'b eq * 'b show -> 'c eq * 'c show ->
      (((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list ->
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list ->
          ((char list -> char list), unit) sum) ->
        (((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list ->
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list ->
            ((char list -> char list), unit) sum) ->
          (('b, (('a, 'b) lab list)) sum * ('b, (('a, 'b) lab list)) sum ->
            bool) ->
            (('a, 'b) lab -> 'd list -> 'd) ->
              (('a, 'b) lab -> 'd list -> ('b, (('a, 'b) lab list)) sum) ->
                ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list ->
                  ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list ->
                    ((char list -> char list), unit) sum
  val rl_tt :
    'a eq * 'a show -> 'b eq * 'b show ->
      ((('a, 'b) lab, (char list)) term *
        (('a, 'b) lab, (char list)) term) list ->
        ((('a, 'b) lab, (char list)) term *
          (('a, 'b) lab, (char list)) term) list ->
          ((char list -> char list), unit) sum
  val wf_terms_list : 'a eq -> ('a * nat) list -> ('a, 'b) term -> bool
  val rp_valid :
    ((char list -> char list), unit) sum *
      ((('a, 'b) term * ('a, 'b) term -> ((char list -> char list), unit) sum) *
        ((('a, 'b) term * ('a, 'b) term ->
           ((char list -> char list), unit) sum) *
          (('a -> nat -> nat -> bool) *
            (((char list -> char list), unit) sum *
              (char list -> char list))))) ->
      ((char list -> char list), unit) sum
  val funas_term_lista : ('a, 'b) term -> ('a * nat) list
  val funas_rule_list : ('a, 'b) term * ('a, 'b) term -> ('a * nat) list
  val funas_trs_list :
    'a eq -> (('a, 'b) term * ('a, 'b) term) list -> ('a * nat) list
  val arith_fun : xml -> ((char list), arithFun) sum
  val sl_inter :
    (xml -> ((char list), ('a, 'b) lab) sum) ->
      xml -> ((char list), (('a, 'b) sl_inter option)) sum
  val xml_term : 'a show -> 'b show -> ('a, 'b) term -> xml
  val supteq_list : ('a, 'b) term -> ('a, 'b) term list
  val dP_list :
    'a eq -> 'b eq ->
      (('a, 'b) term * ('a, 'b) term) list ->
        (('a shp, 'b) term * ('a shp, 'b) term) list
  val iD_list :
    (('a, 'b) term * ('a, 'b) term) list ->
      (('a shp, 'b) term * ('a shp, 'b) term) list
  type ('a, 'b) dPDisproof =
    DPLoop of
      ('a, 'b) term *
        (pos *
          ((('a, 'b) term * ('a, 'b) term) * (bool * ('a, 'b) term))) list *
        ('b * ('a, 'b) term) list * ('a, 'b) ctxt
    | DPRuleRemoval of
        (('a, 'b) term * ('a, 'b) term) list *
          (('a, 'b) term * ('a, 'b) term) list * ('a, 'b) dPDisproof
  type ('a, 'b) tRSDisproof =
    Loop of
      ('a, 'b) term *
        (pos * ((('a, 'b) term * ('a, 'b) term) * ('a, 'b) term)) list *
        ('b * ('a, 'b) term) list * ('a, 'b) ctxt
    | NotWellFormed |
    NTRuleRemoval of (('a, 'b) term * ('a, 'b) term) list * ('a, 'b) tRSDisproof
    | NTStringReversal of
        (('a, 'b) term * ('a, 'b) term) list * ('a, 'b) tRSDisproof
    | NTDPTrans of
        (('a shp, 'b) term * ('a shp, 'b) term) list * ('a shp, 'b) dPDisproof
  val indent : (char list -> char list) -> char list -> char list
  val check_rule_reflecting :
    'a eq * 'a show ->
      ('a, (char list)) ctxt list ->
        (('a, (char list)) term * ('a, (char list)) term) list ->
          ('a, (char list)) term * ('a, (char list)) term ->
            ((char list -> char list), unit) sum
  val check_rule_preserving :
    'a eq * 'a show ->
      ('a, (char list)) ctxt list ->
        (('a, (char list)) term * ('a, (char list)) term) list ->
          ('a, (char list)) term * ('a, (char list)) term ->
            ((char list -> char list), unit) sum
  val hole_at : 'a eq -> nat -> nat -> 'a -> ('a, 'b) ctxt -> bool
  val all_from_to_nat : (nat -> bool) -> nat -> nat -> bool
  val check_flat_ctxt_complete :
    'a eq * 'a show ->
      ('a, (char list)) ctxt list ->
        'a * nat -> ((char list -> char list), unit) sum
  val shows_prec_ctxt :
    'a show -> 'b show -> nat -> ('a, 'b) ctxt -> char list -> char list
  val is_flat_ctxt_list :
    'a eq -> 'b eq -> 'a list -> ('b * nat) list -> ('b, 'a) ctxt -> bool
  val check_is_flat_ctxt :
    'a eq * 'a show ->
      (char list) list ->
        ('a * nat) list ->
          ('a, (char list)) ctxt -> ((char list -> char list), unit) sum
  val check_flat_ctxt :
    'a eq * 'a show ->
      (char list) list ->
        ('a, (char list)) ctxt -> ((char list -> char list), unit) sum
  val fcc_tt :
    'a eq * 'a show ->
      (('a, (char list)) term * ('a, (char list)) term) list ->
        ('a, (char list)) ctxt list ->
          (('a, (char list)) term * ('a, (char list)) term) list ->
            ((char list -> char list), unit) sum
  val rp_strict :
    ((char list -> char list), unit) sum *
      ((('a, 'b) term * ('a, 'b) term -> ((char list -> char list), unit) sum) *
        ((('a, 'b) term * ('a, 'b) term ->
           ((char list -> char list), unit) sum) *
          (('a -> nat -> nat -> bool) *
            (((char list -> char list), unit) sum *
              (char list -> char list))))) ->
      ('a, 'b) term * ('a, 'b) term -> ((char list -> char list), unit) sum
  val pi_full : 'a -> nat -> nat -> bool
  val parse_text :
    char list -> ((char list), ((char list) option * char list)) sum
  val parse_attribute_value :
    char list -> ((char list), (char list * char list)) sum
  val parse_name : char list -> ((char list), (char list * char list)) sum
  val parse_attributes :
    char list -> ((char list), ((char list * char list) list * char list)) sum
  val parse_nodes : char list -> ((char list), (xml list * char list)) sum
  val parse_node : char list -> ((char list), (xml * char list)) sum
  val scan_upto :
    char list -> char list -> ((char list), (char list * char list)) sum
  val parse_header : char list -> ((char list), (char list * char list)) sum
  val remove_comments_aux : bool -> char list -> char list
  val remove_comments : char list -> char list
  val update_tokens :
    ('a list -> 'a list) -> 'a list -> ((char list), ('a list * 'a list)) sum
  val parse_doc : char list -> ((char list), (xmldoc * char list)) sum
  type 'a filtered = FPair of 'a * nat
  val xml_rules :
    'a show -> 'b show ->
      char list -> (('a, 'b) term * ('a, 'b) term) list -> xml
  val check_subseteq : 'a eq -> 'a list -> 'a list -> ('a, unit) sum
  val check_wf_trs :
    'a show -> 'b eq * 'b show ->
      (('a, 'b) term * ('a, 'b) term) list ->
        ((char list -> char list), unit) sum
  val check_DP :
    'a eq * 'a show -> 'b eq * 'b show ->
      (('a, 'b) term * ('a, 'b) term) list ->
        (('a shp, 'b) term * ('a shp, 'b) term) list ->
          ((char list -> char list), unit) sum
  val create_afI :
    'a eq -> 'b eq ->
      'a -> (('b * nat) * ('a * 'a list)) list -> 'b -> nat -> nat -> bool
  val check_sem_lab_proc :
    'a eq * 'a show -> 'b eq * 'b show -> 'c eq * 'c show ->
      (((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list ->
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list ->
          ((char list -> char list), unit) sum) ->
        (((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list ->
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list ->
            ((char list -> char list), unit) sum) ->
          (('b, (('a, 'b) lab list)) sum * ('b, (('a, 'b) lab list)) sum ->
            bool) ->
            (('a, 'b) lab -> 'd list -> 'd) ->
              (('a, 'b) lab -> 'd list -> ('b, (('a, 'b) lab list)) sum) ->
                ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list ->
                  ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list ->
                    ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list ->
                      ((('a, 'b) lab, 'c) term *
                        (('a, 'b) lab, 'c) term) list ->
                        ((char list -> char list), unit) sum
  val rl_proc :
    'a eq * 'a show -> 'b eq * 'b show ->
      ((('a, 'b) lab, (char list)) term *
        (('a, 'b) lab, (char list)) term) list ->
        ((('a, 'b) lab, (char list)) term *
          (('a, 'b) lab, (char list)) term) list ->
          ((('a, 'b) lab, (char list)) term *
            (('a, 'b) lab, (char list)) term) list ->
            ((('a, 'b) lab, (char list)) term *
              (('a, 'b) lab, (char list)) term) list ->
              ((char list -> char list), unit) sum
  val funas_term_list : 'a eq -> ('a, 'b) term -> ('a * nat) list
  val plain_name : xml -> ((char list), ((char list), (nat list)) lab) sum
  val sharp_name : xml -> ((char list), (char list) shp) sum
  type 'a ordered_semiring_0 =
    {semiring_0_ordered_semiring_0 : 'a semiring_0;
      ordered_ab_semigroup_ordered_semiring_0 : 'a ordered_ab_semigroup}
  type 'a ordered_semiring_1 =
    {semiring_1_ordered_semiring_1 : 'a semiring_1;
      ordered_semiring_0_ordered_semiring_1 : 'a ordered_semiring_0}
  type 'a poly_carrier =
    {comm_semiring_1_poly_carrier : 'a comm_semiring_1;
      ordered_semiring_1_poly_carrier : 'a ordered_semiring_1}
  val default_I : 'a poly_carrier -> 'a -> nat -> ((nat * nat) list * 'a) list
  val poly_power :
    'a eq -> 'b eq * 'b comm_semiring_1 ->
      (('a * nat) list * 'b) list -> nat -> (('a * nat) list * 'b) list
  val monom_subst :
    'b eq -> 'c eq * 'c comm_semiring_1 ->
      ('a -> (('b * nat) list * 'c) list) ->
        ('a * nat) list -> (('b * nat) list * 'c) list
  val poly_subst :
    'b eq -> 'c eq * 'c comm_semiring_1 ->
      ('a -> (('b * nat) list * 'c) list) ->
        (('a * nat) list * 'c) list -> (('b * nat) list * 'c) list
  val eval_term :
    'b eq * 'b poly_carrier -> 'c eq ->
      ('a -> nat -> ((nat * nat) list * 'b) list) ->
        ('a, 'c) term -> (('c * nat) list * 'b) list
  val poly_var : 'a eq -> (('a * nat) list * 'b) list -> 'a -> bool
  type ('a, 'b) relTRSDisproof =
    RelLoop of
      ('a, 'b) term *
        (pos *
          ((('a, 'b) term * ('a, 'b) term) * (bool * ('a, 'b) term))) list *
        ('b * ('a, 'b) term) list * ('a, 'b) ctxt
    | RelNotWellFormed |
    NTRelRuleRemoval of
      (('a, 'b) term * ('a, 'b) term) list *
        (('a, 'b) term * ('a, 'b) term) list * ('a, 'b) relTRSDisproof
    | RNotSN of ('a, 'b) tRSDisproof
  val get_comp_ge :
    ('a -> bool) *
      ('a * ('a * ('a * (('a -> 'a -> 'a) *
                          (('a -> 'a -> 'a) *
                            (('a -> 'a) *
                              (('a -> 'a -> bool) *
                                (('a -> 'a -> bool) *
                                  (bool *
                                    (char list *
                                      (('a -> bool) * ('a -> bool)))))))))))) ->
      'a -> 'a -> bool
  val show_pvars :
    'a eq * 'a show -> 'b show -> 'a -> ('b * 'a) list -> (char list) list
  type ('a, 'b, 'c) relTRSProof =
    RelRuleRemoval of
      ('a, 'b) lab redpair *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ('a, 'b, 'c) relTRSProof
    | RelSisEmpty of ('a, 'b, 'c) tRSProof |
    RelUnlab of
      ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ('a, 'b, 'c) relTRSProof
    | RelSemlab of
        ('a, 'b) sl_inter *
          (('a, 'b) lab -> nat list -> ('b, (('a, 'b) lab list)) sum) *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ('a, 'b, 'c) relTRSProof
    | RelRootlab of
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ('a, 'b, 'c) relTRSProof
    | RelRisEmpty
  type ('a, 'b, 'c) certificationProblem =
    TRSProof of (('a, 'c) term * ('a, 'c) term) list * ('a, 'b, 'c) tRSProof |
    TRSDisproof of (('a, 'c) term * ('a, 'c) term) list * ('a, 'c) tRSDisproof |
    RelTRSProof of
      ((('a, 'c) term * ('a, 'c) term) list *
        (('a, 'c) term * ('a, 'c) term) list) *
        ('a, 'b, 'c) relTRSProof
    | RelTRSDisproof of
        ((('a, 'c) term * ('a, 'c) term) list *
          (('a, 'c) term * ('a, 'c) term) list) *
          ('a, 'c) relTRSDisproof
  val block_term : 'a -> ('a, 'b) term -> ('a, 'b) term
  val block_rule :
    'a -> ('a, 'b) term * ('a, 'b) term -> ('a, 'b) term * ('a, 'b) term
  val check_superset_of_blocked :
    'a eq * 'a show ->
      'a -> (('a, (char list)) term * ('a, (char list)) term) list ->
              (('a, (char list)) term * ('a, (char list)) term) list ->
                ((char list -> char list), unit) sum
  val check_no_defined_root_defs :
    'a eq * 'a show -> 'b show ->
      ('a * nat) list -> ('a, 'b) term -> ((char list -> char list), unit) sum
  val check_no_var :
    'a show -> 'b show -> ('a, 'b) term -> ((char list -> char list), unit) sum
  val check_left_linear_trs :
    'a show ->
      (('a, (char list)) term * ('a, (char list)) term) list ->
        ((char list -> char list), unit) sum
  val remove_lab : ('a, 'b) lab -> 'a
  val funas_below_term_list : ('a, 'b) term -> ('a * nat) list
  val funas_below_rule_list : ('a, 'b) term * ('a, 'b) term -> ('a * nat) list
  val funas_below_trs_list :
    'a eq -> (('a, 'b) term * ('a, 'b) term) list -> ('a * nat) list
  val fcc_proc :
    'a eq * 'a show -> 'b eq * 'b show ->
      ((('a, 'b) lab, (char list)) term *
        (('a, 'b) lab, (char list)) term) list ->
        ((('a, 'b) lab, (char list)) term *
          (('a, 'b) lab, (char list)) term) list ->
          ('a, 'b) lab ->
            (('a, 'b) lab, (char list)) ctxt list ->
              ((('a, 'b) lab, (char list)) term *
                (('a, 'b) lab, (char list)) term) list ->
                ((('a, 'b) lab, (char list)) term *
                  (('a, 'b) lab, (char list)) term) list ->
                  ((char list -> char list), unit) sum
  val get_arg : ('a, 'b) term -> nat -> ('a, 'b) term
  val ctxt_of_pos_term : pos -> ('a, 'b) term -> ('a, 'b) ctxt
  val subst_apply_term : ('a, 'b) term -> ('a, 'b) subst -> ('a, 'b) term
  val id_labeling :
    ('a, ('b list)) lab ->
      'b list -> (('b list), (('a, ('b list)) lab list)) sum
  val flat_contexts :
    (xml -> ((char list), 'a) sum) ->
      xml -> ((char list), (('a, (char list)) ctxt list)) sum
  val create_proj : 'a eq -> 'a projL -> 'a -> nat
  val projected_rseq :
    'a eq ->
      (xml -> ((char list), 'a) sum) ->
        ('a -> nat) ->
          xml ->
            ((char list),
              ((('a, (char list)) term * ('a, (char list)) term) *
                (pos *
                  ((('a, (char list)) term * ('a, (char list)) term) *
                    ('a, (char list)) term)) list))
              sum
  val xml1many2elements_gen :
    char list ->
      (xml -> ((char list), 'a) sum) ->
        ('a -> xml -> ((char list), 'b) sum) ->
          (xml -> ((char list), 'c) sum) ->
            (xml -> ((char list), 'd) sum) ->
              ('a -> 'b list -> 'c -> 'd -> 'e) -> xml -> ((char list), 'e) sum
  val ordering_constraint_proof :
    (xml -> ((char list), 'a) sum) -> xml -> ((char list), 'a redpair) sum
  val xml2dpProof :
    'a eq ->
      nat ->
        (nat -> xml -> ((char list), ('a, (nat list)) lab) sum) ->
          xml -> ((char list), ('a, (nat list), (char list)) dPProof) sum
  val shows_monom : 'a show -> ('a * nat) list -> char list -> char list
  val shows_poly :
    'a show -> 'b eq * 'b poly_carrier * 'b show ->
      (('a * nat) list * 'b) list -> char list -> char list
  val eval_monom : 'b comm_semiring_1 -> ('a -> 'b) -> ('a * nat) list -> 'b
  val eval_poly :
    'b comm_semiring_1 -> ('a -> 'b) -> (('a * nat) list * 'b) list -> 'b
  val shows_arctic : arctic -> char list -> char list
  val shows_prec_arctic : nat -> arctic -> char list -> char list
  val shows_list_arctic : arctic list -> char list -> char list
  val show_arctic : arctic show
  val lookup_rest :
    'a eq -> 'a -> ('a * 'b) list -> ('b * ('a * 'b) list) option
  val shows_lpoly :
    'a eq * 'a show -> 'b show ->
      'a -> 'a -> ('b, 'a) l_poly -> char list -> char list
  val lpo_nstrict_unbounded :
    'a eq * 'a show -> 'b eq * 'b show ->
      ('a -> nat -> nat) ->
        ('a, 'b) term * ('a, 'b) term -> ((char list -> char list), unit) sum
  val lpo_strict_unbounded :
    'a eq * 'a show -> 'b eq * 'b show ->
      ('a -> nat -> nat) ->
        ('a, 'b) term * ('a, 'b) term -> ((char list -> char list), unit) sum
  val create_LPO_redpair :
    'a show -> 'b eq * 'b show -> 'c eq * 'c show ->
      ((('a * nat) * nat) list -> 'b -> nat -> nat) ->
        (('a * nat) * nat) list ->
          ((char list -> char list), unit) sum *
            ((('b, 'c) term * ('b, 'c) term ->
               ((char list -> char list), unit) sum) *
              ((('b, 'c) term * ('b, 'c) term ->
                 ((char list -> char list), unit) sum) *
                (('b -> nat -> nat -> bool) *
                  (((char list -> char list), unit) sum *
                    (char list -> char list)))))
  val check_sem_lab_rel_tt :
    'a show -> 'b show -> 'c show ->
      (((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list ->
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list ->
          ((char list -> char list), unit) sum) ->
        (((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list ->
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list ->
            ((char list -> char list), unit) sum) ->
          (('b, (('a, 'b) lab list)) sum * ('b, (('a, 'b) lab list)) sum ->
            bool) ->
            (('a, 'b) lab -> 'd list -> 'd) ->
              (('a, 'b) lab -> 'd list -> ('b, (('a, 'b) lab list)) sum) ->
                ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
                  ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list ->
                  ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
                    ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list ->
                    ((char list -> char list), unit) sum
  val rl_rel_tt :
    'a eq * 'a show -> 'b eq * 'b show ->
      ((('a, 'b) lab, (char list)) term *
        (('a, 'b) lab, (char list)) term) list *
        ((('a, 'b) lab, (char list)) term *
          (('a, 'b) lab, (char list)) term) list ->
        ((('a, 'b) lab, (char list)) term *
          (('a, 'b) lab, (char list)) term) list *
          ((('a, 'b) lab, (char list)) term *
            (('a, 'b) lab, (char list)) term) list ->
          ((char list -> char list), unit) sum
  val matchList :
    'a eq ->
      (('a, 'b) term * ('a, 'b) term) list -> (('b * ('a, 'b) term) list) option
  val matchVars :
    'a eq -> 'b eq -> ('a * ('b, 'a) term) list -> ('b, 'a) subst option
  val apply_af_entry : 'a -> af_entry -> ('a, 'b) term list -> ('a, 'b) term
  val afs_term :
    ('a -> nat -> af_entry) -> ('a, 'b) term -> ('a filtered, 'b) term
  val xml2trsInput :
    (xml -> ((char list), 'a) sum) ->
      xml ->
        ((char list),
          ((('a, (char list)) term * ('a, (char list)) term) list *
            ((('a, (char list)) term * ('a, (char list)) term) list) option))
          sum
  val xml2trsProof :
    'a eq ->
      (xml -> ((char list), ('a, (nat list)) lab) sum) ->
        (xml -> ((char list), ('a, (nat list)) lab shp) sum) ->
          (nat ->
            xml ->
              ((char list), (('a, (nat list)) lab shp, (nat list)) lab) sum) ->
            xml -> ((char list), ('a, (nat list), (char list)) tRSProof) sum
  val search_len :
    char list -> char list -> nat -> (char list * char list) option
  val reverse_trs :
    (('a, 'b) term * ('a, 'b) term) list -> (('a, 'b) term * ('a, 'b) term) list
  val poly_split :
    'a eq -> 'b zero ->
      ('a * nat) list ->
        (('a * nat) list * 'b) list -> 'b * (('a * nat) list * 'b) list
  val fresh_strings_list :
    char list -> nat -> (char list) list -> nat -> (char list) list
  val subst_of : 'a eq -> ('a * ('b, 'a) term) list -> ('b, 'a) subst
  val check_pvarsI :
    'b eq ->
      'a -> ('a -> 'a -> bool) ->
              ('b * 'a) list -> ('b * 'a) list -> ('b, unit) sum
  val check_lpoly_sI :
    'a eq * 'a show -> 'b eq * 'b show ->
      bool ->
        'a -> 'a -> ('a -> 'a -> bool) ->
                      ('a -> 'a -> bool) ->
                        ('b, 'a) l_poly ->
                          ('b, 'a) l_poly ->
                            ((char list -> char list), unit) sum
  val check_polo_sI :
    'a eq * 'a show -> 'b show -> 'c eq * 'c show ->
      bool ->
        'a -> 'a -> ('a -> 'a -> 'a) ->
                      ('a -> 'a -> 'a) ->
                        ('a -> 'a) ->
                          ('a -> 'a -> bool) ->
                            ('a -> 'a -> bool) ->
                              ('b -> nat -> 'a * 'a list) ->
                                ('b, 'c) term * ('b, 'c) term ->
                                  ((char list -> char list), unit) sum
  val get_comp_max0 :
    ('a -> bool) *
      ('a * ('a * ('a * (('a -> 'a -> 'a) *
                          (('a -> 'a -> 'a) *
                            (('a -> 'a) *
                              (('a -> 'a -> bool) *
                                (('a -> 'a -> bool) *
                                  (bool *
                                    (char list *
                                      (('a -> bool) * ('a -> bool)))))))))))) ->
      'a -> 'a
  val lpo_repr_to_pr :
    'a eq -> (('a * nat) * nat) list -> 'a filtered -> nat -> nat
  val filtered_fun : 'a filtered -> 'a
  val shows_prec_filtered :
    'a show -> nat -> 'a filtered -> char list -> char list
  val shows_list_filtered :
    'a show -> 'a filtered list -> char list -> char list
  val show_filtered : 'a show -> 'a filtered show
  val eq_filtered : 'a eq -> 'a filtered -> 'a filtered -> bool
  val eq_filtereda : 'a eq -> 'a filtered eq
  val shows_afs :
    'a show -> (('a * nat) * af_entry) list -> char list -> char list
  val check_mono_afs_help : 'a show -> ('a * 'b) * 'c -> char list -> char list
  val mono_af_entry : nat -> af_entry -> bool
  val check_mono_afs :
    'a show ->
      (('a * nat) * af_entry) list -> ((char list -> char list), unit) sum
  val rp_non_strict :
    ((char list -> char list), unit) sum *
      ((('a, 'b) term * ('a, 'b) term -> ((char list -> char list), unit) sum) *
        ((('a, 'b) term * ('a, 'b) term ->
           ((char list -> char list), unit) sum) *
          (('a -> nat -> nat -> bool) *
            (((char list -> char list), unit) sum *
              (char list -> char list))))) ->
      ('a, 'b) term * ('a, 'b) term -> ((char list -> char list), unit) sum
  val afs_check :
    'a show -> 'b show ->
      (char list -> char list) ->
        ('a -> nat -> af_entry) ->
          (('a filtered, 'b) term * ('a filtered, 'b) term ->
            ((char list -> char list), unit) sum) ->
            ('a, 'b) term * ('a, 'b) term ->
              ((char list -> char list), unit) sum
  val check_wf_afs :
    'a show ->
      (('a * nat) * af_entry) list -> ((char list -> char list), unit) sum
  val default_af_entry : nat -> af_entry
  val afs_list_to_afs :
    'a eq -> (('a * nat) * af_entry) list -> 'a -> nat -> af_entry
  val afs_list_to_af :
    'a eq -> (('a * nat) * af_entry) list -> 'a -> nat -> nat -> bool
  val af_redpair :
    'a eq * 'a show -> 'b show ->
      (('a * nat) * af_entry) list ->
        ((char list -> char list), unit) sum *
          ((('a filtered, 'b) term * ('a filtered, 'b) term ->
             ((char list -> char list), unit) sum) *
            ((('a filtered, 'b) term * ('a filtered, 'b) term ->
               ((char list -> char list), unit) sum) *
              (('a filtered -> nat -> nat -> bool) *
                (((char list -> char list), unit) sum *
                  (char list -> char list))))) ->
          ((char list -> char list), unit) sum *
            ((('a, 'b) term * ('a, 'b) term ->
               ((char list -> char list), unit) sum) *
              ((('a, 'b) term * ('a, 'b) term ->
                 ((char list -> char list), unit) sum) *
                (('a -> nat -> nat -> bool) *
                  (((char list -> char list), unit) sum *
                    (char list -> char list)))))
  val shows_arctic_rat : arctic_rat -> char list -> char list
  val shows_prec_arctic_rat : nat -> arctic_rat -> char list -> char list
  val shows_list_arctic_rat : arctic_rat list -> char list -> char list
  val show_arctic_rat : arctic_rat show
  val faulty_redpair_impl :
    'a show -> 'b show ->
      char list ->
        ((char list -> char list), unit) sum *
          ((('a, 'b) term * ('a, 'b) term ->
             ((char list -> char list), unit) sum) *
            ((('a, 'b) term * ('a, 'b) term ->
               ((char list -> char list), unit) sum) *
              (('a -> nat -> nat -> bool) *
                (((char list -> char list), unit) sum *
                  (char list -> char list)))))
  val ordered_semiring_0_rat : rat ordered_semiring_0
  val ordered_semiring_1_rat : rat ordered_semiring_1
  val poly_carrier_rat : rat poly_carrier
  val ordered_semiring_0_int : Big_int.big_int ordered_semiring_0
  val ordered_semiring_1_int : Big_int.big_int ordered_semiring_1
  val poly_carrier_int : Big_int.big_int poly_carrier
  val check_monom_strict_mono : 'a eq -> bool -> ('a * nat) list -> 'a -> bool
  val check_poly_strict_mono :
    'a eq -> 'b poly_carrier ->
      bool -> (('a * nat) list * 'b) list -> 'a -> bool
  val check_poly_ge :
    'a eq -> 'b ordered_semiring_0 ->
      (('a * nat) list * 'b) list -> (('a * nat) list * 'b) list -> bool
  val check_poly_gt :
    'a ordered_semiring_0 -> 'b eq ->
      ('a -> 'a -> bool) ->
        (('b * nat) list * 'a) list -> (('b * nat) list * 'a) list -> bool
  val check_poly_strict_mono_discrete :
    'a eq * 'a poly_carrier -> 'b eq ->
      ('a -> 'a -> bool) -> (('b * nat) list * 'a) list -> 'b -> bool
  val check_poly_strict_mono_smart :
    'a eq * 'a poly_carrier -> 'b eq ->
      bool ->
        bool -> ('a -> 'a -> bool) -> (('b * nat) list * 'a) list -> 'b -> bool
  val poly_inter_to_af :
    ('a -> nat -> ((nat * nat) list * 'b) list) -> 'a -> nat -> nat -> bool
  val check_poly_weak_mono_all :
    'b ordered_semiring_0 -> (('a * nat) list * 'b) list -> bool
  val poly_vars_list : 'a eq -> (('a * nat) list * 'b) list -> 'a list
  val check_poly_weak_mono_discrete :
    'a eq -> 'b eq * 'b poly_carrier ->
      (('a * nat) list * 'b) list -> 'a -> bool
  val check_poly_weak_mono_and_pos :
    'a eq -> 'b eq * 'b poly_carrier ->
      bool -> (('a * nat) list * 'b) list -> bool
  val check_poly_inter_list :
    'b eq * 'b poly_carrier ->
      bool ->
        (('a * nat) * ((nat * nat) list * 'b) list) list ->
          (('a * ((nat * nat) list * 'b) list), unit) sum
  val poly_inter_list_to_inter :
    'a poly_carrier -> 'b eq ->
      'a -> (('b * nat) * ((nat * nat) list * 'a) list) list ->
              'b -> nat -> ((nat * nat) list * 'a) list
  val create_nlpoly_redpair :
    'a eq * 'a poly_carrier * 'a show -> 'b eq * 'b show -> 'c eq * 'c show ->
      'a -> ('a -> 'a -> bool) ->
              bool ->
                bool ->
                  (('b * nat) * ((nat * nat) list * 'a) list) list ->
                    ((char list -> char list), unit) sum *
                      ((('b, 'c) term * ('b, 'c) term ->
                         ((char list -> char list), unit) sum) *
                        ((('b, 'c) term * ('b, 'c) term ->
                           ((char list -> char list), unit) sum) *
                          (('b -> nat -> nat -> bool) *
                            (((char list -> char list), unit) sum *
                              (char list -> char list)))))
  val to_lpoly_inter :
    'b eq ->
      'a -> 'a -> (('b * nat) * ('a * 'a list)) list ->
                    'b -> nat -> 'a * 'a list
  val create_lpoly_repr :
    'a eq * 'a show -> 'b eq * 'b show ->
      ('a -> bool) *
        ('a * ('a * ('a * (('a -> 'a -> 'a) *
                            (('a -> 'a -> 'a) *
                              (('a -> 'a) *
                                (('a -> 'a -> bool) *
                                  (('a -> 'a -> bool) *
                                    (bool *
                                      (char list *
(('a -> bool) * ('a -> bool)))))))))))) ->
        (('b * nat) * ('a * 'a list)) list -> char list -> char list
  val check_poly_monoI :
    'a show -> 'b show ->
      'a -> ('a -> 'a -> bool) ->
              ('a -> bool) ->
                (('b * nat) * ('a * 'a list)) list ->
                  ((char list -> char list), unit) sum
  val check_lpoly_nsI :
    'a eq * 'a show -> 'b eq * 'b show ->
      'a -> 'a -> ('a -> 'a -> bool) ->
                    ('b, 'a) l_poly ->
                      ('b, 'a) l_poly -> ((char list -> char list), unit) sum
  val check_polo_nsI :
    'a eq * 'a show -> 'b show -> 'c eq * 'c show ->
      'a -> 'a -> ('a -> 'a -> 'a) ->
                    ('a -> 'a -> 'a) ->
                      ('a -> 'a) ->
                        ('a -> 'a -> bool) ->
                          ('b -> nat -> 'a * 'a list) ->
                            ('b, 'c) term * ('b, 'c) term ->
                              ((char list -> char list), unit) sum
  val get_comp_wf_elem :
    ('a -> bool) *
      ('a * ('a * ('a * (('a -> 'a -> 'a) *
                          (('a -> 'a -> 'a) *
                            (('a -> 'a) *
                              (('a -> 'a -> bool) *
                                (('a -> 'a -> bool) *
                                  (bool *
                                    (char list *
                                      (('a -> bool) * ('a -> bool)))))))))))) ->
      'a -> bool
  val check_lpoly_coeffs :
    'a show -> 'b show ->
      ('a -> bool) ->
        ('a -> bool) ->
          ('a -> bool) ->
            (('b * nat) * ('a * 'a list)) list ->
              ((char list -> char list), unit) sum
  val create_poly_redpair :
    'a eq * 'a show -> 'b eq * 'b show -> 'c eq * 'c show ->
      ((('a * nat) * ('b * 'b list)) list ->
        ((char list -> char list), unit) sum) ->
        ('b -> bool) *
          ('b * ('b * ('b * (('b -> 'b -> 'b) *
                              (('b -> 'b -> 'b) *
                                (('b -> 'b) *
                                  (('b -> 'b -> bool) *
                                    (('b -> 'b -> bool) *
                                      (bool *
(char list * (('b -> bool) * ('b -> bool)))))))))))) ->
          (('a * nat) * ('b * 'b list)) list ->
            ((char list -> char list), unit) sum *
              ((('a, 'c) term * ('a, 'c) term ->
                 ((char list -> char list), unit) sum) *
                ((('a, 'c) term * ('a, 'c) term ->
                   ((char list -> char list), unit) sum) *
                  (('a -> nat -> nat -> bool) *
                    (((char list -> char list), unit) sum *
                      (char list -> char list)))))
  val get_redpair :
    'a eq * 'a show -> 'b eq * 'b show ->
      'a redpair ->
        ((char list -> char list), unit) sum *
          ((('a, 'b) term * ('a, 'b) term ->
             ((char list -> char list), unit) sum) *
            ((('a, 'b) term * ('a, 'b) term ->
               ((char list -> char list), unit) sum) *
              (('a -> nat -> nat -> bool) *
                (((char list -> char list), unit) sum *
                  (char list -> char list)))))
  val rev_term : ('a, 'b) ctxt -> ('a, 'b) term -> ('a, 'b) term
  val rev_rule : ('a, 'b) term * ('a, 'b) term -> ('a, 'b) term * ('a, 'b) term
  val match_list :
    'a eq -> 'b eq ->
      (('a, 'b) term * ('a, 'b) term) list -> ('a, 'b) subst option
  val doc_of_string : char list -> ((char list), xmldoc) sum
  val starts_with : char list -> char list -> bool
  val check_pairwise : ('a -> 'a -> ('b, unit) sum) -> 'a list -> ('b, unit) sum
  val check_graph_decomp :
    ('a -> char list -> char list) ->
      ('a * 'a -> bool) ->
        (bool * 'a list) list -> ((char list -> char list), unit) sum
  val check_DPs :
    'a eq * 'a show -> 'b eq * 'b show ->
      (('a, 'b) term * ('a, 'b) term) list ->
        (('a shp, 'b) term * ('a shp, 'b) term) list ->
          ((('a shp, 'b) term * ('a shp, 'b) term), unit) sum
  val sharp_lab_name :
    xml -> ((char list), ((char list), (nat list)) lab shp) sum
  val lab_sharp_name :
    nat ->
      xml ->
        ((char list), (((char list), (nat list)) lab shp, (nat list)) lab) sum
  val xml2dpDisproof :
    (xml -> ((char list), 'a) sum) ->
      xml -> ((char list), ('a, (char list)) dPDisproof) sum
  val xml2trsDisproof :
    (xml -> ((char list), 'a) sum) ->
      (xml -> ((char list), 'a shp) sum) ->
        xml -> ((char list), ('a, (char list)) tRSDisproof) sum
  val xml2relTrsDisproof :
    (xml -> ((char list), 'a) sum) ->
      (xml -> ((char list), 'a shp) sum) ->
        xml -> ((char list), ('a, (char list)) relTRSDisproof) sum
  val xml2relTrsProof :
    'a eq ->
      (xml -> ((char list), ('a, (nat list)) lab) sum) ->
        (xml -> ((char list), ('a, (nat list)) lab shp) sum) ->
          (nat ->
            xml ->
              ((char list), (('a, (nat list)) lab shp, (nat list)) lab) sum) ->
            xml -> ((char list), ('a, (nat list), (char list)) relTRSProof) sum
  val xml2certProblem :
    'a eq ->
      (xml -> ((char list), 'a) sum) ->
        (xml -> ((char list), 'a shp) sum) ->
          (xml -> ((char list), ('a, (nat list)) lab) sum) ->
            (xml -> ((char list), ('a, (nat list)) lab shp) sum) ->
              (nat ->
                xml ->
                  ((char list), (('a, (nat list)) lab shp, (nat list)) lab)
                    sum) ->
                xml ->
                  ((char list),
                    ('a, (nat list), (char list)) certificationProblem)
                    sum
  val xmldoc2certProblem :
    xmldoc ->
      ((char list), ((char list), (nat list), (char list)) certificationProblem)
        sum
  val parseCertProblem :
    char list ->
      ((char list), ((char list), (nat list), (char list)) certificationProblem)
        sum
  val extract_input_proof :
    char list -> (char list * (char list * char list)) option
  val check_wf_rel_trs :
    'a show -> 'b eq * 'b show ->
      (('a, 'b) term * ('a, 'b) term) list *
        (('a, 'b) term * ('a, 'b) term) list ->
        ((char list -> char list), unit) sum
  val check_not_wf_rel_trs :
    'a show -> 'b eq * 'b show ->
      (('a, 'b) term * ('a, 'b) term) list *
        (('a, 'b) term * ('a, 'b) term) list ->
        ((char list -> char list), unit) sum
  val shows_pos : pos -> char list -> char list
  val shows_prec_pos : nat -> pos -> char list -> char list
  val instance_rule :
    'a eq -> 'b eq ->
      ('a, 'b) term * ('a, 'b) term -> ('a, 'b) term * ('a, 'b) term -> bool
  val eq_rule_mod_vars :
    'a eq -> 'b eq ->
      ('a, 'b) term * ('a, 'b) term -> ('a, 'b) term * ('a, 'b) term -> bool
  val check_rstep :
    'a eq * 'a show -> 'b eq * 'b show ->
      (('a, 'b) term * ('a, 'b) term) list ->
        pos ->
          ('a, 'b) term * ('a, 'b) term ->
            ('a, 'b) term ->
              ('a, 'b) term -> ((char list -> char list), unit) sum
  val check_rrstep :
    'a eq * 'a show -> 'b eq * 'b show ->
      (('a, 'b) term * ('a, 'b) term) list ->
        ('a, 'b) term * ('a, 'b) term ->
          ('a, 'b) term -> ('a, 'b) term -> ((char list -> char list), unit) sum
  val check_steps :
    'a eq * 'a show -> 'b eq * 'b show ->
      (('a, 'b) term * ('a, 'b) term) list ->
        (('a, 'b) term * ('a, 'b) term) list ->
          (pos *
            ((('a, 'b) term * ('a, 'b) term) * (bool * ('a, 'b) term))) list ->
            ('a, 'b) term ->
              ('a, 'b) term -> ((char list -> char list), unit) sum
  val check_rsteps :
    'a eq * 'a show -> 'b eq * 'b show ->
      (('a, 'b) term * ('a, 'b) term) list ->
        (pos * ((('a, 'b) term * ('a, 'b) term) * ('a, 'b) term)) list ->
          ('a, 'b) term -> ('a, 'b) term -> ((char list -> char list), unit) sum
  val check_loop :
    'a eq * 'a show -> 'b eq * 'b show ->
      ('a, 'b) term ->
        (pos * ((('a, 'b) term * ('a, 'b) term) * ('a, 'b) term)) list ->
          ('b * ('a, 'b) term) list ->
            ('a, 'b) ctxt ->
              (('a, 'b) term * ('a, 'b) term) list ->
                ((char list -> char list), unit) sum
  val check_dp_loop :
    'a eq * 'a show -> 'b eq * 'b show ->
      ('a, 'b) term ->
        (pos *
          ((('a, 'b) term * ('a, 'b) term) * (bool * ('a, 'b) term))) list ->
          ('b * ('a, 'b) term) list ->
            ('a, 'b) ctxt ->
              (('a, 'b) term * ('a, 'b) term) list ->
                (('a, 'b) term * ('a, 'b) term) list ->
                  ((char list -> char list), unit) sum
  val check_dp_disproof :
    'a eq * 'a show -> 'b eq * 'b show ->
      (char list -> char list) ->
        (('a, 'b) term * ('a, 'b) term) list ->
          (('a, 'b) term * ('a, 'b) term) list ->
            ('a, 'b) dPDisproof -> ((char list -> char list), unit) sum
  val unary_term : ('a, 'b) term -> bool
  val check_unary_signature :
    (('a, 'b) term * ('a, 'b) term) list -> ((char list -> char list), unit) sum
  val check_string_rev :
    'a eq * 'a show -> 'b eq * 'b show ->
      (('a, 'b) term * ('a, 'b) term) list ->
        (('a, 'b) term * ('a, 'b) term) list ->
          ((char list -> char list), unit) sum
  val check_not_wf_trs :
    'a show -> 'b eq * 'b show ->
      (('a, 'b) term * ('a, 'b) term) list ->
        ((char list -> char list), unit) sum
  val checkTRSDisproof :
    'a eq * 'a show -> 'b eq * 'b show ->
      (char list -> char list) ->
        (('a, 'b) term * ('a, 'b) term) list ->
          ('a, 'b) tRSDisproof -> ((char list -> char list), unit) sum
  val check_rel_seq :
    'a eq * 'a show -> 'b eq * 'b show ->
      (('a, 'b) term * ('a, 'b) term) list ->
        (('a, 'b) term * ('a, 'b) term) list ->
          (pos *
            ((('a, 'b) term * ('a, 'b) term) * (bool * ('a, 'b) term))) list ->
            ('a, 'b) term ->
              ('a, 'b) term -> bool -> ((char list -> char list), unit) sum
  val check_rel_loop :
    'a eq * 'a show -> 'b eq * 'b show ->
      ('a, 'b) term ->
        (pos *
          ((('a, 'b) term * ('a, 'b) term) * (bool * ('a, 'b) term))) list ->
          ('b * ('a, 'b) term) list ->
            ('a, 'b) ctxt ->
              (('a, 'b) term * ('a, 'b) term) list ->
                (('a, 'b) term * ('a, 'b) term) list ->
                  ((char list -> char list), unit) sum
  val checkRelTRSDisproof :
    'a eq * 'a show -> 'b eq * 'b show ->
      (char list -> char list) ->
        (('a, 'b) term * ('a, 'b) term) list *
          (('a, 'b) term * ('a, 'b) term) list ->
          ('a, 'b) relTRSDisproof -> ((char list -> char list), unit) sum
  val shows_arithFun : arithFun -> char list -> char list
  val shows_prec_arithFun : nat -> arithFun -> char list -> char list
  val shows_sl_inter :
    'a show -> 'b show -> ('a, 'b) sl_inter -> char list -> char list
  val shows_prec_sl_inter :
    'a show -> 'b show -> nat -> ('a, 'b) sl_inter -> char list -> char list
  val take_default : 'a -> 'a list -> nat -> 'a
  val eval_arithFun_unbound : nat list -> arithFun -> nat
  val eval_arithFun : nat -> arithFun -> nat list -> nat
  val sl_inter_to_inter :
    'a eq -> 'b eq -> ('a, 'b) sl_inter -> ('a, 'b) lab -> nat list -> nat
  val get_largest_element : ('a, 'b) sl_inter -> nat
  val create_sem_lab_rel_tt :
    'a eq * 'a show -> 'b eq * 'b show -> 'c eq * 'c show ->
      ('a, 'b) sl_inter ->
        (('a, 'b) lab -> nat list -> ('b, (('a, 'b) lab list)) sum) ->
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
            ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list ->
            ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
              ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list ->
              ((char list -> char list), unit) sum
  val unlab_reltrs_tt :
    'a eq * 'a show -> 'b eq * 'b show -> 'c eq * 'c show ->
      ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list ->
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list ->
          ((char list -> char list), unit) sum
  val internal_error : char list -> char list
  val check_relative_rule_removal :
    'a eq * 'a show -> 'b eq * 'b show ->
      ((char list -> char list), unit) sum *
        ((('a, 'b) term * ('a, 'b) term ->
           ((char list -> char list), unit) sum) *
          ((('a, 'b) term * ('a, 'b) term ->
             ((char list -> char list), unit) sum) *
            (('a -> nat -> nat -> bool) *
              (((char list -> char list), unit) sum *
                (char list -> char list))))) ->
        (('a, 'b) term * ('a, 'b) term) list *
          (('a, 'b) term * ('a, 'b) term) list ->
          (('a, 'b) term * ('a, 'b) term) list *
            (('a, 'b) term * ('a, 'b) term) list ->
            ((char list -> char list), unit) sum
  val create_sem_lab_tt :
    'a eq * 'a show -> 'b eq * 'b show -> 'c eq * 'c show ->
      ('a, 'b) sl_inter ->
        (('a, 'b) lab -> nat list -> ('b, (('a, 'b) lab list)) sum) ->
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list ->
            ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list ->
              ((char list -> char list), unit) sum
  val unlab_of_trsI :
    'a eq -> 'b eq -> 'c eq ->
      ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list ->
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list
  val unlab_trs_tt :
    'a eq * 'a show -> 'b eq * 'b show -> 'c eq * 'c show ->
      ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list ->
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list ->
          ((char list -> char list), unit) sum
  val check_rule_removal_proc :
    'a eq * 'a show -> 'b eq * 'b show ->
      ((char list -> char list), unit) sum *
        ((('a, 'b) term * ('a, 'b) term ->
           ((char list -> char list), unit) sum) *
          ((('a, 'b) term * ('a, 'b) term ->
             ((char list -> char list), unit) sum) *
            (('a -> nat -> nat -> bool) *
              (((char list -> char list), unit) sum *
                (char list -> char list))))) ->
        (('a, 'b) term * ('a, 'b) term) list ->
          (('a, 'b) term * ('a, 'b) term) list ->
            ((char list -> char list), unit) sum
  val computeRuleMapH :
    'a eq ->
      (('a, 'b) term * ('a, 'b) term) list ->
        ((('a * nat) * (('a, 'b) term * ('a, 'b) term) list) list) option
  val computeRuleMap :
    'a eq ->
      (('a, 'b) term * ('a, 'b) term) list ->
        ('a * nat -> (('a, 'b) term * ('a, 'b) term) list) option
  val init_lab : 'a -> ('a, 'b) lab
  val check_no_defined_root :
    'a show -> 'b show ->
      ('a * nat -> (('a, 'b) term * ('a, 'b) term) list) ->
        ('a, 'b) term -> ((char list -> char list), unit) sum
  val matchCapRMBelow :
    'a eq -> 'b eq ->
      ('a, 'b) term ->
        ('a * nat -> (('a, 'b) term * ('a, 'b) term) list) option ->
          ('a, 'b) term -> bool
  val forallm_index_aux :
    ('a -> nat -> ('b, unit) sum) ->
      nat -> 'a list -> ((('a * nat) * 'b), unit) sum
  val forallm_index :
    ('a -> nat -> ('b, unit) sum) -> 'a list -> ((('a * nat) * 'b), unit) sum
  val check_ur_closed_term_rm_af :
    'a eq * 'a show -> 'b eq * 'b show ->
      ('a * nat -> (('a, 'b) term * ('a, 'b) term) list) ->
        (('a, 'b) term * ('a, 'b) term) list ->
          ('a -> nat -> nat -> bool) ->
            ('a, 'b) term -> ((char list -> char list), unit) sum
  val check_sct_ur_af_proc :
    'a eq * 'a show -> 'b eq * 'b show ->
      ((char list -> char list), unit) sum *
        ((('a, 'b) term * ('a, 'b) term ->
           ((char list -> char list), unit) sum) *
          ((('a, 'b) term * ('a, 'b) term ->
             ((char list -> char list), unit) sum) *
            (('a -> nat -> nat -> bool) *
              (((char list -> char list), unit) sum *
                (char list -> char list))))) ->
        (('a, 'b) term * ('a, 'b) term) list ->
          ((('a, 'b) term * ('a, 'b) term) *
            ((nat * nat) list * (nat * nat) list)) list ->
            ('a * nat -> (('a, 'b) term * ('a, 'b) term) list) option ->
              ('a * nat -> (('a, 'b) term * ('a, 'b) term) list) option ->
                (('a, 'b) term * ('a, 'b) term) list ->
                  ((char list -> char list), unit) sum
  val check_supteq :
    'a eq * 'a show -> 'b eq * 'b show ->
      ('a, 'b) term -> ('a, 'b) term -> ((char list -> char list), unit) sum
  val check_supt :
    'a eq * 'a show -> 'b eq * 'b show ->
      ('a, 'b) term -> ('a, 'b) term -> ((char list -> char list), unit) sum
  val check_sct_subterm_proc :
    'a eq * 'a show -> 'b eq * 'b show ->
      (('a, 'b) term * ('a, 'b) term) list ->
        ((('a, 'b) term * ('a, 'b) term) *
          ((nat * nat) list * (nat * nat) list)) list ->
          ('a * nat -> (('a, 'b) term * ('a, 'b) term) list) option ->
            ('a * nat -> (('a, 'b) term * ('a, 'b) term) list) option ->
              ((char list -> char list), unit) sum
  val check_weak :
    'a eq * 'a show -> 'b eq * 'b show ->
      ('a -> nat) ->
        ('a, 'b) term * ('a, 'b) term -> ((char list -> char list), unit) sum
  val check_strict :
    'a eq * 'a show -> 'b eq * 'b show ->
      (('a, 'b) term * ('a, 'b) term) list ->
        (('a, 'b) term * ('a, 'b) term ->
          ((pos *
             ((('a, 'b) term * ('a, 'b) term) * ('a, 'b) term)) list) option) ->
          ('a -> nat) ->
            ('a, 'b) term * ('a, 'b) term ->
              ((char list -> char list), unit) sum
  val check_subterm_criterion_proc :
    'a eq * 'a show -> 'b eq * 'b show ->
      ('a -> nat) ->
        (('a, 'b) term * ('a, 'b) term ->
          ((pos *
             ((('a, 'b) term * ('a, 'b) term) * ('a, 'b) term)) list) option) ->
          (('a, 'b) term * ('a, 'b) term) list ->
            (('a, 'b) term * ('a, 'b) term) list ->
              (('a, 'b) term * ('a, 'b) term) list ->
                ('a * nat -> (('a, 'b) term * ('a, 'b) term) list) option ->
                  ((char list -> char list), unit) sum
  val create_rseq_map :
    'a eq -> 'b eq ->
      ((('a, 'b) term * ('a, 'b) term) *
        (pos * ((('a, 'b) term * ('a, 'b) term) * ('a, 'b) term)) list) list ->
        ('a, 'b) term * ('a, 'b) term ->
          ((pos *
             ((('a, 'b) term * ('a, 'b) term) * ('a, 'b) term)) list) option
  val create_subterm_criterion_proc :
    'a eq * 'a show -> 'b eq * 'b show ->
      'a projL ->
        ((('a, 'b) term * ('a, 'b) term) *
          (pos *
            ((('a, 'b) term * ('a, 'b) term) * ('a, 'b) term)) list) list ->
          (('a, 'b) term * ('a, 'b) term) list ->
            (('a, 'b) term * ('a, 'b) term) list ->
              (('a, 'b) term * ('a, 'b) term) list ->
                ('a * nat -> (('a, 'b) term * ('a, 'b) term) list) option ->
                  ((char list -> char list), unit) sum
  val create_sem_lab_proc :
    'a eq * 'a show -> 'b eq * 'b show -> 'c eq * 'c show ->
      ('a, 'b) sl_inter ->
        (('a, 'b) lab -> nat list -> ('b, (('a, 'b) lab list)) sum) ->
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list ->
            ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list ->
              ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list ->
                ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list ->
                  ((char list -> char list), unit) sum
  val check_unlab_proc :
    'a eq * 'a show -> 'b eq * 'b show -> 'c eq * 'c show ->
      ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list ->
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list ->
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list ->
            ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list ->
              ((char list -> char list), unit) sum
  val matchCapBelowI :
    'a eq -> 'b eq ->
      ('a, 'b) term ->
        (('a, 'b) term * ('a, 'b) term) list -> ('a, 'b) term -> bool
  val check_ur_closed_term_af :
    'a eq * 'a show -> 'b eq * 'b show ->
      (('a, 'b) term * ('a, 'b) term) list ->
        (('a, 'b) term * ('a, 'b) term) list ->
          ('a -> nat -> nat -> bool) ->
            ('a, 'b) term -> ((char list -> char list), unit) sum
  val check_ur_P_closed_af :
    'a eq * 'a show -> 'b eq * 'b show ->
      (('a, 'b) term * ('a, 'b) term) list ->
        (('a, 'b) term * ('a, 'b) term) list ->
          (('a, 'b) term * ('a, 'b) term) list ->
            ('a -> nat -> nat -> bool) -> ((char list -> char list), unit) sum
  val check_ur_P_closed_rm_af :
    'a eq * 'a show -> 'b eq * 'b show ->
      (('a, 'b) term * ('a, 'b) term) list ->
        ('a * nat -> (('a, 'b) term * ('a, 'b) term) list) option ->
          (('a, 'b) term * ('a, 'b) term) list ->
            (('a, 'b) term * ('a, 'b) term) list ->
              ('a -> nat -> nat -> bool) -> ((char list -> char list), unit) sum
  val check_mono_redpair_ur_proc :
    'a eq * 'a show -> 'b eq * 'b show ->
      ((char list -> char list), unit) sum *
        ((('a, 'b) term * ('a, 'b) term ->
           ((char list -> char list), unit) sum) *
          ((('a, 'b) term * ('a, 'b) term ->
             ((char list -> char list), unit) sum) *
            (('a -> nat -> nat -> bool) *
              (((char list -> char list), unit) sum *
                (char list -> char list))))) ->
        (('a, 'b) term * ('a, 'b) term) list ->
          (('a, 'b) term * ('a, 'b) term) list ->
            (('a, 'b) term * ('a, 'b) term) list ->
              ('a * nat -> (('a, 'b) term * ('a, 'b) term) list) option ->
                (('a, 'b) term * ('a, 'b) term) list ->
                  (('a, 'b) term * ('a, 'b) term) list ->
                    ((char list -> char list), unit) sum
  val check_mono_redpair_proc :
    'a eq * 'a show -> 'b eq * 'b show ->
      ((char list -> char list), unit) sum *
        ((('a, 'b) term * ('a, 'b) term ->
           ((char list -> char list), unit) sum) *
          ((('a, 'b) term * ('a, 'b) term ->
             ((char list -> char list), unit) sum) *
            (('a -> nat -> nat -> bool) *
              (((char list -> char list), unit) sum *
                (char list -> char list))))) ->
        (('a, 'b) term * ('a, 'b) term) list ->
          (('a, 'b) term * ('a, 'b) term) list ->
            (('a, 'b) term * ('a, 'b) term) list ->
              (('a, 'b) term * ('a, 'b) term) list ->
                ((char list -> char list), unit) sum
  val check_allm_gen_index :
    ('a -> nat -> nat) ->
      ('a -> nat -> ('b, unit) sum) -> nat -> 'a list -> ('b, unit) sum
  val check_dep_graph_proc :
    'a eq * 'a show -> 'b eq * 'b show ->
      (('a, 'b) term * ('a, 'b) term) list ->
        (bool * (('a, 'b) term * ('a, 'b) term) list) list ->
          ('a * nat -> (('a, 'b) term * ('a, 'b) term) list) option ->
            ('a * nat -> (('a, 'b) term * ('a, 'b) term) list) option ->
              ((char list -> char list), unit) sum
  val check_redpair_ur_af_proc :
    'a eq * 'a show -> 'b eq * 'b show ->
      ((char list -> char list), unit) sum *
        ((('a, 'b) term * ('a, 'b) term ->
           ((char list -> char list), unit) sum) *
          ((('a, 'b) term * ('a, 'b) term ->
             ((char list -> char list), unit) sum) *
            (('a -> nat -> nat -> bool) *
              (((char list -> char list), unit) sum *
                (char list -> char list))))) ->
        (('a, 'b) term * ('a, 'b) term) list ->
          (('a, 'b) term * ('a, 'b) term) list ->
            (('a, 'b) term * ('a, 'b) term) list ->
              ('a * nat -> (('a, 'b) term * ('a, 'b) term) list) option ->
                (('a, 'b) term * ('a, 'b) term) list ->
                  ((char list -> char list), unit) sum
  val check_redpair_proc :
    'a eq * 'a show -> 'b eq * 'b show ->
      ((char list -> char list), unit) sum *
        ((('a, 'b) term * ('a, 'b) term ->
           ((char list -> char list), unit) sum) *
          ((('a, 'b) term * ('a, 'b) term ->
             ((char list -> char list), unit) sum) *
            (('a -> nat -> nat -> bool) *
              (((char list -> char list), unit) sum *
                (char list -> char list))))) ->
        (('a, 'b) term * ('a, 'b) term) list ->
          (('a, 'b) term * ('a, 'b) term) list ->
            (('a, 'b) term * ('a, 'b) term) list ->
              ((char list -> char list), unit) sum
  val checkDPProof :
    'a eq * 'a show -> 'b eq * 'b show ->
      (char list -> char list) ->
        ((('a, 'b) lab, (char list)) term *
          (('a, 'b) lab, (char list)) term) list ->
          ((('a, 'b) lab, (char list)) term *
            (('a, 'b) lab, (char list)) term) list ->
            nat ->
              (('a, 'b) lab * nat ->
                ((('a, 'b) lab, (char list)) term *
                  (('a, 'b) lab, (char list)) term) list) option ->
                (('a, 'b) lab * nat ->
                  ((('a, 'b) lab, (char list)) term *
                    (('a, 'b) lab, (char list)) term) list) option ->
                  ('a, 'b, (char list)) dPProof ->
                    ((char list -> char list), unit) sum
  val checkTRSProof :
    'a eq * 'a show -> 'b eq * 'b show ->
      (char list -> char list) ->
        ((('a, 'b) lab, (char list)) term *
          (('a, 'b) lab, (char list)) term) list ->
          nat ->
            ('a, 'b, (char list)) tRSProof ->
              ((char list -> char list), unit) sum
  val checkRelTRSProof :
    'a eq * 'a show -> 'b eq * 'b show ->
      (char list -> char list) ->
        ((('a, 'b) lab, (char list)) term *
          (('a, 'b) lab, (char list)) term) list ->
          ((('a, 'b) lab, (char list)) term *
            (('a, 'b) lab, (char list)) term) list ->
            ('a, 'b, (char list)) relTRSProof ->
              ((char list -> char list), unit) sum
  val certifyCertProblem :
    'a eq * 'a show -> 'b eq * 'b show ->
      ('a, 'b, (char list)) certificationProblem -> certificationResult
  val certificationResult_case :
    (char list -> 'a) -> (char list -> 'a) -> certificationResult -> 'a
  val xml_certificationProblem :
    'a show -> 'c show -> ('a, 'b, 'c) certificationProblem -> xml
  val eqWhiteSpace : char list -> char list -> bool
  val certifyProof : char list -> certificationResult
end = struct

let rec id x = (fun xa -> xa) x;;

type 'a eq = {eq : 'a -> 'a -> bool};;
let eq _A = _A.eq;;

type nat = Zero_nat | Suc of nat;;

type rat = Frct of (Big_int.big_int * Big_int.big_int);;

type ('a, 'b) scg = Null | Scg of 'a * 'a * ('b * 'b) list * ('b * 'b) list;;

type 'a shp = Sharp of 'a | Plain of 'a;;

let rec eqa _A a b = eq _A a b;;

let rec leta s f = f s;;

let rec nat_aux
  i n = (if Big_int.le_big_int i (Big_int.big_int_of_int 0) then n
          else nat_aux (Big_int.sub_big_int i (Big_int.big_int_of_int 1))
                 (Suc n));;

let rec nat i = nat_aux i Zero_nat;;

let rec hd (x :: xs) = x;;

let rec tl = function [] -> []
             | x :: xs -> xs;;

type ('a, 'b) sum = Inl of 'a | Inr of 'b;;

type nibble = Nibble0 | Nibble1 | Nibble2 | Nibble3 | Nibble4 | Nibble5 |
  Nibble6 | Nibble7 | Nibble8 | Nibble9 | NibbleA | NibbleB | NibbleC | NibbleD
  | NibbleE | NibbleF;;

let rec append
  x0 ys = match x0, ys with [], ys -> ys
    | x :: xs, ys -> x :: append xs ys;;

let rec digit2int
  x = (if ((x : char) = '0') then Inr (Big_int.big_int_of_int 0)
        else (if ((x : char) = '1') then Inr (Big_int.big_int_of_int 1)
               else (if ((x : char) = '2') then Inr (Big_int.big_int_of_int 2)
                      else (if ((x : char) = '3')
                             then Inr (Big_int.big_int_of_int 3)
                             else (if ((x : char) = '4')
                                    then Inr (Big_int.big_int_of_int 4)
                                    else (if ((x : char) = '5')
   then Inr (Big_int.big_int_of_int 5)
   else (if ((x : char) = '6') then Inr (Big_int.big_int_of_int 6)
          else (if ((x : char) = '7') then Inr (Big_int.big_int_of_int 7)
                 else (if ((x : char) = '8') then Inr (Big_int.big_int_of_int 8)
                        else (if ((x : char) = '9')
                               then Inr (Big_int.big_int_of_int 9)
                               else Inl (append [x]
  [' '; 'i'; 's'; ' '; 'n'; 'o'; 't'; ' '; 'a'; ' '; 'd'; 'i'; 'g'; 'i';
    't'])))))))))));;

let rec sum_case
  f1 f2 x2 = match f1, f2, x2 with f1, f2, Inr b -> f2 b
    | f1, f2, Inl a -> f1 a;;

let rec bind m f = (match m with Inl a -> Inl a | Inr a -> f a);;

let rec string2int_aux
  n x1 = match n, x1 with n, [] -> Inr n
    | n, d :: s ->
        bind (digit2int d)
          (fun m ->
            string2int_aux
              (Big_int.add_big_int
                (Big_int.mult_big_int (Big_int.big_int_of_int 10) n) m)
              s);;

let one_nat : nat = Suc Zero_nat;;

let rec nat_case
  f1 f2 x2 = match f1, f2, x2 with f1, f2, Suc nat -> f2 nat
    | f1, f2, Zero_nat -> f1;;

let rec take
  n x1 = match n, x1 with n, [] -> []
    | n, x :: xs -> (match n with Zero_nat -> [] | Suc m -> x :: take m xs);;

let eq_char = ({eq = (fun a b -> ((a : char) = b))} : char eq);;

let rec eq_list _A
  x0 x1 = match x0, x1 with [], [] -> true
    | aa :: listaa, a :: lista -> eqa _A aa a && eq_list _A listaa lista
    | [], a :: lista -> false
    | a :: lista, [] -> false;;

let rec null = function [] -> true
               | x :: xs -> false;;

let rec string2int
  s = (if null s
        then Inl ['c'; 'a'; 'n'; 'n'; 'o'; 't'; ' '; 'c'; 'o'; 'n'; 'v'; 'e';
                   'r'; 't'; ' '; 'e'; 'm'; 'p'; 't'; 'y'; ' '; 's'; 't'; 'r';
                   'i'; 'n'; 'g'; ' '; 'i'; 'n'; 't'; 'o'; ' '; 'n'; 'u'; 'm';
                   'b'; 'e'; 'r']
        else (if eq_list eq_char (take one_nat s) ['-']
               then bind (string2int_aux (Big_int.big_int_of_int 0) (tl s))
                      (fun i ->
                        Inr (Big_int.sub_big_int (Big_int.big_int_of_int 0) i))
               else string2int_aux (Big_int.big_int_of_int 0) s));;

let newline : char = '\010';;

let rec the (Some x) = x;;

let rec replicate
  xa0 x = match xa0, x with Zero_nat, x -> []
    | Suc n, x -> x :: replicate n x;;

let rec comp f g = (fun x -> f (g x));;

let rec shows_map
  s x1 = match s, x1 with s, [] -> id
    | s, x :: xs -> comp (s x) (shows_map s xs);;

let rec is_none = function Some x -> false
                  | None -> true;;

let rec snd (a, b) = b;;

let dquote : char list = ['\034'];;

let rec shows_string x = append x;;

let rec fst (a, b) = a;;

let rec shows_list_char cs = shows_string cs;;

type 'a show =
  {shows_prec : nat -> 'a -> char list -> char list;
    shows_list : 'a list -> char list -> char list};;
let shows_prec _A = _A.shows_prec;;
let shows_list _A = _A.shows_list;;

let rec shows_prec_char d c = (fun a -> c :: a);;

let show_char =
  ({shows_prec = shows_prec_char; shows_list = shows_list_char} : char show);;

let rec shows_prec_list _A d l = shows_list _A l;;

let rec shows_attr
  av = comp (shows_prec_list show_char Zero_nat (fst av))
         (comp (shows_string ['='])
           (shows_string (append dquote (append (snd av) dquote))));;

let rec shows_attrs
  asa = shows_map (fun a -> comp (shows_string [' ']) (shows_attr a)) asa;;

type xml =
  Xml of
    char list * (char list * char list) list * xml list * (char list) option;;

let rec shows_XML_indent
  ind i (Xml (n, a, c, t)) =
    comp (shows_string ind)
      (comp (shows_string ['<'])
        (comp (shows_prec_list show_char Zero_nat n)
          (comp (shows_attrs a)
            (if null c && is_none t then shows_string ['/'; '>']
              else comp (shows_string ['>'])
                     (comp (if not (null c)
                             then comp (shows_map
 (shows_XML_indent (append ind (replicate i ' ')) i) c)
                                    (shows_string ind)
                             else id)
                       (comp (if is_none t then id else shows_string (the t))
                         (comp (shows_string ['<'; '/'])
                           (comp (shows_prec_list show_char Zero_nat n)
                             (shows_string ['>'])))))))));;

let rec shows_prec_xml
  d xml = shows_XML_indent [newline] (nat (Big_int.big_int_of_int 2)) xml;;

let rec concat = function [] -> []
                 | x :: xs -> append x (concat xs);;

let rec text
  tag (Xml (n, atts, cs, t)) =
    (if eq_list eq_char n tag &&
          (null atts && (null cs && (not (is_none t) && not (null (the t)))))
      then Inr (the t)
      else Inl (concat
                 [['c'; 'o'; 'u'; 'l'; 'd'; ' '; 'n'; 'o'; 't'; ' '; 'e'; 'x';
                    't'; 'r'; 'a'; 'c'; 't'; ' '; 't'; 'e'; 'x'; 't'; ' '; 'f';
                    'o'; 'r'; ' '];
                   tag; [' '; 'f'; 'r'; 'o'; 'm'; ' ']; [newline];
                   shows_prec_xml Zero_nat (Xml (n, atts, cs, t)) []]));;

let rec int tag x = bind (text tag x) string2int;;

let rec map
  f x1 = match f, x1 with f, [] -> []
    | f, x :: xs -> f x :: map f xs;;

let rec sequence
  = function [] -> Inr []
    | m :: ms ->
        bind m (fun x -> bind (sequence ms) (fun xs -> Inr (x :: xs)));;

let rec mapm f ms = sequence (map f ms);;

let rec mapa x = mapm x;;

let rec nata
  tag x =
    bind (text tag x)
      (fun txt -> bind (string2int txt) (fun i -> Inr (nat i)));;

let rec no_transform
  tag xml =
    Inl (concat
          [['c'; 'o'; 'u'; 'l'; 'd'; ' '; 'n'; 'o'; 't'; ' '; 't'; 'r'; 'a';
             'n'; 's'; 'f'; 'o'; 'r'; 'm'; ' '; 't'; 'h'; 'e'; ' '; 'f'; 'o';
             'l'; 'l'; 'o'; 'w'; 'i'; 'n'; 'g'; '\010'; ' '; ' '; ' '; ' '; ' ';
             'x'; 'm'; 'l'; ' '; 'e'; 'l'; 'e'; 'm'; 'e'; 'n'; 't'; ' '; '(';
             'e'; 'x'; 'p'; 'e'; 'c'; 't'; 'e'; 'd'; ' '];
            tag; [')']; [newline]; shows_prec_xml Zero_nat xml []]);;

let rec nth
  x0 x1 = match x0, x1 with x :: xs, Suc n -> nth xs n
    | x :: xs, Zero_nat -> x;;

let rec plus_nat
  x0 n = match x0, n with Suc m, n -> plus_nat m (Suc n)
    | Zero_nat, n -> n;;

let rec size_list
  = function [] -> Zero_nat
    | a :: lista -> plus_nat (size_list lista) (Suc Zero_nat);;

let rec eq_nat
  x0 x1 = match x0, x1 with Zero_nat, Zero_nat -> true
    | Suc nata, Suc nat -> eq_nat nata nat
    | Zero_nat, Suc nat -> false
    | Suc nat, Zero_nat -> false;;

let rec xml2elements
  tag p1 p2 f (Xml (name, atts, cs, text)) =
    (if eq_list eq_char name tag &&
          (null atts &&
            (eq_nat (size_list cs) (nat (Big_int.big_int_of_int 2)) &&
              is_none text))
      then bind (p1 (nth cs Zero_nat))
             (fun x1 -> bind (p2 (nth cs one_nat)) (fun x2 -> Inr (f x1 x2)))
      else no_transform tag (Xml (name, atts, cs, text)));;

let rec abs_int
  i = (if Big_int.lt_big_int i (Big_int.big_int_of_int 0)
        then Big_int.minus_big_int i else i);;

let rec split f (a, b) = f a b;;

let rec sgn_int
  i = (if Big_int.eq_big_int i (Big_int.big_int_of_int 0)
        then (Big_int.big_int_of_int 0)
        else (if Big_int.lt_big_int (Big_int.big_int_of_int 0) i
               then (Big_int.big_int_of_int 1)
               else Big_int.minus_big_int (Big_int.big_int_of_int 1)));;

let rec apsnd f (x, y) = (x, f y);;

let rec divmod_int
  k l = (if Big_int.eq_big_int k (Big_int.big_int_of_int 0)
          then ((Big_int.big_int_of_int 0), (Big_int.big_int_of_int 0))
          else (if Big_int.eq_big_int l (Big_int.big_int_of_int 0)
                 then ((Big_int.big_int_of_int 0), k)
                 else apsnd (Big_int.mult_big_int (sgn_int l))
                        (if Big_int.eq_big_int (sgn_int k) (sgn_int l)
                          then Big_int.quomod_big_int (Big_int.abs_big_int k)
                                 (Big_int.abs_big_int l)
                          else let (r, s) =
                                 Big_int.quomod_big_int (Big_int.abs_big_int k)
                                   (Big_int.abs_big_int l)
                                 in
                               (if Big_int.eq_big_int s
                                     (Big_int.big_int_of_int 0)
                                 then (Big_int.minus_big_int r,
(Big_int.big_int_of_int 0))
                                 else (Big_int.sub_big_int
 (Big_int.minus_big_int r) (Big_int.big_int_of_int 1),
Big_int.sub_big_int (abs_int l) s)))));;

let rec div_int a b = fst (divmod_int a b);;

let rec mod_int a b = snd (divmod_int a b);;

let rec gcd_int
  k l = abs_int
          (if Big_int.eq_big_int l (Big_int.big_int_of_int 0) then k
            else gcd_int l (mod_int (abs_int k) (abs_int l)));;

let rec normalize
  p = (if Big_int.lt_big_int (Big_int.big_int_of_int 0) (snd p)
        then let a = gcd_int (fst p) (snd p) in
             (div_int (fst p) a, div_int (snd p) a)
        else (if Big_int.eq_big_int (snd p) (Big_int.big_int_of_int 0)
               then ((Big_int.big_int_of_int 0), (Big_int.big_int_of_int 1))
               else let a = Big_int.minus_big_int (gcd_int (fst p) (snd p)) in
                    (div_int (fst p) a, div_int (snd p) a)));;

let rec fract a b = Frct (normalize (a, b));;

let rec xml_change p f x = bind (p x) (fun a -> Inr (f a));;

let rec get_name (Xml (name, uu, uv, uw)) = name;;

let rec eq_lista _A = ({eq = eq_list _A} : ('a list) eq);;

let rec lookup _A
  uu x1 = match uu, x1 with uu, [] -> None
    | aa, (a, b) :: xs -> (if eqa _A aa a then Some b else lookup _A aa xs);;

let rec concat_map
  f x1 = match f, x1 with f, [] -> []
    | f, x :: xs -> append (f x) (concat_map f xs);;

let rec option_case
  f1 f2 x2 = match f1, f2, x2 with f1, f2, Some a -> f2 a
    | f1, f2, None -> f1;;

let rec xml_options
  ps x =
    (match lookup (eq_lista eq_char) (get_name x) ps
      with None ->
        Inl (concat
              [['e'; 'x'; 'p'; 'e'; 'c'; 't'; 'e'; 'd'; ' '; 'o'; 'n'; 'e'; ' ';
                 'o'; 'f'; ':'; ' '];
                concat_map (fun p -> append (fst p) [' ']) ps; [newline];
                ['b'; 'u'; 't'; ' '; 'f'; 'o'; 'u'; 'n'; 'd']; [newline];
                shows_prec_xml Zero_nat x []])
      | Some p -> p x);;

let rec rat
  x = xml_options
        [(['i'; 'n'; 't'; 'e'; 'g'; 'e'; 'r'],
           xml_change (int ['i'; 'n'; 't'; 'e'; 'g'; 'e'; 'r'])
             (fun xa -> fract xa (Big_int.big_int_of_int 1)));
          (['r'; 'a'; 't'; 'i'; 'o'; 'n'; 'a'; 'l'],
            xml2elements ['r'; 'a'; 't'; 'i'; 'o'; 'n'; 'a'; 'l']
              (int ['n'; 'u'; 'm'; 'e'; 'r'; 'a'; 't'; 'o'; 'r'])
              (int ['d'; 'e'; 'n'; 'o'; 'm'; 'i'; 'n'; 'a'; 't'; 'o'; 'r'])
              fract)]
        x;;

type ('a, 'b) term = Var of 'b | Fun of 'a * ('a, 'b) term list;;

let rec decomp
  x0 x1 = match x0, x1 with [], [] -> Some []
    | uu :: uv, [] -> None
    | [], uw :: ux -> None
    | s :: ss, t :: ts ->
        (match decomp ss ts with None -> None
          | Some pairs -> Some ((s, t) :: pairs));;

type ('a, 'b) hterm = HHole | HFun of 'a * ('a, 'b) hterm list;;

let rec gcMatchList _A
  = function [] -> Some []
    | (HHole, uu) :: ps -> gcMatchList _A ps
    | (HFun (f, hs), Fun (g, ss)) :: ps ->
        (if eqa _A f g
          then (match decomp hs ss with None -> None
                 | Some pairs -> gcMatchList _A (append pairs ps))
          else None)
    | (HFun (f, hs), Var x) :: ps ->
        (match gcMatchList _A ps with None -> None
          | Some pairs -> Some ((HFun (f, hs), x) :: pairs));;

let rec mergeHTerms _A
  x0 x1 = match x0, x1 with [], [] -> Some []
    | [], uu :: uv -> None
    | uw :: ux, [] -> None
    | HHole :: hsl, h :: hsr ->
        (match mergeHTerms _A hsl hsr with None -> None
          | Some res -> Some (h :: res))
    | HFun (f, hs) :: hsl, HHole :: hsr ->
        (match mergeHTerms _A hsl hsr with None -> None
          | Some res -> Some (HFun (f, hs) :: res))
    | HFun (f, fs) :: hsl, HFun (g, gs) :: hsr ->
        (if eqa _A f g
          then (match mergeHTerms _A fs gs with None -> None
                 | Some mhs ->
                   (match mergeHTerms _A hsl hsr with None -> None
                     | Some res -> Some (HFun (f, mhs) :: res)))
          else None);;

let rec merge _A
  hl hr =
    (match mergeHTerms _A [hl] [hr] with None -> None
      | Some res -> Some (nth res Zero_nat));;

let rec mergeX _A _B
  x h xa2 = match x, h, xa2 with x, h, [] -> Some []
    | x, h, (ht, y) :: ps ->
        (if eqa _A x y
          then (match merge _B h ht with None -> None
                 | Some m -> mergeX _A _B x m ps)
          else (match mergeX _A _B x h ps with None -> None
                 | Some pairs -> Some ((ht, y) :: pairs)));;

let rec mergeAll _A _B
  = function [] -> true
    | (h, x) :: ps ->
        (match mergeX _B _A x h ps with None -> false
          | Some a -> mergeAll _A _B a);;

let rec gcMatchI _A _B
  h t = (match gcMatchList _A [(h, t)] with None -> false
          | Some a -> mergeAll _A _B a);;

let rec list_ex
  p x1 = match p, x1 with p, [] -> false
    | p, x :: xs -> p x || list_ex p xs;;

let rec capI _A _B
  uu x1 = match uu, x1 with uu, Var uv -> HHole
    | r, Fun (f, ts) ->
        let h = HFun (f, map (capI _A _B r) ts) in
        (if list_ex (fun ra -> gcMatchI _A _B h (fst ra)) r then HHole else h);;

let rec foldl
  f a x2 = match f, a, x2 with f, a, [] -> a
    | f, a, x :: xs -> foldl f (f a x) xs;;

let rec rev xs = foldl (fun xsa x -> x :: xsa) [] xs;;

let rec less_nat
  m x1 = match m, x1 with m, Suc n -> less_eq_nat m n
    | n, Zero_nat -> false
and less_eq_nat
  x0 n = match x0, n with Suc m, n -> less_nat m n
    | Zero_nat, n -> true;;

let rec upt i j = (if less_nat i j then i :: upt (Suc i) j else []);;

let rec zip
  xs ys = match xs, ys with x :: xs, y :: ys -> (x, y) :: zip xs ys
    | xs, [] -> []
    | [], ys -> [];;

let rec prod_case f1 (a, b) = f1 a b;;

let rec eqb _A _B (aa, ba) (a, b) = eqa _A aa a && eqa _B ba b;;

let rec eqc _A _B = ({eq = eqb _A _B} : ('a * 'b) eq);;

let rec member _A
  x0 y = match x0, y with [], y -> false
    | x :: xs, y -> eqa _A x y || member _A xs y;;

let rec remdups _A
  = function [] -> []
    | x :: xs ->
        (if member _A xs x then remdups _A xs else x :: remdups _A xs);;

let rec compa _A
  esa es =
    remdups (eqc _A _A)
      (concat_map
        (fun (x, y) ->
          concat_map (fun (ya, z) -> (if eqa _A y ya then [(x, z)] else [])) es)
        esa);;

let rec shows_paren
  p = comp (shows_prec_char Zero_nat '(')
        (comp p (shows_prec_char Zero_nat ')'));;

let rec shows_preca _A _B
  d p = shows_paren
          (comp (shows_prec _A Zero_nat (fst p))
            (comp (shows_prec_char Zero_nat ',')
              (shows_prec _B Zero_nat (snd p))));;

let rec shows_sep
  s sep x2 = match s, sep, x2 with s, sep, [] -> shows_string []
    | s, sep, [x] -> s x
    | s, sep, x :: v :: va ->
        comp (s x) (comp sep (shows_sep s sep (v :: va)));;

let rec shows_between l p r = comp l (comp p r);;

let rec shows_list_gen
  elt e l s r xs =
    (if null xs then shows_string e
      else shows_between (shows_string l) (shows_sep elt (shows_string s) xs)
             (shows_string r));;

let rec shows_list_aux s xs = shows_list_gen s ['['; ']'] ['['] [','] [']'] xs;;

let rec shows_lista _A _B ps = shows_list_aux (shows_preca _A _B Zero_nat) ps;;

let rec show _A _B =
  ({shows_prec = shows_preca _A _B; shows_list = shows_lista _A _B} :
    ('a * 'b) show);;

type ('a, 'b) ctxt = Hole |
  More of 'a * ('a, 'b) term list * ('a, 'b) ctxt * ('a, 'b) term list;;

let rec string2bool
  s = (if eq_list eq_char s ['t'; 'r'; 'u'; 'e'] then Inr true
        else (if eq_list eq_char s ['f'; 'a'; 'l'; 's'; 'e'] then Inr false
               else Inl (append
                          ['c'; 'a'; 'n'; 'n'; 'o'; 't'; ' '; 'c'; 'o'; 'n';
                            'v'; 'e'; 'r'; 't'; ' ']
                          (append s
                            [' '; 'i'; 'n'; 't'; 'o'; ' '; 'B'; 'o'; 'o'; 'l';
                              'e'; 'a'; 'n']))));;

let rec boola tag node = bind (text tag node) string2bool;;

let rec capRM2 _A _B
  uu x1 = match uu, x1 with uu, Var uv -> HHole
    | rm, Fun (f, ts) ->
        let h = HFun (f, map (capRM2 _A _B rm) ts) in
        let n = size_list ts in
        (if list_ex (fun r -> gcMatchI _A _B h (fst r)) (rm (f, n)) then HHole
          else h);;

let rec capRM _A _B
  r = (match r with None -> (fun _ -> HHole) | Some a -> capRM2 _A _B a);;

let eq_int = ({eq = Big_int.eq_big_int} : Big_int.big_int eq);;

let rec drop
  n x1 = match n, x1 with n, [] -> []
    | n, x :: xs -> (match n with Zero_nat -> x :: xs | Suc m -> drop m xs);;

let rec last (x :: xs) = (if null xs then x else last xs);;

let eq_nata = ({eq = eq_nat} : nat eq);;

let rec quotient_of (Frct x) = x;;

let rec eq_rat a b = eqb eq_int eq_int (quotient_of a) (quotient_of b);;

let eq_rata = ({eq = eq_rat} : rat eq);;

type 'a times = {times : 'a -> 'a -> 'a};;
let times _A = _A.times;;

type 'a dvd = {times_dvd : 'a times};;

let rec combine _B
  x0 s = match x0, s with
    Scg (pa, qa, stra, wka), Scg (p, q, str, wk) ->
      Scg (pa, qa, remdups (eqc _B _B) (append stra str),
            remdups (eqc _B _B) (append wka wk))
    | Null, s -> Null
    | Scg (v, va, vb, vc), Null -> Null;;

let rec list_all
  p x1 = match p, x1 with p, [] -> true
    | p, x :: xs -> p x && list_all p xs;;

let rec subsumes _A _B
  g x1 = match g, x1 with
    Scg (pa, qa, stra, wka), Scg (p, q, str, wk) ->
      eqa _A pa p &&
        (eqa _A qa q &&
          (list_all (member (eqc _B _B) str) stra &&
            list_all (member (eqc _B _B) (append str wk)) wka))
    | g, Null -> true
    | Null, Scg (v, va, vb, vc) -> false;;

let rec filter
  p x1 = match p, x1 with p, [] -> []
    | p, x :: xs -> (if p x then x :: filter p xs else filter p xs);;

let rec subtract_list _A xs ys = filter (fun x -> not (member _A ys x)) xs;;

let rec scg_comp _B
  conn x1 g = match conn, x1, g with
    conn, Scg (pa, qa, stra, wka), Scg (p, q, str, wk) ->
      (if not (conn qa p) then Null
        else let strs =
               remdups (eqc _B _B)
                 (append (compa _B stra str)
                   (append (compa _B stra wk) (compa _B wka str)))
               in
             let a =
               subtract_list (eqc _B _B) (remdups (eqc _B _B) (compa _B wka wk))
                 strs
               in
             Scg (pa, q, strs, a))
    | conn, Null, g -> Null
    | conn, Scg (v, va, vb, vc), Null -> Null;;

let rec in_situ _B
  = function Null -> true
    | Scg (p, q, str, wk) -> list_ex (fun (a, b) -> eqa _B a b) str;;

let rec sagiv _A _B
  conn g =
    (if in_situ _B g then true
      else let gg = scg_comp _B conn g g in
           (if subsumes _A _B gg g then false
             else sagiv _A _B conn (combine _B g gg)));;

let rec args = function Var x -> []
               | Fun (f, ts) -> ts;;

let rec root = function Var x -> None
               | Fun (f, ts) -> Some f;;

type ('a, 'b) subst = Subst of ('b -> ('a, 'b) term);;

let rec eq_shp _A
  x0 x1 = match x0, x1 with Sharp fa, Sharp f -> eqa _A fa f
    | Plain fa, Plain f -> eqa _A fa f
    | Sharp fa, Plain f -> false
    | Plain fa, Sharp f -> false;;

let rec eq_shpa _A = ({eq = eq_shp _A} : 'a shp eq);;

type 'a one = {one : 'a};;
let one _A = _A.one;;

let times_int = ({times = Big_int.mult_big_int} : Big_int.big_int times);;

let dvd_int = ({times_dvd = times_int} : Big_int.big_int dvd);;

let one_int : Big_int.big_int = (Big_int.big_int_of_int 1);;

let one_inta = ({one = one_int} : Big_int.big_int one);;

type 'a ord = {less_eq : 'a -> 'a -> bool; less : 'a -> 'a -> bool};;
let less_eq _A = _A.less_eq;;
let less _A = _A.less;;

let ord_int =
  ({less_eq = Big_int.le_big_int; less = Big_int.lt_big_int} :
    Big_int.big_int ord);;

let rec foldr
  f x1 a = match f, x1, a with f, [], a -> a
    | f, x :: xs, a -> f x (foldr f xs a);;

let rec vec n x = eq_nat (size_list x) n;;

let rec mat nr nc m = eq_nat (size_list m) nc && list_all (vec nr) m;;

let ord_nat = ({less_eq = less_eq_nat; less = less_nat} : nat ord);;

let rec times_rat
  p q = Frct (let (a, c) = quotient_of p in
              let (b, d) = quotient_of q in
              normalize (Big_int.mult_big_int a b, Big_int.mult_big_int c d));;

let times_rata = ({times = times_rat} : rat times);;

let dvd_rat = ({times_dvd = times_rata} : rat dvd);;

let one_rat : rat = Frct (one_int, one_int);;

let one_rata = ({one = one_rat} : rat one);;

let rec less_rat
  p q = let (a, c) = quotient_of p in
        let (b, d) = quotient_of q in
        Big_int.lt_big_int (Big_int.mult_big_int a d)
          (Big_int.mult_big_int c b);;

let rec less_eq_rat
  p q = let (a, c) = quotient_of p in
        let (b, d) = quotient_of q in
        Big_int.le_big_int (Big_int.mult_big_int a d)
          (Big_int.mult_big_int c b);;

let ord_rat = ({less_eq = less_eq_rat; less = less_rat} : rat ord);;

let rec eq_scg _A _B
  x0 x1 = match x0, x1 with Null, Null -> true
    | Scg (pp1a, pp2a, list1a, list2a), Scg (pp1, pp2, list1, list2) ->
        eqa _A pp1a pp1 &&
          (eqa _A pp2a pp2 &&
            (eq_list (eqc _B _B) list1a list1 &&
              eq_list (eqc _B _B) list2a list2))
    | Null, Scg (pp1, pp2, list1, list2) -> false
    | Scg (pp1, pp2, list1, list2), Null -> false;;

let rec list_all2
  p xs ys = match p, xs, ys with
    p, x :: xs, y :: ys -> p x y && list_all2 p xs ys
    | p, xs, [] -> null xs
    | p, [], ys -> null ys;;

let rec eq_term _A _B
  x0 x1 = match x0, x1 with
    Fun (f, ts), Fun (g, us) -> eq _A f g && list_all2 (eq_term _A _B) ts us
    | Var x, Var y -> eq _B x y
    | Var v, Fun (f, lista) -> false
    | Fun (f, lista), Var v -> false;;

let rec eq_terma _A _B = ({eq = eq_term _A _B} : ('a, 'b) term eq);;

let rec term_case
  f1 f2 x2 = match f1, f2, x2 with f1, f2, Fun (f, lista) -> f2 f lista
    | f1, f2, Var v -> f1 v;;

let rec suptp _A _B
  s t = (match s with Var _ -> false
          | Fun (_, ts) ->
            member (eq_terma _A _B) ts t ||
              list_ex (fun sa -> suptp _A _B sa t) ts);;

let rec plaina
  = function Var x -> Var x
    | Fun (f, ss) -> Fun (Plain f, map plaina ss);;

let rec sharpa
  = function Var x -> Var x
    | Fun (f, ss) -> Fun (Sharp f, map plaina ss);;

let rec debug i t x = x;;

let rec eq_hterm _A = ({eq = eq_hterma _A} : ('a, 'b) hterm eq)
and eq_hterma _A
  x0 x1 = match x0, x1 with HHole, HHole -> true
    | HFun (fa, listaa), HFun (f, lista) ->
        eqa _A fa f && eq_list (eq_hterm _A) listaa lista
    | HHole, HFun (f, lista) -> false
    | HFun (f, lista), HHole -> false;;

let rec fun_upd _A f a b = (fun x -> (if eqa _A x a then b else f x));;

type 'a plus = {plus : 'a -> 'a -> 'a};;
let plus _A = _A.plus;;

type 'a zero = {zero : 'a};;
let zero _A = _A.zero;;

let rec implies
  p pa = match p, pa with p, true -> true
    | p, false -> not p
    | true, p -> p
    | false, p -> true;;

let plus_int = ({plus = Big_int.add_big_int} : Big_int.big_int plus);;

let zero_int : Big_int.big_int = (Big_int.big_int_of_int 0);;

let zero_inta = ({zero = zero_int} : Big_int.big_int zero);;

type pos = Empty | PCons of nat * pos;;

type 'a power = {one_power : 'a one; times_power : 'a times};;

let rec powera
  one times a x3 = match one, times, a, x3 with
    one, times, a, Suc n -> times a (powera one times a n)
    | one, times, a, Zero_nat -> one;;

let rec power _A = powera (one _A.one_power) (times _A.times_power);;

let rec plus_rat
  p q = Frct (let (a, c) = quotient_of p in
              let (b, d) = quotient_of q in
              normalize
                (Big_int.add_big_int (Big_int.mult_big_int a d)
                   (Big_int.mult_big_int b c),
                  Big_int.mult_big_int c d));;

let plus_rata = ({plus = plus_rat} : rat plus);;

let zero_rat : rat = Frct (zero_int, one_int);;

let zero_rata = ({zero = zero_rat} : rat zero);;

let rec is_var = function Var x -> true
                 | Fun (f, ts) -> false;;

let rec shows_shp _A
  = function Sharp s -> comp (shows_prec _A Zero_nat s) (shows_string ['#'])
    | Plain s -> shows_prec _A Zero_nat s;;

let rec shows_prec_shp _A d f = shows_shp _A f;;

let rec shows_list_shp _A fs = shows_list_aux (shows_prec_shp _A Zero_nat) fs;;

let rec show_shp _A =
  ({shows_prec = shows_prec_shp _A; shows_list = shows_list_shp _A} :
    'a shp show);;

let rec shows_nl x = shows_prec_char Zero_nat newline x;;

let rec shows_term _A _B
  = function Var x -> shows_prec _B Zero_nat x
    | Fun (f, ts) ->
        comp (shows_prec _A Zero_nat f)
          (shows_list_gen id [] ['('] [','; ' '] [')']
            (map (shows_term _A _B) ts));;

let rec shows_prec_term _A _B d t = shows_term _A _B t;;

let rec shows_rule _A _B
  (l, r) =
    comp (shows_prec_term _A _B Zero_nat l)
      (comp (shows_string [' '; '-'; '>'; ' '])
        (shows_prec_term _A _B Zero_nat r));;

let rec shows_rules _A _B
  trs = comp (shows_list_gen (shows_rule _A _B) [] [] [newline] [] trs)
          shows_nl;;

let rec shows_p _A _B
  p = comp (shows_string
             ['d'; 'e'; 'p'; 'e'; 'n'; 'd'; 'e'; 'n'; 'c'; 'y'; ' '; 'p'; 'a';
               'i'; 'r'; 's'; ':'])
        (comp shows_nl (shows_rules _A _B p));;

let power_int =
  ({one_power = one_inta; times_power = times_int} : Big_int.big_int power);;

let rec vec0I ze n = replicate n ze;;

let rec mat0I ze nr nc = replicate nc (vec0I ze nr);;

let rec minus_nat
  m n = match m, n with Suc m, Suc n -> minus_nat m n
    | Zero_nat, n -> Zero_nat
    | m, Zero_nat -> m;;

let rec vec1I
  ze on n i =
    append (replicate i ze)
      (on :: replicate (minus_nat (minus_nat n one_nat) i) ze);;

let rec mat1I ze on n = map (vec1I ze on n) (upt Zero_nat n);;

let power_rat = ({one_power = one_rata; times_power = times_rata} : rat power);;

type 'a non_strict_order = {ge : 'a -> 'a -> bool};;
let ge _A = _A.ge;;

let rec divmod_nat
  m n = (if eq_nat n Zero_nat || less_nat m n then (Zero_nat, m)
          else let (q, a) = divmod_nat (minus_nat m n) n in
               (Suc q, a));;

let rec mod_nat m n = snd (divmod_nat m n);;

let rec div_nat m n = fst (divmod_nat m n);;

let rec digit2string
  n = (if eq_nat n Zero_nat then ['0']
        else (if eq_nat n one_nat then ['1']
               else (if eq_nat n (nat (Big_int.big_int_of_int 2)) then ['2']
                      else (if eq_nat n (nat (Big_int.big_int_of_int 3))
                             then ['3']
                             else (if eq_nat n (nat (Big_int.big_int_of_int 4))
                                    then ['4']
                                    else (if eq_nat n
       (nat (Big_int.big_int_of_int 5))
   then ['5']
   else (if eq_nat n (nat (Big_int.big_int_of_int 6)) then ['6']
          else (if eq_nat n (nat (Big_int.big_int_of_int 7)) then ['7']
                 else (if eq_nat n (nat (Big_int.big_int_of_int 8)) then ['8']
                        else (if eq_nat n (nat (Big_int.big_int_of_int 9))
                               then ['9']
                               else ['n'; 'o'; 't'; ' '; 'a'; ' '; 'd'; 'i';
                                      'g'; 'i'; 't']))))))))));;

let rec shows_nat
  n = (if less_nat n (nat (Big_int.big_int_of_int 10))
        then shows_string (digit2string n)
        else comp (shows_nat (div_nat n (nat (Big_int.big_int_of_int 10))))
               (shows_string
                 (digit2string
                   (mod_nat n (nat (Big_int.big_int_of_int 10))))));;

let rec shows_prec_nat d n = shows_nat n;;

let rec shows_prec_int
  d i = (if Big_int.lt_big_int i (Big_int.big_int_of_int 0)
          then comp (shows_prec_char Zero_nat '-')
                 (shows_prec_nat Zero_nat
                   (nat (Big_int.sub_big_int (Big_int.big_int_of_int 0) i)))
          else shows_prec_nat Zero_nat (nat i));;

let rec shows_list_int is = shows_list_aux (shows_prec_int Zero_nat) is;;

let show_int =
  ({shows_prec = shows_prec_int; shows_list = shows_list_int} :
    Big_int.big_int show);;

let rec shows_list_nat ns = shows_list_aux (shows_prec_nat Zero_nat) ns;;

let show_nat =
  ({shows_prec = shows_prec_nat; shows_list = shows_list_nat} : nat show);;

let rec show_rat
  x = let (den, num) = quotient_of x in
      (if Big_int.eq_big_int num (Big_int.big_int_of_int 1)
        then shows_prec_int Zero_nat den []
        else comp (comp (shows_prec_int Zero_nat den)
                    (shows_prec_char Zero_nat '/'))
               (shows_prec_int Zero_nat num) []);;

let rec shows_prec_rat d x = shows_string (show_rat x);;

let rec shows_list_rat rs = shows_list_aux (shows_prec_rat Zero_nat) rs;;

let show_rata =
  ({shows_prec = shows_prec_rat; shows_list = shows_list_rat} : rat show);;

let rec eq_ctxt _A _B
  x0 x1 = match x0, x1 with Hole, Hole -> true
    | More (fa, list1a, ctxta, list2a), More (f, list1, ctxt, list2) ->
        eqa _A fa f &&
          (eq_list (eq_terma _A _B) list1a list1 &&
            (eq_ctxt _A _B ctxta ctxt && eq_list (eq_terma _A _B) list2a list2))
    | Hole, More (f, list1, ctxt, list2) -> false
    | More (f, list1, ctxt, list2), Hole -> false;;

let rec subt_at
  s x1 = match s, x1 with s, Empty -> s
    | Fun (f, ss), PCons (i, p) -> subt_at (nth ss i) p;;

let rec supteqp _A _B s t = eq_term _A _B s t || suptp _A _B s t;;

let rec the_var (Var x) = x;;

let rec map_term
  fg x1 = match fg, x1 with fg, Var x -> Var x
    | fg, Fun (f, ts) -> Fun (fg f, map (map_term fg) ts);;

let rec map_rule fg lr = (map_term fg (fst lr), map_term fg (snd lr));;

let rec map_trsI fg r = map (map_rule fg) r;;

let rec extract
  p x1 = match p, x1 with p, [] -> None
    | p, x :: xs ->
        (if p x then Some ([], (x, xs))
          else (match extract p xs with None -> None
                 | Some (ys, (y, zs)) -> Some (x :: ys, (y, zs))));;

let rec distinct _A
  = function [] -> true
    | x :: xs -> not (member _A xs x) && distinct _A xs;;

let rec vec_comp_all rel v w = list_all (fun (a, b) -> rel a b) (zip v w);;

let rec mat_comp_all
  rel m1 m2 = list_all (fun (a, b) -> vec_comp_all rel a b) (zip m1 m2);;

let rec mat_ge _A = mat_comp_all (ge _A);;

let rec times_nat
  x0 n = match x0, n with Zero_nat, n -> Zero_nat
    | Suc m, n -> plus_nat n (times_nat m n);;

type 'a preorder = {ord_preorder : 'a ord};;

type 'a bot = {preorder_bot : 'a preorder; bot : 'a};;
let bot _A = _A.bot;;

let rec maxa less_eq a b = (if less_eq a b then b else a);;

let rec max _A = maxa (less_eq _A);;

let rec mina less_eq a b = (if less_eq a b then a else b);;

let rec min _A = mina (less_eq _A);;

let rec minus_rat
  p q = Frct (let (a, c) = quotient_of p in
              let (b, d) = quotient_of q in
              normalize
                (Big_int.sub_big_int (Big_int.mult_big_int a d)
                   (Big_int.mult_big_int b c),
                  Big_int.mult_big_int c d));;

let rec insert_scg _A _B
  g gs =
    (if eq_scg _A _B g Null then None
      else (if list_ex (fun ga -> subsumes _A _B ga g) gs then None
             else Some (g :: filter (fun ga -> not (subsumes _A _B g ga))
                               gs)));;

let rec mk_trancl _A _B
  conn x1 s = match conn, x1, s with conn, [], s -> s
    | conn, g :: gs, s ->
        (match insert_scg _A _B g s with None -> mk_trancl _A _B conn gs s
          | Some sa ->
            mk_trancl _A _B conn
              (append (map (scg_comp _B conn g) sa)
                (append (map (fun f -> scg_comp _B conn f g) sa) gs))
              sa);;

let rec check_SCT _A _B
  conn gs =
    let a = mk_trancl _A _B conn gs [] in
    list_all (sagiv _A _B conn) a;;

let rec shows_list_list _A
  ls = shows_list_aux (shows_prec_list _A Zero_nat) ls;;

let rec show_list _A =
  ({shows_prec = shows_prec_list _A; shows_list = shows_list_list _A} :
    ('a list) show);;

let rec num_args = function Var x -> Zero_nat
                   | Fun (f, ts) -> size_list ts;;

let rec shows_list_term _A _B
  is = shows_list_aux (shows_prec_term _A _B Zero_nat) is;;

let rec show_term _A _B =
  ({shows_prec = shows_prec_term _A _B; shows_list = shows_list_term _A _B} :
    ('a, 'b) term show);;

let rec defs_list _A
  = function [] -> []
    | (Fun (f, ss), r) :: ts ->
        let fs = defs_list _A ts in
        let n = size_list ss in
        (if member (eqc _A eq_nata) fs (f, n) then fs else (f, n) :: fs)
    | (Var x, r) :: ts -> defs_list _A ts;;

let rec shows_trs _A _B
  r = comp (shows_string
             ['r'; 'e'; 'w'; 'r'; 'i'; 't'; 'e'; ' '; 's'; 'y'; 's'; 't'; 'e';
               'm'; ':'])
        (comp shows_nl (shows_rules _A _B r));;

let rec shows_dpp _A _B p r = comp (shows_p _A _B p) (shows_trs _A _B r);;

let rec rev_append
  x0 ys = match x0, ys with [], ys -> ys
    | x :: xs, ys -> rev_append xs (x :: ys);;

let rec flat_map_aux
  f x1 ys = match f, x1, ys with f, [], ys -> rev ys
    | f, x :: xs, ys -> flat_map_aux f xs (rev_append (f x) ys);;

let rec flat_map f xs = flat_map_aux f xs [];;

let rec quote
  s = shows_between (shows_prec_char Zero_nat '\039') s
        (shows_prec_char Zero_nat '\039');;

let rec expecting _A
  msg ts =
    Inl (append ['e'; 'x'; 'p'; 'e'; 'c'; 't'; 'i'; 'n'; 'g'; ':'; ' ']
          (append msg
            (append
              [','; ' '; 'b'; 'u'; 't'; ' '; 'f'; 'o'; 'u'; 'n'; 'd'; ':'; ' ']
              (quote
                (shows_prec_list _A Zero_nat
                  (take (nat (Big_int.big_int_of_int 30)) ts))
                []))));;

let rec eoi _A
  = function [] -> Inr ((), [])
    | v :: va ->
        expecting _A
          ['e'; 'n'; 'd'; ' '; 'o'; 'f'; ' '; 'i'; 'n'; 'p'; 'u'; 't']
          (v :: va);;

type af_entry = Collapse of nat | AFList of nat list;;

let rec position
  x = xml_change (nata ['p'; 'o'; 's'; 'i'; 't'; 'i'; 'o'; 'n'])
        (fun n -> minus_nat n one_nat) x;;

let rec xml3elements
  tag p1 p2 p3 f (Xml (name, atts, cs, text)) =
    (if eq_list eq_char name tag &&
          (null atts &&
            (eq_nat (size_list cs) (nat (Big_int.big_int_of_int 3)) &&
              is_none text))
      then bind (p1 (nth cs Zero_nat))
             (fun x1 ->
               bind (p2 (nth cs one_nat))
                 (fun x2 ->
                   bind (p3 (nth cs (nat (Big_int.big_int_of_int 2))))
                     (fun x3 -> Inr (f x1 x2 x3))))
      else no_transform tag (Xml (name, atts, cs, text)));;

let rec xml_many_elements
  tag p f (Xml (name, atts, cs, text)) =
    (if eq_list eq_char name tag && (null atts && is_none text)
      then bind (mapa p cs) (comp (fun a -> Inr a) f)
      else no_transform tag (Xml (name, atts, cs, text)));;

let rec afs
  xml2name =
    xml_many_elements
      ['a'; 'r'; 'g'; 'u'; 'm'; 'e'; 'n'; 't'; 'F'; 'i'; 'l'; 't'; 'e'; 'r']
      (xml3elements
        ['a'; 'r'; 'g'; 'u'; 'm'; 'e'; 'n'; 't'; 'F'; 'i'; 'l'; 't'; 'e'; 'r';
          'E'; 'n'; 't'; 'r'; 'y']
        xml2name (nata ['a'; 'r'; 'i'; 't'; 'y'])
        (xml_options
          [(['c'; 'o'; 'l'; 'l'; 'a'; 'p'; 's'; 'i'; 'n'; 'g'],
             xml_change
               (nata ['c'; 'o'; 'l'; 'l'; 'a'; 'p'; 's'; 'i'; 'n'; 'g'])
               (fun i -> Collapse (minus_nat i one_nat)));
            (['n'; 'o'; 'n'; 'C'; 'o'; 'l'; 'l'; 'a'; 'p'; 's'; 'i'; 'n'; 'g'],
              xml_many_elements
                ['n'; 'o'; 'n'; 'C'; 'o'; 'l'; 'l'; 'a'; 'p'; 's'; 'i'; 'n';
                  'g']
                position (fun a -> AFList a))])
        (fun f a -> (fun b -> ((f, a), b))))
      id;;

let rec list2position
  = function [] -> Empty
    | n :: ns -> PCons (n, list2position ns);;

let rec pos
  x = xml_many_elements
        ['p'; 'o'; 's'; 'i'; 't'; 'i'; 'o'; 'n'; 'I'; 'n'; 'T'; 'e'; 'r'; 'm']
        position list2position x;;

let rec scg_position x = nata ['p'; 'o'; 's'; 'i'; 't'; 'i'; 'o'; 'n'] x;;

let rec xml1element
  tag p1 f (Xml (name, atts, cs, text)) =
    (if eq_list eq_char name tag &&
          (null atts && (eq_nat (size_list cs) one_nat && is_none text))
      then bind (p1 (nth cs Zero_nat)) (fun x1 -> Inr (f x1))
      else no_transform tag (Xml (name, atts, cs, text)));;

let rec xml1many_elements_gen
  tag p1 p2 f (Xml (name, atts, cs, text)) =
    (if eq_list eq_char name tag &&
          (null atts && (is_none text && not (null cs)))
      then bind (p1 (hd cs))
             (fun x -> bind (mapa (p2 x) (tl cs)) (fun xs -> Inr (f x xs)))
      else no_transform tag (Xml (name, atts, cs, text)));;

let rec xml1many_elements
  tag p1 p2 = xml1many_elements_gen tag p1 (fun _ -> p2);;

let rec var
  x = bind (text ['v'; 'a'; 'r'] x) (comp (fun a -> Inr a) (fun a -> Var a));;

let rec term
  xml2name x =
    xml_options
      [(['v'; 'a'; 'r'], var);
        (['f'; 'u'; 'n'; 'a'; 'p'; 'p'],
          xml1many_elements ['f'; 'u'; 'n'; 'a'; 'p'; 'p'] xml2name
            (xml1element ['a'; 'r'; 'g'] (term xml2name) id)
            (fun a b -> Fun (a, b)))]
      x;;

let rec rule
  xml2name =
    xml2elements ['r'; 'u'; 'l'; 'e']
      (xml1element ['l'; 'h'; 's'] (term xml2name) id)
      (xml1element ['r'; 'h'; 's'] (term xml2name) id) (fun a b -> (a, b));;

let rec scg
  xml2name =
    xml1many_elements
      ['s'; 'i'; 'z'; 'e'; 'C'; 'h'; 'a'; 'n'; 'g'; 'e'; 'G'; 'r'; 'a'; 'p';
        'h']
      (rule xml2name)
      (xml3elements ['e'; 'd'; 'g'; 'e'] scg_position
        (boola ['s'; 't'; 'r'; 'i'; 'c'; 't']) scg_position
        (fun p s q -> (s, (p, q))))
      (fun lr edges ->
        (lr, (map snd (filter fst edges),
               map snd (filter (fun x -> not (fst x)) edges))));;

let rec list_case
  f1 f2 x2 = match f1, f2, x2 with f1, f2, a :: lista -> f2 a lista
    | f1, f2, [] -> f1;;

let rec partition
  p x1 = match p, x1 with p, [] -> ([], [])
    | p, x :: xs ->
        let (yes, no) = partition p xs in
        (if p x then (x :: yes, no) else (yes, x :: no));;

let rec sub_vec x = take x;;

let rec sub_mat nr nc m = map (sub_vec nr) (take nc m);;

let rec vec_pre_gtI gt v w = list_ex (fun (a, b) -> gt a b) (zip v w);;

let rec mat_pre_gtI
  gt m1 m2 = list_ex (fun (a, b) -> vec_pre_gtI gt a b) (zip m1 m2);;

let rec mat_gtI _A
  gt sd m1 m2 =
    mat_ge _A m1 m2 && mat_pre_gtI gt (sub_mat sd sd m1) (sub_mat sd sd m2);;

let rec vec_map x = map x;;

let rec mat_map f = map (vec_map f);;

let rec eq_pos
  x0 x1 = match x0, x1 with Empty, Empty -> true
    | PCons (nata, posa), PCons (nat, pos) -> eq_nat nata nat && eq_pos posa pos
    | Empty, PCons (nat, pos) -> false
    | PCons (nat, pos), Empty -> false;;

let eq_posa = ({eq = eq_pos} : pos eq);;

type 'a semigroup_mult = {times_semigroup_mult : 'a times};;

type 'a semigroup_add = {plus_semigroup_add : 'a plus};;

type 'a ab_semigroup_add = {semigroup_add_ab_semigroup_add : 'a semigroup_add};;

type 'a semiring =
  {ab_semigroup_add_semiring : 'a ab_semigroup_add;
    semigroup_mult_semiring : 'a semigroup_mult};;

type 'a ordered_ab_semigroup =
  {ab_semigroup_add_ordered_ab_semigroup : 'a ab_semigroup_add;
    non_strict_order_ordered_ab_semigroup : 'a non_strict_order};;

type 'a monoid_add =
  {semigroup_add_monoid_add : 'a semigroup_add; zero_monoid_add : 'a zero};;

type 'a max_ordered_monoid_add =
  {monoid_add_max_ordered_monoid_add : 'a monoid_add;
    ordered_ab_semigroup_max_ordered_monoid_add : 'a ordered_ab_semigroup;
    max0 : 'a -> 'a};;
let max0 _A = _A.max0;;

let rec ctxt_case
  f1 f2 x2 = match f1, f2, x2 with
    f1, f2, More (f, list1, ctxt, list2) -> f2 f list1 ctxt list2
    | f1, f2, Hole -> f1;;

let rec get_subst (Subst sigma) = sigma;;

let rec poss_list
  = function Var x -> [Empty]
    | Fun (f, ss) ->
        Empty ::
          concat_map (fun (i, a) -> map (fun aa -> PCons (i, aa)) a)
            (zip (upt Zero_nat (size_list ss)) (map poss_list ss));;

let rec list_diff _A
  x0 ys = match x0, ys with [], ys -> []
    | x :: xs, ys ->
        let zs = list_diff _A xs ys in
        (if member _A ys x then zs else x :: zs);;

let rec binda m f ts = bind (m ts) (fun (a, b) -> f a b);;

let rec many
  p x1 = match p, x1 with p, [] -> Inr ([], [])
    | p, t :: ts ->
        (if p t then bind (many p ts) (fun (rs, tsa) -> Inr (t :: rs, tsa))
          else Inr ([], t :: ts));;

let wspace : char list = [newline; '\009'; '\013'; ' '];;

let rec trim
  = function [] -> []
    | c :: s -> (if member eq_char wspace c then trim s else c :: s);;

type ('a, 'b, 'c, 'd, 'e, 'f, 'g, 'h, 'i, 'j) alter = Alter1 of 'a |
  Alter2 of 'b | Alter3 of 'c | Alter4 of 'd | Alter5 of 'e | Alter6 of 'f |
  Alter7 of 'g | Alter8 of 'h | Alter9 of 'i | Alter10 of 'j;;

let rec xml4elements
  tag p1 p2 p3 p4 f (Xml (name, atts, cs, text)) =
    (if eq_list eq_char name tag &&
          (null atts &&
            (eq_nat (size_list cs) (nat (Big_int.big_int_of_int 4)) &&
              is_none text))
      then bind (p1 (nth cs Zero_nat))
             (fun x1 ->
               bind (p2 (nth cs one_nat))
                 (fun x2 ->
                   bind (p3 (nth cs (nat (Big_int.big_int_of_int 2))))
                     (fun x3 ->
                       bind (p4 (nth cs (nat (Big_int.big_int_of_int 3))))
                         (fun x4 -> Inr (f x1 x2 x3 x4)))))
      else no_transform tag (Xml (name, atts, cs, text)));;

let rec xml0elements
  tag x (Xml (name, atts, cs, text)) =
    (if eq_list eq_char name tag && (null atts && (null cs && is_none text))
      then Inr x else no_transform tag (Xml (name, atts, cs, text)));;

let rec ctxt
  xml2name x =
    xml_options
      [(['b'; 'o'; 'x'], xml0elements ['b'; 'o'; 'x'] Hole);
        (['f'; 'u'; 'n'; 'C'; 'o'; 'n'; 't'; 'e'; 'x'; 't'],
          xml4elements ['f'; 'u'; 'n'; 'C'; 'o'; 'n'; 't'; 'e'; 'x'; 't']
            xml2name
            (xml_many_elements ['b'; 'e'; 'f'; 'o'; 'r'; 'e'] (term xml2name)
              id)
            (ctxt xml2name)
            (xml_many_elements ['a'; 'f'; 't'; 'e'; 'r'] (term xml2name) id)
            (fun a b c d -> More (a, b, c, d)))]
      x;;

let rec subst
  xml2name =
    xml_many_elements
      ['s'; 'u'; 'b'; 's'; 't'; 'i'; 't'; 'u'; 't'; 'i'; 'o'; 'n']
      (xml2elements ['s'; 'u'; 'b'; 's'; 't'; 'E'; 'n'; 't'; 'r'; 'y']
        (text ['v'; 'a'; 'r']) (term xml2name) (fun a b -> (a, b)))
      id;;

let rec xml3to4elements
  tag p1 p2 p3 p4 f (Xml (name, atts, cs, text)) =
    let l = size_list cs in
    (if eq_list eq_char name tag &&
          (null atts &&
            (less_eq_nat (nat (Big_int.big_int_of_int 3)) l &&
              (less_eq_nat l (nat (Big_int.big_int_of_int 4)) && is_none text)))
      then bind (p1 (nth cs Zero_nat))
             (fun x1 ->
               bind (p2 (nth cs one_nat))
                 (fun x2 ->
                   (if eq_nat l (nat (Big_int.big_int_of_int 4))
                     then bind (p3 (nth cs (nat (Big_int.big_int_of_int 2))))
                            (fun x3 ->
                              bind (p4 (nth cs
 (nat (Big_int.big_int_of_int 3))))
                                (fun x4 -> Inr (f x1 x2 (Some x3) x4)))
                     else bind (p4 (nth cs (nat (Big_int.big_int_of_int 2))))
                            (fun x4 -> Inr (f x1 x2 None x4)))))
      else no_transform tag (Xml (name, atts, cs, text)));;

let rec rstep
  xml2name =
    xml3to4elements ['r'; 'e'; 'w'; 'r'; 'i'; 't'; 'e'; 'S'; 't'; 'e'; 'p'] pos
      (rule xml2name) (xml0elements ['r'; 'e'; 'l'; 'a'; 't'; 'i'; 'v'; 'e'] ())
      (term xml2name) (fun p r rel t -> (p, (r, (is_none rel, t))));;

let rec rsteps
  xml2name =
    xml1many_elements
      ['r'; 'e'; 'w'; 'r'; 'i'; 't'; 'e'; 'S'; 'e'; 'q'; 'u'; 'e'; 'n'; 'c';
        'e']
      (xml1element ['s'; 't'; 'a'; 'r'; 't'; 'T'; 'e'; 'r'; 'm'] (term xml2name)
        id)
      (rstep xml2name) (fun a b -> (a, b));;

let rec loop
  xml2name =
    xml3elements ['l'; 'o'; 'o'; 'p'] (rsteps xml2name) (subst xml2name)
      (ctxt xml2name) (fun (s, rseq) sigma c -> (s, (rseq, (sigma, c))));;

let rec af_entry_case
  f1 f2 x2 = match f1, f2, x2 with f1, f2, AFList lista -> f2 lista
    | f1, f2, Collapse nat -> f1 nat;;

type 'a projL = Projection of ('a * nat) list;;

let rec proj
  xml2name =
    xml_change (afs xml2name)
      (fun afl ->
        Projection
          (map (fun (a, b) ->
                 let (f, aa) = a in
                 (fun ba ->
                   (match ba with Collapse ab -> (f, ab) | AFList _ -> (f, aa)))
                   b)
            afl));;

let rec proj_term
  p x1 = match p, x1 with p, Var x -> Var x
    | p, Fun (f, ts) ->
        (if less_nat (p f) (size_list ts) then nth ts (p f) else Fun (f, ts));;

let rec start_term _A
  xml2name t =
    xml1element ['s'; 't'; 'a'; 'r'; 't'; 'T'; 'e'; 'r'; 'm']
      (fun xml ->
        bind (term xml2name xml)
          (fun s ->
            (if eq_term _A (eq_lista eq_char) s t then Inr t
              else Inl ['<'; 's'; 't'; 'a'; 'r'; 't'; 'T'; 'e'; 'r'; 'm'; '>';
                         ' '; 'd'; 'o'; 'e'; 's'; ' '; 'n'; 'o'; 't'; ' '; 'm';
                         'a'; 't'; 'c'; 'h'; ' '; 'l'; 'h'; 's'])))
      id;;

let rec rseq _A
  xml2name pi r =
    xml1many_elements
      ['r'; 'e'; 'w'; 'r'; 'i'; 't'; 'e'; 'S'; 'e'; 'q'; 'u'; 'e'; 'n'; 'c';
        'e']
      (start_term _A xml2name (proj_term pi (fst r))) (rstep xml2name)
      (fun _ rseq -> (r, map (fun (x, (y, (_, z))) -> (x, (y, z))) rseq));;

let semigroup_mult_int =
  ({times_semigroup_mult = times_int} : Big_int.big_int semigroup_mult);;

let semigroup_add_int =
  ({plus_semigroup_add = plus_int} : Big_int.big_int semigroup_add);;

let ab_semigroup_add_int =
  ({semigroup_add_ab_semigroup_add = semigroup_add_int} :
    Big_int.big_int ab_semigroup_add);;

let semiring_int =
  ({ab_semigroup_add_semiring = ab_semigroup_add_int;
     semigroup_mult_semiring = semigroup_mult_int}
    : Big_int.big_int semiring);;

let rec list_inter _A
  x0 bs = match x0, bs with [], bs -> []
    | a :: asa, bs ->
        (if member _A bs a then a :: list_inter _A asa bs
          else list_inter _A asa bs);;

let rec mat_max0 _A = mat_map (max0 _A);;

let semigroup_mult_rat =
  ({times_semigroup_mult = times_rata} : rat semigroup_mult);;

let semigroup_add_rat = ({plus_semigroup_add = plus_rata} : rat semigroup_add);;

let ab_semigroup_add_rat =
  ({semigroup_add_ab_semigroup_add = semigroup_add_rat} :
    rat ab_semigroup_add);;

let semiring_rat =
  ({ab_semigroup_add_semiring = ab_semigroup_add_rat;
     semigroup_mult_semiring = semigroup_mult_rat}
    : rat semiring);;

type arctic_rat = MinInfty_rat | Num_arc_rat of rat;;

type arctic = MinInfty | Num_arc of Big_int.big_int;;

type 'a redpair =
  Int_carrier of (('a * nat) * (Big_int.big_int * Big_int.big_int list)) list |
  Int_nl_carrier of
    (('a * nat) * ((nat * nat) list * Big_int.big_int) list) list
  | Rat_carrier of rat * (('a * nat) * (rat * rat list)) list |
  Rat_nl_carrier of rat * (('a * nat) * ((nat * nat) list * rat) list) list |
  Arctic_carrier of (('a * nat) * (arctic * arctic list)) list |
  Arctic_rat_carrier of rat * (('a * nat) * (arctic_rat * arctic_rat list)) list
  | Int_mat_carrier of
      nat * nat *
        (('a * nat) *
          ((Big_int.big_int list) list *
            ((Big_int.big_int list) list) list)) list
  | Rat_mat_carrier of
      rat * nat * nat *
        (('a * nat) * ((rat list) list * ((rat list) list) list)) list
  | Arc_mat_carrier of
      nat * (('a * nat) * ((arctic list) list * ((arctic list) list) list)) list
  | Arc_rat_mat_carrier of
      rat * nat *
        (('a * nat) *
          ((arctic_rat list) list * ((arctic_rat list) list) list)) list
  | Lpo of (('a * nat) * nat) list * (('a * nat) * af_entry) list;;

type 'a mult_zero = {times_mult_zero : 'a times; zero_mult_zero : 'a zero};;

let rec ctxt_apply
  x0 s = match x0, s with Hole, s -> s
    | More (f, ss1, c, ss2), s -> Fun (f, append ss1 (ctxt_apply c s :: ss2));;

let rec shows_ctxt _A _B
  = function Hole -> shows_string ['['; ']']
    | More (f, ss1, d, ss2) ->
        comp (shows_prec _A Zero_nat f)
          (comp (shows_string ['('])
            (comp (shows_list_gen (shows_prec_term _A _B Zero_nat) [] []
                    [','; ' '] [','; ' '] ss1)
              (comp (shows_ctxt _A _B d)
                (shows_list_gen (shows_prec_term _A _B Zero_nat) [')']
                  [','; ' '] [','; ' '] [')'] ss2))));;

let rec rp_af (v, (s, (n, (a, (m, d))))) = a;;

let rec unsharp_fun = function Plain f -> f
                      | Sharp f -> f;;

let rec list_union _A
  x0 ys = match x0, ys with [], ys -> ys
    | x :: xs, ys ->
        let zs = list_union _A xs ys in
        (if member _A zs x then zs else x :: zs);;

let rec oneof_aux
  allowed x1 ts = match allowed, x1, ts with
    allowed, [], ts ->
      expecting show_char
        (append ['o'; 'n'; 'e'; ' '; 'o'; 'f'; ' ']
          (shows_list_list show_char allowed []))
        ts
    | allowed, x :: xs, ts ->
        (if eq_list eq_char (map snd (zip x ts)) x
          then Inr (x, trim (drop (size_list x) ts))
          else oneof_aux allowed xs ts);;

let rec oneof xs = oneof_aux xs xs;;

type xmldoc = Xmldoc of char list * xml;;

type domain = Natural of nat | Arctic | Arctic_rat of rat | Int_mat of nat * nat
  | Arc_mat of nat | Arc_rat_mat of rat * nat | Rational of rat * nat |
  Rat_mat of rat * nat * nat;;

let rec label
  xml2name =
    xml_options
      [(['n'; 'u'; 'm'; 'b'; 'e'; 'r'; 'L'; 'a'; 'b'; 'e'; 'l'],
         xml_many_elements
           ['n'; 'u'; 'm'; 'b'; 'e'; 'r'; 'L'; 'a'; 'b'; 'e'; 'l']
           (nata ['n'; 'u'; 'm'; 'b'; 'e'; 'r']) (fun a -> Inl a));
        (['s'; 'y'; 'm'; 'b'; 'o'; 'l'; 'L'; 'a'; 'b'; 'e'; 'l'],
          xml_many_elements
            ['s'; 'y'; 'm'; 'b'; 'o'; 'l'; 'L'; 'a'; 'b'; 'e'; 'l'] xml2name
            (fun a -> Inr a))];;

let rec rules
  xml2name = xml_many_elements ['r'; 'u'; 'l'; 'e'; 's'] (rule xml2name) id;;

let rec isOK m = (match m with Inl _ -> false | Inr _ -> true);;

let mult_zero_int =
  ({times_mult_zero = times_int; zero_mult_zero = zero_inta} :
    Big_int.big_int mult_zero);;

let rec mat_monoI geq1 sd m = list_all (list_ex geq1) (sub_mat sd sd m);;

let rec transpose
  nr x1 = match nr, x1 with nr, [] -> replicate nr []
    | nr, v :: m -> map (fun (a, b) -> a :: b) (zip v (transpose nr m));;

let rec scalar_prodI
  ze pl ti v w = foldr (fun (x, y) -> pl (ti x y)) (zip v w) ze;;

let rec matT_vec_multI
  ze pl ti m v = map (fun w -> scalar_prodI ze pl ti w v) m;;

let rec mat_multI
  ze pl ti nr m1 m2 = map (matT_vec_multI ze pl ti (transpose nr m1)) m2;;

let rec vec_plusI pl v w = map (fun xy -> pl (fst xy) (snd xy)) (zip v w);;

let rec mat_plusI
  pl m1 m2 = map (fun uv -> vec_plusI pl (fst uv) (snd uv)) (zip m1 m2);;

let rec mul_pvarsI _A
  uu uv a x3 = match uu, uv, a, x3 with uu, uv, a, [] -> []
    | ze, ti, a, (x, b) :: vas ->
        let p = ti a b in
        let res = mul_pvarsI _A ze ti a vas in
        (if eqa _A p ze then res else (x, p) :: res);;

type ('a, 'b) l_poly = LPoly of 'b * ('a * 'b) list;;

let rec mul_lpolyI _A
  ze ti a (LPoly (b, vas)) = LPoly (ti a b, mul_pvarsI _A ze ti a vas);;

let rec list_sumI
  ze pl x2 = match ze, pl, x2 with ze, pl, [] -> ze
    | ze, pl, x :: xs -> pl x (list_sumI ze pl xs);;

let rec add_varI _A _B
  uu uv x a xa4 = match uu, uv, x, a, xa4 with uu, uv, x, a, [] -> [(x, a)]
    | ze, pl, x, a, (y, b) :: vas ->
        (if eqa _B x y
          then let s = pl a b in
               (if eqa _A s ze then vas else (x, s) :: vas)
          else (y, b) :: add_varI _A _B ze pl x a vas);;

let rec sum_pvarsI _A _B
  uu uv x2 vbs = match uu, uv, x2, vbs with uu, uv, [], vbs -> vbs
    | ze, pl, (x, a) :: vas, vbs ->
        (if eqa _A a ze then sum_pvarsI _A _B ze pl vas vbs
          else sum_pvarsI _A _B ze pl vas (add_varI _A _B ze pl x a vbs));;

let rec sum_lpolyI _A _B
  ze pl (LPoly (a, vas)) (LPoly (b, vbs)) =
    LPoly (pl a b, sum_pvarsI _A _B ze pl vas vbs);;

let rec l_poly_case f1 (LPoly (a, lista)) = f1 a lista;;

let rec pleftI _A _C
  ze on pl ti mz pi x6 = match ze, on, pl, ti, mz, pi, x6 with
    ze, on, pl, ti, mz, pi, Var x -> LPoly (ze, [(x, on)])
    | ze, on, pl, ti, mz, pi, Fun (f, ts) ->
        let (c, asa) = pi f (size_list ts) in
        (match
          sum_lpolyI _A _C ze pl (LPoly (c, []))
            (list_sumI (LPoly (ze, [])) (sum_lpolyI _A _C ze pl)
              (map (fun at ->
                     mul_lpolyI _A ze ti (fst at)
                       (pleftI _A _C ze on pl ti mz pi (snd at)))
                (zip asa ts)))
          with LPoly (d, []) -> LPoly (mz d, [])
          | LPoly (d, ab :: lista) -> LPoly (d, ab :: lista));;

type arithFun = Arg of nat | Const of nat | Sum of arithFun list |
  Max of arithFun list | Min of arithFun list | Prod of arithFun list;;

type ('a, 'b) lab = Lab of ('a, 'b) lab * 'b |
  FunLab of ('a, 'b) lab * ('a, 'b) lab list | UnLab of 'a;;

type ('a, 'b) sl_inter =
  SL_Inter of nat * ((('a, 'b) lab * nat) * arithFun) list;;

type ('a, 'b, 'c) dPProof = PisEmpty |
  RedPairProc of
    ('a, 'b) lab redpair *
      ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
      ('a, 'b, 'c) dPProof
  | RedPairUrProc of
      ('a, 'b) lab redpair *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ('a, 'b, 'c) dPProof
  | DepGraphProc of
      (('a, 'b, 'c) dPProof option *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list) list
  | MonoRedPairProc of
      ('a, 'b) lab redpair *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ('a, 'b, 'c) dPProof
  | MonoRedPairUrProc of
      ('a, 'b) lab redpair *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ('a, 'b, 'c) dPProof
  | UnlabProc of
      ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ('a, 'b, 'c) dPProof
  | SemlabProc of
      ('a, 'b) sl_inter *
        (('a, 'b) lab -> nat list -> ('b, (('a, 'b) lab list)) sum) *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ('a, 'b, 'c) dPProof
  | RootlabProc of
      ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ('a, 'b, 'c) dPProof
  | SubtermCriterionProc of
      ('a, 'b) lab projL *
        (((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) *
          (pos *
            (((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) *
              (('a, 'b) lab, 'c) term)) list) list *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ('a, 'b, 'c) dPProof
  | SizeChangeSubTerm of
      (((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) *
        ((nat * nat) list * (nat * nat) list)) list
  | SizeChangeRedPair of
      ('a, 'b) lab redpair *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        (((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) *
          ((nat * nat) list * (nat * nat) list)) list
  | FccProc of
      ('a, 'b) lab * (('a, 'b) lab, 'c) ctxt list *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ('a, 'b, 'c) dPProof;;

type ('a, 'b, 'c) tRSProof =
  DPTrans of
    ((('a, 'b) lab shp, 'c) term * (('a, 'b) lab shp, 'c) term) list *
      (('a, 'b) lab shp, 'b, 'c) dPProof
  | RuleRemoval of
      ('a, 'b) lab redpair *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ('a, 'b, 'c) tRSProof
  | Unlab of
      ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ('a, 'b, 'c) tRSProof
  | Semlab of
      ('a, 'b) sl_inter *
        (('a, 'b) lab -> nat list -> ('b, (('a, 'b) lab list)) sum) *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ('a, 'b, 'c) tRSProof
  | Rootlab of
      ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ('a, 'b, 'c) tRSProof
  | Fcc of
      (('a, 'b) lab, 'c) ctxt list *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ('a, 'b, 'c) tRSProof
  | StringReversal of
      ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ('a, 'b, 'c) tRSProof
  | RisEmpty;;

let mult_zero_rat =
  ({times_mult_zero = times_rata; zero_mult_zero = zero_rata} : rat mult_zero);;

type 'a comm_monoid_add =
  {ab_semigroup_add_comm_monoid_add : 'a ab_semigroup_add;
    monoid_add_comm_monoid_add : 'a monoid_add};;

type 'a semiring_0 =
  {comm_monoid_add_semiring_0 : 'a comm_monoid_add;
    mult_zero_semiring_0 : 'a mult_zero; semiring_semiring_0 : 'a semiring};;

type 'a zero_neq_one =
  {one_zero_neq_one : 'a one; zero_zero_neq_one : 'a zero};;

type 'a monoid_mult =
  {semigroup_mult_monoid_mult : 'a semigroup_mult;
    power_monoid_mult : 'a power};;

type 'a semiring_1 =
  {monoid_mult_semiring_1 : 'a monoid_mult;
    semiring_0_semiring_1 : 'a semiring_0;
    zero_neq_one_semiring_1 : 'a zero_neq_one};;

let rec linear_term_impl _A
  xs x1 = match xs, x1 with
    xs, Var x -> (if member _A xs x then None else Some (x :: xs))
    | xs, Fun (uu, []) -> Some xs
    | xs, Fun (f, t :: ts) ->
        (match linear_term_impl _A xs t with None -> None
          | Some ys -> linear_term_impl _A ys (Fun (f, ts)));;

let rec linear_term _B
  t = (match linear_term_impl _B [] t with None -> false | Some _ -> true);;

let subst_empty : ('a, 'b) subst = Subst (fun a -> Var a);;

let rec xml5elements
  tag p1 p2 p3 p4 p5 f (Xml (name, atts, cs, text)) =
    (if eq_list eq_char name tag &&
          (null atts &&
            (eq_nat (size_list cs) (nat (Big_int.big_int_of_int 5)) &&
              is_none text))
      then bind (p1 (nth cs Zero_nat))
             (fun x1 ->
               bind (p2 (nth cs one_nat))
                 (fun x2 ->
                   bind (p3 (nth cs (nat (Big_int.big_int_of_int 2))))
                     (fun x3 ->
                       bind (p4 (nth cs (nat (Big_int.big_int_of_int 3))))
                         (fun x4 ->
                           bind (p5 (nth cs (nat (Big_int.big_int_of_int 4))))
                             (fun x5 -> Inr (f x1 x2 x3 x4 x5))))))
      else no_transform tag (Xml (name, atts, cs, text)));;

let rec manyof cs = many (member eq_char cs);;

let rec spaces x = binda (manyof wspace) (fun _ ts -> Inr ((), ts)) x;;

let rec store c k v = (k, v) :: c;;

let rec lex_extE
  f c x2 x3 = match f, c, x2, x3 with f, c, [], [] -> ((false, true), c)
    | f, c, uu :: uv, [] -> ((true, true), c)
    | f, c, [], uw :: ux -> ((false, false), c)
    | f, c, a :: asa, b :: bs ->
        let (aa, ba) = f c a b in
        let (stri, nstri) = aa in
        (fun ca ->
          (if stri then ((true, true), ca)
            else (if nstri then lex_extE f ca asa bs
                   else ((false, false), ca))))
          ba;;

let rec forAllStriE
  f c x2 = match f, c, x2 with f, c, [] -> (true, c)
    | f, c, t :: ts ->
        let (a, b) = f c t in
        let (stri, _) = a in
        (fun ca -> (if stri then forAllStriE f ca ts else (false, ca)))
          b;;

let rec anyNstriE
  f c x2 = match f, c, x2 with f, c, [] -> (false, c)
    | f, c, s :: ss ->
        let (a, b) = f c s in
        let (_, nstri) = a in
        (fun ca -> (if nstri then (nstri, ca) else anyNstriE f ca ss))
          b;;

let rec lpoE _A _B
  c pr s t =
    (match lookup (eqc (eq_terma _A _B) (eq_terma _A _B)) (s, t) c
      with None ->
        let (v, new_c) =
          (match (s, t) with (Var x, Var y) -> ((false, eqa _B x y), c)
            | (Var x, Fun (g, ts)) ->
              ((false, null ts && eq_nat (pr g Zero_nat) Zero_nat), c)
            | (Fun (f, ss), Var _) ->
              let (con, a) = anyNstriE (fun lc sa -> lpoE _A _B lc pr sa t) c ss
                in
              ((con, con), a)
            | (Fun (f, ss), Fun (g, ts)) ->
              (match anyNstriE (fun lc sa -> lpoE _A _B lc pr sa t) c ss
                with (true, ca) -> ((true, true), ca)
                | (false, ca) ->
                  let prl = pr f (size_list ss) in
                  let prr = pr g (size_list ts) in
                  let (sAllStri, cb) =
                    forAllStriE (fun lc -> lpoE _A _B lc pr s) ca ts in
                  (if less_eq_nat prr prl && sAllStri
                    then (if less_nat prr prl then ((true, true), cb)
                           else lex_extE (fun lc -> lpoE _A _B lc pr) cb ss ts)
                    else ((false, false), cb))))
          in
        (v, store new_c (s, t) v)
      | Some (stri, nstri) -> ((stri, nstri), c));;

let rec catch m f = (match m with Inl a -> f a | Inr a -> Inr a);;

let rec check b e = (if b then Inr () else Inl e);;

let rec forallm
  f x1 = match f, x1 with f, [] -> Inr ()
    | f, x :: xs ->
        bind (catch (f x) (fun xa -> Inl (x, xa))) (fun _ -> forallm f xs);;

let rec check_edges
  ss g c d =
    catch (forallm
            (fun n ->
              catch (forallm
                      (fun m ->
                        check (not (g (m, n)))
                          (comp (shows_string
                                  ['e'; 'd'; 'g'; 'e'; ' '; 'f'; 'r'; 'o'; 'm';
                                    ' '])
                            (comp (ss m)
                              (comp (shows_string [' '; 't'; 'o'; ' '])
                                (ss n)))))
                      d)
                (fun x -> Inl (snd x)))
            c)
      (fun x -> Inl (snd x));;

let monoid_add_int =
  ({semigroup_add_monoid_add = semigroup_add_int; zero_monoid_add = zero_inta} :
    Big_int.big_int monoid_add);;

let comm_monoid_add_int =
  ({ab_semigroup_add_comm_monoid_add = ab_semigroup_add_int;
     monoid_add_comm_monoid_add = monoid_add_int}
    : Big_int.big_int comm_monoid_add);;

let semiring_0_int =
  ({comm_monoid_add_semiring_0 = comm_monoid_add_int;
     mult_zero_semiring_0 = mult_zero_int; semiring_semiring_0 = semiring_int}
    : Big_int.big_int semiring_0);;

let zero_neq_one_int =
  ({one_zero_neq_one = one_inta; zero_zero_neq_one = zero_inta} :
    Big_int.big_int zero_neq_one);;

let monoid_mult_int =
  ({semigroup_mult_monoid_mult = semigroup_mult_int;
     power_monoid_mult = power_int}
    : Big_int.big_int monoid_mult);;

let semiring_1_int =
  ({monoid_mult_semiring_1 = monoid_mult_int;
     semiring_0_semiring_1 = semiring_0_int;
     zero_neq_one_semiring_1 = zero_neq_one_int}
    : Big_int.big_int semiring_1);;

type ('a, 'b) tpoly = PVar of 'a | PNum of 'b | PSum of ('a, 'b) tpoly list |
  PMult of ('a, 'b) tpoly list;;

let bot_bool : bool = false;;

let rec less_bool x0 b = match x0, b with true, b -> false
                    | false, b -> b;;

let rec less_eq_bool x0 b = match x0, b with true, b -> b
                       | false, b -> true;;

let ord_bool = ({less_eq = less_eq_bool; less = less_bool} : bool ord);;

let preorder_bool = ({ord_preorder = ord_bool} : bool preorder);;

let bot_boola = ({preorder_bot = preorder_bool; bot = bot_bool} : bool bot);;

let rec bot_fun _B = (fun _ -> bot _B);;

let rec prightI _A _C
  ze on pl ti mz pi x6 = match ze, on, pl, ti, mz, pi, x6 with
    ze, on, pl, ti, mz, pi, Var x -> LPoly (ze, [(x, on)])
    | ze, on, pl, ti, mz, pi, Fun (f, ts) ->
        let (c, asa) = pi f (size_list ts) in
        let LPoly (d, a) =
          sum_lpolyI _A _C ze pl (LPoly (c, []))
            (list_sumI (LPoly (ze, [])) (sum_lpolyI _A _C ze pl)
              (map (fun at ->
                     mul_lpolyI _A ze ti (fst at)
                       (prightI _A _C ze on pl ti mz pi (snd at)))
                (zip asa ts)))
          in
        LPoly (mz d, a);;

let rec lpo_E _A _B pr s t = fst (lpoE _A _B [] pr s t);;

let rec lpo_unbounded _A _B = lpo_E _A _B;;

let monoid_add_rat =
  ({semigroup_add_monoid_add = semigroup_add_rat; zero_monoid_add = zero_rata} :
    rat monoid_add);;

let comm_monoid_add_rat =
  ({ab_semigroup_add_comm_monoid_add = ab_semigroup_add_rat;
     monoid_add_comm_monoid_add = monoid_add_rat}
    : rat comm_monoid_add);;

let semiring_0_rat =
  ({comm_monoid_add_semiring_0 = comm_monoid_add_rat;
     mult_zero_semiring_0 = mult_zero_rat; semiring_semiring_0 = semiring_rat}
    : rat semiring_0);;

let zero_neq_one_rat =
  ({one_zero_neq_one = one_rata; zero_zero_neq_one = zero_rata} :
    rat zero_neq_one);;

let monoid_mult_rat =
  ({semigroup_mult_monoid_mult = semigroup_mult_rat;
     power_monoid_mult = power_rat}
    : rat monoid_mult);;

let semiring_1_rat =
  ({monoid_mult_semiring_1 = monoid_mult_rat;
     semiring_0_semiring_1 = semiring_0_rat;
     zero_neq_one_semiring_1 = zero_neq_one_rat}
    : rat semiring_1);;

let rec full_af f n i = true;;

let rec rp_desc (v, (s, (n, (a, (m, d))))) = d;;

let rec rp_mono (v, (s, (n, (a, (m, d))))) = m;;

let rec funs_term_list
  = function Var x -> []
    | Fun (f, ts) -> f :: flat_map funs_term_list ts;;

let rec funs_rule_list
  r = append (funs_term_list (fst r)) (funs_term_list (snd r));;

let rec funs_trs_list _A r = remdups _A (flat_map funs_rule_list r);;

let rec vars_term_lista
  = function Var x -> [x]
    | Fun (f, ts) -> flat_map vars_term_lista ts;;

let rec vars_rule_list
  r = append (vars_term_lista (fst r)) (vars_term_lista (snd r));;

let rec vars_trs_list _B trs = remdups _B (flat_map vars_rule_list trs);;

let rec xml2nd_choice
  tag p1 cn p2 f (Xml (name, atts, cs, text)) =
    let l = size_list cs in
    (if eq_list eq_char name tag &&
          (null atts &&
            (less_eq_nat (nat (Big_int.big_int_of_int 2)) l && is_none text))
      then bind (p1 (nth cs Zero_nat))
             (fun x1 ->
               bind (boola cn (nth cs one_nat))
                 (fun b ->
                   (if b then bind (p2 (nth cs (minus_nat l one_nat)))
                                (fun x2 -> Inr (f x1 (Some x2)))
                     else Inr (f x1 None))))
      else no_transform tag (Xml (name, atts, cs, text)));;

let letters : char list
  = ['a'; 'b'; 'c'; 'd'; 'e'; 'f'; 'g'; 'h'; 'i'; 'j'; 'k'; 'l'; 'm'; 'n'; 'o';
      'p'; 'q'; 'r'; 's'; 't'; 'u'; 'v'; 'w'; 'x'; 'y'; 'z'; 'A'; 'B'; 'C'; 'D';
      'E'; 'F'; 'G'; 'H'; 'I'; 'J'; 'K'; 'L'; 'M'; 'N'; 'O'; 'P'; 'Q'; 'R'; 'S';
      'T'; 'U'; 'V'; 'W'; 'X'; 'Y'; 'Z'; '_'; '0'; '1'; '2'; '3'; '4'; '5'; '6';
      '7'; '8'; '9'; '&'; ';'; ':'];;

let rec alter1a (Alter1 x) = x;;

let rec alter2a (Alter2 x) = x;;

let rec alter3a (Alter3 x) = x;;

let rec alter4a (Alter4 x) = x;;

let rec alter5a (Alter5 x) = x;;

let rec alter6a (Alter6 x) = x;;

let rec alter7a (Alter7 x) = x;;

let rec alter8a (Alter8 x) = x;;

let rec alter9a (Alter9 x) = x;;

let rec precedence
  xml2name =
    xml_many_elements
      ['s'; 't'; 'a'; 't'; 'u'; 's'; 'P'; 'r'; 'e'; 'c'; 'e'; 'd'; 'e'; 'n';
        'c'; 'e']
      (xml4elements
        ['s'; 't'; 'a'; 't'; 'u'; 's'; 'P'; 'r'; 'e'; 'c'; 'e'; 'd'; 'e'; 'n';
          'c'; 'e'; 'E'; 'n'; 't'; 'r'; 'y']
        xml2name (nata ['a'; 'r'; 'i'; 't'; 'y'])
        (nata ['p'; 'r'; 'e'; 'c'; 'e'; 'd'; 'e'; 'n'; 'c'; 'e'])
        (xml_options
          [(['l'; 'e'; 'x'], xml0elements ['l'; 'e'; 'x'] ());
            (['m'; 'u'; 'l'],
              (fun _ ->
                Inl ['m'; 'u'; 'l'; 't'; 'i'; 's'; 'e'; 't'; '-'; 'c'; 'o'; 'm';
                      'p'; 'a'; 'r'; 'i'; 's'; 'o'; 'n'; 's'; ' '; 'n'; 'o';
                      't'; ' '; 's'; 'u'; 'p'; 'p'; 'o'; 'r'; 't'; 'e'; 'd']))])
        (fun f a p _ -> ((f, a), p)))
      id;;

let rec xml1to2elements
  tag p1 p2 f (Xml (name, atts, cs, text)) =
    let l = size_list cs in
    (if eq_list eq_char name tag &&
          (null atts &&
            (less_eq_nat one_nat l &&
              (less_eq_nat l (nat (Big_int.big_int_of_int 2)) && is_none text)))
      then bind (p1 (nth cs Zero_nat))
             (fun x1 ->
               (if eq_nat l (nat (Big_int.big_int_of_int 2))
                 then bind (p2 (nth cs one_nat))
                        (fun x2 -> Inr (f x1 (Some x2)))
                 else Inr (f x1 None)))
      else no_transform tag (Xml (name, atts, cs, text)));;

let rec path_order
  xml2name =
    xml1to2elements ['p'; 'a'; 't'; 'h'; 'O'; 'r'; 'd'; 'e'; 'r']
      (precedence xml2name) (afs xml2name)
      (fun pr a ->
        (match a with None -> Lpo (pr, []) | Some aa -> Lpo (pr, aa)));;

let rec alter10a (Alter10 x) = x;;

let rec ge_rat x y = less_eq_rat y x;;

let non_strict_order_rat = ({ge = ge_rat} : rat non_strict_order);;

let rec max0_rat
  x = max ord_rat (fract (Big_int.big_int_of_int 0) (Big_int.big_int_of_int 1))
        x;;

let ordered_ab_semigroup_rat =
  ({ab_semigroup_add_ordered_ab_semigroup = ab_semigroup_add_rat;
     non_strict_order_ordered_ab_semigroup = non_strict_order_rat}
    : rat ordered_ab_semigroup);;

let max_ordered_monoid_add_rat =
  ({monoid_add_max_ordered_monoid_add = monoid_add_rat;
     ordered_ab_semigroup_max_ordered_monoid_add = ordered_ab_semigroup_rat;
     max0 = max0_rat}
    : rat max_ordered_monoid_add);;

type 'a ab_semigroup_mult =
  {semigroup_mult_ab_semigroup_mult : 'a semigroup_mult};;

type 'a comm_semiring =
  {ab_semigroup_mult_comm_semiring : 'a ab_semigroup_mult;
    semiring_comm_semiring : 'a semiring};;

type 'a comm_semiring_0 =
  {comm_semiring_comm_semiring_0 : 'a comm_semiring;
    semiring_0_comm_semiring_0 : 'a semiring_0};;

type 'a comm_monoid_mult =
  {ab_semigroup_mult_comm_monoid_mult : 'a ab_semigroup_mult;
    monoid_mult_comm_monoid_mult : 'a monoid_mult};;

type 'a comm_semiring_1 =
  {comm_monoid_mult_comm_semiring_1 : 'a comm_monoid_mult;
    comm_semiring_0_comm_semiring_1 : 'a comm_semiring_0;
    dvd_comm_semiring_1 : 'a dvd; semiring_1_comm_semiring_1 : 'a semiring_1};;

let ab_semigroup_mult_rat =
  ({semigroup_mult_ab_semigroup_mult = semigroup_mult_rat} :
    rat ab_semigroup_mult);;

let comm_semiring_rat =
  ({ab_semigroup_mult_comm_semiring = ab_semigroup_mult_rat;
     semiring_comm_semiring = semiring_rat}
    : rat comm_semiring);;

let comm_semiring_0_rat =
  ({comm_semiring_comm_semiring_0 = comm_semiring_rat;
     semiring_0_comm_semiring_0 = semiring_0_rat}
    : rat comm_semiring_0);;

let comm_monoid_mult_rat =
  ({ab_semigroup_mult_comm_monoid_mult = ab_semigroup_mult_rat;
     monoid_mult_comm_monoid_mult = monoid_mult_rat}
    : rat comm_monoid_mult);;

let comm_semiring_1_rat =
  ({comm_monoid_mult_comm_semiring_1 = comm_monoid_mult_rat;
     comm_semiring_0_comm_semiring_1 = comm_semiring_0_rat;
     dvd_comm_semiring_1 = dvd_rat; semiring_1_comm_semiring_1 = semiring_1_rat}
    : rat comm_semiring_1);;

let rec rat_mono
  x = less_eq_rat (fract (Big_int.big_int_of_int 1) (Big_int.big_int_of_int 1))
        x;;

let rat_name : char list
  = ['r'; 'a'; 't'; 'i'; 'o'; 'n'; 'a'; 'l'; 's'; ' '; '('; 'w'; 'i'; 't'; 'h';
      ' '; 'n'; 'e'; 'g'; 'a'; 't'; 'i'; 'v'; 'e'; ' '; 'c'; 'o'; 'n'; 's'; 't';
      'a'; 'n'; 't'; 's'; ')'];;

let rec rat_gt delta = (fun x y -> less_eq_rat delta (minus_rat x y));;

let rec ge_arctic_rat
  x xa1 = match x, xa1 with x, MinInfty_rat -> true
    | MinInfty_rat, Num_arc_rat uu -> false
    | Num_arc_rat x, Num_arc_rat y -> less_eq_rat y x;;

let non_strict_order_arctic_rat =
  ({ge = ge_arctic_rat} : arctic_rat non_strict_order);;

let rec get_comp_apos
  (wfe, (ze, (on, (def, (pl, (ti, (mz, (ge, (gt, (mo, (de, (ap, cm)))))))))))) =
    ap;;

let rec mat_arc_posI ap m = ap (nth (nth m Zero_nat) Zero_nat);;

let rec ge_arctic
  x xa1 = match x, xa1 with x, MinInfty -> true
    | MinInfty, Num_arc uu -> false
    | Num_arc x, Num_arc y -> Big_int.le_big_int y x;;

let non_strict_order_arctic = ({ge = ge_arctic} : arctic non_strict_order);;

let rec get_comp_check_mono
  (wfe, (ze, (on, (def, (pl, (ti, (mz, (ge, (gt, (mo, (de, (ap, cm)))))))))))) =
    cm;;

let rec mat_mono sd m = mat_monoI m sd;;

let rec get_comp_description
  (wfe, (ze, (on, (def, (pl, (ti, (mz, (ge, (gt, (mo, (de, (ap, cm)))))))))))) =
    de;;

let rec get_comp_mono
  (wfe, (ze, (on, (def, (pl, (ti, (mz, (ge, (gt, (mo, (de, (ap, cm)))))))))))) =
    mo;;

let rec get_comp_gt
  (wfe, (ze, (on, (def, (pl, (ti, (mz, (ge, (gt, (mo, (de, (ap, cm)))))))))))) =
    gt;;

let rec ge_int x y = Big_int.le_big_int y x;;

let non_strict_order_int = ({ge = ge_int} : Big_int.big_int non_strict_order);;

let rec max0_int x = max ord_int (Big_int.big_int_of_int 0) x;;

let ordered_ab_semigroup_int =
  ({ab_semigroup_add_ordered_ab_semigroup = ab_semigroup_add_int;
     non_strict_order_ordered_ab_semigroup = non_strict_order_int}
    : Big_int.big_int ordered_ab_semigroup);;

let max_ordered_monoid_add_int =
  ({monoid_add_max_ordered_monoid_add = monoid_add_int;
     ordered_ab_semigroup_max_ordered_monoid_add = ordered_ab_semigroup_int;
     max0 = max0_int}
    : Big_int.big_int max_ordered_monoid_add);;

let rec get_comp_def
  (wfe, (ze, (on, (def, (pl, (ti, (mz, (ge, (gt, (mo, (de, (ap, cm)))))))))))) =
    def;;

let rec vec_coeff
  xml2coeff =
    xml_many_elements ['v'; 'e'; 'c'; 't'; 'o'; 'r']
      (xml1element ['c'; 'o'; 'e'; 'f'; 'f'; 'i'; 'c'; 'i'; 'e'; 'n'; 't']
        xml2coeff id)
      id;;

let rec mat_coeff
  ze xml2coeff =
    xml_options
      [(['m'; 'a'; 't'; 'r'; 'i'; 'x'],
         xml_many_elements ['m'; 'a'; 't'; 'r'; 'i'; 'x'] (vec_coeff xml2coeff)
           id);
        (['v'; 'e'; 'c'; 't'; 'o'; 'r'],
          xml_change (vec_coeff xml2coeff)
            (fun v ->
              v :: replicate (minus_nat (size_list v) one_nat)
                     (replicate (size_list v) ze)))];;

let rec pos_arctic_rat
  = function MinInfty_rat -> false
    | Num_arc_rat n ->
        less_eq_rat
          (fract (Big_int.big_int_of_int 0) (Big_int.big_int_of_int 1)) n;;

let arctic_rat_name : char list
  = ['a'; 'r'; 'c'; 't'; 'i'; 'c'; ' '; 'r'; 'a'; 't'; 'i'; 'o'; 'n'; 'a'; 'l';
      's'];;

let rec gt_arctic_rat
  delta uu x2 = match delta, uu, x2 with delta, uu, MinInfty_rat -> true
    | delta, MinInfty_rat, Num_arc_rat uv -> false
    | delta, Num_arc_rat x, Num_arc_rat y -> rat_gt delta x y;;

let rec times_arctic_rat
  x0 y = match x0, y with MinInfty_rat, y -> MinInfty_rat
    | Num_arc_rat v, MinInfty_rat -> MinInfty_rat
    | Num_arc_rat x, Num_arc_rat y -> Num_arc_rat (plus_rat x y);;

let rec plus_arctic_rat
  x0 y = match x0, y with MinInfty_rat, y -> y
    | Num_arc_rat v, MinInfty_rat -> Num_arc_rat v
    | Num_arc_rat x, Num_arc_rat y -> Num_arc_rat (max ord_rat x y);;

let one_arctic_rat : arctic_rat
  = Num_arc_rat (fract (Big_int.big_int_of_int 0) (Big_int.big_int_of_int 1));;

let zero_arctic_rat : arctic_rat = MinInfty_rat;;

let rec eq_arctic_rat
  x0 x1 = match x0, x1 with MinInfty_rat, MinInfty_rat -> true
    | Num_arc_rat rata, Num_arc_rat rat -> eq_rat rata rat
    | MinInfty_rat, Num_arc_rat rat -> false
    | Num_arc_rat rat, MinInfty_rat -> false;;

let eq_arctic_rata = ({eq = eq_arctic_rat} : arctic_rat eq);;

let rec arctic_rat_coeff
  x = xml_options
        [(['i'; 'n'; 't'; 'e'; 'g'; 'e'; 'r'],
           xml_change rat (fun a -> Num_arc_rat a));
          (['r'; 'a'; 't'; 'i'; 'o'; 'n'; 'a'; 'l'],
            xml_change rat (fun a -> Num_arc_rat a));
          (['m'; 'i'; 'n'; 'u'; 's'; 'I'; 'n'; 'f'; 'i'; 'n'; 'i'; 't'; 'y'],
            xml0elements
              ['m'; 'i'; 'n'; 'u'; 's'; 'I'; 'n'; 'f'; 'i'; 'n'; 'i'; 't'; 'y']
              MinInfty_rat)]
        x;;

let rec pos_arctic
  = function MinInfty -> false
    | Num_arc n -> Big_int.le_big_int (Big_int.big_int_of_int 0) n;;

let arctic_name : char list
  = ['a'; 'r'; 'c'; 't'; 'i'; 'c'; ' '; 's'; 'e'; 'm'; 'i'; 'r'; 'i'; 'n';
      'g'];;

let rec gt_arctic
  uu x1 = match uu, x1 with uu, MinInfty -> true
    | MinInfty, Num_arc uv -> false
    | Num_arc x, Num_arc y -> Big_int.lt_big_int y x;;

let rec times_arctic
  x0 y = match x0, y with MinInfty, y -> MinInfty
    | Num_arc v, MinInfty -> MinInfty
    | Num_arc x, Num_arc y -> Num_arc (Big_int.add_big_int x y);;

let rec plus_arctic
  x0 y = match x0, y with MinInfty, y -> y
    | Num_arc v, MinInfty -> Num_arc v
    | Num_arc x, Num_arc y -> Num_arc (max ord_int x y);;

let one_arctic : arctic = Num_arc (Big_int.big_int_of_int 0);;

let zero_arctic : arctic = MinInfty;;

let rec eq_arctic
  x0 x1 = match x0, x1 with MinInfty, MinInfty -> true
    | Num_arc inta, Num_arc int -> Big_int.eq_big_int inta int
    | MinInfty, Num_arc int -> false
    | Num_arc int, MinInfty -> false;;

let eq_arctica = ({eq = eq_arctic} : arctic eq);;

let rec arctic_coeff
  x = xml_options
        [(['i'; 'n'; 't'; 'e'; 'g'; 'e'; 'r'],
           xml_change (int ['i'; 'n'; 't'; 'e'; 'g'; 'e'; 'r'])
             (fun a -> Num_arc a));
          (['m'; 'i'; 'n'; 'u'; 's'; 'I'; 'n'; 'f'; 'i'; 'n'; 'i'; 't'; 'y'],
            xml0elements
              ['m'; 'i'; 'n'; 'u'; 's'; 'I'; 'n'; 'f'; 'i'; 'n'; 'i'; 't'; 'y']
              MinInfty)]
        x;;

let ab_semigroup_mult_int =
  ({semigroup_mult_ab_semigroup_mult = semigroup_mult_int} :
    Big_int.big_int ab_semigroup_mult);;

let comm_semiring_int =
  ({ab_semigroup_mult_comm_semiring = ab_semigroup_mult_int;
     semiring_comm_semiring = semiring_int}
    : Big_int.big_int comm_semiring);;

let comm_semiring_0_int =
  ({comm_semiring_comm_semiring_0 = comm_semiring_int;
     semiring_0_comm_semiring_0 = semiring_0_int}
    : Big_int.big_int comm_semiring_0);;

let comm_monoid_mult_int =
  ({ab_semigroup_mult_comm_monoid_mult = ab_semigroup_mult_int;
     monoid_mult_comm_monoid_mult = monoid_mult_int}
    : Big_int.big_int comm_monoid_mult);;

let comm_semiring_1_int =
  ({comm_monoid_mult_comm_semiring_1 = comm_monoid_mult_int;
     comm_semiring_0_comm_semiring_1 = comm_semiring_0_int;
     dvd_comm_semiring_1 = dvd_int; semiring_1_comm_semiring_1 = semiring_1_int}
    : Big_int.big_int comm_semiring_1);;

let rec monom_mult _A
  x0 n = match x0, n with [], n -> n
    | (x, p) :: m, n ->
        (match extract (fun yq -> eqa _A (fst yq) x) n
          with None -> (x, p) :: monom_mult _A m n
          | Some (n1, ((_, q), n2)) ->
            (x, plus_nat p q) :: monom_mult _A m (append n1 n2));;

let rec monom_mult_poly _A (_B1, _B2)
  uu x1 = match uu, x1 with uu, [] -> []
    | (ma, c), (m, d) :: p ->
        (if eqa _B1 (times _B2.mult_zero_semiring_0.times_mult_zero c d)
              (zero _B2.mult_zero_semiring_0.zero_mult_zero)
          then monom_mult_poly _A (_B1, _B2) (ma, c) p
          else (monom_mult _A ma m,
                 times _B2.mult_zero_semiring_0.times_mult_zero c d) ::
                 monom_mult_poly _A (_B1, _B2) (ma, c) p);;

let rec eq_monom _A
  x0 n = match x0, n with [], n -> null n
    | (x, p) :: m, n ->
        (match extract (fun yq -> eqa _A (fst yq) x) n with None -> false
          | Some (n1, ((_, q), n2)) ->
            eq_nat p q && eq_monom _A m (append n1 n2));;

let rec poly_add _A (_B1, _B2)
  x0 q = match x0, q with [], q -> q
    | (m, c) :: p, q ->
        (match extract (fun mc -> eq_monom _A (fst mc) m) q
          with None -> (m, c) :: poly_add _A (_B1, _B2) p q
          | Some (q1, ((_, d), q2)) ->
            (if eqa _B1
                  (plus _B2.comm_monoid_add_semiring_0.monoid_add_comm_monoid_add.semigroup_add_monoid_add.plus_semigroup_add
                    c d)
                  (zero _B2.mult_zero_semiring_0.zero_mult_zero)
              then poly_add _A (_B1, _B2) p (append q1 q2)
              else (m, plus _B2.comm_monoid_add_semiring_0.monoid_add_comm_monoid_add.semigroup_add_monoid_add.plus_semigroup_add
                         c d) ::
                     poly_add _A (_B1, _B2) p (append q1 q2)));;

let rec poly_mult _A (_B1, _B2)
  x0 q = match x0, q with [], q -> []
    | mc :: p, q ->
        poly_add _A (_B1, _B2) (monom_mult_poly _A (_B1, _B2) mc q)
          (poly_mult _A (_B1, _B2) p q);;

let rec one_poly _B
  = [([], one _B.monoid_mult_semiring_1.power_monoid_mult.one_power)];;

let zero_poly : (('a * nat) list * 'b) list = [];;

let rec poly_of _A (_B1, _B2)
  = function
    PNum i ->
      (if eqa _B1 i
            (zero _B2.semiring_1_comm_semiring_1.zero_neq_one_semiring_1.zero_zero_neq_one)
        then [] else [([], i)])
    | PVar x ->
        [([(x, one_nat)],
           one _B2.semiring_1_comm_semiring_1.monoid_mult_semiring_1.power_monoid_mult.one_power)]
    | PSum [] -> zero_poly
    | PSum (p :: ps) ->
        poly_add _A
          (_B1, _B2.comm_semiring_0_comm_semiring_1.semiring_0_comm_semiring_0)
          (poly_of _A (_B1, _B2) p) (poly_of _A (_B1, _B2) (PSum ps))
    | PMult [] -> one_poly _B2.semiring_1_comm_semiring_1
    | PMult (p :: ps) ->
        poly_mult _A
          (_B1, _B2.comm_semiring_0_comm_semiring_1.semiring_0_comm_semiring_0)
          (poly_of _A (_B1, _B2) p) (poly_of _A (_B1, _B2) (PMult ps));;

let rec fit_length
  uu x1 uv = match uu, x1, uv with uu, Zero_nat, uv -> []
    | a, Suc v, [] -> replicate (Suc v) a
    | a, Suc n, b :: asa -> b :: fit_length a n asa;;

let rec get_comp_times
  (wfe, (ze, (on, (def, (pl, (ti, (mz, (ge, (gt, (mo, (de, (ap, cm)))))))))))) =
    ti;;

let rec get_comp_plus
  (wfe, (ze, (on, (def, (pl, (ti, (mz, (ge, (gt, (mo, (de, (ap, cm)))))))))))) =
    pl;;

let rec get_comp_1
  (wfe, (ze, (on, (def, (pl, (ti, (mz, (ge, (gt, (mo, (de, (ap, cm)))))))))))) =
    on;;

let rec int_mono x = Big_int.le_big_int (Big_int.big_int_of_int 1) x;;

let int_name : char list
  = ['n'; 'a'; 't'; 'u'; 'r'; 'a'; 'l'; 's'; ' '; 'w'; 'i'; 't'; 'h'; ' '; 'n';
      'e'; 'g'; 'a'; 't'; 'i'; 'v'; 'e'; ' '; 'c'; 'o'; 'n'; 's'; 't'; 'a'; 'n';
      't'; 's'];;

let rec get_comp_0
  (wfe, (ze, (on, (def, (pl, (ti, (mz, (ge, (gt, (mo, (de, (ap, cm)))))))))))) =
    ze;;

let rec sum_lpoly
  uu x1 ys = match uu, x1, ys with uu, [], ys -> ys
    | uv, v :: va, [] -> v :: va
    | pl, x :: xs, y :: ys -> pl x y :: sum_lpoly pl xs ys;;

let rec lpoly_of _A
  uu uv uw ux x4 = match uu, uv, uw, ux, x4 with
    uu, uv, uw, ux, PNum i -> Inr (i, [])
    | ze, on, pl, ti, PVar x -> Inr (ze, append (replicate x ze) [on])
    | ze, on, pl, ti, PSum [] -> Inr (ze, [])
    | ze, on, pl, ti, PSum (p :: ps) ->
        bind (lpoly_of _A ze on pl ti p)
          (fun (cp, ncp) ->
            bind (lpoly_of _A ze on pl ti (PSum ps))
              (fun (cq, ncq) -> Inr (pl cp cq, sum_lpoly pl ncp ncq)))
    | ze, on, pl, ti, PMult [] -> Inr (on, [])
    | ze, on, pl, ti, PMult (p :: ps) ->
        bind (lpoly_of _A ze on pl ti p)
          (fun (cp, ncp) ->
            bind (lpoly_of _A ze on pl ti (PMult ps))
              (fun (cq, ncq) ->
                (if list_all (eqa _A ze) ncp
                  then Inr (ti cp cq, map (ti cp) ncq)
                  else (if list_all (eqa _A ze) ncq
                         then Inr (ti cp cq, map (fun x -> ti x cq) ncp)
                         else Inl ['c'; 'a'; 'n'; 'n'; 'o'; 't'; ' '; 't'; 'r';
                                    'a'; 'n'; 's'; 'f'; 'o'; 'r'; 'm'; ' '; 'n';
                                    'o'; 'n'; '-'; 'l'; 'i'; 'n'; 'e'; 'a'; 'r';
                                    ' '; 'p'; 'o'; 'l'; 'y'; 'n'; 'o'; 'm'; 'i';
                                    'a'; 'l'; ' '; 't'; 'o'; ' '; 'l'; 'i'; 'n';
                                    'e'; 'a'; 'r'; ' '; 'p'; 'o'; 'l'; 'y'; 'n';
                                    'o'; 'm'; 'i'; 'a'; 'l']))));;

let rec int_coeff x = int ['i'; 'n'; 't'; 'e'; 'g'; 'e'; 'r'] x;;

let rec polynomial
  xml2coeff x =
    xml1element ['p'; 'o'; 'l'; 'y'; 'n'; 'o'; 'm'; 'i'; 'a'; 'l']
      (xml_options
        [(['c'; 'o'; 'e'; 'f'; 'f'; 'i'; 'c'; 'i'; 'e'; 'n'; 't'],
           xml1element ['c'; 'o'; 'e'; 'f'; 'f'; 'i'; 'c'; 'i'; 'e'; 'n'; 't']
             xml2coeff (fun a -> PNum a));
          (['v'; 'a'; 'r'; 'i'; 'a'; 'b'; 'l'; 'e'],
            xml_change (nata ['v'; 'a'; 'r'; 'i'; 'a'; 'b'; 'l'; 'e'])
              (fun n -> PVar (minus_nat n one_nat)));
          (['s'; 'u'; 'm'],
            xml_many_elements ['s'; 'u'; 'm'] (polynomial xml2coeff)
              (fun a -> PSum a));
          (['p'; 'r'; 'o'; 'd'; 'u'; 'c'; 't'],
            xml_many_elements ['p'; 'r'; 'o'; 'd'; 'u'; 'c'; 't']
              (polynomial xml2coeff) (fun a -> PMult a))])
      id x;;

let rec domain_case
  f1 f2 f3 f4 f5 f6 f7 f8 x8 = match f1, f2, f3, f4, f5, f6, f7, f8, x8 with
    f1, f2, f3, f4, f5, f6, f7, f8, Rat_mat (rat, nat1, nat2) ->
      f8 rat nat1 nat2
    | f1, f2, f3, f4, f5, f6, f7, f8, Rational (rat, nat) -> f7 rat nat
    | f1, f2, f3, f4, f5, f6, f7, f8, Arc_rat_mat (rat, nat) -> f6 rat nat
    | f1, f2, f3, f4, f5, f6, f7, f8, Arc_mat nat -> f5 nat
    | f1, f2, f3, f4, f5, f6, f7, f8, Int_mat (nat1, nat2) -> f4 nat1 nat2
    | f1, f2, f3, f4, f5, f6, f7, f8, Arctic_rat rat -> f3 rat
    | f1, f2, f3, f4, f5, f6, f7, f8, Arctic -> f2
    | f1, f2, f3, f4, f5, f6, f7, f8, Natural nat -> f1 nat;;

let rec rat_domain
  x = xml1element ['r'; 'a'; 't'; 'i'; 'o'; 'n'; 'a'; 'l'; 's']
        (xml1element ['d'; 'e'; 'l'; 't'; 'a'] rat id) id x;;

let rec basic_domain
  x = xml_options
        [(['n'; 'a'; 't'; 'u'; 'r'; 'a'; 'l'; 's'],
           xml0elements ['n'; 'a'; 't'; 'u'; 'r'; 'a'; 'l'; 's']
             (fun a -> Natural a));
          (['a'; 'r'; 'c'; 't'; 'i'; 'c'],
            xml1element ['a'; 'r'; 'c'; 't'; 'i'; 'c']
              (xml1element ['d'; 'o'; 'm'; 'a'; 'i'; 'n']
                (xml_options
                  [(['n'; 'a'; 't'; 'u'; 'r'; 'a'; 'l'; 's'],
                     xml0elements ['n'; 'a'; 't'; 'u'; 'r'; 'a'; 'l'; 's']
                       (fun _ -> Arctic));
                    (['i'; 'n'; 't'; 'e'; 'g'; 'e'; 'r'; 's'],
                      xml0elements ['i'; 'n'; 't'; 'e'; 'g'; 'e'; 'r'; 's']
                        (fun _ -> Arctic));
                    (['r'; 'a'; 't'; 'i'; 'o'; 'n'; 'a'; 'l'; 's'],
                      xml_change rat_domain (fun r _ -> Arctic_rat r))])
                id)
              id);
          (['r'; 'a'; 't'; 'i'; 'o'; 'n'; 'a'; 'l'; 's'],
            xml_change rat_domain (fun a b -> Rational (a, b)))]
        x;;

let rec interpretation_type
  x = xml1element ['t'; 'y'; 'p'; 'e']
        (xml_options
          [(['p'; 'o'; 'l'; 'y'; 'n'; 'o'; 'm'; 'i'; 'a'; 'l'],
             xml2elements ['p'; 'o'; 'l'; 'y'; 'n'; 'o'; 'm'; 'i'; 'a'; 'l']
               (xml1element ['d'; 'o'; 'm'; 'a'; 'i'; 'n']
                 (xml_options
                   [(['n'; 'a'; 't'; 'u'; 'r'; 'a'; 'l'; 's'], basic_domain);
                     (['a'; 'r'; 'c'; 't'; 'i'; 'c'], basic_domain);
                     (['r'; 'a'; 't'; 'i'; 'o'; 'n'; 'a'; 'l'; 's'],
                       basic_domain);
                     (['m'; 'a'; 't'; 'r'; 'i'; 'c'; 'e'; 's'],
                       xml3elements ['m'; 'a'; 't'; 'r'; 'i'; 'c'; 'e'; 's']
                         (nata ['d'; 'i'; 'm'; 'e'; 'n'; 's'; 'i'; 'o'; 'n'])
                         (nata ['s'; 't'; 'r'; 'i'; 'c'; 't'; 'D'; 'i'; 'm';
                                 'e'; 'n'; 's'; 'i'; 'o'; 'n'])
                         (xml1element ['d'; 'o'; 'm'; 'a'; 'i'; 'n']
                           basic_domain id)
                         (fun di sd domain d ->
                           (match domain d with Natural _ -> Int_mat (di, sd)
                             | Arctic -> Arc_mat di
                             | Arctic_rat delta -> Arc_rat_mat (delta, di)
                             | Rational (delta, _) ->
                               Rat_mat (delta, di, sd))))])
                 id)
               (nata ['d'; 'e'; 'g'; 'r'; 'e'; 'e']) (fun typea -> typea));
            (['m'; 'a'; 't'; 'r'; 'i'; 'x'; 'I'; 'n'; 't'; 'e'; 'r'; 'p'; 'r';
               'e'; 't'; 'a'; 't'; 'i'; 'o'; 'n'],
              xml3elements
                ['m'; 'a'; 't'; 'r'; 'i'; 'x'; 'I'; 'n'; 't'; 'e'; 'r'; 'p';
                  'r'; 'e'; 't'; 'a'; 't'; 'i'; 'o'; 'n']
                (xml1element ['d'; 'o'; 'm'; 'a'; 'i'; 'n'] basic_domain id)
                (nata ['d'; 'i'; 'm'; 'e'; 'n'; 's'; 'i'; 'o'; 'n'])
                (nata ['s'; 't'; 'r'; 'i'; 'c'; 't'; 'D'; 'i'; 'm'; 'e'; 'n';
                        's'; 'i'; 'o'; 'n'])
                (fun domain di sd ->
                  (match domain Zero_nat with Natural _ -> Int_mat (di, sd)
                    | Arctic -> Arc_mat di
                    | Arctic_rat delta -> Arc_rat_mat (delta, di)
                    | Rational (delta, _) -> Rat_mat (delta, di, sd))))])
        id x;;

let rec interpretation
  xml2name =
    xml1many_elements_gen
      ['i'; 'n'; 't'; 'e'; 'r'; 'p'; 'r'; 'e'; 't'; 'a'; 't'; 'i'; 'o'; 'n']
      interpretation_type
      (fun a ->
        (match a
          with Natural deg ->
            (if less_eq_nat deg one_nat
              then xml3elements ['i'; 'n'; 't'; 'e'; 'r'; 'p'; 'r'; 'e'; 't']
                     xml2name (nata ['a'; 'r'; 'i'; 't'; 'y'])
                     (fun x ->
                       bind (polynomial int_coeff x)
                         (lpoly_of eq_int
                           (get_comp_0
                             ((fun _ -> true),
                               ((Big_int.big_int_of_int 0),
                                 ((Big_int.big_int_of_int 1),
                                   ((Big_int.big_int_of_int 1),
                                     (Big_int.add_big_int,
                                       (Big_int.mult_big_int,
 (max0_int,
   (ge_int,
     ((fun xa y -> Big_int.lt_big_int y xa),
       (true, (int_name, ((fun _ -> true), int_mono)))))))))))))
                           (get_comp_1
                             ((fun _ -> true),
                               ((Big_int.big_int_of_int 0),
                                 ((Big_int.big_int_of_int 1),
                                   ((Big_int.big_int_of_int 1),
                                     (Big_int.add_big_int,
                                       (Big_int.mult_big_int,
 (max0_int,
   (ge_int,
     ((fun xa y -> Big_int.lt_big_int y xa),
       (true, (int_name, ((fun _ -> true), int_mono)))))))))))))
                           (get_comp_plus
                             ((fun _ -> true),
                               ((Big_int.big_int_of_int 0),
                                 ((Big_int.big_int_of_int 1),
                                   ((Big_int.big_int_of_int 1),
                                     (Big_int.add_big_int,
                                       (Big_int.mult_big_int,
 (max0_int,
   (ge_int,
     ((fun xa y -> Big_int.lt_big_int y xa),
       (true, (int_name, ((fun _ -> true), int_mono)))))))))))))
                           (get_comp_times
                             ((fun _ -> true),
                               ((Big_int.big_int_of_int 0),
                                 ((Big_int.big_int_of_int 1),
                                   ((Big_int.big_int_of_int 1),
                                     (Big_int.add_big_int,
                                       (Big_int.mult_big_int,
 (max0_int,
   (ge_int,
     ((fun xa y -> Big_int.lt_big_int y xa),
       (true, (int_name, ((fun _ -> true), int_mono)))))))))))))))
                     (fun f aa poly ->
                       Alter1
                         ((f, aa),
                           (fst poly,
                             fit_length
                               (get_comp_0
                                 ((fun _ -> true),
                                   ((Big_int.big_int_of_int 0),
                                     ((Big_int.big_int_of_int 1),
                                       ((Big_int.big_int_of_int 1),
 (Big_int.add_big_int,
   (Big_int.mult_big_int,
     (max0_int,
       (ge_int,
         ((fun x y -> Big_int.lt_big_int y x),
           (true, (int_name, ((fun _ -> true), int_mono)))))))))))))
                               aa (snd poly))))
              else xml3elements ['i'; 'n'; 't'; 'e'; 'r'; 'p'; 'r'; 'e'; 't']
                     xml2name (nata ['a'; 'r'; 'i'; 't'; 'y'])
                     (fun x ->
                       bind (polynomial int_coeff x)
                         (fun p ->
                           Inr (poly_of eq_nata (eq_int, comm_semiring_1_int)
                                 p)))
                     (fun f aa poly -> Alter9 ((f, aa), poly)))
          | Arctic ->
            xml3elements ['i'; 'n'; 't'; 'e'; 'r'; 'p'; 'r'; 'e'; 't'] xml2name
              (nata ['a'; 'r'; 'i'; 't'; 'y'])
              (fun x ->
                bind (polynomial arctic_coeff x)
                  (lpoly_of eq_arctica
                    (get_comp_0
                      ((fun _ -> true),
                        (zero_arctic,
                          (one_arctic,
                            (one_arctic,
                              (plus_arctic,
                                (times_arctic,
                                  (id, (ge_arctic,
 (gt_arctic, (false, (arctic_name, (pos_arctic, (fun _ -> false))))))))))))))
                    (get_comp_1
                      ((fun _ -> true),
                        (zero_arctic,
                          (one_arctic,
                            (one_arctic,
                              (plus_arctic,
                                (times_arctic,
                                  (id, (ge_arctic,
 (gt_arctic, (false, (arctic_name, (pos_arctic, (fun _ -> false))))))))))))))
                    (get_comp_plus
                      ((fun _ -> true),
                        (zero_arctic,
                          (one_arctic,
                            (one_arctic,
                              (plus_arctic,
                                (times_arctic,
                                  (id, (ge_arctic,
 (gt_arctic, (false, (arctic_name, (pos_arctic, (fun _ -> false))))))))))))))
                    (get_comp_times
                      ((fun _ -> true),
                        (zero_arctic,
                          (one_arctic,
                            (one_arctic,
                              (plus_arctic,
                                (times_arctic,
                                  (id, (ge_arctic,
 (gt_arctic, (false, (arctic_name, (pos_arctic, (fun _ -> false))))))))))))))))
              (fun f aa poly ->
                Alter3
                  ((f, aa),
                    (fst poly,
                      fit_length
                        (get_comp_0
                          ((fun _ -> true),
                            (zero_arctic,
                              (one_arctic,
                                (one_arctic,
                                  (plus_arctic,
                                    (times_arctic,
                                      (id,
(ge_arctic,
  (gt_arctic, (false, (arctic_name, (pos_arctic, (fun _ -> false))))))))))))))
                        aa (snd poly))))
          | Arctic_rat d ->
            xml3elements ['i'; 'n'; 't'; 'e'; 'r'; 'p'; 'r'; 'e'; 't'] xml2name
              (nata ['a'; 'r'; 'i'; 't'; 'y'])
              (fun x ->
                bind (polynomial arctic_rat_coeff x)
                  (lpoly_of eq_arctic_rata
                    (get_comp_0
                      ((fun _ -> true),
                        (zero_arctic_rat,
                          (one_arctic_rat,
                            (one_arctic_rat,
                              (plus_arctic_rat,
                                (times_arctic_rat,
                                  (id, (ge_arctic_rat,
 (gt_arctic_rat d,
   (false, (arctic_rat_name, (pos_arctic_rat, (fun _ -> false))))))))))))))
                    (get_comp_1
                      ((fun _ -> true),
                        (zero_arctic_rat,
                          (one_arctic_rat,
                            (one_arctic_rat,
                              (plus_arctic_rat,
                                (times_arctic_rat,
                                  (id, (ge_arctic_rat,
 (gt_arctic_rat d,
   (false, (arctic_rat_name, (pos_arctic_rat, (fun _ -> false))))))))))))))
                    (get_comp_plus
                      ((fun _ -> true),
                        (zero_arctic_rat,
                          (one_arctic_rat,
                            (one_arctic_rat,
                              (plus_arctic_rat,
                                (times_arctic_rat,
                                  (id, (ge_arctic_rat,
 (gt_arctic_rat d,
   (false, (arctic_rat_name, (pos_arctic_rat, (fun _ -> false))))))))))))))
                    (get_comp_times
                      ((fun _ -> true),
                        (zero_arctic_rat,
                          (one_arctic_rat,
                            (one_arctic_rat,
                              (plus_arctic_rat,
                                (times_arctic_rat,
                                  (id, (ge_arctic_rat,
 (gt_arctic_rat d,
   (false, (arctic_rat_name, (pos_arctic_rat, (fun _ -> false))))))))))))))))
              (fun f aa poly ->
                Alter7
                  ((f, aa),
                    (fst poly,
                      fit_length
                        (get_comp_0
                          ((fun _ -> true),
                            (zero_arctic_rat,
                              (one_arctic_rat,
                                (one_arctic_rat,
                                  (plus_arctic_rat,
                                    (times_arctic_rat,
                                      (id,
(ge_arctic_rat,
  (gt_arctic_rat d,
    (false, (arctic_rat_name, (pos_arctic_rat, (fun _ -> false))))))))))))))
                        aa (snd poly))))
          | Int_mat (n, sd) ->
            xml3elements ['i'; 'n'; 't'; 'e'; 'r'; 'p'; 'r'; 'e'; 't'] xml2name
              (nata ['a'; 'r'; 'i'; 't'; 'y'])
              (fun x ->
                bind (polynomial
                       (mat_coeff (Big_int.big_int_of_int 0) int_coeff) x)
                  (lpoly_of (eq_lista (eq_lista eq_int))
                    (get_comp_0
                      (mat n n,
                        (mat0I (Big_int.big_int_of_int 0) n n,
                          (mat1I (Big_int.big_int_of_int 0)
                             (Big_int.big_int_of_int 1) n,
                            (mat1I (Big_int.big_int_of_int 0)
                               (get_comp_def
                                 ((fun _ -> true),
                                   ((Big_int.big_int_of_int 0),
                                     ((Big_int.big_int_of_int 1),
                                       ((Big_int.big_int_of_int 1),
 (Big_int.add_big_int,
   (Big_int.mult_big_int,
     (max0_int,
       (ge_int,
         ((fun xa y -> Big_int.lt_big_int y xa),
           (true, (int_name, ((fun _ -> true), int_mono)))))))))))))
                               n,
                              (mat_plusI Big_int.add_big_int,
                                (mat_multI (Big_int.big_int_of_int 0)
                                   Big_int.add_big_int Big_int.mult_big_int n,
                                  (mat_max0 max_ordered_monoid_add_int,
                                    (mat_ge non_strict_order_int,
                                      (mat_gtI non_strict_order_int
 (get_comp_gt
   ((fun _ -> true),
     ((Big_int.big_int_of_int 0),
       ((Big_int.big_int_of_int 1),
         ((Big_int.big_int_of_int 1),
           (Big_int.add_big_int,
             (Big_int.mult_big_int,
               (max0_int,
                 (ge_int,
                   ((fun xa y -> Big_int.lt_big_int y xa),
                     (true, (int_name, ((fun _ -> true), int_mono)))))))))))))
 sd,
(get_comp_mono
   ((fun _ -> true),
     ((Big_int.big_int_of_int 0),
       ((Big_int.big_int_of_int 1),
         ((Big_int.big_int_of_int 1),
           (Big_int.add_big_int,
             (Big_int.mult_big_int,
               (max0_int,
                 (ge_int,
                   ((fun xa y -> Big_int.lt_big_int y xa),
                     (true, (int_name, ((fun _ -> true), int_mono)))))))))))),
  (concat
     [shows_prec_nat Zero_nat n []; ['x']; shows_prec_nat Zero_nat n [];
       [' '; 'm'; 'a'; 't'; 'r'; 'i'; 'c'; 'e'; 's'; ' '; 'w'; 'i'; 't'; 'h';
         ' '; 's'; 't'; 'r'; 'i'; 'c'; 't'; ' '; 'd'; 'i'; 'm'; 'e'; 'n'; 's';
         'i'; 'o'; 'n'; ' '];
       shows_prec_nat Zero_nat sd []; [' '; 'o'; 'v'; 'e'; 'r'; ' '];
       get_comp_description
         ((fun _ -> true),
           ((Big_int.big_int_of_int 0),
             ((Big_int.big_int_of_int 1),
               ((Big_int.big_int_of_int 1),
                 (Big_int.add_big_int,
                   (Big_int.mult_big_int,
                     (max0_int,
                       (ge_int,
                         ((fun xa y -> Big_int.lt_big_int y xa),
                           (true,
                             (int_name, ((fun _ -> true), int_mono))))))))))))],
    ((fun _ -> true),
      mat_mono sd
        (get_comp_check_mono
          ((fun _ -> true),
            ((Big_int.big_int_of_int 0),
              ((Big_int.big_int_of_int 1),
                ((Big_int.big_int_of_int 1),
                  (Big_int.add_big_int,
                    (Big_int.mult_big_int,
                      (max0_int,
                        (ge_int,
                          ((fun xa y -> Big_int.lt_big_int y xa),
                            (true,
                              (int_name,
                                ((fun _ -> true),
                                  int_mono))))))))))))))))))))))))))
                    (get_comp_1
                      (mat n n,
                        (mat0I (Big_int.big_int_of_int 0) n n,
                          (mat1I (Big_int.big_int_of_int 0)
                             (Big_int.big_int_of_int 1) n,
                            (mat1I (Big_int.big_int_of_int 0)
                               (get_comp_def
                                 ((fun _ -> true),
                                   ((Big_int.big_int_of_int 0),
                                     ((Big_int.big_int_of_int 1),
                                       ((Big_int.big_int_of_int 1),
 (Big_int.add_big_int,
   (Big_int.mult_big_int,
     (max0_int,
       (ge_int,
         ((fun xa y -> Big_int.lt_big_int y xa),
           (true, (int_name, ((fun _ -> true), int_mono)))))))))))))
                               n,
                              (mat_plusI Big_int.add_big_int,
                                (mat_multI (Big_int.big_int_of_int 0)
                                   Big_int.add_big_int Big_int.mult_big_int n,
                                  (mat_max0 max_ordered_monoid_add_int,
                                    (mat_ge non_strict_order_int,
                                      (mat_gtI non_strict_order_int
 (get_comp_gt
   ((fun _ -> true),
     ((Big_int.big_int_of_int 0),
       ((Big_int.big_int_of_int 1),
         ((Big_int.big_int_of_int 1),
           (Big_int.add_big_int,
             (Big_int.mult_big_int,
               (max0_int,
                 (ge_int,
                   ((fun xa y -> Big_int.lt_big_int y xa),
                     (true, (int_name, ((fun _ -> true), int_mono)))))))))))))
 sd,
(get_comp_mono
   ((fun _ -> true),
     ((Big_int.big_int_of_int 0),
       ((Big_int.big_int_of_int 1),
         ((Big_int.big_int_of_int 1),
           (Big_int.add_big_int,
             (Big_int.mult_big_int,
               (max0_int,
                 (ge_int,
                   ((fun xa y -> Big_int.lt_big_int y xa),
                     (true, (int_name, ((fun _ -> true), int_mono)))))))))))),
  (concat
     [shows_prec_nat Zero_nat n []; ['x']; shows_prec_nat Zero_nat n [];
       [' '; 'm'; 'a'; 't'; 'r'; 'i'; 'c'; 'e'; 's'; ' '; 'w'; 'i'; 't'; 'h';
         ' '; 's'; 't'; 'r'; 'i'; 'c'; 't'; ' '; 'd'; 'i'; 'm'; 'e'; 'n'; 's';
         'i'; 'o'; 'n'; ' '];
       shows_prec_nat Zero_nat sd []; [' '; 'o'; 'v'; 'e'; 'r'; ' '];
       get_comp_description
         ((fun _ -> true),
           ((Big_int.big_int_of_int 0),
             ((Big_int.big_int_of_int 1),
               ((Big_int.big_int_of_int 1),
                 (Big_int.add_big_int,
                   (Big_int.mult_big_int,
                     (max0_int,
                       (ge_int,
                         ((fun xa y -> Big_int.lt_big_int y xa),
                           (true,
                             (int_name, ((fun _ -> true), int_mono))))))))))))],
    ((fun _ -> true),
      mat_mono sd
        (get_comp_check_mono
          ((fun _ -> true),
            ((Big_int.big_int_of_int 0),
              ((Big_int.big_int_of_int 1),
                ((Big_int.big_int_of_int 1),
                  (Big_int.add_big_int,
                    (Big_int.mult_big_int,
                      (max0_int,
                        (ge_int,
                          ((fun xa y -> Big_int.lt_big_int y xa),
                            (true,
                              (int_name,
                                ((fun _ -> true),
                                  int_mono))))))))))))))))))))))))))
                    (get_comp_plus
                      (mat n n,
                        (mat0I (Big_int.big_int_of_int 0) n n,
                          (mat1I (Big_int.big_int_of_int 0)
                             (Big_int.big_int_of_int 1) n,
                            (mat1I (Big_int.big_int_of_int 0)
                               (get_comp_def
                                 ((fun _ -> true),
                                   ((Big_int.big_int_of_int 0),
                                     ((Big_int.big_int_of_int 1),
                                       ((Big_int.big_int_of_int 1),
 (Big_int.add_big_int,
   (Big_int.mult_big_int,
     (max0_int,
       (ge_int,
         ((fun xa y -> Big_int.lt_big_int y xa),
           (true, (int_name, ((fun _ -> true), int_mono)))))))))))))
                               n,
                              (mat_plusI Big_int.add_big_int,
                                (mat_multI (Big_int.big_int_of_int 0)
                                   Big_int.add_big_int Big_int.mult_big_int n,
                                  (mat_max0 max_ordered_monoid_add_int,
                                    (mat_ge non_strict_order_int,
                                      (mat_gtI non_strict_order_int
 (get_comp_gt
   ((fun _ -> true),
     ((Big_int.big_int_of_int 0),
       ((Big_int.big_int_of_int 1),
         ((Big_int.big_int_of_int 1),
           (Big_int.add_big_int,
             (Big_int.mult_big_int,
               (max0_int,
                 (ge_int,
                   ((fun xa y -> Big_int.lt_big_int y xa),
                     (true, (int_name, ((fun _ -> true), int_mono)))))))))))))
 sd,
(get_comp_mono
   ((fun _ -> true),
     ((Big_int.big_int_of_int 0),
       ((Big_int.big_int_of_int 1),
         ((Big_int.big_int_of_int 1),
           (Big_int.add_big_int,
             (Big_int.mult_big_int,
               (max0_int,
                 (ge_int,
                   ((fun xa y -> Big_int.lt_big_int y xa),
                     (true, (int_name, ((fun _ -> true), int_mono)))))))))))),
  (concat
     [shows_prec_nat Zero_nat n []; ['x']; shows_prec_nat Zero_nat n [];
       [' '; 'm'; 'a'; 't'; 'r'; 'i'; 'c'; 'e'; 's'; ' '; 'w'; 'i'; 't'; 'h';
         ' '; 's'; 't'; 'r'; 'i'; 'c'; 't'; ' '; 'd'; 'i'; 'm'; 'e'; 'n'; 's';
         'i'; 'o'; 'n'; ' '];
       shows_prec_nat Zero_nat sd []; [' '; 'o'; 'v'; 'e'; 'r'; ' '];
       get_comp_description
         ((fun _ -> true),
           ((Big_int.big_int_of_int 0),
             ((Big_int.big_int_of_int 1),
               ((Big_int.big_int_of_int 1),
                 (Big_int.add_big_int,
                   (Big_int.mult_big_int,
                     (max0_int,
                       (ge_int,
                         ((fun xa y -> Big_int.lt_big_int y xa),
                           (true,
                             (int_name, ((fun _ -> true), int_mono))))))))))))],
    ((fun _ -> true),
      mat_mono sd
        (get_comp_check_mono
          ((fun _ -> true),
            ((Big_int.big_int_of_int 0),
              ((Big_int.big_int_of_int 1),
                ((Big_int.big_int_of_int 1),
                  (Big_int.add_big_int,
                    (Big_int.mult_big_int,
                      (max0_int,
                        (ge_int,
                          ((fun xa y -> Big_int.lt_big_int y xa),
                            (true,
                              (int_name,
                                ((fun _ -> true),
                                  int_mono))))))))))))))))))))))))))
                    (get_comp_times
                      (mat n n,
                        (mat0I (Big_int.big_int_of_int 0) n n,
                          (mat1I (Big_int.big_int_of_int 0)
                             (Big_int.big_int_of_int 1) n,
                            (mat1I (Big_int.big_int_of_int 0)
                               (get_comp_def
                                 ((fun _ -> true),
                                   ((Big_int.big_int_of_int 0),
                                     ((Big_int.big_int_of_int 1),
                                       ((Big_int.big_int_of_int 1),
 (Big_int.add_big_int,
   (Big_int.mult_big_int,
     (max0_int,
       (ge_int,
         ((fun xa y -> Big_int.lt_big_int y xa),
           (true, (int_name, ((fun _ -> true), int_mono)))))))))))))
                               n,
                              (mat_plusI Big_int.add_big_int,
                                (mat_multI (Big_int.big_int_of_int 0)
                                   Big_int.add_big_int Big_int.mult_big_int n,
                                  (mat_max0 max_ordered_monoid_add_int,
                                    (mat_ge non_strict_order_int,
                                      (mat_gtI non_strict_order_int
 (get_comp_gt
   ((fun _ -> true),
     ((Big_int.big_int_of_int 0),
       ((Big_int.big_int_of_int 1),
         ((Big_int.big_int_of_int 1),
           (Big_int.add_big_int,
             (Big_int.mult_big_int,
               (max0_int,
                 (ge_int,
                   ((fun xa y -> Big_int.lt_big_int y xa),
                     (true, (int_name, ((fun _ -> true), int_mono)))))))))))))
 sd,
(get_comp_mono
   ((fun _ -> true),
     ((Big_int.big_int_of_int 0),
       ((Big_int.big_int_of_int 1),
         ((Big_int.big_int_of_int 1),
           (Big_int.add_big_int,
             (Big_int.mult_big_int,
               (max0_int,
                 (ge_int,
                   ((fun xa y -> Big_int.lt_big_int y xa),
                     (true, (int_name, ((fun _ -> true), int_mono)))))))))))),
  (concat
     [shows_prec_nat Zero_nat n []; ['x']; shows_prec_nat Zero_nat n [];
       [' '; 'm'; 'a'; 't'; 'r'; 'i'; 'c'; 'e'; 's'; ' '; 'w'; 'i'; 't'; 'h';
         ' '; 's'; 't'; 'r'; 'i'; 'c'; 't'; ' '; 'd'; 'i'; 'm'; 'e'; 'n'; 's';
         'i'; 'o'; 'n'; ' '];
       shows_prec_nat Zero_nat sd []; [' '; 'o'; 'v'; 'e'; 'r'; ' '];
       get_comp_description
         ((fun _ -> true),
           ((Big_int.big_int_of_int 0),
             ((Big_int.big_int_of_int 1),
               ((Big_int.big_int_of_int 1),
                 (Big_int.add_big_int,
                   (Big_int.mult_big_int,
                     (max0_int,
                       (ge_int,
                         ((fun xa y -> Big_int.lt_big_int y xa),
                           (true,
                             (int_name, ((fun _ -> true), int_mono))))))))))))],
    ((fun _ -> true),
      mat_mono sd
        (get_comp_check_mono
          ((fun _ -> true),
            ((Big_int.big_int_of_int 0),
              ((Big_int.big_int_of_int 1),
                ((Big_int.big_int_of_int 1),
                  (Big_int.add_big_int,
                    (Big_int.mult_big_int,
                      (max0_int,
                        (ge_int,
                          ((fun xa y -> Big_int.lt_big_int y xa),
                            (true,
                              (int_name,
                                ((fun _ -> true),
                                  int_mono))))))))))))))))))))))))))))
              (fun f aa poly ->
                Alter4
                  ((f, aa),
                    (fst poly,
                      fit_length
                        (get_comp_0
                          (mat n n,
                            (mat0I (Big_int.big_int_of_int 0) n n,
                              (mat1I (Big_int.big_int_of_int 0)
                                 (Big_int.big_int_of_int 1) n,
                                (mat1I (Big_int.big_int_of_int 0)
                                   (get_comp_def
                                     ((fun _ -> true),
                                       ((Big_int.big_int_of_int 0),
 ((Big_int.big_int_of_int 1),
   ((Big_int.big_int_of_int 1),
     (Big_int.add_big_int,
       (Big_int.mult_big_int,
         (max0_int,
           (ge_int,
             ((fun x y -> Big_int.lt_big_int y x),
               (true, (int_name, ((fun _ -> true), int_mono)))))))))))))
                                   n,
                                  (mat_plusI Big_int.add_big_int,
                                    (mat_multI (Big_int.big_int_of_int 0)
                                       Big_int.add_big_int Big_int.mult_big_int
                                       n,
                                      (mat_max0 max_ordered_monoid_add_int,
(mat_ge non_strict_order_int,
  (mat_gtI non_strict_order_int
     (get_comp_gt
       ((fun _ -> true),
         ((Big_int.big_int_of_int 0),
           ((Big_int.big_int_of_int 1),
             ((Big_int.big_int_of_int 1),
               (Big_int.add_big_int,
                 (Big_int.mult_big_int,
                   (max0_int,
                     (ge_int,
                       ((fun x y -> Big_int.lt_big_int y x),
                         (true,
                           (int_name, ((fun _ -> true), int_mono)))))))))))))
     sd,
    (get_comp_mono
       ((fun _ -> true),
         ((Big_int.big_int_of_int 0),
           ((Big_int.big_int_of_int 1),
             ((Big_int.big_int_of_int 1),
               (Big_int.add_big_int,
                 (Big_int.mult_big_int,
                   (max0_int,
                     (ge_int,
                       ((fun x y -> Big_int.lt_big_int y x),
                         (true,
                           (int_name, ((fun _ -> true), int_mono)))))))))))),
      (concat
         [shows_prec_nat Zero_nat n []; ['x']; shows_prec_nat Zero_nat n [];
           [' '; 'm'; 'a'; 't'; 'r'; 'i'; 'c'; 'e'; 's'; ' '; 'w'; 'i'; 't';
             'h'; ' '; 's'; 't'; 'r'; 'i'; 'c'; 't'; ' '; 'd'; 'i'; 'm'; 'e';
             'n'; 's'; 'i'; 'o'; 'n'; ' '];
           shows_prec_nat Zero_nat sd []; [' '; 'o'; 'v'; 'e'; 'r'; ' '];
           get_comp_description
             ((fun _ -> true),
               ((Big_int.big_int_of_int 0),
                 ((Big_int.big_int_of_int 1),
                   ((Big_int.big_int_of_int 1),
                     (Big_int.add_big_int,
                       (Big_int.mult_big_int,
                         (max0_int,
                           (ge_int,
                             ((fun x y -> Big_int.lt_big_int y x),
                               (true,
                                 (int_name,
                                   ((fun _ -> true), int_mono))))))))))))],
        ((fun _ -> true),
          mat_mono sd
            (get_comp_check_mono
              ((fun _ -> true),
                ((Big_int.big_int_of_int 0),
                  ((Big_int.big_int_of_int 1),
                    ((Big_int.big_int_of_int 1),
                      (Big_int.add_big_int,
                        (Big_int.mult_big_int,
                          (max0_int,
                            (ge_int,
                              ((fun x y -> Big_int.lt_big_int y x),
                                (true,
                                  (int_name,
                                    ((fun _ -> true),
                                      int_mono))))))))))))))))))))))))))
                        aa (snd poly))))
          | Arc_mat n ->
            xml3elements ['i'; 'n'; 't'; 'e'; 'r'; 'p'; 'r'; 'e'; 't'] xml2name
              (nata ['a'; 'r'; 'i'; 't'; 'y'])
              (fun x ->
                bind (polynomial (mat_coeff MinInfty arctic_coeff) x)
                  (lpoly_of (eq_lista (eq_lista eq_arctica))
                    (get_comp_0
                      (mat n n,
                        (mat0I zero_arctic n n,
                          (mat1I zero_arctic one_arctic n,
                            (mat1I zero_arctic
                               (get_comp_def
                                 ((fun _ -> true),
                                   (zero_arctic,
                                     (one_arctic,
                                       (one_arctic,
 (plus_arctic,
   (times_arctic,
     (id, (ge_arctic,
            (gt_arctic,
              (false, (arctic_name, (pos_arctic, (fun _ -> false))))))))))))))
                               n,
                              (mat_plusI plus_arctic,
                                (mat_multI zero_arctic plus_arctic times_arctic
                                   n,
                                  (id, (mat_ge non_strict_order_arctic,
 (mat_comp_all
    (get_comp_gt
      ((fun _ -> true),
        (zero_arctic,
          (one_arctic,
            (one_arctic,
              (plus_arctic,
                (times_arctic,
                  (id, (ge_arctic,
                         (gt_arctic,
                           (false,
                             (arctic_name,
                               (pos_arctic, (fun _ -> false)))))))))))))),
   (false,
     (concat
        [shows_prec_nat Zero_nat n []; ['x']; shows_prec_nat Zero_nat n [];
          [' '; 'm'; 'a'; 't'; 'r'; 'i'; 'c'; 'e'; 's'; ' '; 'o'; 'v'; 'e'; 'r';
            ' '];
          get_comp_description
            ((fun _ -> true),
              (zero_arctic,
                (one_arctic,
                  (one_arctic,
                    (plus_arctic,
                      (times_arctic,
                        (id, (ge_arctic,
                               (gt_arctic,
                                 (false,
                                   (arctic_name,
                                     (pos_arctic, (fun _ -> false)))))))))))))],
       (mat_arc_posI
          (get_comp_apos
            ((fun _ -> true),
              (zero_arctic,
                (one_arctic,
                  (one_arctic,
                    (plus_arctic,
                      (times_arctic,
                        (id, (ge_arctic,
                               (gt_arctic,
                                 (false,
                                   (arctic_name,
                                     (pos_arctic, (fun _ -> false)))))))))))))),
         (fun _ -> false))))))))))))))
                    (get_comp_1
                      (mat n n,
                        (mat0I zero_arctic n n,
                          (mat1I zero_arctic one_arctic n,
                            (mat1I zero_arctic
                               (get_comp_def
                                 ((fun _ -> true),
                                   (zero_arctic,
                                     (one_arctic,
                                       (one_arctic,
 (plus_arctic,
   (times_arctic,
     (id, (ge_arctic,
            (gt_arctic,
              (false, (arctic_name, (pos_arctic, (fun _ -> false))))))))))))))
                               n,
                              (mat_plusI plus_arctic,
                                (mat_multI zero_arctic plus_arctic times_arctic
                                   n,
                                  (id, (mat_ge non_strict_order_arctic,
 (mat_comp_all
    (get_comp_gt
      ((fun _ -> true),
        (zero_arctic,
          (one_arctic,
            (one_arctic,
              (plus_arctic,
                (times_arctic,
                  (id, (ge_arctic,
                         (gt_arctic,
                           (false,
                             (arctic_name,
                               (pos_arctic, (fun _ -> false)))))))))))))),
   (false,
     (concat
        [shows_prec_nat Zero_nat n []; ['x']; shows_prec_nat Zero_nat n [];
          [' '; 'm'; 'a'; 't'; 'r'; 'i'; 'c'; 'e'; 's'; ' '; 'o'; 'v'; 'e'; 'r';
            ' '];
          get_comp_description
            ((fun _ -> true),
              (zero_arctic,
                (one_arctic,
                  (one_arctic,
                    (plus_arctic,
                      (times_arctic,
                        (id, (ge_arctic,
                               (gt_arctic,
                                 (false,
                                   (arctic_name,
                                     (pos_arctic, (fun _ -> false)))))))))))))],
       (mat_arc_posI
          (get_comp_apos
            ((fun _ -> true),
              (zero_arctic,
                (one_arctic,
                  (one_arctic,
                    (plus_arctic,
                      (times_arctic,
                        (id, (ge_arctic,
                               (gt_arctic,
                                 (false,
                                   (arctic_name,
                                     (pos_arctic, (fun _ -> false)))))))))))))),
         (fun _ -> false))))))))))))))
                    (get_comp_plus
                      (mat n n,
                        (mat0I zero_arctic n n,
                          (mat1I zero_arctic one_arctic n,
                            (mat1I zero_arctic
                               (get_comp_def
                                 ((fun _ -> true),
                                   (zero_arctic,
                                     (one_arctic,
                                       (one_arctic,
 (plus_arctic,
   (times_arctic,
     (id, (ge_arctic,
            (gt_arctic,
              (false, (arctic_name, (pos_arctic, (fun _ -> false))))))))))))))
                               n,
                              (mat_plusI plus_arctic,
                                (mat_multI zero_arctic plus_arctic times_arctic
                                   n,
                                  (id, (mat_ge non_strict_order_arctic,
 (mat_comp_all
    (get_comp_gt
      ((fun _ -> true),
        (zero_arctic,
          (one_arctic,
            (one_arctic,
              (plus_arctic,
                (times_arctic,
                  (id, (ge_arctic,
                         (gt_arctic,
                           (false,
                             (arctic_name,
                               (pos_arctic, (fun _ -> false)))))))))))))),
   (false,
     (concat
        [shows_prec_nat Zero_nat n []; ['x']; shows_prec_nat Zero_nat n [];
          [' '; 'm'; 'a'; 't'; 'r'; 'i'; 'c'; 'e'; 's'; ' '; 'o'; 'v'; 'e'; 'r';
            ' '];
          get_comp_description
            ((fun _ -> true),
              (zero_arctic,
                (one_arctic,
                  (one_arctic,
                    (plus_arctic,
                      (times_arctic,
                        (id, (ge_arctic,
                               (gt_arctic,
                                 (false,
                                   (arctic_name,
                                     (pos_arctic, (fun _ -> false)))))))))))))],
       (mat_arc_posI
          (get_comp_apos
            ((fun _ -> true),
              (zero_arctic,
                (one_arctic,
                  (one_arctic,
                    (plus_arctic,
                      (times_arctic,
                        (id, (ge_arctic,
                               (gt_arctic,
                                 (false,
                                   (arctic_name,
                                     (pos_arctic, (fun _ -> false)))))))))))))),
         (fun _ -> false))))))))))))))
                    (get_comp_times
                      (mat n n,
                        (mat0I zero_arctic n n,
                          (mat1I zero_arctic one_arctic n,
                            (mat1I zero_arctic
                               (get_comp_def
                                 ((fun _ -> true),
                                   (zero_arctic,
                                     (one_arctic,
                                       (one_arctic,
 (plus_arctic,
   (times_arctic,
     (id, (ge_arctic,
            (gt_arctic,
              (false, (arctic_name, (pos_arctic, (fun _ -> false))))))))))))))
                               n,
                              (mat_plusI plus_arctic,
                                (mat_multI zero_arctic plus_arctic times_arctic
                                   n,
                                  (id, (mat_ge non_strict_order_arctic,
 (mat_comp_all
    (get_comp_gt
      ((fun _ -> true),
        (zero_arctic,
          (one_arctic,
            (one_arctic,
              (plus_arctic,
                (times_arctic,
                  (id, (ge_arctic,
                         (gt_arctic,
                           (false,
                             (arctic_name,
                               (pos_arctic, (fun _ -> false)))))))))))))),
   (false,
     (concat
        [shows_prec_nat Zero_nat n []; ['x']; shows_prec_nat Zero_nat n [];
          [' '; 'm'; 'a'; 't'; 'r'; 'i'; 'c'; 'e'; 's'; ' '; 'o'; 'v'; 'e'; 'r';
            ' '];
          get_comp_description
            ((fun _ -> true),
              (zero_arctic,
                (one_arctic,
                  (one_arctic,
                    (plus_arctic,
                      (times_arctic,
                        (id, (ge_arctic,
                               (gt_arctic,
                                 (false,
                                   (arctic_name,
                                     (pos_arctic, (fun _ -> false)))))))))))))],
       (mat_arc_posI
          (get_comp_apos
            ((fun _ -> true),
              (zero_arctic,
                (one_arctic,
                  (one_arctic,
                    (plus_arctic,
                      (times_arctic,
                        (id, (ge_arctic,
                               (gt_arctic,
                                 (false,
                                   (arctic_name,
                                     (pos_arctic, (fun _ -> false)))))))))))))),
         (fun _ -> false))))))))))))))))
              (fun f aa poly ->
                Alter6
                  ((f, aa),
                    (fst poly,
                      fit_length
                        (get_comp_0
                          (mat n n,
                            (mat0I zero_arctic n n,
                              (mat1I zero_arctic one_arctic n,
                                (mat1I zero_arctic
                                   (get_comp_def
                                     ((fun _ -> true),
                                       (zero_arctic,
 (one_arctic,
   (one_arctic,
     (plus_arctic,
       (times_arctic,
         (id, (ge_arctic,
                (gt_arctic,
                  (false,
                    (arctic_name, (pos_arctic, (fun _ -> false))))))))))))))
                                   n,
                                  (mat_plusI plus_arctic,
                                    (mat_multI zero_arctic plus_arctic
                                       times_arctic n,
                                      (id,
(mat_ge non_strict_order_arctic,
  (mat_comp_all
     (get_comp_gt
       ((fun _ -> true),
         (zero_arctic,
           (one_arctic,
             (one_arctic,
               (plus_arctic,
                 (times_arctic,
                   (id, (ge_arctic,
                          (gt_arctic,
                            (false,
                              (arctic_name,
                                (pos_arctic, (fun _ -> false)))))))))))))),
    (false,
      (concat
         [shows_prec_nat Zero_nat n []; ['x']; shows_prec_nat Zero_nat n [];
           [' '; 'm'; 'a'; 't'; 'r'; 'i'; 'c'; 'e'; 's'; ' '; 'o'; 'v'; 'e';
             'r'; ' '];
           get_comp_description
             ((fun _ -> true),
               (zero_arctic,
                 (one_arctic,
                   (one_arctic,
                     (plus_arctic,
                       (times_arctic,
                         (id, (ge_arctic,
                                (gt_arctic,
                                  (false,
                                    (arctic_name,
                                      (pos_arctic,
(fun _ -> false)))))))))))))],
        (mat_arc_posI
           (get_comp_apos
             ((fun _ -> true),
               (zero_arctic,
                 (one_arctic,
                   (one_arctic,
                     (plus_arctic,
                       (times_arctic,
                         (id, (ge_arctic,
                                (gt_arctic,
                                  (false,
                                    (arctic_name,
                                      (pos_arctic,
(fun _ -> false)))))))))))))),
          (fun _ -> false))))))))))))))
                        aa (snd poly))))
          | Arc_rat_mat (d, n) ->
            xml3elements ['i'; 'n'; 't'; 'e'; 'r'; 'p'; 'r'; 'e'; 't'] xml2name
              (nata ['a'; 'r'; 'i'; 't'; 'y'])
              (fun x ->
                bind (polynomial (mat_coeff MinInfty_rat arctic_rat_coeff) x)
                  (lpoly_of (eq_lista (eq_lista eq_arctic_rata))
                    (get_comp_0
                      (mat n n,
                        (mat0I zero_arctic_rat n n,
                          (mat1I zero_arctic_rat one_arctic_rat n,
                            (mat1I zero_arctic_rat
                               (get_comp_def
                                 ((fun _ -> true),
                                   (zero_arctic_rat,
                                     (one_arctic_rat,
                                       (one_arctic_rat,
 (plus_arctic_rat,
   (times_arctic_rat,
     (id, (ge_arctic_rat,
            (gt_arctic_rat d,
              (false,
                (arctic_rat_name, (pos_arctic_rat, (fun _ -> false))))))))))))))
                               n,
                              (mat_plusI plus_arctic_rat,
                                (mat_multI zero_arctic_rat plus_arctic_rat
                                   times_arctic_rat n,
                                  (id, (mat_ge non_strict_order_arctic_rat,
 (mat_comp_all
    (get_comp_gt
      ((fun _ -> true),
        (zero_arctic_rat,
          (one_arctic_rat,
            (one_arctic_rat,
              (plus_arctic_rat,
                (times_arctic_rat,
                  (id, (ge_arctic_rat,
                         (gt_arctic_rat d,
                           (false,
                             (arctic_rat_name,
                               (pos_arctic_rat, (fun _ -> false)))))))))))))),
   (false,
     (concat
        [shows_prec_nat Zero_nat n []; ['x']; shows_prec_nat Zero_nat n [];
          [' '; 'm'; 'a'; 't'; 'r'; 'i'; 'c'; 'e'; 's'; ' '; 'o'; 'v'; 'e'; 'r';
            ' '];
          get_comp_description
            ((fun _ -> true),
              (zero_arctic_rat,
                (one_arctic_rat,
                  (one_arctic_rat,
                    (plus_arctic_rat,
                      (times_arctic_rat,
                        (id, (ge_arctic_rat,
                               (gt_arctic_rat d,
                                 (false,
                                   (arctic_rat_name,
                                     (pos_arctic_rat,
                                       (fun _ -> false)))))))))))))],
       (mat_arc_posI
          (get_comp_apos
            ((fun _ -> true),
              (zero_arctic_rat,
                (one_arctic_rat,
                  (one_arctic_rat,
                    (plus_arctic_rat,
                      (times_arctic_rat,
                        (id, (ge_arctic_rat,
                               (gt_arctic_rat d,
                                 (false,
                                   (arctic_rat_name,
                                     (pos_arctic_rat,
                                       (fun _ -> false)))))))))))))),
         (fun _ -> false))))))))))))))
                    (get_comp_1
                      (mat n n,
                        (mat0I zero_arctic_rat n n,
                          (mat1I zero_arctic_rat one_arctic_rat n,
                            (mat1I zero_arctic_rat
                               (get_comp_def
                                 ((fun _ -> true),
                                   (zero_arctic_rat,
                                     (one_arctic_rat,
                                       (one_arctic_rat,
 (plus_arctic_rat,
   (times_arctic_rat,
     (id, (ge_arctic_rat,
            (gt_arctic_rat d,
              (false,
                (arctic_rat_name, (pos_arctic_rat, (fun _ -> false))))))))))))))
                               n,
                              (mat_plusI plus_arctic_rat,
                                (mat_multI zero_arctic_rat plus_arctic_rat
                                   times_arctic_rat n,
                                  (id, (mat_ge non_strict_order_arctic_rat,
 (mat_comp_all
    (get_comp_gt
      ((fun _ -> true),
        (zero_arctic_rat,
          (one_arctic_rat,
            (one_arctic_rat,
              (plus_arctic_rat,
                (times_arctic_rat,
                  (id, (ge_arctic_rat,
                         (gt_arctic_rat d,
                           (false,
                             (arctic_rat_name,
                               (pos_arctic_rat, (fun _ -> false)))))))))))))),
   (false,
     (concat
        [shows_prec_nat Zero_nat n []; ['x']; shows_prec_nat Zero_nat n [];
          [' '; 'm'; 'a'; 't'; 'r'; 'i'; 'c'; 'e'; 's'; ' '; 'o'; 'v'; 'e'; 'r';
            ' '];
          get_comp_description
            ((fun _ -> true),
              (zero_arctic_rat,
                (one_arctic_rat,
                  (one_arctic_rat,
                    (plus_arctic_rat,
                      (times_arctic_rat,
                        (id, (ge_arctic_rat,
                               (gt_arctic_rat d,
                                 (false,
                                   (arctic_rat_name,
                                     (pos_arctic_rat,
                                       (fun _ -> false)))))))))))))],
       (mat_arc_posI
          (get_comp_apos
            ((fun _ -> true),
              (zero_arctic_rat,
                (one_arctic_rat,
                  (one_arctic_rat,
                    (plus_arctic_rat,
                      (times_arctic_rat,
                        (id, (ge_arctic_rat,
                               (gt_arctic_rat d,
                                 (false,
                                   (arctic_rat_name,
                                     (pos_arctic_rat,
                                       (fun _ -> false)))))))))))))),
         (fun _ -> false))))))))))))))
                    (get_comp_plus
                      (mat n n,
                        (mat0I zero_arctic_rat n n,
                          (mat1I zero_arctic_rat one_arctic_rat n,
                            (mat1I zero_arctic_rat
                               (get_comp_def
                                 ((fun _ -> true),
                                   (zero_arctic_rat,
                                     (one_arctic_rat,
                                       (one_arctic_rat,
 (plus_arctic_rat,
   (times_arctic_rat,
     (id, (ge_arctic_rat,
            (gt_arctic_rat d,
              (false,
                (arctic_rat_name, (pos_arctic_rat, (fun _ -> false))))))))))))))
                               n,
                              (mat_plusI plus_arctic_rat,
                                (mat_multI zero_arctic_rat plus_arctic_rat
                                   times_arctic_rat n,
                                  (id, (mat_ge non_strict_order_arctic_rat,
 (mat_comp_all
    (get_comp_gt
      ((fun _ -> true),
        (zero_arctic_rat,
          (one_arctic_rat,
            (one_arctic_rat,
              (plus_arctic_rat,
                (times_arctic_rat,
                  (id, (ge_arctic_rat,
                         (gt_arctic_rat d,
                           (false,
                             (arctic_rat_name,
                               (pos_arctic_rat, (fun _ -> false)))))))))))))),
   (false,
     (concat
        [shows_prec_nat Zero_nat n []; ['x']; shows_prec_nat Zero_nat n [];
          [' '; 'm'; 'a'; 't'; 'r'; 'i'; 'c'; 'e'; 's'; ' '; 'o'; 'v'; 'e'; 'r';
            ' '];
          get_comp_description
            ((fun _ -> true),
              (zero_arctic_rat,
                (one_arctic_rat,
                  (one_arctic_rat,
                    (plus_arctic_rat,
                      (times_arctic_rat,
                        (id, (ge_arctic_rat,
                               (gt_arctic_rat d,
                                 (false,
                                   (arctic_rat_name,
                                     (pos_arctic_rat,
                                       (fun _ -> false)))))))))))))],
       (mat_arc_posI
          (get_comp_apos
            ((fun _ -> true),
              (zero_arctic_rat,
                (one_arctic_rat,
                  (one_arctic_rat,
                    (plus_arctic_rat,
                      (times_arctic_rat,
                        (id, (ge_arctic_rat,
                               (gt_arctic_rat d,
                                 (false,
                                   (arctic_rat_name,
                                     (pos_arctic_rat,
                                       (fun _ -> false)))))))))))))),
         (fun _ -> false))))))))))))))
                    (get_comp_times
                      (mat n n,
                        (mat0I zero_arctic_rat n n,
                          (mat1I zero_arctic_rat one_arctic_rat n,
                            (mat1I zero_arctic_rat
                               (get_comp_def
                                 ((fun _ -> true),
                                   (zero_arctic_rat,
                                     (one_arctic_rat,
                                       (one_arctic_rat,
 (plus_arctic_rat,
   (times_arctic_rat,
     (id, (ge_arctic_rat,
            (gt_arctic_rat d,
              (false,
                (arctic_rat_name, (pos_arctic_rat, (fun _ -> false))))))))))))))
                               n,
                              (mat_plusI plus_arctic_rat,
                                (mat_multI zero_arctic_rat plus_arctic_rat
                                   times_arctic_rat n,
                                  (id, (mat_ge non_strict_order_arctic_rat,
 (mat_comp_all
    (get_comp_gt
      ((fun _ -> true),
        (zero_arctic_rat,
          (one_arctic_rat,
            (one_arctic_rat,
              (plus_arctic_rat,
                (times_arctic_rat,
                  (id, (ge_arctic_rat,
                         (gt_arctic_rat d,
                           (false,
                             (arctic_rat_name,
                               (pos_arctic_rat, (fun _ -> false)))))))))))))),
   (false,
     (concat
        [shows_prec_nat Zero_nat n []; ['x']; shows_prec_nat Zero_nat n [];
          [' '; 'm'; 'a'; 't'; 'r'; 'i'; 'c'; 'e'; 's'; ' '; 'o'; 'v'; 'e'; 'r';
            ' '];
          get_comp_description
            ((fun _ -> true),
              (zero_arctic_rat,
                (one_arctic_rat,
                  (one_arctic_rat,
                    (plus_arctic_rat,
                      (times_arctic_rat,
                        (id, (ge_arctic_rat,
                               (gt_arctic_rat d,
                                 (false,
                                   (arctic_rat_name,
                                     (pos_arctic_rat,
                                       (fun _ -> false)))))))))))))],
       (mat_arc_posI
          (get_comp_apos
            ((fun _ -> true),
              (zero_arctic_rat,
                (one_arctic_rat,
                  (one_arctic_rat,
                    (plus_arctic_rat,
                      (times_arctic_rat,
                        (id, (ge_arctic_rat,
                               (gt_arctic_rat d,
                                 (false,
                                   (arctic_rat_name,
                                     (pos_arctic_rat,
                                       (fun _ -> false)))))))))))))),
         (fun _ -> false))))))))))))))))
              (fun f aa poly ->
                Alter8
                  ((f, aa),
                    (fst poly,
                      fit_length
                        (get_comp_0
                          (mat n n,
                            (mat0I zero_arctic_rat n n,
                              (mat1I zero_arctic_rat one_arctic_rat n,
                                (mat1I zero_arctic_rat
                                   (get_comp_def
                                     ((fun _ -> true),
                                       (zero_arctic_rat,
 (one_arctic_rat,
   (one_arctic_rat,
     (plus_arctic_rat,
       (times_arctic_rat,
         (id, (ge_arctic_rat,
                (gt_arctic_rat d,
                  (false,
                    (arctic_rat_name,
                      (pos_arctic_rat, (fun _ -> false))))))))))))))
                                   n,
                                  (mat_plusI plus_arctic_rat,
                                    (mat_multI zero_arctic_rat plus_arctic_rat
                                       times_arctic_rat n,
                                      (id,
(mat_ge non_strict_order_arctic_rat,
  (mat_comp_all
     (get_comp_gt
       ((fun _ -> true),
         (zero_arctic_rat,
           (one_arctic_rat,
             (one_arctic_rat,
               (plus_arctic_rat,
                 (times_arctic_rat,
                   (id, (ge_arctic_rat,
                          (gt_arctic_rat d,
                            (false,
                              (arctic_rat_name,
                                (pos_arctic_rat, (fun _ -> false)))))))))))))),
    (false,
      (concat
         [shows_prec_nat Zero_nat n []; ['x']; shows_prec_nat Zero_nat n [];
           [' '; 'm'; 'a'; 't'; 'r'; 'i'; 'c'; 'e'; 's'; ' '; 'o'; 'v'; 'e';
             'r'; ' '];
           get_comp_description
             ((fun _ -> true),
               (zero_arctic_rat,
                 (one_arctic_rat,
                   (one_arctic_rat,
                     (plus_arctic_rat,
                       (times_arctic_rat,
                         (id, (ge_arctic_rat,
                                (gt_arctic_rat d,
                                  (false,
                                    (arctic_rat_name,
                                      (pos_arctic_rat,
(fun _ -> false)))))))))))))],
        (mat_arc_posI
           (get_comp_apos
             ((fun _ -> true),
               (zero_arctic_rat,
                 (one_arctic_rat,
                   (one_arctic_rat,
                     (plus_arctic_rat,
                       (times_arctic_rat,
                         (id, (ge_arctic_rat,
                                (gt_arctic_rat d,
                                  (false,
                                    (arctic_rat_name,
                                      (pos_arctic_rat,
(fun _ -> false)))))))))))))),
          (fun _ -> false))))))))))))))
                        aa (snd poly))))
          | Rational (d, deg) ->
            (if less_eq_nat deg one_nat
              then xml3elements ['i'; 'n'; 't'; 'e'; 'r'; 'p'; 'r'; 'e'; 't']
                     xml2name (nata ['a'; 'r'; 'i'; 't'; 'y'])
                     (fun x ->
                       bind (polynomial rat x)
                         (lpoly_of eq_rata
                           (get_comp_0
                             ((fun _ -> true),
                               (fract (Big_int.big_int_of_int 0)
                                  (Big_int.big_int_of_int 1),
                                 (fract (Big_int.big_int_of_int 1)
                                    (Big_int.big_int_of_int 1),
                                   (d, (plus_rat,
 (times_rat,
   (max0_rat,
     (ge_rat,
       (rat_gt d, (true, (rat_name, ((fun _ -> true), rat_mono)))))))))))))
                           (get_comp_1
                             ((fun _ -> true),
                               (fract (Big_int.big_int_of_int 0)
                                  (Big_int.big_int_of_int 1),
                                 (fract (Big_int.big_int_of_int 1)
                                    (Big_int.big_int_of_int 1),
                                   (d, (plus_rat,
 (times_rat,
   (max0_rat,
     (ge_rat,
       (rat_gt d, (true, (rat_name, ((fun _ -> true), rat_mono)))))))))))))
                           (get_comp_plus
                             ((fun _ -> true),
                               (fract (Big_int.big_int_of_int 0)
                                  (Big_int.big_int_of_int 1),
                                 (fract (Big_int.big_int_of_int 1)
                                    (Big_int.big_int_of_int 1),
                                   (d, (plus_rat,
 (times_rat,
   (max0_rat,
     (ge_rat,
       (rat_gt d, (true, (rat_name, ((fun _ -> true), rat_mono)))))))))))))
                           (get_comp_times
                             ((fun _ -> true),
                               (fract (Big_int.big_int_of_int 0)
                                  (Big_int.big_int_of_int 1),
                                 (fract (Big_int.big_int_of_int 1)
                                    (Big_int.big_int_of_int 1),
                                   (d, (plus_rat,
 (times_rat,
   (max0_rat,
     (ge_rat,
       (rat_gt d, (true, (rat_name, ((fun _ -> true), rat_mono)))))))))))))))
                     (fun f aa poly ->
                       Alter2
                         ((f, aa),
                           (fst poly,
                             fit_length
                               (get_comp_0
                                 ((fun _ -> true),
                                   (fract (Big_int.big_int_of_int 0)
                                      (Big_int.big_int_of_int 1),
                                     (fract (Big_int.big_int_of_int 1)
(Big_int.big_int_of_int 1),
                                       (d,
 (plus_rat,
   (times_rat,
     (max0_rat,
       (ge_rat,
         (rat_gt d, (true, (rat_name, ((fun _ -> true), rat_mono)))))))))))))
                               aa (snd poly))))
              else xml3elements ['i'; 'n'; 't'; 'e'; 'r'; 'p'; 'r'; 'e'; 't']
                     xml2name (nata ['a'; 'r'; 'i'; 't'; 'y'])
                     (fun x ->
                       bind (polynomial rat x)
                         (fun p ->
                           Inr (poly_of eq_nata (eq_rata, comm_semiring_1_rat)
                                 p)))
                     (fun f aa poly -> Alter10 ((f, aa), poly)))
          | Rat_mat (d, n, sd) ->
            xml3elements ['i'; 'n'; 't'; 'e'; 'r'; 'p'; 'r'; 'e'; 't'] xml2name
              (nata ['a'; 'r'; 'i'; 't'; 'y'])
              (fun x ->
                bind (polynomial
                       (mat_coeff
                         (fract (Big_int.big_int_of_int 0)
                           (Big_int.big_int_of_int 1))
                         rat)
                       x)
                  (lpoly_of (eq_lista (eq_lista eq_rata))
                    (get_comp_0
                      (mat n n,
                        (mat0I (fract (Big_int.big_int_of_int 0)
                                 (Big_int.big_int_of_int 1))
                           n n,
                          (mat1I (fract (Big_int.big_int_of_int 0)
                                   (Big_int.big_int_of_int 1))
                             (fract (Big_int.big_int_of_int 1)
                               (Big_int.big_int_of_int 1))
                             n,
                            (mat1I (fract (Big_int.big_int_of_int 0)
                                     (Big_int.big_int_of_int 1))
                               (get_comp_def
                                 ((fun _ -> true),
                                   (fract (Big_int.big_int_of_int 0)
                                      (Big_int.big_int_of_int 1),
                                     (fract (Big_int.big_int_of_int 1)
(Big_int.big_int_of_int 1),
                                       (d,
 (plus_rat,
   (times_rat,
     (max0_rat,
       (ge_rat,
         (rat_gt d, (true, (rat_name, ((fun _ -> true), rat_mono)))))))))))))
                               n,
                              (mat_plusI plus_rat,
                                (mat_multI
                                   (fract (Big_int.big_int_of_int 0)
                                     (Big_int.big_int_of_int 1))
                                   plus_rat times_rat n,
                                  (mat_max0 max_ordered_monoid_add_rat,
                                    (mat_ge non_strict_order_rat,
                                      (mat_gtI non_strict_order_rat
 (get_comp_gt
   ((fun _ -> true),
     (fract (Big_int.big_int_of_int 0) (Big_int.big_int_of_int 1),
       (fract (Big_int.big_int_of_int 1) (Big_int.big_int_of_int 1),
         (d, (plus_rat,
               (times_rat,
                 (max0_rat,
                   (ge_rat,
                     (rat_gt d,
                       (true, (rat_name, ((fun _ -> true), rat_mono)))))))))))))
 sd,
(get_comp_mono
   ((fun _ -> true),
     (fract (Big_int.big_int_of_int 0) (Big_int.big_int_of_int 1),
       (fract (Big_int.big_int_of_int 1) (Big_int.big_int_of_int 1),
         (d, (plus_rat,
               (times_rat,
                 (max0_rat,
                   (ge_rat,
                     (rat_gt d,
                       (true, (rat_name, ((fun _ -> true), rat_mono)))))))))))),
  (concat
     [shows_prec_nat Zero_nat n []; ['x']; shows_prec_nat Zero_nat n [];
       [' '; 'm'; 'a'; 't'; 'r'; 'i'; 'c'; 'e'; 's'; ' '; 'w'; 'i'; 't'; 'h';
         ' '; 's'; 't'; 'r'; 'i'; 'c'; 't'; ' '; 'd'; 'i'; 'm'; 'e'; 'n'; 's';
         'i'; 'o'; 'n'; ' '];
       shows_prec_nat Zero_nat sd []; [' '; 'o'; 'v'; 'e'; 'r'; ' '];
       get_comp_description
         ((fun _ -> true),
           (fract (Big_int.big_int_of_int 0) (Big_int.big_int_of_int 1),
             (fract (Big_int.big_int_of_int 1) (Big_int.big_int_of_int 1),
               (d, (plus_rat,
                     (times_rat,
                       (max0_rat,
                         (ge_rat,
                           (rat_gt d,
                             (true,
                               (rat_name,
                                 ((fun _ -> true), rat_mono))))))))))))],
    ((fun _ -> true),
      mat_mono sd
        (get_comp_check_mono
          ((fun _ -> true),
            (fract (Big_int.big_int_of_int 0) (Big_int.big_int_of_int 1),
              (fract (Big_int.big_int_of_int 1) (Big_int.big_int_of_int 1),
                (d, (plus_rat,
                      (times_rat,
                        (max0_rat,
                          (ge_rat,
                            (rat_gt d,
                              (true,
                                (rat_name,
                                  ((fun _ -> true),
                                    rat_mono))))))))))))))))))))))))))
                    (get_comp_1
                      (mat n n,
                        (mat0I (fract (Big_int.big_int_of_int 0)
                                 (Big_int.big_int_of_int 1))
                           n n,
                          (mat1I (fract (Big_int.big_int_of_int 0)
                                   (Big_int.big_int_of_int 1))
                             (fract (Big_int.big_int_of_int 1)
                               (Big_int.big_int_of_int 1))
                             n,
                            (mat1I (fract (Big_int.big_int_of_int 0)
                                     (Big_int.big_int_of_int 1))
                               (get_comp_def
                                 ((fun _ -> true),
                                   (fract (Big_int.big_int_of_int 0)
                                      (Big_int.big_int_of_int 1),
                                     (fract (Big_int.big_int_of_int 1)
(Big_int.big_int_of_int 1),
                                       (d,
 (plus_rat,
   (times_rat,
     (max0_rat,
       (ge_rat,
         (rat_gt d, (true, (rat_name, ((fun _ -> true), rat_mono)))))))))))))
                               n,
                              (mat_plusI plus_rat,
                                (mat_multI
                                   (fract (Big_int.big_int_of_int 0)
                                     (Big_int.big_int_of_int 1))
                                   plus_rat times_rat n,
                                  (mat_max0 max_ordered_monoid_add_rat,
                                    (mat_ge non_strict_order_rat,
                                      (mat_gtI non_strict_order_rat
 (get_comp_gt
   ((fun _ -> true),
     (fract (Big_int.big_int_of_int 0) (Big_int.big_int_of_int 1),
       (fract (Big_int.big_int_of_int 1) (Big_int.big_int_of_int 1),
         (d, (plus_rat,
               (times_rat,
                 (max0_rat,
                   (ge_rat,
                     (rat_gt d,
                       (true, (rat_name, ((fun _ -> true), rat_mono)))))))))))))
 sd,
(get_comp_mono
   ((fun _ -> true),
     (fract (Big_int.big_int_of_int 0) (Big_int.big_int_of_int 1),
       (fract (Big_int.big_int_of_int 1) (Big_int.big_int_of_int 1),
         (d, (plus_rat,
               (times_rat,
                 (max0_rat,
                   (ge_rat,
                     (rat_gt d,
                       (true, (rat_name, ((fun _ -> true), rat_mono)))))))))))),
  (concat
     [shows_prec_nat Zero_nat n []; ['x']; shows_prec_nat Zero_nat n [];
       [' '; 'm'; 'a'; 't'; 'r'; 'i'; 'c'; 'e'; 's'; ' '; 'w'; 'i'; 't'; 'h';
         ' '; 's'; 't'; 'r'; 'i'; 'c'; 't'; ' '; 'd'; 'i'; 'm'; 'e'; 'n'; 's';
         'i'; 'o'; 'n'; ' '];
       shows_prec_nat Zero_nat sd []; [' '; 'o'; 'v'; 'e'; 'r'; ' '];
       get_comp_description
         ((fun _ -> true),
           (fract (Big_int.big_int_of_int 0) (Big_int.big_int_of_int 1),
             (fract (Big_int.big_int_of_int 1) (Big_int.big_int_of_int 1),
               (d, (plus_rat,
                     (times_rat,
                       (max0_rat,
                         (ge_rat,
                           (rat_gt d,
                             (true,
                               (rat_name,
                                 ((fun _ -> true), rat_mono))))))))))))],
    ((fun _ -> true),
      mat_mono sd
        (get_comp_check_mono
          ((fun _ -> true),
            (fract (Big_int.big_int_of_int 0) (Big_int.big_int_of_int 1),
              (fract (Big_int.big_int_of_int 1) (Big_int.big_int_of_int 1),
                (d, (plus_rat,
                      (times_rat,
                        (max0_rat,
                          (ge_rat,
                            (rat_gt d,
                              (true,
                                (rat_name,
                                  ((fun _ -> true),
                                    rat_mono))))))))))))))))))))))))))
                    (get_comp_plus
                      (mat n n,
                        (mat0I (fract (Big_int.big_int_of_int 0)
                                 (Big_int.big_int_of_int 1))
                           n n,
                          (mat1I (fract (Big_int.big_int_of_int 0)
                                   (Big_int.big_int_of_int 1))
                             (fract (Big_int.big_int_of_int 1)
                               (Big_int.big_int_of_int 1))
                             n,
                            (mat1I (fract (Big_int.big_int_of_int 0)
                                     (Big_int.big_int_of_int 1))
                               (get_comp_def
                                 ((fun _ -> true),
                                   (fract (Big_int.big_int_of_int 0)
                                      (Big_int.big_int_of_int 1),
                                     (fract (Big_int.big_int_of_int 1)
(Big_int.big_int_of_int 1),
                                       (d,
 (plus_rat,
   (times_rat,
     (max0_rat,
       (ge_rat,
         (rat_gt d, (true, (rat_name, ((fun _ -> true), rat_mono)))))))))))))
                               n,
                              (mat_plusI plus_rat,
                                (mat_multI
                                   (fract (Big_int.big_int_of_int 0)
                                     (Big_int.big_int_of_int 1))
                                   plus_rat times_rat n,
                                  (mat_max0 max_ordered_monoid_add_rat,
                                    (mat_ge non_strict_order_rat,
                                      (mat_gtI non_strict_order_rat
 (get_comp_gt
   ((fun _ -> true),
     (fract (Big_int.big_int_of_int 0) (Big_int.big_int_of_int 1),
       (fract (Big_int.big_int_of_int 1) (Big_int.big_int_of_int 1),
         (d, (plus_rat,
               (times_rat,
                 (max0_rat,
                   (ge_rat,
                     (rat_gt d,
                       (true, (rat_name, ((fun _ -> true), rat_mono)))))))))))))
 sd,
(get_comp_mono
   ((fun _ -> true),
     (fract (Big_int.big_int_of_int 0) (Big_int.big_int_of_int 1),
       (fract (Big_int.big_int_of_int 1) (Big_int.big_int_of_int 1),
         (d, (plus_rat,
               (times_rat,
                 (max0_rat,
                   (ge_rat,
                     (rat_gt d,
                       (true, (rat_name, ((fun _ -> true), rat_mono)))))))))))),
  (concat
     [shows_prec_nat Zero_nat n []; ['x']; shows_prec_nat Zero_nat n [];
       [' '; 'm'; 'a'; 't'; 'r'; 'i'; 'c'; 'e'; 's'; ' '; 'w'; 'i'; 't'; 'h';
         ' '; 's'; 't'; 'r'; 'i'; 'c'; 't'; ' '; 'd'; 'i'; 'm'; 'e'; 'n'; 's';
         'i'; 'o'; 'n'; ' '];
       shows_prec_nat Zero_nat sd []; [' '; 'o'; 'v'; 'e'; 'r'; ' '];
       get_comp_description
         ((fun _ -> true),
           (fract (Big_int.big_int_of_int 0) (Big_int.big_int_of_int 1),
             (fract (Big_int.big_int_of_int 1) (Big_int.big_int_of_int 1),
               (d, (plus_rat,
                     (times_rat,
                       (max0_rat,
                         (ge_rat,
                           (rat_gt d,
                             (true,
                               (rat_name,
                                 ((fun _ -> true), rat_mono))))))))))))],
    ((fun _ -> true),
      mat_mono sd
        (get_comp_check_mono
          ((fun _ -> true),
            (fract (Big_int.big_int_of_int 0) (Big_int.big_int_of_int 1),
              (fract (Big_int.big_int_of_int 1) (Big_int.big_int_of_int 1),
                (d, (plus_rat,
                      (times_rat,
                        (max0_rat,
                          (ge_rat,
                            (rat_gt d,
                              (true,
                                (rat_name,
                                  ((fun _ -> true),
                                    rat_mono))))))))))))))))))))))))))
                    (get_comp_times
                      (mat n n,
                        (mat0I (fract (Big_int.big_int_of_int 0)
                                 (Big_int.big_int_of_int 1))
                           n n,
                          (mat1I (fract (Big_int.big_int_of_int 0)
                                   (Big_int.big_int_of_int 1))
                             (fract (Big_int.big_int_of_int 1)
                               (Big_int.big_int_of_int 1))
                             n,
                            (mat1I (fract (Big_int.big_int_of_int 0)
                                     (Big_int.big_int_of_int 1))
                               (get_comp_def
                                 ((fun _ -> true),
                                   (fract (Big_int.big_int_of_int 0)
                                      (Big_int.big_int_of_int 1),
                                     (fract (Big_int.big_int_of_int 1)
(Big_int.big_int_of_int 1),
                                       (d,
 (plus_rat,
   (times_rat,
     (max0_rat,
       (ge_rat,
         (rat_gt d, (true, (rat_name, ((fun _ -> true), rat_mono)))))))))))))
                               n,
                              (mat_plusI plus_rat,
                                (mat_multI
                                   (fract (Big_int.big_int_of_int 0)
                                     (Big_int.big_int_of_int 1))
                                   plus_rat times_rat n,
                                  (mat_max0 max_ordered_monoid_add_rat,
                                    (mat_ge non_strict_order_rat,
                                      (mat_gtI non_strict_order_rat
 (get_comp_gt
   ((fun _ -> true),
     (fract (Big_int.big_int_of_int 0) (Big_int.big_int_of_int 1),
       (fract (Big_int.big_int_of_int 1) (Big_int.big_int_of_int 1),
         (d, (plus_rat,
               (times_rat,
                 (max0_rat,
                   (ge_rat,
                     (rat_gt d,
                       (true, (rat_name, ((fun _ -> true), rat_mono)))))))))))))
 sd,
(get_comp_mono
   ((fun _ -> true),
     (fract (Big_int.big_int_of_int 0) (Big_int.big_int_of_int 1),
       (fract (Big_int.big_int_of_int 1) (Big_int.big_int_of_int 1),
         (d, (plus_rat,
               (times_rat,
                 (max0_rat,
                   (ge_rat,
                     (rat_gt d,
                       (true, (rat_name, ((fun _ -> true), rat_mono)))))))))))),
  (concat
     [shows_prec_nat Zero_nat n []; ['x']; shows_prec_nat Zero_nat n [];
       [' '; 'm'; 'a'; 't'; 'r'; 'i'; 'c'; 'e'; 's'; ' '; 'w'; 'i'; 't'; 'h';
         ' '; 's'; 't'; 'r'; 'i'; 'c'; 't'; ' '; 'd'; 'i'; 'm'; 'e'; 'n'; 's';
         'i'; 'o'; 'n'; ' '];
       shows_prec_nat Zero_nat sd []; [' '; 'o'; 'v'; 'e'; 'r'; ' '];
       get_comp_description
         ((fun _ -> true),
           (fract (Big_int.big_int_of_int 0) (Big_int.big_int_of_int 1),
             (fract (Big_int.big_int_of_int 1) (Big_int.big_int_of_int 1),
               (d, (plus_rat,
                     (times_rat,
                       (max0_rat,
                         (ge_rat,
                           (rat_gt d,
                             (true,
                               (rat_name,
                                 ((fun _ -> true), rat_mono))))))))))))],
    ((fun _ -> true),
      mat_mono sd
        (get_comp_check_mono
          ((fun _ -> true),
            (fract (Big_int.big_int_of_int 0) (Big_int.big_int_of_int 1),
              (fract (Big_int.big_int_of_int 1) (Big_int.big_int_of_int 1),
                (d, (plus_rat,
                      (times_rat,
                        (max0_rat,
                          (ge_rat,
                            (rat_gt d,
                              (true,
                                (rat_name,
                                  ((fun _ -> true),
                                    rat_mono))))))))))))))))))))))))))))
              (fun f aa poly ->
                Alter5
                  ((f, aa),
                    (fst poly,
                      fit_length
                        (get_comp_0
                          (mat n n,
                            (mat0I (fract (Big_int.big_int_of_int 0)
                                     (Big_int.big_int_of_int 1))
                               n n,
                              (mat1I (fract (Big_int.big_int_of_int 0)
                                       (Big_int.big_int_of_int 1))
                                 (fract (Big_int.big_int_of_int 1)
                                   (Big_int.big_int_of_int 1))
                                 n,
                                (mat1I (fract (Big_int.big_int_of_int 0)
 (Big_int.big_int_of_int 1))
                                   (get_comp_def
                                     ((fun _ -> true),
                                       (fract (Big_int.big_int_of_int 0)
  (Big_int.big_int_of_int 1),
 (fract (Big_int.big_int_of_int 1) (Big_int.big_int_of_int 1),
   (d, (plus_rat,
         (times_rat,
           (max0_rat,
             (ge_rat,
               (rat_gt d,
                 (true, (rat_name, ((fun _ -> true), rat_mono)))))))))))))
                                   n,
                                  (mat_plusI plus_rat,
                                    (mat_multI
                                       (fract (Big_int.big_int_of_int 0)
 (Big_int.big_int_of_int 1))
                                       plus_rat times_rat n,
                                      (mat_max0 max_ordered_monoid_add_rat,
(mat_ge non_strict_order_rat,
  (mat_gtI non_strict_order_rat
     (get_comp_gt
       ((fun _ -> true),
         (fract (Big_int.big_int_of_int 0) (Big_int.big_int_of_int 1),
           (fract (Big_int.big_int_of_int 1) (Big_int.big_int_of_int 1),
             (d, (plus_rat,
                   (times_rat,
                     (max0_rat,
                       (ge_rat,
                         (rat_gt d,
                           (true,
                             (rat_name, ((fun _ -> true), rat_mono)))))))))))))
     sd,
    (get_comp_mono
       ((fun _ -> true),
         (fract (Big_int.big_int_of_int 0) (Big_int.big_int_of_int 1),
           (fract (Big_int.big_int_of_int 1) (Big_int.big_int_of_int 1),
             (d, (plus_rat,
                   (times_rat,
                     (max0_rat,
                       (ge_rat,
                         (rat_gt d,
                           (true,
                             (rat_name, ((fun _ -> true), rat_mono)))))))))))),
      (concat
         [shows_prec_nat Zero_nat n []; ['x']; shows_prec_nat Zero_nat n [];
           [' '; 'm'; 'a'; 't'; 'r'; 'i'; 'c'; 'e'; 's'; ' '; 'w'; 'i'; 't';
             'h'; ' '; 's'; 't'; 'r'; 'i'; 'c'; 't'; ' '; 'd'; 'i'; 'm'; 'e';
             'n'; 's'; 'i'; 'o'; 'n'; ' '];
           shows_prec_nat Zero_nat sd []; [' '; 'o'; 'v'; 'e'; 'r'; ' '];
           get_comp_description
             ((fun _ -> true),
               (fract (Big_int.big_int_of_int 0) (Big_int.big_int_of_int 1),
                 (fract (Big_int.big_int_of_int 1) (Big_int.big_int_of_int 1),
                   (d, (plus_rat,
                         (times_rat,
                           (max0_rat,
                             (ge_rat,
                               (rat_gt d,
                                 (true,
                                   (rat_name,
                                     ((fun _ -> true), rat_mono))))))))))))],
        ((fun _ -> true),
          mat_mono sd
            (get_comp_check_mono
              ((fun _ -> true),
                (fract (Big_int.big_int_of_int 0) (Big_int.big_int_of_int 1),
                  (fract (Big_int.big_int_of_int 1) (Big_int.big_int_of_int 1),
                    (d, (plus_rat,
                          (times_rat,
                            (max0_rat,
                              (ge_rat,
                                (rat_gt d,
                                  (true,
                                    (rat_name,
                                      ((fun _ -> true),
rat_mono))))))))))))))))))))))))))
                        aa (snd poly))))))
      (fun typea pi ->
        (match typea
          with Natural deg ->
            (if less_eq_nat deg one_nat then Int_carrier (map alter1a pi)
              else Int_nl_carrier (map alter9a pi))
          | Arctic -> Arctic_carrier (map alter3a pi)
          | Arctic_rat d -> Arctic_rat_carrier (d, map alter7a pi)
          | Int_mat (n, sd) -> Int_mat_carrier (n, sd, map alter4a pi)
          | Arc_mat n -> Arc_mat_carrier (n, map alter6a pi)
          | Arc_rat_mat (d, n) -> Arc_rat_mat_carrier (d, n, map alter8a pi)
          | Rational (d, deg) ->
            (if less_eq_nat deg one_nat then Rat_carrier (d, map alter2a pi)
              else Rat_nl_carrier (d, map alter10a pi))
          | Rat_mat (d, n, sd) -> Rat_mat_carrier (d, n, sd, map alter5a pi)));;

let rec redpair
  xml2name =
    xml1element ['r'; 'e'; 'd'; 'P'; 'a'; 'i'; 'r']
      (xml_options
        [(['i'; 'n'; 't'; 'e'; 'r'; 'p'; 'r'; 'e'; 't'; 'a'; 't'; 'i'; 'o';
            'n'],
           interpretation xml2name);
          (['p'; 'a'; 't'; 'h'; 'O'; 'r'; 'd'; 'e'; 'r'], path_order xml2name)])
      id;;

let rec length_unique _A
  = function [] -> Zero_nat
    | x :: xs ->
        (if member _A xs x then length_unique _A xs
          else Suc (length_unique _A xs));;

type certificationResult = Certified of char list | Error of char list;;

let rec shows_lpo_repr _A
  prs = comp (shows_string
               ['L'; 'P'; 'O'; ' '; 'w'; 'i'; 't'; 'h'; ' '; 't'; 'h'; 'e'; ' ';
                 'f'; 'o'; 'l'; 'l'; 'o'; 'w'; 'i'; 'n'; 'g'; ' '; 'p'; 'r';
                 'e'; 'c'; 'e'; 'd'; 'e'; 'n'; 'c'; 'e'])
          (comp shows_nl
            (comp (shows_map
                    (fun (a, b) ->
                      let (f, n) = a in
                      (fun pr ->
                        comp (shows_string
                               ['p'; 'r'; 'e'; 'c'; 'e'; 'd'; 'e'; 'n'; 'c';
                                 'e'; '('])
                          (comp (shows_prec _A Zero_nat f)
                            (comp (shows_string ['['])
                              (comp (shows_prec_nat Zero_nat n)
                                (comp (shows_string [']'; ')'; ' '; '='; ' '])
                                  (comp (shows_prec_nat Zero_nat pr)
                                    shows_nl))))))
                        b)
                    prs)
              (comp shows_nl
                (comp (shows_string
                        ['p'; 'r'; 'e'; 'c'; 'e'; 'd'; 'e'; 'n'; 'c'; 'e'; '(';
                          '_'; ')'; ' '; '='; ' '; '0'])
                  shows_nl))));;

let rec vars_term_list _B t = remdups _B (vars_term_lista t);;

let rec enum_vectors
  c x1 = match c, x1 with c, [] -> [[]]
    | c, x :: xs ->
        let a = enum_vectors c xs in
        concat_map (fun vec -> map (fun ca -> (x, ca) :: vec) c) a;;

let rec assign_from_vector _A vec x = the (lookup _A x vec);;

let rec eq_lab _A _B
  x0 x1 = match x0, x1 with
    FunLab (f, ls), FunLab (g, ks) ->
      eq_lab _A _B f g && list_all2 (eq_lab _A _B) ls ks
    | Lab (laba, la), Lab (lab, l) -> eq_lab _A _B laba lab && eqa _B la l
    | UnLab fa, UnLab f -> eqa _A fa f
    | Lab (laba, l), FunLab (lab, lista) -> false
    | FunLab (laba, lista), Lab (lab, l) -> false
    | Lab (lab, l), UnLab f -> false
    | UnLab f, Lab (lab, l) -> false
    | FunLab (lab, lista), UnLab f -> false
    | UnLab f, FunLab (lab, lista) -> false;;

let rec eq_laba _A _B = ({eq = eq_lab _A _B} : ('a, 'b) lab eq);;

let rec shows_lab _A _B
  = function UnLab f -> shows_prec _A Zero_nat f
    | Lab (f, l) ->
        comp (shows_lab _A _B f)
          (comp (shows_string ['['])
            (comp (shows_prec _B Zero_nat l) (shows_string [']'])))
    | FunLab (f, l) ->
        comp (shows_lab _A _B f)
          (comp (shows_string ['['])
            (comp (shows_map (shows_lab _A _B) l) (shows_string [']'])));;

let rec shows_prec_lab _A _B d l = shows_lab _A _B l;;

let rec shows_list_lab _A _B
  fs = shows_list_aux (shows_prec_lab _A _B Zero_nat) fs;;

let rec show_lab _A _B =
  ({shows_prec = shows_prec_lab _A _B; shows_list = shows_list_lab _A _B} :
    ('a, 'b) lab show);;

let rec labela
  f x1 = match f, x1 with f, Inl l -> Lab (f, l)
    | f, Inr l -> FunLab (f, l);;

let rec eval_lab
  i l alpha x3 = match i, l, alpha, x3 with
    i, l, alpha, Var x -> (alpha x, Var x)
    | i, l, alpha, Fun (f, ts) ->
        let clts = map (eval_lab i l alpha) ts in
        let cs = map fst clts in
        let c = i f cs in
        let lts = map snd clts in
        let la = l f cs in
        (c, Fun (labela f la, lts));;

let rec check_sl_rule_ass (_A1, _A2) (_B1, _B2) (_C1, _C2) (_D1, _D2)
  mc i la lR alpha (l, r) =
    let cl_ll = eval_lab i la alpha l in
    let cr_lr = eval_lab i la alpha r in
    bind (check (implies mc (eqa _C1 (fst cl_ll) (fst cr_lr)))
           (comp (shows_string ['r'; 'u'; 'l'; 'e'; ' '])
             (comp (shows_rule (show_lab _A2 _B2) _D2 (l, r))
               (comp (shows_string
                       [' '; 'v'; 'i'; 'o'; 'l'; 'a'; 't'; 'e'; 's'; ' '; 't';
                         'h'; 'e'; ' '; 'm'; 'o'; 'd'; 'e'; 'l'; ' '; 'c'; 'o';
                         'n'; 'd'; 'i'; 't'; 'i'; 'o'; 'n'; ','; ' '; '['; 'l';
                         'h'; 's'; ']'; ' '; '='; ' '])
                 (comp (shows_prec _C2 Zero_nat (fst cl_ll))
                   (comp (shows_string
                           [','; ' '; '['; 'r'; 'h'; 's'; ']'; ' '; '='; ' '])
                     (shows_prec _C2 Zero_nat (fst cr_lr))))))))
      (fun _ ->
        check (member
                (eqc (eq_terma (eq_laba _A1 _B1) _D1)
                  (eq_terma (eq_laba _A1 _B1) _D1))
                lR (snd cl_ll, snd cr_lr))
          (comp (shows_string
                  ['l'; 'a'; 'b'; 'e'; 'l'; 'e'; 'd'; ' '; 'r'; 'u'; 'l'; 'e';
                    ' '])
            (comp (shows_rule (show_lab _A2 _B2) _D2 (snd cl_ll, snd cr_lr))
              (shows_string [' '; 'm'; 'i'; 's'; 's'; 'i'; 'n'; 'g']))));;

let rec check_sl_rule (_A1, _A2) (_B1, _B2) (_C1, _C2) (_D1, _D2)
  i la c mc lR (l, r) =
    catch (forallm
            (fun alpha ->
              check_sl_rule_ass (_A1, _A2) (_B1, _B2) (_C1, _C2) (_D1, _D2) mc i
                la lR alpha (l, r))
            (map (assign_from_vector _D1)
              (enum_vectors c
                (list_union _D1 (vars_term_list _D1 l)
                  (vars_term_list _D1 r)))))
      (fun x -> Inl (snd x));;

let rec check_sl_model_lab_trs (_A1, _A2) (_B1, _B2) (_C1, _C2) (_D1, _D2)
  i l c lR r =
    catch (forallm
            (check_sl_rule (_A1, _A2) (_B1, _B2) (_C1, _C2) (_D1, _D2) i l c
              true lR)
            r)
      (fun x -> Inl (snd x));;

let rec rl_fun uu cs = Inr cs;;

let rec rl_inter_list _A fs d g uu = (if member _A fs g then g else d);;

let rec check_sl_lab_trs (_A1, _A2) (_B1, _B2) (_C1, _C2) (_D1, _D2)
  i l c lP p =
    catch (forallm
            (check_sl_rule (_A1, _A2) (_B1, _B2) (_C1, _C2) (_D1, _D2) i l c
              false lP)
            p)
      (fun x -> Inl (snd x));;

let rec get_lab = function Lab (f, l) -> Inl l
                  | FunLab (f, l) -> Inr l;;

let rec unlab
  = function Lab (f, l) -> f
    | FunLab (f, l) -> f
    | UnLab v -> UnLab v;;

let rec check_sl_only_lab_and_decr (_A1, _A2) (_B1, _B2) (_C1, _C2)
  gr r =
    (fun xs ->
      catch (forallm
              (fun (ll, lr) ->
                let l = map_term unlab ll in
                let ra = map_term unlab lr in
                check (if eq_term (eq_laba _B1 _A1) _C1 l ra
                        then not (is_var ll) &&
                               (not (is_var lr) &&
                                 gr (get_lab (the (root ll)),
                                      get_lab (the (root lr)))) ||
                               eq_term (eq_laba _B1 _A1) _C1 ll lr &&
                                 member
                                   (eqc (eq_terma (eq_laba _B1 _A1) _C1)
                                     (eq_terma (eq_laba _B1 _A1) _C1))
                                   r (l, ra)
                        else member
                               (eqc (eq_terma (eq_laba _B1 _A1) _C1)
                                 (eq_terma (eq_laba _B1 _A1) _C1))
                               r (l, ra))
                  (comp (shows_string
                          ['l'; 'a'; 'b'; 'e'; 'l'; 'e'; 'd'; ' '; 'r'; 'u';
                            'l'; 'e'; ' '])
                    (comp (shows_rule (show_lab _B2 _A2) _C2 (l, ra))
                      (shows_string
                        [' '; 'i'; 's'; ' '; 'n'; 'e'; 'i'; 't'; 'h'; 'e'; 'r';
                          ' '; 'd'; 'e'; 'c'; 'r'; 'e'; 'a'; 's'; 'i'; 'n'; 'g';
                          ' '; 'n'; 'o'; 'r'; ' '; 'a'; ' '; 'l'; 'a'; 'b'; 'e';
                          'l'; 'e'; 'd'; ' '; 'v'; 'e'; 'r'; 's'; 'i'; 'o'; 'n';
                          ' '; 'o'; 'f'; ' '; 'o'; 'r'; 'i'; 'g'; 'i'; 'n'; 'a';
                          'l'; ' '; 'r'; 'u'; 'l'; 'e']))))
              xs)
        (fun x -> Inl (snd x)));;

let rec check_sem_lab_tt (_A1, _A2) (_B1, _B2) (_C1, _C2)
  check_lab check_model_lab gr i l r lR =
    catch (bind (check_model_lab lR r)
            (fun _ ->
              check_sl_only_lab_and_decr (_B1, _B2) (_A1, _A2) (_C1, _C2) gr r
                lR))
      (fun x ->
        Inl (comp (shows_string
                    ['p'; 'r'; 'o'; 'b'; 'l'; 'e'; 'm'; ' '; 'w'; 'i'; 't'; 'h';
                      ' '; 'l'; 'a'; 'b'; 'e'; 'l'; 'e'; 'd'; ' '; 'T'; 'R';
                      'S'; ':'])
              (comp shows_nl x)));;

let rec rl_tt (_A1, _A2) (_B1, _B2)
  r lR =
    let fs = funs_trs_list (eq_laba _A1 _B1) r in
    bind (check (not (null fs))
           (comp (shows_string
                   ['r'; 'o'; 'o'; 't'; '-'; 'l'; 'a'; 'b'; 'e'; 'l'; 'i'; 'n';
                     'g'; ' '; 'r'; 'e'; 'q'; 'u'; 'i'; 'r'; 'e'; 's'; ' '; 'a';
                     't'; ' '; 'l'; 'e'; 'a'; 's'; 't'; ' '; 'o'; 'n'; 'e'; ' ';
                     'f'; 'u'; 'n'; 'c'; 't'; 'i'; 'o'; 'n'; ' '; 's'; 'y'; 'm';
                     'b'; 'o'; 'l'; ' '; 'i'; 'n'; ' '; 't'; 'h'; 'e'; ' '; 's';
                     'i'; 'g'; 'n'; 'a'; 't'; 'u'; 'r'; 'e'])
             shows_nl))
      (fun _ ->
        let d = hd fs in
        check_sem_lab_tt (_A1, _A2) (_B1, _B2)
          (eq_lista eq_char, show_list show_char)
          (check_sl_lab_trs (_A1, _A2) (_B1, _B2)
            (eq_laba _A1 _B1, show_lab _A2 _B2)
            (eq_lista eq_char, show_list show_char)
            (rl_inter_list (eq_laba _A1 _B1) fs d) rl_fun fs)
          (check_sl_model_lab_trs (_A1, _A2) (_B1, _B2)
            (eq_laba _A1 _B1, show_lab _A2 _B2)
            (eq_lista eq_char, show_list show_char)
            (rl_inter_list (eq_laba _A1 _B1) fs d) rl_fun fs)
          (bot_fun bot_boola) (rl_inter_list (eq_laba _A1 _B1) fs d) rl_fun r
          lR);;

let rec wf_terms_list _A
  uu x1 = match uu, x1 with uu, Var uv -> true
    | fa, Fun (f, ts) ->
        member (eqc _A eq_nata) fa (f, size_list ts) &&
          list_all (wf_terms_list _A fa) ts;;

let rec rp_valid (v, (s, (n, (a, (m, d))))) = v;;

let rec funas_term_lista
  = function Var x -> []
    | Fun (f, ts) -> (f, size_list ts) :: flat_map funas_term_lista ts;;

let rec funas_rule_list
  r = append (funas_term_lista (fst r)) (funas_term_lista (snd r));;

let rec funas_trs_list _A
  r = remdups (eqc _A eq_nata) (flat_map funas_rule_list r);;

let rec arith_fun
  xml = xml1element
          ['a'; 'r'; 'i'; 't'; 'h'; 'F'; 'u'; 'n'; 'c'; 't'; 'i'; 'o'; 'n']
          (xml_options
            [(['n'; 'a'; 't'; 'u'; 'r'; 'a'; 'l'],
               xml_change (nata ['n'; 'a'; 't'; 'u'; 'r'; 'a'; 'l'])
                 (fun a -> Const a));
              (['v'; 'a'; 'r'; 'i'; 'a'; 'b'; 'l'; 'e'],
                xml_change (nata ['v'; 'a'; 'r'; 'i'; 'a'; 'b'; 'l'; 'e'])
                  (fun n -> Arg (minus_nat n one_nat)));
              (['s'; 'u'; 'm'],
                xml_many_elements ['s'; 'u'; 'm'] arith_fun (fun a -> Sum a));
              (['p'; 'r'; 'o'; 'd'; 'u'; 'c'; 't'],
                xml_many_elements ['p'; 'r'; 'o'; 'd'; 'u'; 'c'; 't'] arith_fun
                  (fun a -> Prod a));
              (['m'; 'i'; 'n'],
                xml_many_elements ['m'; 'i'; 'n'] arith_fun (fun a -> Min a));
              (['m'; 'a'; 'x'],
                xml_many_elements ['m'; 'a'; 'x'] arith_fun (fun a -> Max a))])
          id xml;;

let rec sl_inter
  xml2name =
    xml1element ['m'; 'o'; 'd'; 'e'; 'l']
      (xml_options
        [(['f'; 'i'; 'n'; 'i'; 't'; 'e'; 'M'; 'o'; 'd'; 'e'; 'l'],
           xml1many_elements
             ['f'; 'i'; 'n'; 'i'; 't'; 'e'; 'M'; 'o'; 'd'; 'e'; 'l']
             (xml_change
               (nata ['c'; 'a'; 'r'; 'r'; 'i'; 'e'; 'r'; 'S'; 'i'; 'z'; 'e'])
               (fun n -> minus_nat n one_nat))
             (xml3elements ['i'; 'n'; 't'; 'e'; 'r'; 'p'; 'r'; 'e'; 't']
               xml2name (nata ['a'; 'r'; 'i'; 't'; 'y']) arith_fun
               (fun f a -> (fun b -> ((f, a), b))))
             (fun n xs -> Some (SL_Inter (n, xs))));
          (['r'; 'o'; 'o'; 't'; 'L'; 'a'; 'b'; 'e'; 'l'; 'i'; 'n'; 'g'],
            xml0elements
              ['r'; 'o'; 'o'; 't'; 'L'; 'a'; 'b'; 'e'; 'l'; 'i'; 'n'; 'g']
              None)])
      id;;

let rec xml_term _A _B
  = function
    Var x -> Xml (['v'; 'a'; 'r'], [], [], Some (shows_prec _B Zero_nat x []))
    | Fun (f, ts) ->
        Xml (['f'; 'u'; 'n'; 'a'; 'p'; 'p'], [],
              Xml (['n'; 'a'; 'm'; 'e'], [], [],
                    Some (shows_prec _A Zero_nat f [])) ::
                map (fun t ->
                      Xml (['a'; 'r'; 'g'], [], [xml_term _A _B t], None))
                  ts,
              None);;

let rec supteq_list
  = function Var x -> [Var x]
    | Fun (f, ts) -> Fun (f, ts) :: concat_map supteq_list ts;;

let rec dP_list _A _B
  r = let d = defs_list _A r in
      concat_map
        (fun lr ->
          let l = fst lr in
          let s = sharpa l in
          map (fun u -> (s, sharpa u))
            (filter
              (fun u ->
                not (suptp _A _B l u) &&
                  (not (is_var u) &&
                    member (eqc _A eq_nata) d (the (root u), num_args u)))
              (supteq_list (snd lr))))
        r;;

let rec iD_list r = map (fun lr -> (plaina (fst lr), plaina (snd lr))) r;;

type ('a, 'b) dPDisproof =
  DPLoop of
    ('a, 'b) term *
      (pos * ((('a, 'b) term * ('a, 'b) term) * (bool * ('a, 'b) term))) list *
      ('b * ('a, 'b) term) list * ('a, 'b) ctxt
  | DPRuleRemoval of
      (('a, 'b) term * ('a, 'b) term) list *
        (('a, 'b) term * ('a, 'b) term) list * ('a, 'b) dPDisproof;;

type ('a, 'b) tRSDisproof =
  Loop of
    ('a, 'b) term *
      (pos * ((('a, 'b) term * ('a, 'b) term) * ('a, 'b) term)) list *
      ('b * ('a, 'b) term) list * ('a, 'b) ctxt
  | NotWellFormed |
  NTRuleRemoval of (('a, 'b) term * ('a, 'b) term) list * ('a, 'b) tRSDisproof |
  NTStringReversal of
    (('a, 'b) term * ('a, 'b) term) list * ('a, 'b) tRSDisproof
  | NTDPTrans of
      (('a shp, 'b) term * ('a shp, 'b) term) list * ('a shp, 'b) dPDisproof;;

let rec indent
  p s = flat_map
          (fun c -> (if ((c : char) = newline) then [newline; ' '] else [c]))
          (p s);;

let rec check_rule_reflecting (_A1, _A2)
  fcs rs rule =
    check (list_ex
            (fun (l, r) ->
              list_ex
                (fun c ->
                  eq_term _A1 (eq_lista eq_char) (fst rule) (ctxt_apply c l) &&
                    eq_term _A1 (eq_lista eq_char) (snd rule) (ctxt_apply c r))
                (Hole :: fcs))
            rs)
      (comp (shows_string ['t'; 'h'; 'e'; ' '; 'r'; 'u'; 'l'; 'e'; ' '])
        (comp (shows_rule _A2 (show_list show_char) rule)
          (comp (shows_string
                  [' '; 'i'; 's'; ' '; 'n'; 'e'; 'i'; 't'; 'h'; 'e'; 'r'; ' ';
                    'c'; 'o'; 'n'; 't'; 'a'; 'i'; 'n'; 'e'; 'd'; ' '; 'i'; 'n';
                    ' '; 't'; 'h'; 'e'; ' '; 'o'; 'r'; 'i'; 'g'; 'i'; 'n'; 'a';
                    'l'; ' '; 's'; 'e'; 't'; ' '; 'o'; 'f'; ' '; 'r'; 'u'; 'l';
                    'e'; 's'; ' '; 'n'; 'o'; 'r'; ' '; 'o'; 'b'; 't'; 'a'; 'i';
                    'n'; 'e'; 'd'; ' '; 'b'; 'y'; ' '; 'a'; 'p'; 'p'; 'l'; 'y';
                    'i'; 'n'; 'g'; ' '; 'a'; ' '; 'f'; 'l'; 'a'; 't'; ' '; 'c';
                    'o'; 'n'; 't'; 'e'; 'x'; 't'])
            shows_nl)));;

let rec check_rule_preserving (_A1, _A2)
  fcs rs rule =
    check (member
             (eqc (eq_terma _A1 (eq_lista eq_char))
               (eq_terma _A1 (eq_lista eq_char)))
             rs rule ||
            list_all
              (fun c ->
                member
                  (eqc (eq_terma _A1 (eq_lista eq_char))
                    (eq_terma _A1 (eq_lista eq_char)))
                  rs (ctxt_apply c (fst rule), ctxt_apply c (snd rule)))
              fcs)
      (comp (shows_string ['t'; 'h'; 'e'; ' '; 'r'; 'u'; 'l'; 'e'; ' '])
        (comp (shows_rule _A2 (show_list show_char) rule)
          (comp (shows_string
                  [' '; 'i'; 's'; ' '; 'n'; 'e'; 'i'; 't'; 'h'; 'e'; 'r'; ' ';
                    'c'; 'o'; 'n'; 't'; 'a'; 'i'; 'n'; 'e'; 'd'; ' '; 'i'; 'n';
                    ' '; 't'; 'h'; 'e'; ' '; 'r'; 'e'; 's'; 'u'; 'l'; 't'; 'i';
                    'n'; 'g'; ' '; 's'; 'e'; 't'; ' '; 'o'; 'f'; ' '; 'r'; 'u';
                    'l'; 'e'; 's'; ' '; 'n'; 'o'; 'r'; ' '; 'c'; 'l'; 'o'; 's';
                    'e'; 'd'; ' '; 'u'; 'n'; 'd'; 'e'; 'r'; ' '; 'a'; 'l'; 'l';
                    ' '; 'f'; 'l'; 'a'; 't'; ' '; 'c'; 'o'; 'n'; 't'; 'e'; 'x';
                    't'; 's'])
            shows_nl)));;

let rec hole_at _A
  n i f x3 = match n, i, f, x3 with
    n, i, f, More (g, ss1, Hole, ss2) ->
      eqa _A g f &&
        (eq_nat (size_list ss1) i &&
          eq_nat (size_list ss2) (minus_nat (minus_nat n i) one_nat))
    | n, i, f, Hole -> false
    | n, i, f, More (v, va, More (vd, ve, vf, vg), vc) -> false;;

let rec all_from_to_nat
  p i j =
    (if less_nat i j
      then (if p i then all_from_to_nat p (plus_nat i one_nat) j else false)
      else true);;

let rec check_flat_ctxt_complete (_A1, _A2)
  fcs fa =
    check (all_from_to_nat
            (fun i -> list_ex (hole_at _A1 (snd fa) i (fst fa)) fcs) Zero_nat
            (snd fa))
      (comp (shows_string
              ['t'; 'h'; 'e'; ' '; 'l'; 'i'; 's'; 't'; ' '; 'o'; 'f'; ' '; 'f';
                'l'; 'a'; 't'; ' '; 'c'; 'o'; 'n'; 't'; 'e'; 'x'; 't'; 's'; ' ';
                'i'; 's'; ' '; 'i'; 'n'; 'c'; 'o'; 'm'; 'p'; 'l'; 'e'; 't';
                'e'])
        shows_nl);;

let rec shows_prec_ctxt _A _B d c = shows_ctxt _A _B c;;

let rec is_flat_ctxt_list _A _B
  vs fas x2 = match vs, fas, x2 with
    vs, fas, More (f, ss1, Hole, ss2) ->
      member (eqc _B eq_nata) fas (f, Suc (size_list (append ss1 ss2))) &&
        (list_all is_var (append ss1 ss2) &&
          (distinct (eq_terma _B _A) (append ss1 ss2) &&
            null (list_inter _A (map the_var (append ss1 ss2)) vs)))
    | vs, fas, Hole -> false
    | vs, fas, More (v, va, More (vd, ve, vf, vg), vc) -> false;;

let rec check_is_flat_ctxt (_A1, _A2)
  vs fas c =
    check (is_flat_ctxt_list (eq_lista eq_char) _A1 vs fas c)
      (comp (shows_prec_ctxt _A2 (show_list show_char) Zero_nat c)
        (comp (shows_string
                [' '; 'i'; 's'; ' '; 'n'; 'o'; 't'; ' '; 'a'; ' '; 'f'; 'l';
                  'a'; 't'; ' '; 'c'; 'o'; 'n'; 't'; 'e'; 'x'; 't'])
          shows_nl));;

let rec check_flat_ctxt (_A1, _A2)
  vs c =
    (match c
      with Hole ->
        Inl (comp (shows_prec_ctxt _A2 (show_list show_char) Zero_nat c)
              (comp (shows_string
                      [' '; 'i'; 's'; ' '; 'n'; 'o'; 't'; ' '; 'a'; ' '; 'f';
                        'l'; 'a'; 't'; ' '; 'c'; 'o'; 'n'; 't'; 'e'; 'x'; 't'])
                shows_nl))
      | More (_, ss1, Hole, ss2) ->
        bind (check
               (distinct (eq_terma _A1 (eq_lista eq_char)) (append ss1 ss2))
               (comp (shows_prec_ctxt _A2 (show_list show_char) Zero_nat c)
                 (comp (shows_string
                         [' '; 'c'; 'o'; 'n'; 't'; 'a'; 'i'; 'n'; 's'; ' '; 'd';
                           'u'; 'p'; 'l'; 'i'; 'c'; 'a'; 't'; 'e'; ' '; 'v';
                           'a'; 'r'; 'i'; 'a'; 'b'; 'l'; 'e'; 's'])
                   shows_nl)))
          (fun _ ->
            bind (check (list_all is_var (append ss1 ss2))
                   (comp (shows_prec_ctxt _A2 (show_list show_char) Zero_nat c)
                     (comp (shows_string
                             [' '; 'i'; 's'; ' '; 'n'; 'o'; 't'; ' '; 'f'; 'l';
                               'a'; 't'; ','; ' '; 'i'; '.'; 'e'; '.'; ','; ' ';
                               'h'; 'a'; 's'; ' '; 'd'; 'e'; 'p'; 't'; 'h'; ' ';
                               'g'; 'r'; 'e'; 'a'; 't'; 'e'; 'r'; ' '; 't'; 'h';
                               'a'; 'n'; ' '; 'o'; 'n'; 'e'])
                       shows_nl)))
              (fun _ ->
                check (list_all
                        (fun t ->
                          not (member (eq_lista eq_char) vs (the_var t)))
                        (append ss1 ss2))
                  (comp (shows_prec_ctxt _A2 (show_list show_char) Zero_nat c)
                    (comp (shows_string
                            [' '; 'h'; 'a'; 's'; ' '; 't'; 'o'; ' '; 'c'; 'o';
                              'n'; 't'; 'a'; 'i'; 'n'; ' '; 'o'; 'n'; 'l'; 'y';
                              ' '; 'f'; 'r'; 'e'; 's'; 'h'; ' '; 'v'; 'a'; 'r';
                              'i'; 'a'; 'b'; 'l'; 'e'; 's'])
                      shows_nl))))
      | More (_, ss1, More (_, _, _, _), ss2) ->
        Inl (comp (shows_prec_ctxt _A2 (show_list show_char) Zero_nat c)
              (comp (shows_string
                      [' '; 'i'; 's'; ' '; 'n'; 'o'; 't'; ' '; 'a'; ' '; 'f';
                        'l'; 'a'; 't'; ' '; 'c'; 'o'; 'n'; 't'; 'e'; 'x'; 't'])
                shows_nl)));;

let rec fcc_tt (_A1, _A2)
  r fcs lR =
    let vs = vars_trs_list (eq_lista eq_char) r in
    let fas = funas_trs_list _A1 r in
    bind (check (not (null fcs))
           (comp (shows_string
                   [' '; 'a'; 't'; ' '; 'l'; 'e'; 'a'; 's'; 't'; ' '; 'o'; 'n';
                     'e'; ' '; 'f'; 'l'; 'a'; 't'; ' '; 'c'; 'o'; 'n'; 't'; 'e';
                     'x'; 't'; ' '; 'i'; 's'; ' '; 'r'; 'e'; 'q'; 'u'; 'i'; 'r';
                     'e'; 'd'; ' '; 'f'; 'o'; 'r'; ' '; 't'; 'h'; 'e'; ' '; 'c';
                     'l'; 'o'; 's'; 'u'; 'r'; 'e'; ' '; 'u'; 'n'; 'd'; 'e'; 'r';
                     ' '; 'f'; 'l'; 'a'; 't'; ' '; 'c'; 'o'; 'n'; 't'; 'e'; 'x';
                     't'; 's'])
             shows_nl))
      (fun _ ->
        bind (catch (forallm (check_flat_ctxt (_A1, _A2) vs) fcs)
               (fun x -> Inl (snd x)))
          (fun _ ->
            bind (catch (forallm (check_is_flat_ctxt (_A1, _A2) vs fas) fcs)
                   (fun x -> Inl (snd x)))
              (fun _ ->
                bind (catch
                       (forallm (check_flat_ctxt_complete (_A1, _A2) fcs) fas)
                       (fun x -> Inl (snd x)))
                  (fun _ ->
                    bind (catch
                           (forallm (check_rule_preserving (_A1, _A2) fcs lR) r)
                           (fun x -> Inl (snd x)))
                      (fun _ ->
                        catch (forallm (check_rule_reflecting (_A1, _A2) fcs r)
                                lR)
                          (fun x -> Inl (snd x)))))));;

let rec rp_strict (v, (s, (n, (a, (m, d))))) = s;;

let rec pi_full uu uv uw = true;;

let rec parse_text
  x = binda (many (fun c -> not (eq_list eq_char [c] ['<'])))
        (fun ts ->
          let text = trim ts in
          (if null text then (fun tsa -> Inr (None, tsa))
            else (fun tsa -> Inr (Some (rev (trim (rev text))), tsa))))
        x;;

let rec parse_attribute_value
  x = binda (oneof [dquote])
        (fun _ ->
          binda (many (fun c -> not (eq_list eq_char [c] dquote)))
            (fun v -> binda (oneof [dquote]) (fun _ ts -> Inr (v, ts))))
        x;;

let rec parse_name
  x = binda (manyof letters)
        (fun n ->
          binda spaces
            (fun _ ->
              (if null n then (fun _ -> Inl letters)
                else (fun ts -> Inr (n, ts)))))
        x;;

let rec parse_attributes
  = function [] -> Inr ([], [])
    | c :: s ->
        (if member eq_char ['/'; '>'] c then Inr ([], c :: s)
          else binda parse_name
                 (fun k ->
                   binda (oneof [['=']])
                     (fun _ ->
                       binda parse_attribute_value
                         (fun v ->
                           binda parse_attributes
                             (fun atts ts -> Inr ((k, v) :: atts, ts)))))
                 (c :: s));;

let rec parse_nodes
  ts = (if null ts ||
             eq_list eq_char (take (nat (Big_int.big_int_of_int 2)) ts)
               ['<'; '/']
         then Inr ([], ts)
         else binda (oneof [['<']])
                (fun _ ->
                  binda parse_name
                    (fun n ->
                      binda parse_attributes
                        (fun atts ->
                          binda (oneof [['/'; '>']; ['>']])
                            (fun e tsa ->
                              (if eq_list eq_char e ['/'; '>']
                                then binda parse_nodes
                                       (fun cs tsb ->
 Inr (Xml (n, atts, [], None) :: cs, tsb))
                                       tsa
                                else binda parse_text
                                       (fun t ->
 binda parse_nodes
   (fun cs ->
     binda (oneof [append ['<'; '/'] (append n ['>'])])
       (fun _ ->
         binda parse_nodes
           (fun ns tsb -> Inr (Xml (n, atts, cs, t) :: ns, tsb)))))
                                       tsa)))))
                ts);;

let rec parse_node
  x = binda (oneof [['<']])
        (fun _ ->
          binda parse_name
            (fun n ->
              binda parse_attributes
                (fun atts ->
                  binda (oneof [['/'; '>']; ['>']])
                    (fun e ->
                      (if eq_list eq_char e ['/'; '>']
                        then (fun ts -> Inr (Xml (n, atts, [], None), ts))
                        else binda parse_text
                               (fun t ->
                                 binda parse_nodes
                                   (fun cs ->
                                     binda (oneof
     [append ['<'; '/'] (append n ['>'])])
                                       (fun _ ts ->
 Inr (Xml (n, atts, cs, t), ts)))))))))
        x;;

let rec scan_upto
  enda x1 = match enda, x1 with
    enda, [] ->
      Inl (append
            ['d'; 'i'; 'd'; ' '; 'n'; 'o'; 't'; ' '; 'f'; 'i'; 'n'; 'd'; ' ';
              'e'; 'n'; 'd'; '-'; 'm'; 'a'; 'r'; 'k'; 'e'; 'r'; ' ']
            (quote (shows_prec_list show_char Zero_nat enda) []))
    | enda, t :: ts ->
        (if eq_list eq_char (map snd (zip enda (t :: ts))) enda
          then Inr (enda, drop (size_list enda) (t :: ts))
          else bind (scan_upto enda ts)
                 (fun (res, tsa) -> Inr (t :: res, tsa)));;

let rec parse_header
  ts = (if eq_list eq_char (take (nat (Big_int.big_int_of_int 2)) (trim ts))
             ['<'; '?']
         then binda (scan_upto ['?'; '>'])
                (fun h ->
                  binda parse_header (fun hs tsa -> Inr (append h hs, tsa)))
                ts
         else binda spaces (fun _ tsa -> Inr ([], tsa)) ts);;

let rec remove_comments_aux
  uu x1 = match uu, x1 with
    false, c :: cs ->
      (if ((c : char) = '<') &&
            eq_list eq_char (take (nat (Big_int.big_int_of_int 3)) cs)
              ['!'; '-'; '-']
        then remove_comments_aux true (tl cs)
        else c :: remove_comments_aux false cs)
    | true, c :: cs ->
        (if ((c : char) = '-') &&
              eq_list eq_char (take (nat (Big_int.big_int_of_int 2)) cs)
                ['-'; '>']
          then remove_comments_aux false
                 (drop (nat (Big_int.big_int_of_int 2)) cs)
          else remove_comments_aux true cs)
    | uu, [] -> [];;

let rec remove_comments x = remove_comments_aux false x;;

let rec update_tokens f ts = Inr (ts, f ts);;

let rec parse_doc
  x = debug ['0']
        ['p'; 'a'; 'r'; 's'; 'i'; 'n'; 'g'; ' '; 't'; 'x'; 't'; ' '; 't'; 'o';
          ' '; 'x'; 'm'; 'l']
        (binda (update_tokens remove_comments)
          (fun _ ->
            binda parse_header
              (fun h ->
                binda parse_node
                  (fun xml ->
                    binda (eoi show_char)
                      (fun _ ts -> Inr (Xmldoc (h, xml), ts))))))
        x;;

type 'a filtered = FPair of 'a * nat;;

let rec xml_rules _A _B
  tag rls =
    Xml (tag, [],
          [Xml (['r'; 'u'; 'l'; 'e'; 's'], [],
                 map (fun (l, r) ->
                       Xml (['r'; 'u'; 'l'; 'e'], [],
                             [Xml (['l'; 'h'; 's'], [], [xml_term _A _B l],
                                    None);
                               Xml (['r'; 'h'; 's'], [], [xml_term _A _B r],
                                     None)],
                             None))
                   rls,
                 None)],
          None);;

let rec check_subseteq _A
  xs ys =
    catch (forallm (fun x -> (if member _A ys x then Inr () else Inl x)) xs)
      (fun x -> Inl (snd x));;

let rec check_wf_trs _A (_B1, _B2)
  r = catch (catch
              (forallm
                (fun rule ->
                  catch (bind (check (not (is_var (fst rule)))
                                (shows_string
                                  ['v'; 'a'; 'r'; 'i'; 'a'; 'b'; 'l'; 'e'; ' ';
                                    'l'; 'e'; 'f'; 't'; '-'; 'h'; 'a'; 'n'; 'd';
                                    ' '; 's'; 'i'; 'd'; 'e'; ' '; 'i'; 'n']))
                          (fun _ ->
                            catch (check_subseteq _B1
                                    (vars_term_list _B1 (snd rule))
                                    (vars_term_list _B1 (fst rule)))
                              (fun x ->
                                Inl (comp (shows_string
    ['f'; 'r'; 'e'; 'e'; ' '; 'v'; 'a'; 'r'; 'i'; 'a'; 'b'; 'l'; 'e'; ' '])
                                      (comp (shows_prec _B2 Zero_nat x)
(shows_string
  [' '; 'i'; 'n'; ' '; 'r'; 'i'; 'g'; 'h'; 't'; '-'; 'h'; 'a'; 'n'; 'd'; ' ';
    's'; 'i'; 'd'; 'e'; ' '; 'o'; 'f']))))))
                    (fun x ->
                      Inl (comp x
                            (comp (shows_string [' '; 'r'; 'u'; 'l'; 'e'; ' '])
                              (comp (shows_rule _A _B2 rule) shows_nl)))))
                r)
              (fun x -> Inl (snd x)))
        (fun x ->
          Inl (comp (shows_string
                      ['t'; 'h'; 'e'; ' '; 'T'; 'R'; 'S'; ' '; 'i'; 's'; ' ';
                        'n'; 'o'; 't'; ' '; 'w'; 'e'; 'l'; 'l'; '-'; 'f'; 'o';
                        'r'; 'm'; 'e'; 'd'])
                (comp shows_nl x)));;

let rec check_DP (_A1, _A2) (_B1, _B2)
  r p = catch (bind (check_wf_trs _A2 (_B1, _B2) r)
                (fun _ ->
                  catch (check_subseteq
                          (eqc (eq_terma (eq_shpa _A1) _B1)
                            (eq_terma (eq_shpa _A1) _B1))
                          (dP_list _A1 _B1 r) p)
                    (fun x ->
                      Inl (comp (shows_string
                                  ['t'; 'h'; 'e'; ' '; 'D'; 'P'; ' '])
                            (comp (shows_rule (show_shp _A2) _B2 x)
                              (comp (shows_string
                                      [' '; 'd'; 'o'; 'e'; 's'; ' '; 'n'; 'o';
't'; ' '; 'a'; 'p'; 'p'; 'e'; 'a'; 'r'; ' '; 'i'; 'n'; ' '; 't'; 'h'; 'e'; ' ';
'D'; 'P'; ' '; 'p'; 'r'; 'o'; 'b'; 'l'; 'e'; 'm'])
                                shows_nl))))))
          (fun x ->
            Inl (comp (shows_string
                        ['t'; 'h'; 'e'; ' '; 'D'; 'P'; '-'; 't'; 'r'; 'a'; 'n';
                          's'; 'f'; 'o'; 'r'; 'm'; 'a'; 't'; 'i'; 'o'; 'n'; ' ';
                          'i'; 's'; ' '; 'n'; 'o'; 't'; ' '; 'a'; 'p'; 'p'; 'l';
                          'i'; 'e'; 'd'; ' '; 'c'; 'o'; 'r'; 'r'; 'e'; 'c'; 't';
                          'l'; 'y'; '.'])
                  (comp shows_nl x)));;

let rec create_afI _A _B
  ze x1 f n i = match ze, x1, f, n, i with ze, [], f, n, i -> true
    | ze, ((g, m), (c, coeffs)) :: rest, f, n, i ->
        (if eqa _B f g && eq_nat m n
          then less_nat i (size_list coeffs) && not (eqa _A (nth coeffs i) ze)
          else create_afI _A _B ze rest f n i);;

let rec check_sem_lab_proc (_A1, _A2) (_B1, _B2) (_C1, _C2)
  check_lab check_model_lab gr i l p r lP lR =
    bind (catch (check_lab lP p)
           (fun x ->
             Inl (comp (shows_string
                         ['n'; 'o'; 't'; ' '; 'a'; 'l'; 'l'; ' '; 'l'; 'a'; 'b';
                           'e'; 'l'; 'e'; 'd'; ' '; 'D'; 'P'; 's'; ' '; 'p';
                           'r'; 'e'; 's'; 'e'; 'n'; 't'; ':'])
                   (comp shows_nl x))))
      (fun _ ->
        bind (catch (check_model_lab lR r)
               (fun x ->
                 Inl (comp (shows_string
                             ['p'; 'r'; 'o'; 'b'; 'l'; 'e'; 'm'; ' '; 'w'; 'i';
                               't'; 'h'; ' '; 'l'; 'a'; 'b'; 'e'; 'l'; 'e'; 'd';
                               ' '; 'T'; 'R'; 'S'; ':'])
                       (comp shows_nl x))))
          (fun _ ->
            catch (check_sl_only_lab_and_decr (_B1, _B2) (_A1, _A2) (_C1, _C2)
                    gr r lR)
              (fun x -> Inl (comp x shows_nl))));;

let rec rl_proc (_A1, _A2) (_B1, _B2)
  p r lP lR =
    let fs =
      list_union (eq_laba _A1 _B1) (funs_trs_list (eq_laba _A1 _B1) r)
        (list_diff (eq_laba _A1 _B1) (funs_trs_list (eq_laba _A1 _B1) p)
          (map fst (defs_list (eq_laba _A1 _B1) p)))
      in
    bind (check (not (null fs))
           (comp (shows_string
                   ['r'; 'o'; 'o'; 't'; '-'; 'l'; 'a'; 'b'; 'e'; 'l'; 'i'; 'n';
                     'g'; ' '; 'r'; 'e'; 'q'; 'u'; 'i'; 'r'; 'e'; 's'; ' '; 'a';
                     't'; ' '; 'l'; 'e'; 'a'; 's'; 't'; ' '; 'o'; 'n'; 'e'; ' ';
                     'f'; 'u'; 'n'; 'c'; 't'; 'i'; 'o'; 'n'; ' '; 's'; 'y'; 'm';
                     'b'; 'o'; 'l'; ' '; 'i'; 'n'; ' '; 't'; 'h'; 'e'; ' '; 's';
                     'i'; 'g'; 'n'; 'a'; 't'; 'u'; 'r'; 'e'])
             shows_nl))
      (fun _ ->
        let d = hd fs in
        check_sem_lab_proc (_A1, _A2) (_B1, _B2)
          (eq_lista eq_char, show_list show_char)
          (check_sl_lab_trs (_A1, _A2) (_B1, _B2)
            (eq_laba _A1 _B1, show_lab _A2 _B2)
            (eq_lista eq_char, show_list show_char)
            (rl_inter_list (eq_laba _A1 _B1) fs d) rl_fun fs)
          (check_sl_model_lab_trs (_A1, _A2) (_B1, _B2)
            (eq_laba _A1 _B1, show_lab _A2 _B2)
            (eq_lista eq_char, show_list show_char)
            (rl_inter_list (eq_laba _A1 _B1) fs d) rl_fun fs)
          (bot_fun bot_boola) (rl_inter_list (eq_laba _A1 _B1) fs d) rl_fun p r
          lP lR);;

let rec funas_term_list _A t = remdups (eqc _A eq_nata) (funas_term_lista t);;

let rec plain_name
  x = xml_options
        [(['n'; 'a'; 'm'; 'e'],
           xml_change (text ['n'; 'a'; 'm'; 'e']) (fun a -> UnLab a));
          (['l'; 'a'; 'b'; 'e'; 'l'; 'e'; 'd'; 'S'; 'y'; 'm'; 'b'; 'o'; 'l'],
            xml2elements
              ['l'; 'a'; 'b'; 'e'; 'l'; 'e'; 'd'; 'S'; 'y'; 'm'; 'b'; 'o'; 'l']
              plain_name (label plain_name)
              (fun f a ->
                (match a with Inl aa -> Lab (f, aa)
                  | Inr aa -> FunLab (f, aa))))]
        x;;

let rec sharp_name
  x = (if eq_list eq_char (get_name x) ['s'; 'h'; 'a'; 'r'; 'p']
        then xml1element ['s'; 'h'; 'a'; 'r'; 'p'] (text ['n'; 'a'; 'm'; 'e'])
               (fun a -> Sharp a) x
        else xml_change (text ['n'; 'a'; 'm'; 'e']) (fun a -> Plain a) x);;

type 'a ordered_semiring_0 =
  {semiring_0_ordered_semiring_0 : 'a semiring_0;
    ordered_ab_semigroup_ordered_semiring_0 : 'a ordered_ab_semigroup};;

type 'a ordered_semiring_1 =
  {semiring_1_ordered_semiring_1 : 'a semiring_1;
    ordered_semiring_0_ordered_semiring_1 : 'a ordered_semiring_0};;

type 'a poly_carrier =
  {comm_semiring_1_poly_carrier : 'a comm_semiring_1;
    ordered_semiring_1_poly_carrier : 'a ordered_semiring_1};;

let rec default_I _A
  def n =
    ([], def) ::
      map (fun i ->
            ([(i, one_nat)],
              one _A.ordered_semiring_1_poly_carrier.semiring_1_ordered_semiring_1.monoid_mult_semiring_1.power_monoid_mult.one_power))
        (upt Zero_nat n);;

let rec poly_power _A (_B1, _B2)
  uu x1 = match uu, x1 with
    uu, Zero_nat -> one_poly _B2.semiring_1_comm_semiring_1
    | p, Suc n ->
        poly_mult _A
          (_B1, _B2.comm_semiring_0_comm_semiring_1.semiring_0_comm_semiring_0)
          p (poly_power _A (_B1, _B2) p n);;

let rec monom_subst _B (_C1, _C2)
  sigma x1 = match sigma, x1 with
    sigma, [] -> one_poly _C2.semiring_1_comm_semiring_1
    | sigma, (x, p) :: m ->
        poly_mult _B
          (_C1, _C2.comm_semiring_0_comm_semiring_1.semiring_0_comm_semiring_0)
          (poly_power _B (_C1, _C2) (sigma x) p)
          (monom_subst _B (_C1, _C2) sigma m);;

let rec poly_subst _B (_C1, _C2)
  sigma x1 = match sigma, x1 with sigma, [] -> zero_poly
    | sigma, (m, c) :: p ->
        poly_add _B
          (_C1, _C2.comm_semiring_0_comm_semiring_1.semiring_0_comm_semiring_0)
          (poly_mult _B
            (_C1, _C2.comm_semiring_0_comm_semiring_1.semiring_0_comm_semiring_0)
            [([], c)] (monom_subst _B (_C1, _C2) sigma m))
          (poly_subst _B (_C1, _C2) sigma p);;

let rec eval_term (_B1, _B2) _C
  uu x1 = match uu, x1 with
    uu, Var x ->
      [([(x, one_nat)],
         one _B2.ordered_semiring_1_poly_carrier.semiring_1_ordered_semiring_1.monoid_mult_semiring_1.power_monoid_mult.one_power)]
    | i, Fun (f, ts) ->
        let ps = map (eval_term (_B1, _B2) _C i) ts in
        let n = size_list ts in
        poly_subst _C (_B1, _B2.comm_semiring_1_poly_carrier)
          (fun ia -> (if less_nat ia n then nth ps ia else zero_poly)) (i f n);;

let rec poly_var _A p v = member _A (concat_map (comp (map fst) fst) p) v;;

type ('a, 'b) relTRSDisproof =
  RelLoop of
    ('a, 'b) term *
      (pos * ((('a, 'b) term * ('a, 'b) term) * (bool * ('a, 'b) term))) list *
      ('b * ('a, 'b) term) list * ('a, 'b) ctxt
  | RelNotWellFormed |
  NTRelRuleRemoval of
    (('a, 'b) term * ('a, 'b) term) list *
      (('a, 'b) term * ('a, 'b) term) list * ('a, 'b) relTRSDisproof
  | RNotSN of ('a, 'b) tRSDisproof;;

let rec get_comp_ge
  (wfe, (ze, (on, (def, (pl, (ti, (mz, (ge, (gt, (mo, (de, (ap, cm)))))))))))) =
    ge;;

let rec show_pvars (_A1, _A2) _B
  on x1 = match on, x1 with on, [] -> []
    | on, (x, c) :: vas ->
        append (if eqa _A1 on c then [] else shows_prec _A2 Zero_nat c [])
          (shows_prec _B Zero_nat x []) ::
          show_pvars (_A1, _A2) _B on vas;;

type ('a, 'b, 'c) relTRSProof =
  RelRuleRemoval of
    ('a, 'b) lab redpair *
      ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
      ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
      ('a, 'b, 'c) relTRSProof
  | RelSisEmpty of ('a, 'b, 'c) tRSProof |
  RelUnlab of
    ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
      ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
      ('a, 'b, 'c) relTRSProof
  | RelSemlab of
      ('a, 'b) sl_inter *
        (('a, 'b) lab -> nat list -> ('b, (('a, 'b) lab list)) sum) *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ('a, 'b, 'c) relTRSProof
  | RelRootlab of
      ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ('a, 'b, 'c) relTRSProof
  | RelRisEmpty;;

type ('a, 'b, 'c) certificationProblem =
  TRSProof of (('a, 'c) term * ('a, 'c) term) list * ('a, 'b, 'c) tRSProof |
  TRSDisproof of (('a, 'c) term * ('a, 'c) term) list * ('a, 'c) tRSDisproof |
  RelTRSProof of
    ((('a, 'c) term * ('a, 'c) term) list *
      (('a, 'c) term * ('a, 'c) term) list) *
      ('a, 'b, 'c) relTRSProof
  | RelTRSDisproof of
      ((('a, 'c) term * ('a, 'c) term) list *
        (('a, 'c) term * ('a, 'c) term) list) *
        ('a, 'c) relTRSDisproof;;

let rec block_term
  f x1 = match f, x1 with f, Var x -> Var x
    | f, Fun (g, ts) -> Fun (g, map (fun t -> Fun (f, [t])) ts);;

let rec block_rule f r = (block_term f (fst r), block_term f (snd r));;

let rec check_superset_of_blocked (_A1, _A2)
  f ra r =
    catch (catch
            (catch
              (forallm
                (fun x ->
                  (if member
                        (eqc (eq_terma _A1 (eq_lista eq_char))
                          (eq_terma _A1 (eq_lista eq_char)))
                        ra (block_rule f x)
                    then Inr () else Inl x))
                r)
              (fun x -> Inl (snd x)))
            (fun x ->
              Inl (comp (shows_string
                          ['t'; 'h'; 'e'; ' '; 'r'; 'u'; 'l'; 'e'; ' '])
                    (comp (shows_rule _A2 (show_list show_char)
                            (block_rule f x))
                      (comp (shows_string
                              [' '; 'i'; 's'; ' '; 'm'; 'i'; 's'; 's'; 'i'; 'n';
                                'g'])
                        shows_nl)))))
      (fun x ->
        Inl (comp (shows_trs _A2 (show_list show_char) r)
              (comp (shows_string
                      ['i'; 's'; ' '; 'n'; 'o'; 't'; ' '; 'a'; ' '; 's'; 'u';
                        'b'; 's'; 'e'; 't'; ' '; 'o'; 'f'])
                (comp (shows_trs _A2 (show_list show_char) ra)
                  (comp x shows_nl)))));;

let rec check_no_defined_root_defs (_A1, _A2) _B
  f t = check (not (member (eqc _A1 eq_nata) f (the (root t), num_args t)))
          (comp (shows_string
                  ['t'; 'h'; 'e'; ' '; 'r'; 'o'; 'o'; 't'; ' '; 'o'; 'f'; ' '])
            (comp (shows_prec_term _A2 _B Zero_nat t)
              (shows_string
                [' '; 'i'; 's'; ' '; 'd'; 'e'; 'f'; 'i'; 'n'; 'e'; 'd'])));;

let rec check_no_var _A _B
  t = check (not (is_var t))
        (comp (shows_string
                ['v'; 'a'; 'r'; 'i'; 'a'; 'b'; 'l'; 'e'; ' '; 'f'; 'o'; 'u';
                  'n'; 'd'])
          shows_nl);;

let rec check_left_linear_trs _A
  trs = catch (catch
                (forallm
                  (fun x ->
                    (if linear_term (eq_lista eq_char) (fst x) then Inr ()
                      else Inl x))
                  trs)
                (fun x -> Inl (snd x)))
          (fun _ ->
            Inl (comp (shows_prec_list
                        (show (show_term _A (show_list show_char))
                          (show_term _A (show_list show_char)))
                        Zero_nat trs)
                  (comp shows_nl
                    (comp (shows_string
                            ['i'; 's'; ' '; 'n'; 'o'; 't'; ' '; 'l'; 'e'; 'f';
                              't'; '-'; 'l'; 'i'; 'n'; 'e'; 'a'; 'r'])
                      shows_nl))));;

let rec remove_lab
  = function Lab (f, uu) -> remove_lab f
    | UnLab f -> f
    | FunLab (f, uv) -> remove_lab f;;

let rec funas_below_term_list t = flat_map funas_term_lista (args t);;

let rec funas_below_rule_list
  r = append (funas_below_term_list (fst r)) (funas_below_term_list (snd r));;

let rec funas_below_trs_list _A
  trs = remdups (eqc _A eq_nata) (flat_map funas_below_rule_list trs);;

let rec fcc_proc (_A1, _A2) (_B1, _B2)
  pa ra f fcs p r =
    let fa = (f, Suc Zero_nat) in
    let cf = More (f, [], Hole, []) in
    let fcsa = cf :: fcs in
    let vs = vars_trs_list (eq_lista eq_char) ra in
    let fs =
      list_union (eqc (eq_laba _A1 _B1) eq_nata)
        (funas_below_trs_list (eq_laba _A1 _B1) pa)
        (funas_trs_list (eq_laba _A1 _B1) ra)
      in
    let fas = fa :: fs in
    let ds = defs_list _A1 (map_trsI remove_lab ra) in
    bind (check (not (member (eqc _A1 eq_nata) ds (remove_lab f, one_nat)))
           (comp (shows_prec _A2 Zero_nat (remove_lab f))
             (comp (shows_string
                     [' '; 'i'; 's'; ' '; 'n'; 'o'; 't'; ' '; 'f'; 'r'; 'e';
                       's'; 'h'])
               shows_nl)))
      (fun _ ->
        bind (check_left_linear_trs (show_lab _A2 _B2) ra)
          (fun _ ->
            bind (check_wf_trs (show_lab _A2 _B2)
                   (eq_lista eq_char, show_list show_char) ra)
              (fun _ ->
                bind (catch
                       (forallm
                         (fun rb ->
                           bind (check_no_var (show_lab _A2 _B2)
                                  (show_list show_char) (fst rb))
                             (fun _ ->
                               bind (check_no_var (show_lab _A2 _B2)
                                      (show_list show_char) (snd rb))
                                 (fun _ ->
                                   check_no_defined_root_defs (_A1, _A2)
                                     (show_list show_char) ds
                                     (map_term remove_lab (snd rb)))))
                         pa)
                       (fun x -> Inl (snd x)))
                  (fun _ ->
                    bind (catch
                           (forallm
                             (check_flat_ctxt
                               (eq_laba _A1 _B1, show_lab _A2 _B2) vs)
                             fcsa)
                           (fun x -> Inl (snd x)))
                      (fun _ ->
                        bind (catch
                               (forallm
                                 (check_is_flat_ctxt
                                   (eq_laba _A1 _B1, show_lab _A2 _B2) vs fas)
                                 fcsa)
                               (fun x -> Inl (snd x)))
                          (fun _ ->
                            bind (catch
                                   (forallm
                                     (check_flat_ctxt_complete
                                       (eq_laba _A1 _B1, show_lab _A2 _B2) fcsa)
                                     fas)
                                   (fun x -> Inl (snd x)))
                              (fun _ ->
                                bind (catch
                                       (forallm
 (check_rule_preserving (eq_laba _A1 _B1, show_lab _A2 _B2) fcsa r) ra)
                                       (fun x -> Inl (snd x)))
                                  (fun _ ->
                                    bind (catch
   (forallm (check_rule_reflecting (eq_laba _A1 _B1, show_lab _A2 _B2) fcsa ra)
     r)
   (fun x -> Inl (snd x)))
                                      (fun _ ->
check_superset_of_blocked (eq_laba _A1 _B1, show_lab _A2 _B2) f p pa)))))))));;

let rec get_arg
  t x1 = match t, x1 with t, Zero_nat -> t
    | t, Suc n -> nth (args t) n;;

let rec ctxt_of_pos_term
  x0 t = match x0, t with Empty, t -> Hole
    | PCons (i, ps), Fun (f, ts) ->
        More (f, take i ts, ctxt_of_pos_term ps (nth ts i), drop (Suc i) ts);;

let rec subst_apply_term
  x0 sigma = match x0, sigma with Var x, sigma -> get_subst sigma x
    | Fun (f, ss), sigma ->
        Fun (f, map (fun t -> subst_apply_term t sigma) ss);;

let rec id_labeling uu cs = Inl cs;;

let rec flat_contexts
  xml2name =
    xml_many_elements
      ['f'; 'l'; 'a'; 't'; 'C'; 'o'; 'n'; 't'; 'e'; 'x'; 't'; 's']
      (ctxt xml2name) id;;

let rec create_proj _A
  (Projection p) f = (match lookup _A f p with None -> Zero_nat | Some n -> n);;

let rec projected_rseq _A
  xml2name pi (Xml (name, atts, cs, text)) =
    let tag =
      ['p'; 'r'; 'o'; 'j'; 'e'; 'c'; 't'; 'e'; 'd'; 'R'; 'e'; 'w'; 'r'; 'i';
        't'; 'e'; 'S'; 'e'; 'q'; 'u'; 'e'; 'n'; 'c'; 'e']
      in
    (if eq_list eq_char name tag &&
          (null atts &&
            (is_none text &&
              eq_nat (size_list cs) (nat (Big_int.big_int_of_int 2))))
      then bind (rule xml2name (nth cs Zero_nat))
             (fun r -> rseq _A xml2name pi r (nth cs one_nat))
      else no_transform tag (Xml (name, atts, cs, text)));;

let rec xml1many2elements_gen
  tag p1 p2 p3 p4 f (Xml (name, atts, cs, text)) =
    let ds = rev cs in
    let l = size_list cs in
    (if eq_list eq_char name tag &&
          (null atts &&
            (is_none text && less_eq_nat (nat (Big_int.big_int_of_int 3)) l))
      then bind (p1 (nth cs Zero_nat))
             (fun x ->
               bind (mapa (p2 x)
                      (tl (take (minus_nat l (nat (Big_int.big_int_of_int 2)))
                            cs)))
                 (fun xs ->
                   bind (p3 (nth ds one_nat))
                     (fun y ->
                       bind (p4 (nth ds Zero_nat))
                         (fun z -> Inr (f x xs y z)))))
      else no_transform tag (Xml (name, atts, cs, text)));;

let rec ordering_constraint_proof
  xml2name =
    xml1element
      ['o'; 'r'; 'd'; 'e'; 'r'; 'i'; 'n'; 'g'; 'C'; 'o'; 'n'; 's'; 't'; 'r';
        'a'; 'i'; 'n'; 't'; 'P'; 'r'; 'o'; 'o'; 'f']
      (redpair xml2name) id;;

let rec xml2dpProof _A
  ld xml2name x =
    xml1element ['d'; 'p'; 'P'; 'r'; 'o'; 'o'; 'f']
      (xml_options
        [(['p'; 'I'; 's'; 'E'; 'm'; 'p'; 't'; 'y'],
           xml0elements ['p'; 'I'; 's'; 'E'; 'm'; 'p'; 't'; 'y'] PisEmpty);
          (['d'; 'e'; 'p'; 'G'; 'r'; 'a'; 'p'; 'h'; 'P'; 'r'; 'o'; 'c'],
            xml_many_elements
              ['d'; 'e'; 'p'; 'G'; 'r'; 'a'; 'p'; 'h'; 'P'; 'r'; 'o'; 'c']
              (xml2nd_choice ['c'; 'o'; 'm'; 'p'; 'o'; 'n'; 'e'; 'n'; 't']
                (xml1element ['d'; 'p'; 's'] (rules (xml2name ld)) id)
                ['r'; 'e'; 'a'; 'l'; 'S'; 'c'; 'c'] (xml2dpProof _A ld xml2name)
                (fun dps prfOpt -> (prfOpt, dps)))
              (fun a -> DepGraphProc a));
          (['r'; 'e'; 'd'; 'P'; 'a'; 'i'; 'r'; 'P'; 'r'; 'o'; 'c'],
            xml3elements ['r'; 'e'; 'd'; 'P'; 'a'; 'i'; 'r'; 'P'; 'r'; 'o'; 'c']
              (ordering_constraint_proof (xml2name ld))
              (xml1element ['d'; 'p'; 's'] (rules (xml2name ld)) id)
              (xml2dpProof _A ld xml2name)
              (fun a b c -> RedPairProc (a, b, c)));
          (['r'; 'e'; 'd'; 'P'; 'a'; 'i'; 'r'; 'U'; 'r'; 'P'; 'r'; 'o'; 'c'],
            xml4elements
              ['r'; 'e'; 'd'; 'P'; 'a'; 'i'; 'r'; 'U'; 'r'; 'P'; 'r'; 'o'; 'c']
              (ordering_constraint_proof (xml2name ld))
              (xml1element ['d'; 'p'; 's'] (rules (xml2name ld)) id)
              (xml1element
                ['u'; 's'; 'a'; 'b'; 'l'; 'e'; 'R'; 'u'; 'l'; 'e'; 's']
                (rules (xml2name ld)) id)
              (xml2dpProof _A ld xml2name)
              (fun a b c d -> RedPairUrProc (a, b, c, d)));
          (['m'; 'o'; 'n'; 'o'; 'R'; 'e'; 'd'; 'P'; 'a'; 'i'; 'r'; 'P'; 'r';
             'o'; 'c'],
            xml4elements
              ['m'; 'o'; 'n'; 'o'; 'R'; 'e'; 'd'; 'P'; 'a'; 'i'; 'r'; 'P'; 'r';
                'o'; 'c']
              (ordering_constraint_proof (xml2name ld))
              (xml1element ['d'; 'p'; 's'] (rules (xml2name ld)) id)
              (xml1element ['t'; 'r'; 's'] (rules (xml2name ld)) id)
              (xml2dpProof _A ld xml2name)
              (fun a b c d -> MonoRedPairProc (a, b, c, d)));
          (['m'; 'o'; 'n'; 'o'; 'R'; 'e'; 'd'; 'P'; 'a'; 'i'; 'r'; 'U'; 'r';
             'P'; 'r'; 'o'; 'c'],
            xml5elements
              ['m'; 'o'; 'n'; 'o'; 'R'; 'e'; 'd'; 'P'; 'a'; 'i'; 'r'; 'U'; 'r';
                'P'; 'r'; 'o'; 'c']
              (ordering_constraint_proof (xml2name ld))
              (xml1element ['d'; 'p'; 's'] (rules (xml2name ld)) id)
              (xml1element ['t'; 'r'; 's'] (rules (xml2name ld)) id)
              (xml1element
                ['u'; 's'; 'a'; 'b'; 'l'; 'e'; 'R'; 'u'; 'l'; 'e'; 's']
                (rules (xml2name ld)) id)
              (xml2dpProof _A ld xml2name)
              (fun a b c d e -> MonoRedPairUrProc (a, b, c, d, e)));
          (['s'; 'e'; 'm'; 'l'; 'a'; 'b'; 'P'; 'r'; 'o'; 'c'],
            xml4elements ['s'; 'e'; 'm'; 'l'; 'a'; 'b'; 'P'; 'r'; 'o'; 'c']
              (sl_inter (xml2name ld))
              (xml1element ['d'; 'p'; 's'] (rules (xml2name (Suc ld))) id)
              (xml1element ['t'; 'r'; 's'] (rules (xml2name (Suc ld))) id)
              (xml2dpProof _A (Suc ld) xml2name)
              (fun a ->
                (match a with None -> (fun aa b c -> RootlabProc (aa, b, c))
                  | Some i ->
                    (fun aa b c -> SemlabProc (i, id_labeling, aa, b, c)))));
          (['u'; 'n'; 'l'; 'a'; 'b'; 'P'; 'r'; 'o'; 'c'],
            xml3elements ['u'; 'n'; 'l'; 'a'; 'b'; 'P'; 'r'; 'o'; 'c']
              (xml1element ['d'; 'p'; 's']
                (rules (xml2name (minus_nat ld one_nat))) id)
              (xml1element ['t'; 'r'; 's']
                (rules (xml2name (minus_nat ld one_nat))) id)
              (xml2dpProof _A (minus_nat ld one_nat) xml2name)
              (fun a b c -> UnlabProc (a, b, c)));
          (['s'; 'u'; 'b'; 't'; 'e'; 'r'; 'm'; 'P'; 'r'; 'o'; 'c'],
            xml1many2elements_gen
              ['s'; 'u'; 'b'; 't'; 'e'; 'r'; 'm'; 'P'; 'r'; 'o'; 'c']
              (proj (xml2name ld))
              (fun pi ->
                projected_rseq (eq_laba _A (eq_lista eq_nata)) (xml2name ld)
                  (create_proj (eq_laba _A (eq_lista eq_nata)) pi))
              (xml1element ['d'; 'p'; 's'] (rules (xml2name ld)) id)
              (xml2dpProof _A ld xml2name)
              (fun a b c d -> SubtermCriterionProc (a, b, c, d)));
          (['f'; 'l'; 'a'; 't'; 'C'; 'o'; 'n'; 't'; 'e'; 'x'; 't'; 'C'; 'l';
             'o'; 's'; 'u'; 'r'; 'e'; 'P'; 'r'; 'o'; 'c'],
            xml5elements
              ['f'; 'l'; 'a'; 't'; 'C'; 'o'; 'n'; 't'; 'e'; 'x'; 't'; 'C'; 'l';
                'o'; 's'; 'u'; 'r'; 'e'; 'P'; 'r'; 'o'; 'c']
              (xml1element
                ['f'; 'r'; 'e'; 's'; 'h'; 'S'; 'y'; 'm'; 'b'; 'o'; 'l']
                (xml2name ld) id)
              (flat_contexts (xml2name ld))
              (xml1element ['d'; 'p'; 's'] (rules (xml2name ld)) id)
              (xml1element ['t'; 'r'; 's'] (rules (xml2name ld)) id)
              (xml2dpProof _A ld xml2name)
              (fun a b c d e -> FccProc (a, b, c, d, e)));
          (['s'; 'i'; 'z'; 'e'; 'C'; 'h'; 'a'; 'n'; 'g'; 'e'; 'P'; 'r'; 'o';
             'c'],
            xml1many_elements
              ['s'; 'i'; 'z'; 'e'; 'C'; 'h'; 'a'; 'n'; 'g'; 'e'; 'P'; 'r'; 'o';
                'c']
              (xml_options
                [(['s'; 'u'; 'b'; 't'; 'e'; 'r'; 'm'; 'C'; 'r'; 'i'; 't'; 'e';
                    'r'; 'i'; 'o'; 'n'],
                   xml0elements
                     ['s'; 'u'; 'b'; 't'; 'e'; 'r'; 'm'; 'C'; 'r'; 'i'; 't';
                       'e'; 'r'; 'i'; 'o'; 'n']
                     None);
                  (['r'; 'e'; 'd'; 'u'; 'c'; 't'; 'i'; 'o'; 'n'; 'P'; 'a'; 'i';
                     'r'],
                    xml2elements
                      ['r'; 'e'; 'd'; 'u'; 'c'; 't'; 'i'; 'o'; 'n'; 'P'; 'a';
                        'i'; 'r']
                      (ordering_constraint_proof (xml2name ld))
                      (xml1element
                        ['u'; 's'; 'a'; 'b'; 'l'; 'e'; 'R'; 'u'; 'l'; 'e'; 's']
                        (rules (xml2name ld)) id)
                      (fun redp ur -> Some (redp, ur)))])
              (scg (xml2name ld))
              (fun a ->
                (match a with None -> (fun aa -> SizeChangeSubTerm aa)
                  | Some redp_ur ->
                    (fun aa ->
                      SizeChangeRedPair (fst redp_ur, snd redp_ur, aa)))))])
      id x;;

let rec shows_monom _A
  = function
    [(x, p)] ->
      (if eq_nat p one_nat then shows_prec _A Zero_nat x
        else comp (shows_prec _A Zero_nat x)
               (comp (shows_string ['^']) (shows_prec_nat Zero_nat p)))
    | (x, p) :: v :: va ->
        comp (if eq_nat p one_nat then shows_prec _A Zero_nat x
               else comp (shows_prec _A Zero_nat x)
                      (comp (shows_string ['^']) (shows_prec_nat Zero_nat p)))
          (comp (shows_string ['*']) (shows_monom _A (v :: va)))
    | [] -> shows_string ['1'];;

let rec shows_poly _A (_B1, _B2, _B3)
  = function [] -> shows_string ['0']
    | (m, c) :: p ->
        comp (if eqa _B1 c
                   (one _B2.ordered_semiring_1_poly_carrier.semiring_1_ordered_semiring_1.monoid_mult_semiring_1.power_monoid_mult.one_power)
               then shows_monom _A m
               else (if null m then shows_prec _B3 Zero_nat c
                      else comp (shows_prec _B3 Zero_nat c)
                             (comp (shows_string ['*']) (shows_monom _A m))))
          (if null p then shows_string []
            else comp (shows_string [' '; '+'; ' '])
                   (shows_poly _A (_B1, _B2, _B3) p));;

let rec eval_monom _B
  alpha x1 = match alpha, x1 with
    alpha, [] ->
      one _B.semiring_1_comm_semiring_1.monoid_mult_semiring_1.power_monoid_mult.one_power
    | alpha, (x, p) :: m ->
        times _B.semiring_1_comm_semiring_1.monoid_mult_semiring_1.power_monoid_mult.times_power
          (eval_monom _B alpha m)
          (power
            _B.semiring_1_comm_semiring_1.monoid_mult_semiring_1.power_monoid_mult
            (alpha x) p);;

let rec eval_poly _B
  alpha x1 = match alpha, x1 with
    alpha, [] ->
      zero _B.semiring_1_comm_semiring_1.zero_neq_one_semiring_1.zero_zero_neq_one
    | alpha, mc :: p ->
        plus _B.comm_semiring_0_comm_semiring_1.semiring_0_comm_semiring_0.comm_monoid_add_semiring_0.monoid_add_comm_monoid_add.semigroup_add_monoid_add.plus_semigroup_add
          (times
            _B.semiring_1_comm_semiring_1.monoid_mult_semiring_1.power_monoid_mult.times_power
            (eval_monom _B alpha (fst mc)) (snd mc))
          (eval_poly _B alpha p);;

let rec shows_arctic
  = function Num_arc i -> shows_prec_int Zero_nat i
    | MinInfty -> shows_string ['-'; 'i'; 'n'; 'f'];;

let rec shows_prec_arctic d ai = shows_arctic ai;;

let rec shows_list_arctic
  asa = shows_list_aux (shows_prec_arctic Zero_nat) asa;;

let show_arctic =
  ({shows_prec = shows_prec_arctic; shows_list = shows_list_arctic} :
    arctic show);;

let rec lookup_rest _A
  x xa1 = match x, xa1 with x, [] -> None
    | x, (y, c) :: ycs ->
        (if eqa _A x y then Some (c, ycs)
          else (match lookup_rest _A x ycs with None -> None
                 | Some (d, yccs) -> Some (d, (y, c) :: yccs)));;

let rec shows_lpoly (_A1, _A2) _B
  ze on (LPoly (c, cs)) =
    (match show_pvars (_A1, _A2) _B on cs with [] -> shows_prec _A2 Zero_nat c
      | a :: lista ->
        comp (if eqa _A1 c ze then id
               else comp (shows_prec _A2 Zero_nat c)
                      (shows_string [' '; '+'; ' ']))
          (shows_list_gen (shows_prec_list show_char Zero_nat) [] []
            [' '; '+'; ' '] [] (a :: lista)));;

let rec lpo_nstrict_unbounded (_A1, _A2) (_B1, _B2)
  pr = (fun (s, t) ->
         check (snd (lpo_unbounded _A1 _B1 pr s t))
           (comp (shows_string
                   ['c'; 'o'; 'u'; 'l'; 'd'; ' '; 'n'; 'o'; 't'; ' '; 'o'; 'r';
                     'i'; 'e'; 'n'; 't'; ' '])
             (comp (shows_prec_term _A2 _B2 Zero_nat s)
               (comp (shows_string [' '; '>'; '='; 'L'; 'P'; 'O'; ' '])
                 (comp (shows_prec_term _A2 _B2 Zero_nat t) shows_nl)))));;

let rec lpo_strict_unbounded (_A1, _A2) (_B1, _B2)
  pr = (fun (s, t) ->
         check (fst (lpo_unbounded _A1 _B1 pr s t))
           (comp (shows_string
                   ['c'; 'o'; 'u'; 'l'; 'd'; ' '; 'n'; 'o'; 't'; ' '; 'o'; 'r';
                     'i'; 'e'; 'n'; 't'; ' '])
             (comp (shows_prec_term _A2 _B2 Zero_nat s)
               (comp (shows_string [' '; '>'; 'L'; 'P'; 'O'; ' '])
                 (comp (shows_prec_term _A2 _B2 Zero_nat t) shows_nl)))));;

let rec create_LPO_redpair _A (_B1, _B2) (_C1, _C2)
  lpo_repr_to_pr pr =
    let p = lpo_repr_to_pr pr in
    (Inr (),
      (lpo_strict_unbounded (_B1, _B2) (_C1, _C2) p,
        (lpo_nstrict_unbounded (_B1, _B2) (_C1, _C2) p,
          (full_af, (Inr (), shows_lpo_repr _A pr)))));;

let rec check_sem_lab_rel_tt _A _B _C
  check_lab check_model_lab gr i l rs lRS =
    catch (bind (check_model_lab (fst lRS) (fst rs))
            (fun _ -> check_model_lab (snd lRS) (snd rs)))
      (fun x ->
        Inl (comp (shows_string
                    ['p'; 'r'; 'o'; 'b'; 'l'; 'e'; 'm'; ' '; 'w'; 'i'; 't'; 'h';
                      ' '; 'l'; 'a'; 'b'; 'e'; 'l'; 'e'; 'd'; ' '; 'T'; 'R';
                      'S'; ':'])
              (comp shows_nl x)));;

let rec rl_rel_tt (_A1, _A2) (_B1, _B2)
  rs lRS =
    let fs = funs_trs_list (eq_laba _A1 _B1) (append (fst rs) (snd rs)) in
    bind (check (not (null fs))
           (comp (shows_string
                   ['r'; 'o'; 'o'; 't'; '-'; 'l'; 'a'; 'b'; 'e'; 'l'; 'i'; 'n';
                     'g'; ' '; 'r'; 'e'; 'q'; 'u'; 'i'; 'r'; 'e'; 's'; ' '; 'a';
                     't'; ' '; 'l'; 'e'; 'a'; 's'; 't'; ' '; 'o'; 'n'; 'e'; ' ';
                     'f'; 'u'; 'n'; 'c'; 't'; 'i'; 'o'; 'n'; ' '; 's'; 'y'; 'm';
                     'b'; 'o'; 'l'; ' '; 'i'; 'n'; ' '; 't'; 'h'; 'e'; ' '; 's';
                     'i'; 'g'; 'n'; 'a'; 't'; 'u'; 'r'; 'e'])
             shows_nl))
      (fun _ ->
        let d = hd fs in
        check_sem_lab_rel_tt _A2 _B2 (show_list show_char)
          (check_sl_lab_trs (_A1, _A2) (_B1, _B2)
            (eq_laba _A1 _B1, show_lab _A2 _B2)
            (eq_lista eq_char, show_list show_char)
            (rl_inter_list (eq_laba _A1 _B1) fs d) rl_fun fs)
          (check_sl_model_lab_trs (_A1, _A2) (_B1, _B2)
            (eq_laba _A1 _B1, show_lab _A2 _B2)
            (eq_lista eq_char, show_list show_char)
            (rl_inter_list (eq_laba _A1 _B1) fs d) rl_fun fs)
          (bot_fun bot_boola) (rl_inter_list (eq_laba _A1 _B1) fs d) rl_fun rs
          lRS);;

let rec matchList _A
  = function [] -> Some []
    | (Var uu, Fun (uv, uw)) :: ps -> None
    | (Fun (f, ts), Fun (g, ls)) :: ps ->
        (if eqa _A f g
          then (match decomp ts ls with None -> None
                 | Some pairs -> matchList _A (append pairs ps))
          else None)
    | (t, Var x) :: ps ->
        (match matchList _A ps with None -> None
          | Some pairs -> Some ((x, t) :: pairs));;

let rec matchVars _A _B
  = function [] -> Some subst_empty
    | (x, t) :: ps ->
        (match lookup _A x ps
          with None ->
            (match matchVars _A _B ps with None -> None
              | Some sigma -> Some (Subst (fun_upd _A (get_subst sigma) x t)))
          | Some s ->
            (if eq_term _B _A t s then matchVars _A _B ps else None));;

let rec apply_af_entry
  uu x1 ts = match uu, x1, ts with uu, Collapse i, ts -> nth ts i
    | f, AFList is, ts -> Fun (f, map (nth ts) is);;

let rec afs_term
  pi x1 = match pi, x1 with
    pi, Fun (f, ts) ->
      let l = size_list ts in
      apply_af_entry (FPair (f, l)) (pi f l) (map (afs_term pi) ts)
    | pi, Var x -> Var x;;

let rec xml2trsInput
  xml2name =
    xml1element ['i'; 'n'; 'p'; 'u'; 't']
      (xml1to2elements ['t'; 'r'; 's'; 'I'; 'n'; 'p'; 'u'; 't']
        (xml1element ['t'; 'r'; 's'] (rules xml2name) id)
        (xml1element
          ['r'; 'e'; 'l'; 'a'; 't'; 'i'; 'v'; 'e'; 'R'; 'u'; 'l'; 'e'; 's']
          (rules xml2name) id)
        (fun a b -> (a, b)))
      id;;

let rec xml2trsProof _A
  xml2name xml2sname xml2lsname x =
    xml1element
      ['t'; 'r'; 's'; 'T'; 'e'; 'r'; 'm'; 'i'; 'n'; 'a'; 't'; 'i'; 'o'; 'n';
        'P'; 'r'; 'o'; 'o'; 'f']
      (xml_options
        [(['r'; 'I'; 's'; 'E'; 'm'; 'p'; 't'; 'y'],
           xml0elements ['r'; 'I'; 's'; 'E'; 'm'; 'p'; 't'; 'y'] RisEmpty);
          (['d'; 'p'; 'T'; 'r'; 'a'; 'n'; 's'],
            xml3elements ['d'; 'p'; 'T'; 'r'; 'a'; 'n'; 's']
              (xml1element ['d'; 'p'; 's'] (rules xml2sname) id)
              (boola
                ['m'; 'a'; 'r'; 'k'; 'e'; 'd'; 'S'; 'y'; 'm'; 'b'; 'o'; 'l';
                  's'])
              (xml2dpProof (eq_shpa (eq_laba _A (eq_lista eq_nata))) Zero_nat
                xml2lsname)
              (fun dps _ -> (fun a -> DPTrans (dps, a))));
          (['r'; 'u'; 'l'; 'e'; 'R'; 'e'; 'm'; 'o'; 'v'; 'a'; 'l'],
            xml3elements ['r'; 'u'; 'l'; 'e'; 'R'; 'e'; 'm'; 'o'; 'v'; 'a'; 'l']
              (ordering_constraint_proof xml2name)
              (xml1element ['t'; 'r'; 's'] (rules xml2name) id)
              (xml2trsProof _A xml2name xml2sname xml2lsname)
              (fun a b c -> RuleRemoval (a, b, c)));
          (['u'; 'n'; 'l'; 'a'; 'b'],
            xml2elements ['u'; 'n'; 'l'; 'a'; 'b']
              (xml1element ['t'; 'r'; 's'] (rules xml2name) id)
              (xml2trsProof _A xml2name xml2sname xml2lsname)
              (fun a b -> Unlab (a, b)));
          (['s'; 't'; 'r'; 'i'; 'n'; 'g'; 'R'; 'e'; 'v'; 'e'; 'r'; 's'; 'a';
             'l'],
            xml2elements
              ['s'; 't'; 'r'; 'i'; 'n'; 'g'; 'R'; 'e'; 'v'; 'e'; 'r'; 's'; 'a';
                'l']
              (xml1element ['t'; 'r'; 's'] (rules xml2name) id)
              (xml2trsProof _A xml2name xml2sname xml2lsname)
              (fun a b -> StringReversal (a, b)));
          (['s'; 'e'; 'm'; 'l'; 'a'; 'b'],
            xml3elements ['s'; 'e'; 'm'; 'l'; 'a'; 'b'] (sl_inter xml2name)
              (xml1element ['t'; 'r'; 's'] (rules xml2name) id)
              (xml2trsProof _A xml2name xml2sname xml2lsname)
              (fun a ->
                (match a with None -> (fun aa b -> Rootlab (aa, b))
                  | Some i -> (fun aa b -> Semlab (i, id_labeling, aa, b)))));
          (['f'; 'l'; 'a'; 't'; 'C'; 'o'; 'n'; 't'; 'e'; 'x'; 't'; 'C'; 'l';
             'o'; 's'; 'u'; 'r'; 'e'],
            xml3elements
              ['f'; 'l'; 'a'; 't'; 'C'; 'o'; 'n'; 't'; 'e'; 'x'; 't'; 'C'; 'l';
                'o'; 's'; 'u'; 'r'; 'e']
              (flat_contexts xml2name)
              (xml1element ['t'; 'r'; 's'] (rules xml2name) id)
              (xml2trsProof _A xml2name xml2sname xml2lsname)
              (fun a b c -> Fcc (a, b, c)))])
      id x;;

let rec search_len
  t s n =
    (if eq_list eq_char (take n t) s then Some ([], drop n t)
      else (match t with [] -> None
             | h :: tt ->
               (match search_len tt s n with None -> None
                 | Some (bef, aft) -> Some (h :: bef, aft))));;

let rec reverse_trs r = map (fun lr -> (snd lr, fst lr)) r;;

let rec poly_split _A _B
  m p = (match extract (fun (n, _) -> eq_monom _A m n) p
          with None -> (zero _B, p)
          | Some (p1, ((_, c), p2)) -> (c, append p1 p2));;

let rec fresh_strings_list
  name offset used n =
    take n
      (filter
        (fun s ->
          not (member (eq_lista eq_char) (remdups (eq_lista eq_char) used) s))
        (map (fun i ->
               append name (shows_prec_nat Zero_nat (plus_nat i offset) []))
          (upt Zero_nat
            (plus_nat n (length_unique (eq_lista eq_char) used)))));;

let rec subst_of _A
  xts = Subst (fun x ->
                (match lookup _A x xts with None -> Var x | Some t -> t));;

let rec check_pvarsI _B
  ze ge vas x3 = match ze, ge, vas, x3 with
    ze, ge, vas, [] ->
      catch (forallm (fun va -> check (ge (snd va) ze) (fst va)) vas)
        (fun x -> Inl (snd x))
    | ze, ge, vas, (x, b) :: vbs ->
        let (a, vasa) =
          (match lookup_rest _B x vas with None -> (ze, vas)
            | Some (a, ba) -> (a, ba))
          in
        bind (check (ge a b) x) (fun _ -> check_pvarsI _B ze ge vasa vbs);;

let rec check_lpoly_sI (_A1, _A2) (_B1, _B2)
  mode ze on ge gt (LPoly (a, vas)) (LPoly (b, vbs)) =
    catch (bind (check (gt a b)
                  (shows_string
                    ['p'; 'r'; 'o'; 'b'; 'l'; 'e'; 'm'; ' '; 'w'; 'h'; 'e'; 'n';
                      ' '; 'c'; 'o'; 'm'; 'p'; 'a'; 'r'; 'i'; 'n'; 'g'; ' ';
                      'c'; 'o'; 'n'; 's'; 't'; 'a'; 'n'; 't'; ' '; 'p'; 'a';
                      'r'; 't']))
            (fun _ ->
              catch (check_pvarsI _B1 ze (if mode then ge else gt) vas vbs)
                (fun x ->
                  Inl (comp (shows_string
                              ['p'; 'r'; 'o'; 'b'; 'l'; 'e'; 'm'; ' '; 'w'; 'h';
                                'e'; 'n'; ' '; 'c'; 'o'; 'm'; 'p'; 'a'; 'r';
                                'i'; 'n'; 'g'; ' '; 'c'; 'o'; 'e'; 'f'; 'f';
                                'i'; 'c'; 'i'; 'e'; 'n'; 't'; 's'; ' '; 'o';
                                'f'; ' '; 'v'; 'a'; 'r'; 'i'; 'a'; 'b'; 'l';
                                'e'; ' '])
                        (shows_prec _B2 Zero_nat x)))))
      (fun x ->
        Inl (comp (shows_string
                    ['p'; 'r'; 'o'; 'b'; 'l'; 'e'; 'm'; ' '; 'w'; 'h'; 'e'; 'n';
                      ' '; 'c'; 'o'; 'm'; 'p'; 'a'; 'r'; 'i'; 'n'; 'g'; ' '])
              (comp (shows_lpoly (_A1, _A2) _B2 ze on (LPoly (a, vas)))
                (comp (shows_string [' '; '>'; ' '])
                  (comp (shows_lpoly (_A1, _A2) _B2 ze on (LPoly (b, vbs)))
                    (comp shows_nl x))))));;

let rec check_polo_sI (_A1, _A2) _B (_C1, _C2)
  mode ze on pl ti mz ge gt pi (s, t) =
    let left = pleftI _A1 _C1 ze on pl ti mz pi s in
    let right = prightI _A1 _C1 ze on pl ti mz pi t in
    catch (check_lpoly_sI (_A1, _A2) (_C1, _C2) mode ze on ge gt left right)
      (fun x ->
        Inl (comp (shows_string
                    ['c'; 'o'; 'u'; 'l'; 'd'; ' '; 'n'; 'o'; 't'; ' '; 'e'; 'n';
                      's'; 'u'; 'r'; 'e'; ' '])
              (comp (shows_prec_term _B _C2 Zero_nat s)
                (comp (shows_string [' '; '>'; ' '])
                  (comp (shows_prec_term _B _C2 Zero_nat t)
                    (comp shows_nl x))))));;

let rec get_comp_max0
  (wfe, (ze, (on, (def, (pl, (ti, (mz, (ge, (gt, (mo, (de, (ap, cm)))))))))))) =
    mz;;

let rec lpo_repr_to_pr _A
  prs (FPair (f, a)) uu =
    (match lookup (eqc _A eq_nata) (f, a) prs with None -> Zero_nat
      | Some x -> x);;

let rec filtered_fun (FPair (f, n)) = f;;

let rec shows_prec_filtered _A d ff = shows_prec _A Zero_nat (filtered_fun ff);;

let rec shows_list_filtered _A
  ffs = shows_list_aux (shows_prec_filtered _A Zero_nat) ffs;;

let rec show_filtered _A =
  ({shows_prec = shows_prec_filtered _A; shows_list = shows_list_filtered _A} :
    'a filtered show);;

let rec eq_filtered _A
  (FPair (fa, nata)) (FPair (f, nat)) = eqa _A fa f && eq_nat nata nat;;

let rec eq_filtereda _A = ({eq = eq_filtered _A} : 'a filtered eq);;

let rec shows_afs _A
  af = shows_map
         (fun (a, b) ->
           let (f, n) = a in
           (fun e ->
             comp (shows_string ['p'; 'i'; '('])
               (comp (shows_prec _A Zero_nat f)
                 (comp (shows_string ['/'])
                   (comp (shows_prec_nat Zero_nat n)
                     (comp (shows_string [')'; ' '; '='; ' '])
                       (comp (match e
                               with Collapse i ->
                                 shows_prec_nat Zero_nat (Suc i)
                               | AFList ids ->
                                 shows_prec_list show_nat Zero_nat
                                   (map (fun aa -> Suc aa) ids))
                         shows_nl))))))
             b)
         af;;

let rec check_mono_afs_help _A
  ((f, a), e) =
    comp (shows_string ['e'; 'n'; 't'; 'r'; 'y'; ' '; 'f'; 'o'; 'r'; ' '])
      (comp (shows_prec _A Zero_nat f)
        (comp (shows_string
                [' '; 'n'; 'o'; 't'; ' '; 'm'; 'o'; 'n'; 'o'; 't'; 'o'; 'n';
                  'i'; 'c'])
          shows_nl));;

let rec mono_af_entry
  n x1 = match n, x1 with n, Collapse i -> less_eq_nat n one_nat
    | n, AFList ids -> all_from_to_nat (member eq_nata ids) Zero_nat n;;

let rec check_mono_afs _A
  pi = catch (catch
               (forallm
                 (fun x ->
                   (if mono_af_entry (snd (fst x)) (snd x) then Inr ()
                     else Inl x))
                 pi)
               (fun x -> Inl (snd x)))
         (fun x -> Inl (check_mono_afs_help _A x));;

let rec rp_non_strict (v, (s, (n, (a, (m, d))))) = n;;

let rec afs_check _A _B
  rel pi g lr =
    let pl = afs_term pi (fst lr) in
    let pr = afs_term pi (snd lr) in
    catch (g (pl, pr))
      (fun x ->
        Inl (comp (shows_string
                    ['c'; 'o'; 'u'; 'l'; 'd'; ' '; 'n'; 'o'; 't'; ' '; 'o'; 'r';
                      'i'; 'e'; 'n'; 't'; ' '])
              (comp (shows_prec_term _A _B Zero_nat (fst lr))
                (comp (shows_string [' '])
                  (comp rel
                    (comp (shows_string [' '])
                      (comp (shows_prec_term _A _B Zero_nat (snd lr))
                        (comp shows_nl
                          (comp (shows_string ['p'; 'i'; '('; ' '])
                            (comp (shows_prec_term _A _B Zero_nat (fst lr))
                              (comp (shows_string [' '; ')'; ' '; '='; ' '])
                                (comp (shows_prec_term (show_filtered _A) _B
Zero_nat pl)
                                  (comp shows_nl
                                    (comp (shows_string ['p'; 'i'; '('; ' '])
                                      (comp
(shows_prec_term _A _B Zero_nat (snd lr))
(comp (shows_string [' '; ')'; ' '; '='; ' '])
  (comp (shows_prec_term (show_filtered _A) _B Zero_nat pr)
    (comp shows_nl x))))))))))))))))));;

let rec check_wf_afs _A
  pi = catch (forallm
               (fun (a, b) ->
                 let (f, n) = a in
                 (fun e ->
                   catch (match e with Collapse i -> check (less_nat i n) i
                           | AFList ids ->
                             catch (forallm
                                     (fun x ->
                                       (if less_nat x n then Inr () else Inl x))
                                     ids)
                               (fun x -> Inl (snd x)))
                     (fun x ->
                       Inl (comp (shows_string ['i'; 'n'; 'd'; 'e'; 'x'; ' '])
                             (comp (shows_prec_nat Zero_nat x)
                               (comp (shows_string
                                       [' '; 't'; 'o'; 'o'; ' '; 'h'; 'i'; 'g';
 'h'; ' '; 'f'; 'o'; 'r'; ' '; 'A'; 'F'; '-'; 'e'; 'n'; 't'; 'r'; 'y'; ' '; 'o';
 'f'])
                                 (comp (shows_preca _A show_nat Zero_nat (f, n))
                                   shows_nl))))))
                   b)
               pi)
         (fun x -> Inl (snd x));;

let rec default_af_entry n = AFList (upt Zero_nat n);;

let rec afs_list_to_afs _A
  pi f n =
    (match lookup (eqc _A eq_nata) (f, n) pi with None -> default_af_entry n
      | Some entry -> entry);;

let rec afs_list_to_af _A
  pi f n =
    (fun i ->
      (match lookup (eqc _A eq_nata) (f, n) pi with None -> true
        | Some (Collapse a) -> eq_nat i a
        | Some (AFList ids) -> member eq_nata ids i));;

let rec af_redpair (_A1, _A2) _B
  pi rp =
    let af = afs_list_to_af _A1 pi in
    let afs = afs_list_to_afs _A1 pi in
    (bind (check_wf_afs _A2 pi) (fun _ -> rp_valid rp),
      (afs_check _A2 _B (shows_string ['>']) afs (rp_strict rp),
        (afs_check _A2 _B (shows_string ['>'; '=']) afs (rp_non_strict rp),
          (af, (bind (check_mono_afs _A2 pi) (fun _ -> rp_mono rp),
                 comp (shows_string
                        ['A'; 'r'; 'g'; 'u'; 'm'; 'e'; 'n'; 't'; ' '; 'F'; 'i';
                          'l'; 't'; 'e'; 'r'; ':'; ' '])
                   (comp shows_nl
                     (comp (shows_afs _A2 pi)
                       (comp shows_nl (rp_desc rp)))))))));;

let rec shows_arctic_rat
  = function Num_arc_rat i -> shows_prec_rat Zero_nat i
    | MinInfty_rat -> shows_string ['-'; 'i'; 'n'; 'f'];;

let rec shows_prec_arctic_rat d ari = shows_arctic_rat ari;;

let rec shows_list_arctic_rat
  asa = shows_list_aux (shows_prec_arctic_rat Zero_nat) asa;;

let show_arctic_rat =
  ({shows_prec = shows_prec_arctic_rat; shows_list = shows_list_arctic_rat} :
    arctic_rat show);;

let rec faulty_redpair_impl _A _B
  s = (Inl (shows_string s),
        ((fun _ -> Inr ()), ((fun _ -> Inr ()), (full_af, (Inr (), id)))));;

let ordered_semiring_0_rat =
  ({semiring_0_ordered_semiring_0 = semiring_0_rat;
     ordered_ab_semigroup_ordered_semiring_0 = ordered_ab_semigroup_rat}
    : rat ordered_semiring_0);;

let ordered_semiring_1_rat =
  ({semiring_1_ordered_semiring_1 = semiring_1_rat;
     ordered_semiring_0_ordered_semiring_1 = ordered_semiring_0_rat}
    : rat ordered_semiring_1);;

let poly_carrier_rat =
  ({comm_semiring_1_poly_carrier = comm_semiring_1_rat;
     ordered_semiring_1_poly_carrier = ordered_semiring_1_rat}
    : rat poly_carrier);;

let ordered_semiring_0_int =
  ({semiring_0_ordered_semiring_0 = semiring_0_int;
     ordered_ab_semigroup_ordered_semiring_0 = ordered_ab_semigroup_int}
    : Big_int.big_int ordered_semiring_0);;

let ordered_semiring_1_int =
  ({semiring_1_ordered_semiring_1 = semiring_1_int;
     ordered_semiring_0_ordered_semiring_1 = ordered_semiring_0_int}
    : Big_int.big_int ordered_semiring_1);;

let poly_carrier_int =
  ({comm_semiring_1_poly_carrier = comm_semiring_1_int;
     ordered_semiring_1_poly_carrier = ordered_semiring_1_int}
    : Big_int.big_int poly_carrier);;

let rec check_monom_strict_mono _A
  pm m v =
    not (null m) &&
      (null (tl m) &&
        (eqa _A (fst (hd m)) v &&
          (if pm then less_eq_nat one_nat (snd (hd m))
            else eq_nat (snd (hd m)) one_nat)));;

let rec check_poly_strict_mono _A _B
  pm p v =
    list_ex
      (fun (m, c) ->
        ge _B.ordered_semiring_1_poly_carrier.ordered_semiring_0_ordered_semiring_1.ordered_ab_semigroup_ordered_semiring_0.non_strict_order_ordered_ab_semigroup
          c (one _B.ordered_semiring_1_poly_carrier.semiring_1_ordered_semiring_1.monoid_mult_semiring_1.power_monoid_mult.one_power) &&
          check_monom_strict_mono _A pm m v)
      p;;

let rec check_poly_ge _A _B
  x0 q = match x0, q with
    [], q ->
      list_all
        (fun (_, a) ->
          ge _B.ordered_ab_semigroup_ordered_semiring_0.non_strict_order_ordered_ab_semigroup
            (zero _B.semiring_0_ordered_semiring_0.mult_zero_semiring_0.zero_mult_zero)
            a)
        q
    | (m, c) :: p, q ->
        (match extract (fun nd -> eq_monom _A (fst nd) m) q
          with None ->
            ge _B.ordered_ab_semigroup_ordered_semiring_0.non_strict_order_ordered_ab_semigroup
              c (zero _B.semiring_0_ordered_semiring_0.mult_zero_semiring_0.zero_mult_zero) &&
              check_poly_ge _A _B p q
          | Some (q1, ((_, d), q2)) ->
            ge _B.ordered_ab_semigroup_ordered_semiring_0.non_strict_order_ordered_ab_semigroup
              c d &&
              check_poly_ge _A _B p (append q1 q2));;

let rec check_poly_gt _A _B
  gt p q =
    let (a1, p1) =
      poly_split _B
        _A.semiring_0_ordered_semiring_0.mult_zero_semiring_0.zero_mult_zero []
        p
      in
    let (b1, q1) =
      poly_split _B
        _A.semiring_0_ordered_semiring_0.mult_zero_semiring_0.zero_mult_zero []
        q
      in
    gt a1 b1 && check_poly_ge _B _A p1 q1;;

let rec check_poly_strict_mono_discrete (_A1, _A2) _B
  gt p v =
    check_poly_gt
      _A2.ordered_semiring_1_poly_carrier.ordered_semiring_0_ordered_semiring_1
      _B gt
      (poly_subst _B (_A1, _A2.comm_semiring_1_poly_carrier)
        (fun w ->
          poly_of _B (_A1, _A2.comm_semiring_1_poly_carrier)
            (if eqa _B w v
              then PSum [PNum (one _A2.ordered_semiring_1_poly_carrier.semiring_1_ordered_semiring_1.monoid_mult_semiring_1.power_monoid_mult.one_power);
                          PVar v]
              else PVar w))
        p)
      p;;

let rec check_poly_strict_mono_smart (_A1, _A2) _B
  discrete pm gt p v =
    (if discrete then check_poly_strict_mono_discrete (_A1, _A2) _B gt p v
      else check_poly_strict_mono _B _A2 pm p v);;

let rec poly_inter_to_af i f n = poly_var eq_nata (i f n);;

let rec check_poly_weak_mono_all _B
  p = list_all
        (fun (_, c) ->
          ge _B.ordered_ab_semigroup_ordered_semiring_0.non_strict_order_ordered_ab_semigroup
            c (zero _B.semiring_0_ordered_semiring_0.mult_zero_semiring_0.zero_mult_zero))
        p;;

let rec poly_vars_list _A p = remdups _A (concat_map (comp (map fst) fst) p);;

let rec check_poly_weak_mono_discrete _A (_B1, _B2)
  p v = check_poly_ge _A
          _B2.ordered_semiring_1_poly_carrier.ordered_semiring_0_ordered_semiring_1
          (poly_subst _A (_B1, _B2.comm_semiring_1_poly_carrier)
            (fun w ->
              poly_of _A (_B1, _B2.comm_semiring_1_poly_carrier)
                (if eqa _A w v
                  then PSum [PNum (one _B2.ordered_semiring_1_poly_carrier.semiring_1_ordered_semiring_1.monoid_mult_semiring_1.power_monoid_mult.one_power);
                              PVar v]
                  else PVar w))
            p)
          p;;

let rec check_poly_weak_mono_and_pos _A (_B1, _B2)
  discrete p =
    (if discrete
      then list_all (check_poly_weak_mono_discrete _A (_B1, _B2) p)
             (poly_vars_list _A p) &&
             ge _B2.ordered_semiring_1_poly_carrier.ordered_semiring_0_ordered_semiring_1.ordered_ab_semigroup_ordered_semiring_0.non_strict_order_ordered_ab_semigroup
               (eval_poly _B2.comm_semiring_1_poly_carrier
                 (fun _ ->
                   zero _B2.ordered_semiring_1_poly_carrier.semiring_1_ordered_semiring_1.zero_neq_one_semiring_1.zero_zero_neq_one)
                 p)
               (zero _B2.ordered_semiring_1_poly_carrier.semiring_1_ordered_semiring_1.zero_neq_one_semiring_1.zero_zero_neq_one)
      else check_poly_weak_mono_all
             _B2.ordered_semiring_1_poly_carrier.ordered_semiring_0_ordered_semiring_1
             p);;

let rec check_poly_inter_list (_B1, _B2)
  discrete i =
    catch (catch
            (forallm
              (fun x ->
                (if let (_, a) = x in
                    check_poly_weak_mono_and_pos eq_nata (_B1, _B2) discrete a
                  then Inr () else Inl x))
              i)
            (fun x -> Inl (snd x)))
      (fun x ->
        Inl (let (a, b) = x in
             let (f, _) = a in
             (fun aa -> (f, aa))
               b));;

let rec poly_inter_list_to_inter _A _B
  def i =
    (fun f n ->
      (match lookup (eqc _B eq_nata) (f, n) i with None -> default_I _A def n
        | Some p -> p));;

let rec create_nlpoly_redpair (_A1, _A2, _A3) (_B1, _B2) (_C1, _C2)
  def gt power_mono discrete i =
    let j = poly_inter_list_to_inter _A2 _B1 def i in
    let x =
      poly_subst (eq_lista eq_char) (_A1, _A2.comm_semiring_1_poly_carrier)
        (fun n ->
          poly_of (eq_lista eq_char) (_A1, _A2.comm_semiring_1_poly_carrier)
            (PVar (append ['x'; '_'] (shows_prec_nat Zero_nat n []))))
      in
    (catch (check_poly_inter_list (_A1, _A2) discrete i)
       (fun xa ->
         Inl (let (f, p) = xa in
              comp (shows_string
                     ['i'; 'n'; 't'; 'e'; 'r'; 'p'; 'r'; 'e'; 't'; 'a'; 't';
                       'i'; 'o'; 'n'; ' '])
                (comp (shows_poly (show_list show_char) (_A1, _A2, _A3) (x p))
                  (comp (shows_string [' '; 'o'; 'f'; ' '])
                    (comp (shows_prec _B2 Zero_nat f)
                      (shows_string
                        [' '; 'i'; 'n'; 'v'; 'a'; 'l'; 'i'; 'd'; ' '])))))),
      ((fun (s, t) ->
         let p = eval_term (_A1, _A2) _C1 j s in
         let q = eval_term (_A1, _A2) _C1 j t in
         check (check_poly_gt
                 _A2.ordered_semiring_1_poly_carrier.ordered_semiring_0_ordered_semiring_1
                 _C1 gt p q)
           (comp (shows_string
                   ['c'; 'o'; 'u'; 'l'; 'd'; ' '; 'n'; 'o'; 't'; ' '; 'e'; 'n';
                     's'; 'u'; 'r'; 'e'; ' '])
             (comp (shows_poly _C2 (_A1, _A2, _A3) p)
               (comp (shows_string [' '; '>'; ' '])
                 (shows_poly _C2 (_A1, _A2, _A3) q))))),
        ((fun (s, t) ->
           let p = eval_term (_A1, _A2) _C1 j s in
           let q = eval_term (_A1, _A2) _C1 j t in
           check (check_poly_ge _C1
                   _A2.ordered_semiring_1_poly_carrier.ordered_semiring_0_ordered_semiring_1
                   p q)
             (comp (shows_string
                     ['c'; 'o'; 'u'; 'l'; 'd'; ' '; 'n'; 'o'; 't'; ' '; 'e';
                       'n'; 's'; 'u'; 'r'; 'e'; ' '])
               (comp (shows_poly _C2 (_A1, _A2, _A3) p)
                 (comp (shows_string [' '; '>'; '='; ' '])
                   (shows_poly _C2 (_A1, _A2, _A3) q))))),
          (poly_inter_to_af j,
            (catch (catch
                     (forallm
                       (fun xa ->
                         (if let (a, b) = xa in
                             let (_, n) = a in
                             (fun p ->
                               all_from_to_nat
                                 (check_poly_strict_mono_smart (_A1, _A2)
                                   eq_nata discrete power_mono gt p)
                                 Zero_nat n)
                               b
                           then Inr () else Inl xa))
                       i)
                     (fun xa -> Inl (snd xa)))
               (fun xa ->
                 Inl (let (a, b) = xa in
                      let (f, _) = a in
                      (fun p ->
                        comp (shows_string
                               ['c'; 'o'; 'u'; 'l'; 'd'; ' '; 'n'; 'o'; 't';
                                 ' '; 'e'; 'n'; 's'; 'u'; 'r'; 'e'; ' '; 'm';
                                 'o'; 'n'; 'o'; 't'; 'o'; 'n'; 'i'; 'c'; 't';
                                 'y'; ' '; 'o'; 'f'; ' '])
                          (comp (shows_poly (show_list show_char)
                                  (_A1, _A2, _A3) (x p))
                            (comp (shows_string
                                    [' '; 'a'; 's'; ' '; 'i'; 'n'; 't'; 'e';
                                      'r'; 'p'; 'r'; 'e'; 't'; 'a'; 't'; 'i';
                                      'o'; 'n'; ' '; 'o'; 'f'; ' '])
                              (shows_prec _B2 Zero_nat f))))
                        b)),
              comp (shows_string
                     ['p'; 'o'; 'l'; 'y'; 'n'; 'o'; 'm'; 'i'; 'a'; 'l'; ' ';
                       'i'; 'n'; 't'; 'e'; 'r'; 'p'; 'r'; 'e'; 't'; 'a'; 't';
                       'i'; 'o'; 'n'])
                (comp shows_nl
                  (shows_sep
                    (fun (a, b) ->
                      let (f, n) = a in
                      (fun p ->
                        comp (shows_string ['P'; 'o'; 'l'; '('])
                          (comp (shows_prec _B2 Zero_nat f)
                            (comp (shows_string ['/'])
                              (comp (shows_prec_nat Zero_nat n)
                                (comp (shows_string [')'; ' '; '='; ' '])
                                  (shows_poly (show_list show_char)
                                    (_A1, _A2, _A3) (x p)))))))
                        b)
                    shows_nl i)))))));;

let rec to_lpoly_inter _B
  d on i f n =
    (match lookup (eqc _B eq_nata) (f, n) i with None -> (d, replicate n on)
      | Some cas -> cas);;

let rec create_lpoly_repr (_A1, _A2) (_B1, _B2)
  c i = let pi = to_lpoly_inter _B1 (get_comp_def c) (get_comp_1 c) i in
        comp (shows_string
               ['p'; 'o'; 'l'; 'y'; 'n'; 'o'; 'm'; 'i'; 'a'; 'l'; ' '; 'i'; 'n';
                 't'; 'e'; 'r'; 'p'; 'r'; 'e'; 't'; 'r'; 'a'; 't'; 'i'; 'o';
                 'n'; ' '; 'o'; 'v'; 'e'; 'r'; ' '])
          (comp (shows_string (get_comp_description c))
            (comp shows_nl
              (shows_sep
                (fun (f, n) ->
                  let t =
                    Fun (f, map (fun a -> Var a)
                              (fresh_strings_list ['x'; '_'] one_nat [] n))
                    in
                  comp (shows_string ['P'; 'o'; 'l'; '('])
                    (comp (shows_prec_term _B2 (show_list show_char) Zero_nat t)
                      (comp (shows_string [')'; ' '; '='; ' '])
                        (shows_lpoly (_A1, _A2) (show_list show_char)
                          (get_comp_0 c) (get_comp_1 c)
                          (pleftI _A1 (eq_lista eq_char) (get_comp_0 c)
                            (get_comp_1 c) (get_comp_plus c) (get_comp_times c)
                            (get_comp_max0 c) pi t)))))
                shows_nl (remdups (eqc _B1 eq_nata) (map fst i)))));;

let rec check_poly_monoI _A _B
  ze ge cm =
    (fun xs ->
      catch (forallm
              (fun (a, b) ->
                let (f, n) = a in
                (fun (c, cs) ->
                  catch (bind (check (ge c ze)
                                (comp (shows_string
['c'; 'o'; 'n'; 's'; 't'; 'a'; 'n'; 't'; ' '; 'p'; 'a'; 'r'; 't'; ' '])
                                  (comp (shows_prec _A Zero_nat c)
                                    (comp (shows_string
    [' '; 'm'; 'u'; 's'; 't'; ' '; 'b'; 'e'; ' '; 'a'; 't'; ' '; 'l'; 'e'; 'a';
      's'; 't'; ' '])
                                      (comp (shows_prec _A Zero_nat ze)
shows_nl)))))
                          (fun _ ->
                            bind (check (less_eq_nat n (size_list cs))
                                   (comp (shows_string
   ['t'; 'h'; 'e'; ' '; 'l'; 'a'; 's'; 't'; ' '; 'a'; 'r'; 'g'; 'u'; 'm'; 'e';
     'n'; 't'; ' '; 'i'; 's'; ' '; 'i'; 'g'; 'n'; 'o'; 'r'; 'e'; 'd'])
                                     shows_nl))
                              (fun _ ->
                                catch (forallm
(fun d ->
  check (cm d)
    (comp (shows_string
            ['c'; 'o'; 'e'; 'f'; 'f'; 'i'; 'c'; 'i'; 'e'; 'n'; 't'; ' '])
      (comp (shows_prec _A Zero_nat d)
        (comp (shows_string
                [' '; 'i'; 's'; ' '; 'n'; 'o'; 't'; ' '; 'a'; 'l'; 'l'; 'o';
                  'w'; 'e'; 'd'])
          shows_nl))))
cs)
                                  (fun x -> Inl (snd x)))))
                    (fun x ->
                      Inl (comp (shows_string
                                  ['p'; 'r'; 'o'; 'b'; 'l'; 'e'; 'm'; ' '; 'w';
                                    'i'; 't'; 'h'; ' '; 'm'; 'o'; 'n'; 'o'; 't';
                                    'o'; 'n'; 'i'; 'c'; 'i'; 't'; 'y'; ' '; 'd';
                                    'u'; 'e'; ' '; 't'; 'o'; ' '; 'i'; 'n'; 't';
                                    'e'; 'r'; 'p'; 'r'; 'e'; 't'; 'a'; 't'; 'i';
                                    'o'; 'n'; ' '; 'o'; 'f'; ' '])
                            (comp (shows_prec _B Zero_nat f)
                              (comp (shows_string ['/'])
                                (comp (shows_prec_nat Zero_nat n)
                                  (comp shows_nl x)))))))
                  b)
              xs)
        (fun x -> Inl (snd x)));;

let rec check_lpoly_nsI (_A1, _A2) (_B1, _B2)
  ze on ge (LPoly (a, vas)) (LPoly (b, vbs)) =
    catch (bind (check (ge a b)
                  (shows_string
                    ['p'; 'r'; 'o'; 'b'; 'l'; 'e'; 'm'; ' '; 'w'; 'h'; 'e'; 'n';
                      ' '; 'c'; 'o'; 'm'; 'p'; 'a'; 'r'; 'i'; 'n'; 'g'; ' ';
                      'c'; 'o'; 'n'; 's'; 't'; 'a'; 'n'; 't'; ' '; 'p'; 'a';
                      'r'; 't'; 's']))
            (fun _ ->
              catch (check_pvarsI _B1 ze ge vas vbs)
                (fun x ->
                  Inl (comp (shows_string
                              ['p'; 'r'; 'o'; 'b'; 'l'; 'e'; 'm'; ' '; 'w'; 'h';
                                'e'; 'n'; ' '; 'c'; 'o'; 'm'; 'p'; 'a'; 'r';
                                'i'; 'n'; 'g'; ' '; 'c'; 'o'; 'e'; 'f'; 'f';
                                'i'; 'c'; 'i'; 'e'; 'n'; 't'; 's'; ' '; 'o';
                                'f'; ' '; 'v'; 'a'; 'r'; 'i'; 'a'; 'b'; 'l';
                                'e'; ' '])
                        (shows_prec _B2 Zero_nat x)))))
      (fun x ->
        Inl (comp (shows_string
                    ['p'; 'r'; 'o'; 'b'; 'l'; 'e'; 'm'; ' '; 'w'; 'h'; 'e'; 'n';
                      ' '; 'c'; 'o'; 'm'; 'p'; 'a'; 'r'; 'i'; 'n'; 'g'; ' '])
              (comp (shows_lpoly (_A1, _A2) _B2 ze on (LPoly (a, vas)))
                (comp (shows_string [' '; '>'; '='; ' '])
                  (comp (shows_lpoly (_A1, _A2) _B2 ze on (LPoly (b, vbs)))
                    (comp shows_nl x))))));;

let rec check_polo_nsI (_A1, _A2) _B (_C1, _C2)
  ze on pl ti mz ge pi (s, t) =
    let left = pleftI _A1 _C1 ze on pl ti mz pi s in
    let right = prightI _A1 _C1 ze on pl ti mz pi t in
    catch (check_lpoly_nsI (_A1, _A2) (_C1, _C2) ze on ge left right)
      (fun x ->
        Inl (comp (shows_string
                    ['c'; 'o'; 'u'; 'l'; 'd'; ' '; 'n'; 'o'; 't'; ' '; 'e'; 'n';
                      's'; 'u'; 'r'; 'e'; ' '])
              (comp (shows_prec_term _B _C2 Zero_nat s)
                (comp (shows_string [' '; '>'; '='; ' '])
                  (comp (shows_prec_term _B _C2 Zero_nat t)
                    (comp shows_nl x))))));;

let rec get_comp_wf_elem
  (wfe, (ze, (on, (def, (pl, (ti, (mz, (ge, (gt, (mo, (de, (ap, cm)))))))))))) =
    wfe;;

let rec check_lpoly_coeffs _A _B
  wfe apos ch i =
    catch (forallm
            (fun (a, b) ->
              let (f, n) = a in
              (fun (c, cs) ->
                catch (bind (check (wfe c)
                              (comp (shows_string
                                      ['c'; 'o'; 'n'; 's'; 't'; 'a'; 'n'; 't';
' '; 'p'; 'a'; 'r'; 't'; ' '])
                                (comp (shows_prec _A Zero_nat c)
                                  (comp (shows_string
  [' '; 'i'; 's'; ' '; 'n'; 'o'; 't'; ' '; 'w'; 'e'; 'l'; 'l'; '-'; 'f'; 'o';
    'r'; 'm'; 'e'; 'd'])
                                    shows_nl))))
                        (fun _ ->
                          bind (check (apos c || list_ex apos (take n cs))
                                 (comp (shows_string
 ['c'; 'o'; 'u'; 'l'; 'd'; ' '; 'n'; 'o'; 't'; ' '; 'f'; 'i'; 'n'; 'd'; ' ';
   'p'; 'o'; 's'; 'i'; 't'; 'i'; 'v'; 'e'; ' '; 'e'; 'n'; 't'; 'r'; 'y'; ' ';
   'w'; 'h'; 'i'; 'c'; 'h'; ' '; 'i'; 's'; ' '; 'r'; 'e'; 'q'; 'u'; 'i'; 'r';
   'e'; 'd'; ' '; 'f'; 'o'; 'r'; ' '; 'a'; 'r'; 'c'; 't'; 'i'; 'c'; ' '; 'i';
   'n'; 't'; 'e'; 'r'; 'p'; 'r'; 'e'; 't'; 'a'; 't'; 'i'; 'o'; 'n'; 's'])
                                   shows_nl))
                            (fun _ ->
                              catch (forallm
                                      (fun aa ->
check (ch aa && wfe aa)
  (comp (shows_string
          ['c'; 'o'; 'e'; 'f'; 'f'; 'i'; 'c'; 'i'; 'e'; 'n'; 't'; ' '])
    (comp (shows_prec _A Zero_nat aa)
      (comp (shows_string
              [' '; 'i'; 's'; ' '; 'n'; 'o'; 't'; ' '; 'a'; 'l'; 'l'; 'o'; 'w';
                'e'; 'd'])
        shows_nl))))
                                      cs)
                                (fun x -> Inl (snd x)))))
                  (fun x ->
                    Inl (comp (shows_string
                                ['p'; 'r'; 'o'; 'b'; 'l'; 'e'; 'm'; ' '; 'w';
                                  'i'; 't'; 'h'; ' '; 'i'; 'n'; 't'; 'e'; 'r';
                                  'p'; 'r'; 'e'; 't'; 'a'; 't'; 'i'; 'o'; 'n';
                                  ' '; 'o'; 'f'; ' '])
                          (comp (shows_prec _B Zero_nat f)
                            (comp (shows_string ['/'])
                              (comp (shows_prec_nat Zero_nat n)
                                (comp shows_nl x)))))))
                b)
            i)
      (fun x -> Inl (snd x));;

let rec create_poly_redpair (_A1, _A2) (_B1, _B2) (_C1, _C2)
  cI c i =
    let pi = to_lpoly_inter _A1 (get_comp_def c) (get_comp_1 c) i in
    (bind (cI i)
       (fun _ ->
         check_lpoly_coeffs _B2 _A2 (get_comp_wf_elem c) (get_comp_apos c)
           (fun x -> get_comp_ge c x (get_comp_0 c)) i),
      (check_polo_sI (_B1, _B2) _A2 (_C1, _C2) (get_comp_mono c) (get_comp_0 c)
         (get_comp_1 c) (get_comp_plus c) (get_comp_times c) (get_comp_max0 c)
         (get_comp_ge c) (get_comp_gt c) pi,
        (check_polo_nsI (_B1, _B2) _A2 (_C1, _C2) (get_comp_0 c) (get_comp_1 c)
           (get_comp_plus c) (get_comp_times c) (get_comp_max0 c)
           (get_comp_ge c) pi,
          (create_afI _B1 _A1 (get_comp_0 c) i,
            (bind (check (get_comp_mono c)
                    (shows_string
                      ['m'; 'o'; 'n'; 'o'; 't'; 'o'; 'n'; 'e'; ' '; 'p'; 'o';
                        'l'; 'y'; 'n'; 'o'; 'm'; 'i'; 'a'; 'l'; 's'; ' '; 'n';
                        'o'; 't'; ' '; 's'; 'u'; 'p'; 'p'; 'o'; 'r'; 't'; ' ';
                        'f'; 'o'; 'r'; ' '; 't'; 'h'; 'i'; 's'; ' '; 'd'; 'o';
                        'm'; 'a'; 'i'; 'n']))
               (fun _ ->
                 check_poly_monoI _B2 _A2 (get_comp_0 c) (get_comp_ge c)
                   (get_comp_check_mono c) i),
              create_lpoly_repr (_B1, _B2) (_A1, _A2) c i)))));;

let rec get_redpair (_A1, _A2) (_B1, _B2)
  = function
    Int_carrier i ->
      create_poly_redpair (_A1, _A2) (eq_int, show_int) (_B1, _B2)
        (fun _ -> Inr ())
        ((fun _ -> true),
          ((Big_int.big_int_of_int 0),
            ((Big_int.big_int_of_int 1),
              ((Big_int.big_int_of_int 1),
                (Big_int.add_big_int,
                  (Big_int.mult_big_int,
                    (max0_int,
                      (ge_int,
                        ((fun x y -> Big_int.lt_big_int y x),
                          (true,
                            (int_name, ((fun _ -> true), int_mono))))))))))))
        i
    | Int_nl_carrier i ->
        create_nlpoly_redpair (eq_int, poly_carrier_int, show_int) (_A1, _A2)
          (_B1, _B2) (Big_int.big_int_of_int 1)
          (fun x y -> Big_int.lt_big_int y x) true true i
    | Rat_carrier (d, i) ->
        create_poly_redpair (_A1, _A2) (eq_rata, show_rata) (_B1, _B2)
          (fun _ ->
            check (less_rat
                    (fract (Big_int.big_int_of_int 0)
                      (Big_int.big_int_of_int 1))
                    d)
              (shows_string
                ['i'; 'n'; 'v'; 'a'; 'l'; 'i'; 'd'; ' '; 'd'; 'e'; 'l'; 't';
                  'a']))
          ((fun _ -> true),
            (fract (Big_int.big_int_of_int 0) (Big_int.big_int_of_int 1),
              (fract (Big_int.big_int_of_int 1) (Big_int.big_int_of_int 1),
                (d, (plus_rat,
                      (times_rat,
                        (max0_rat,
                          (ge_rat,
                            (rat_gt d,
                              (true,
                                (rat_name,
                                  ((fun _ -> true), rat_mono))))))))))))
          i
    | Rat_nl_carrier (d, i) ->
        (if less_rat
              (fract (Big_int.big_int_of_int 0) (Big_int.big_int_of_int 1)) d
          then create_nlpoly_redpair (eq_rata, poly_carrier_rat, show_rata)
                 (_A1, _A2) (_B1, _B2) d (rat_gt d)
                 (less_eq_rat
                   (fract (Big_int.big_int_of_int 1) (Big_int.big_int_of_int 1))
                   d)
                 false i
          else faulty_redpair_impl _A2 _B2
                 ['d'; 'e'; 'l'; 't'; 'a'; ' '; 'm'; 'u'; 's'; 't'; ' '; 'b';
                   'e'; ' '; 'l'; 'a'; 'r'; 'g'; 'e'; 'r'; ' '; 't'; 'h'; 'a';
                   'n'; ' '; 'z'; 'e'; 'r'; 'o'])
    | Arctic_carrier i ->
        create_poly_redpair (_A1, _A2) (eq_arctica, show_arctic) (_B1, _B2)
          (fun _ -> Inr ())
          ((fun _ -> true),
            (zero_arctic,
              (one_arctic,
                (one_arctic,
                  (plus_arctic,
                    (times_arctic,
                      (id, (ge_arctic,
                             (gt_arctic,
                               (false,
                                 (arctic_name,
                                   (pos_arctic, (fun _ -> false)))))))))))))
          i
    | Arctic_rat_carrier (d, i) ->
        create_poly_redpair (_A1, _A2) (eq_arctic_rata, show_arctic_rat)
          (_B1, _B2)
          (fun _ ->
            check (less_rat
                    (fract (Big_int.big_int_of_int 0)
                      (Big_int.big_int_of_int 1))
                    d)
              (shows_string
                ['i'; 'n'; 'v'; 'a'; 'l'; 'i'; 'd'; ' '; 'd'; 'e'; 'l'; 't';
                  'a']))
          ((fun _ -> true),
            (zero_arctic_rat,
              (one_arctic_rat,
                (one_arctic_rat,
                  (plus_arctic_rat,
                    (times_arctic_rat,
                      (id, (ge_arctic_rat,
                             (gt_arctic_rat d,
                               (false,
                                 (arctic_rat_name,
                                   (pos_arctic_rat, (fun _ -> false)))))))))))))
          i
    | Int_mat_carrier (n, sd, i) ->
        create_poly_redpair (_A1, _A2)
          (eq_lista (eq_lista eq_int), show_list (show_list show_int))
          (_B1, _B2)
          (fun _ ->
            bind (Inr ())
              (fun _ ->
                check (less_nat Zero_nat sd && less_eq_nat sd n)
                  (shows_string
                    ['i'; 'n'; 'v'; 'a'; 'l'; 'i'; 'd'; ' '; 'd'; 'i'; 'm'; 'e';
                      'n'; 's'; 'i'; 'o'; 'n'])))
          (mat n n,
            (mat0I (Big_int.big_int_of_int 0) n n,
              (mat1I (Big_int.big_int_of_int 0) (Big_int.big_int_of_int 1) n,
                (mat1I (Big_int.big_int_of_int 0)
                   (get_comp_def
                     ((fun _ -> true),
                       ((Big_int.big_int_of_int 0),
                         ((Big_int.big_int_of_int 1),
                           ((Big_int.big_int_of_int 1),
                             (Big_int.add_big_int,
                               (Big_int.mult_big_int,
                                 (max0_int,
                                   (ge_int,
                                     ((fun x y -> Big_int.lt_big_int y x),
                                       (true,
 (int_name, ((fun _ -> true), int_mono)))))))))))))
                   n,
                  (mat_plusI Big_int.add_big_int,
                    (mat_multI (Big_int.big_int_of_int 0) Big_int.add_big_int
                       Big_int.mult_big_int n,
                      (mat_max0 max_ordered_monoid_add_int,
                        (mat_ge non_strict_order_int,
                          (mat_gtI non_strict_order_int
                             (get_comp_gt
                               ((fun _ -> true),
                                 ((Big_int.big_int_of_int 0),
                                   ((Big_int.big_int_of_int 1),
                                     ((Big_int.big_int_of_int 1),
                                       (Big_int.add_big_int,
 (Big_int.mult_big_int,
   (max0_int,
     (ge_int,
       ((fun x y -> Big_int.lt_big_int y x),
         (true, (int_name, ((fun _ -> true), int_mono)))))))))))))
                             sd,
                            (get_comp_mono
                               ((fun _ -> true),
                                 ((Big_int.big_int_of_int 0),
                                   ((Big_int.big_int_of_int 1),
                                     ((Big_int.big_int_of_int 1),
                                       (Big_int.add_big_int,
 (Big_int.mult_big_int,
   (max0_int,
     (ge_int,
       ((fun x y -> Big_int.lt_big_int y x),
         (true, (int_name, ((fun _ -> true), int_mono)))))))))))),
                              (concat
                                 [shows_prec_nat Zero_nat n []; ['x'];
                                   shows_prec_nat Zero_nat n [];
                                   [' '; 'm'; 'a'; 't'; 'r'; 'i'; 'c'; 'e'; 's';
                                     ' '; 'w'; 'i'; 't'; 'h'; ' '; 's'; 't';
                                     'r'; 'i'; 'c'; 't'; ' '; 'd'; 'i'; 'm';
                                     'e'; 'n'; 's'; 'i'; 'o'; 'n'; ' '];
                                   shows_prec_nat Zero_nat sd [];
                                   [' '; 'o'; 'v'; 'e'; 'r'; ' '];
                                   get_comp_description
                                     ((fun _ -> true),
                                       ((Big_int.big_int_of_int 0),
 ((Big_int.big_int_of_int 1),
   ((Big_int.big_int_of_int 1),
     (Big_int.add_big_int,
       (Big_int.mult_big_int,
         (max0_int,
           (ge_int,
             ((fun x y -> Big_int.lt_big_int y x),
               (true, (int_name, ((fun _ -> true), int_mono))))))))))))],
                                ((fun _ -> true),
                                  mat_mono sd
                                    (get_comp_check_mono
                                      ((fun _ -> true),
((Big_int.big_int_of_int 0),
  ((Big_int.big_int_of_int 1),
    ((Big_int.big_int_of_int 1),
      (Big_int.add_big_int,
        (Big_int.mult_big_int,
          (max0_int,
            (ge_int,
              ((fun x y -> Big_int.lt_big_int y x),
                (true,
                  (int_name, ((fun _ -> true), int_mono)))))))))))))))))))))))))
          i
    | Rat_mat_carrier (d, n, sd, i) ->
        create_poly_redpair (_A1, _A2)
          (eq_lista (eq_lista eq_rata), show_list (show_list show_rata))
          (_B1, _B2)
          (fun _ ->
            bind (check
                   (less_rat
                     (fract (Big_int.big_int_of_int 0)
                       (Big_int.big_int_of_int 1))
                     d)
                   (shows_string
                     ['i'; 'n'; 'v'; 'a'; 'l'; 'i'; 'd'; ' '; 'd'; 'e'; 'l';
                       't'; 'a']))
              (fun _ ->
                check (less_nat Zero_nat sd && less_eq_nat sd n)
                  (shows_string
                    ['i'; 'n'; 'v'; 'a'; 'l'; 'i'; 'd'; ' '; 'd'; 'i'; 'm'; 'e';
                      'n'; 's'; 'i'; 'o'; 'n'])))
          (mat n n,
            (mat0I (fract (Big_int.big_int_of_int 0) (Big_int.big_int_of_int 1))
               n n,
              (mat1I (fract (Big_int.big_int_of_int 0)
                       (Big_int.big_int_of_int 1))
                 (fract (Big_int.big_int_of_int 1) (Big_int.big_int_of_int 1))
                 n,
                (mat1I (fract (Big_int.big_int_of_int 0)
                         (Big_int.big_int_of_int 1))
                   (get_comp_def
                     ((fun _ -> true),
                       (fract (Big_int.big_int_of_int 0)
                          (Big_int.big_int_of_int 1),
                         (fract (Big_int.big_int_of_int 1)
                            (Big_int.big_int_of_int 1),
                           (d, (plus_rat,
                                 (times_rat,
                                   (max0_rat,
                                     (ge_rat,
                                       (rat_gt d,
 (true, (rat_name, ((fun _ -> true), rat_mono)))))))))))))
                   n,
                  (mat_plusI plus_rat,
                    (mat_multI
                       (fract (Big_int.big_int_of_int 0)
                         (Big_int.big_int_of_int 1))
                       plus_rat times_rat n,
                      (mat_max0 max_ordered_monoid_add_rat,
                        (mat_ge non_strict_order_rat,
                          (mat_gtI non_strict_order_rat
                             (get_comp_gt
                               ((fun _ -> true),
                                 (fract (Big_int.big_int_of_int 0)
                                    (Big_int.big_int_of_int 1),
                                   (fract (Big_int.big_int_of_int 1)
                                      (Big_int.big_int_of_int 1),
                                     (d, (plus_rat,
   (times_rat,
     (max0_rat,
       (ge_rat,
         (rat_gt d, (true, (rat_name, ((fun _ -> true), rat_mono)))))))))))))
                             sd,
                            (get_comp_mono
                               ((fun _ -> true),
                                 (fract (Big_int.big_int_of_int 0)
                                    (Big_int.big_int_of_int 1),
                                   (fract (Big_int.big_int_of_int 1)
                                      (Big_int.big_int_of_int 1),
                                     (d, (plus_rat,
   (times_rat,
     (max0_rat,
       (ge_rat,
         (rat_gt d, (true, (rat_name, ((fun _ -> true), rat_mono)))))))))))),
                              (concat
                                 [shows_prec_nat Zero_nat n []; ['x'];
                                   shows_prec_nat Zero_nat n [];
                                   [' '; 'm'; 'a'; 't'; 'r'; 'i'; 'c'; 'e'; 's';
                                     ' '; 'w'; 'i'; 't'; 'h'; ' '; 's'; 't';
                                     'r'; 'i'; 'c'; 't'; ' '; 'd'; 'i'; 'm';
                                     'e'; 'n'; 's'; 'i'; 'o'; 'n'; ' '];
                                   shows_prec_nat Zero_nat sd [];
                                   [' '; 'o'; 'v'; 'e'; 'r'; ' '];
                                   get_comp_description
                                     ((fun _ -> true),
                                       (fract (Big_int.big_int_of_int 0)
  (Big_int.big_int_of_int 1),
 (fract (Big_int.big_int_of_int 1) (Big_int.big_int_of_int 1),
   (d, (plus_rat,
         (times_rat,
           (max0_rat,
             (ge_rat,
               (rat_gt d,
                 (true, (rat_name, ((fun _ -> true), rat_mono))))))))))))],
                                ((fun _ -> true),
                                  mat_mono sd
                                    (get_comp_check_mono
                                      ((fun _ -> true),
(fract (Big_int.big_int_of_int 0) (Big_int.big_int_of_int 1),
  (fract (Big_int.big_int_of_int 1) (Big_int.big_int_of_int 1),
    (d, (plus_rat,
          (times_rat,
            (max0_rat,
              (ge_rat,
                (rat_gt d,
                  (true,
                    (rat_name,
                      ((fun _ -> true), rat_mono)))))))))))))))))))))))))
          i
    | Arc_mat_carrier (n, i) ->
        create_poly_redpair (_A1, _A2)
          (eq_lista (eq_lista eq_arctica), show_list (show_list show_arctic))
          (_B1, _B2)
          (fun _ ->
            bind (Inr ())
              (fun _ ->
                check (less_nat Zero_nat n)
                  (shows_string
                    ['i'; 'n'; 'v'; 'a'; 'l'; 'i'; 'd'; ' '; 'd'; 'i'; 'm'; 'e';
                      'n'; 's'; 'i'; 'o'; 'n'])))
          (mat n n,
            (mat0I zero_arctic n n,
              (mat1I zero_arctic one_arctic n,
                (mat1I zero_arctic
                   (get_comp_def
                     ((fun _ -> true),
                       (zero_arctic,
                         (one_arctic,
                           (one_arctic,
                             (plus_arctic,
                               (times_arctic,
                                 (id, (ge_arctic,
(gt_arctic, (false, (arctic_name, (pos_arctic, (fun _ -> false))))))))))))))
                   n,
                  (mat_plusI plus_arctic,
                    (mat_multI zero_arctic plus_arctic times_arctic n,
                      (id, (mat_ge non_strict_order_arctic,
                             (mat_comp_all
                                (get_comp_gt
                                  ((fun _ -> true),
                                    (zero_arctic,
                                      (one_arctic,
(one_arctic,
  (plus_arctic,
    (times_arctic,
      (id, (ge_arctic,
             (gt_arctic,
               (false, (arctic_name, (pos_arctic, (fun _ -> false)))))))))))))),
                               (false,
                                 (concat
                                    [shows_prec_nat Zero_nat n []; ['x'];
                                      shows_prec_nat Zero_nat n [];
                                      [' '; 'm'; 'a'; 't'; 'r'; 'i'; 'c'; 'e';
's'; ' '; 'o'; 'v'; 'e'; 'r'; ' '];
                                      get_comp_description
((fun _ -> true),
  (zero_arctic,
    (one_arctic,
      (one_arctic,
        (plus_arctic,
          (times_arctic,
            (id, (ge_arctic,
                   (gt_arctic,
                     (false,
                       (arctic_name, (pos_arctic, (fun _ -> false)))))))))))))],
                                   (mat_arc_posI
                                      (get_comp_apos
((fun _ -> true),
  (zero_arctic,
    (one_arctic,
      (one_arctic,
        (plus_arctic,
          (times_arctic,
            (id, (ge_arctic,
                   (gt_arctic,
                     (false,
                       (arctic_name, (pos_arctic, (fun _ -> false)))))))))))))),
                                     (fun _ -> false)))))))))))))
          i
    | Arc_rat_mat_carrier (d, n, i) ->
        create_poly_redpair (_A1, _A2)
          (eq_lista (eq_lista eq_arctic_rata),
            show_list (show_list show_arctic_rat))
          (_B1, _B2)
          (fun _ ->
            bind (check
                   (less_rat
                     (fract (Big_int.big_int_of_int 0)
                       (Big_int.big_int_of_int 1))
                     d)
                   (shows_string
                     ['i'; 'n'; 'v'; 'a'; 'l'; 'i'; 'd'; ' '; 'd'; 'e'; 'l';
                       't'; 'a']))
              (fun _ ->
                check (less_nat Zero_nat n)
                  (shows_string
                    ['i'; 'n'; 'v'; 'a'; 'l'; 'i'; 'd'; ' '; 'd'; 'i'; 'm'; 'e';
                      'n'; 's'; 'i'; 'o'; 'n'])))
          (mat n n,
            (mat0I zero_arctic_rat n n,
              (mat1I zero_arctic_rat one_arctic_rat n,
                (mat1I zero_arctic_rat
                   (get_comp_def
                     ((fun _ -> true),
                       (zero_arctic_rat,
                         (one_arctic_rat,
                           (one_arctic_rat,
                             (plus_arctic_rat,
                               (times_arctic_rat,
                                 (id, (ge_arctic_rat,
(gt_arctic_rat d,
  (false, (arctic_rat_name, (pos_arctic_rat, (fun _ -> false))))))))))))))
                   n,
                  (mat_plusI plus_arctic_rat,
                    (mat_multI zero_arctic_rat plus_arctic_rat times_arctic_rat
                       n,
                      (id, (mat_ge non_strict_order_arctic_rat,
                             (mat_comp_all
                                (get_comp_gt
                                  ((fun _ -> true),
                                    (zero_arctic_rat,
                                      (one_arctic_rat,
(one_arctic_rat,
  (plus_arctic_rat,
    (times_arctic_rat,
      (id, (ge_arctic_rat,
             (gt_arctic_rat d,
               (false,
                 (arctic_rat_name,
                   (pos_arctic_rat, (fun _ -> false)))))))))))))),
                               (false,
                                 (concat
                                    [shows_prec_nat Zero_nat n []; ['x'];
                                      shows_prec_nat Zero_nat n [];
                                      [' '; 'm'; 'a'; 't'; 'r'; 'i'; 'c'; 'e';
's'; ' '; 'o'; 'v'; 'e'; 'r'; ' '];
                                      get_comp_description
((fun _ -> true),
  (zero_arctic_rat,
    (one_arctic_rat,
      (one_arctic_rat,
        (plus_arctic_rat,
          (times_arctic_rat,
            (id, (ge_arctic_rat,
                   (gt_arctic_rat d,
                     (false,
                       (arctic_rat_name,
                         (pos_arctic_rat, (fun _ -> false)))))))))))))],
                                   (mat_arc_posI
                                      (get_comp_apos
((fun _ -> true),
  (zero_arctic_rat,
    (one_arctic_rat,
      (one_arctic_rat,
        (plus_arctic_rat,
          (times_arctic_rat,
            (id, (ge_arctic_rat,
                   (gt_arctic_rat d,
                     (false,
                       (arctic_rat_name,
                         (pos_arctic_rat, (fun _ -> false)))))))))))))),
                                     (fun _ -> false)))))))))))))
          i
    | Lpo (prec, pi) ->
        af_redpair (_A1, _A2) _B2 pi
          (create_LPO_redpair _A2 (eq_filtereda _A1, show_filtered _A2)
            (_B1, _B2) (lpo_repr_to_pr _A1) prec);;

let rec rev_term
  c x1 = match c, x1 with c, Var x -> ctxt_apply c (Var x)
    | c, Fun (f, [t]) -> rev_term (More (f, [], c, [])) t;;

let rec rev_rule (l, r) = (rev_term Hole l, rev_term Hole r);;

let rec match_list _A _B
  tls = (match matchList _A tls with None -> None
          | Some a -> matchVars _B _A a);;

let rec doc_of_string s = bind (parse_doc s) (fun (doc, _) -> Inr doc);;

let rec starts_with
  t s = (if not (null t) && member eq_char wspace (hd t)
          then starts_with (tl t) s
          else (match search_len t s (size_list s) with None -> false
                 | Some _ -> true));;

let rec check_pairwise
  c x1 = match c, x1 with c, [] -> Inr ()
    | c, x :: xs ->
        bind (catch (forallm (c x) xs) (fun xa -> Inl (snd xa)))
          (fun _ -> check_pairwise c xs);;

let rec check_graph_decomp
  ss g rcs =
    bind (check_pairwise (check_edges ss g) (map snd rcs))
      (fun _ ->
        catch (forallm (fun c -> check_edges ss g c c)
                (map snd (filter (fun rc -> not (fst rc)) rcs)))
          (fun x -> Inl (snd x)));;

let rec check_DPs (_A1, _A2) (_B1, _B2)
  r p = catch (forallm
                (fun x ->
                  (if let (ll, rr) = x in
                      list_ex
                        (fun (l, ra) ->
                          eq_term _A1 _B1 l (map_term unsharp_fun ll) &&
                            supteqp _A1 _B1 ra (map_term unsharp_fun rr))
                        r
                    then Inr () else Inl x))
                p)
          (fun x -> Inl (snd x));;

let rec sharp_lab_name
  x = (if eq_list eq_char (get_name x) ['s'; 'h'; 'a'; 'r'; 'p']
        then xml1element ['s'; 'h'; 'a'; 'r'; 'p'] plain_name (fun a -> Sharp a)
               x
        else xml_change plain_name (fun a -> Plain a) x);;

let rec lab_sharp_name
  = function Zero_nat -> xml_change sharp_lab_name (fun a -> UnLab a)
    | Suc n ->
        xml2elements
          ['l'; 'a'; 'b'; 'e'; 'l'; 'e'; 'd'; 'S'; 'y'; 'm'; 'b'; 'o'; 'l']
          (lab_sharp_name n) (label (lab_sharp_name n))
          (fun f a ->
            (match a with Inl aa -> Lab (f, aa) | Inr aa -> FunLab (f, aa)));;

let rec xml2dpDisproof
  xml2name x =
    xml1element
      ['d'; 'p'; 'N'; 'o'; 'n'; 't'; 'e'; 'r'; 'm'; 'i'; 'n'; 'a'; 't'; 'i';
        'o'; 'n'; 'P'; 'r'; 'o'; 'o'; 'f']
      (xml_options
        [(['d'; 'p'; 'R'; 'u'; 'l'; 'e'; 'R'; 'e'; 'm'; 'o'; 'v'; 'a'; 'l'],
           xml3elements
             ['d'; 'p'; 'R'; 'u'; 'l'; 'e'; 'R'; 'e'; 'm'; 'o'; 'v'; 'a'; 'l']
             (xml1element ['d'; 'p'; 's'] (rules xml2name) id)
             (xml1element ['t'; 'r'; 's'] (rules xml2name) id)
             (xml2dpDisproof xml2name) (fun a b c -> DPRuleRemoval (a, b, c)));
          (['l'; 'o'; 'o'; 'p'],
            xml_change (loop xml2name)
              (fun (s, (rseq, (a, b))) -> DPLoop (s, rseq, a, b)))])
      id x;;

let rec xml2trsDisproof
  xml2name xml2sname x =
    xml1element
      ['t'; 'r'; 's'; 'N'; 'o'; 'n'; 't'; 'e'; 'r'; 'm'; 'i'; 'n'; 'a'; 't';
        'i'; 'o'; 'n'; 'P'; 'r'; 'o'; 'o'; 'f']
      (xml_options
        [(['v'; 'a'; 'r'; 'i'; 'a'; 'b'; 'l'; 'e'; 'C'; 'o'; 'n'; 'd'; 'i'; 't';
            'i'; 'o'; 'n'; 'V'; 'i'; 'o'; 'l'; 'a'; 't'; 'e'; 'd'],
           xml0elements
             ['v'; 'a'; 'r'; 'i'; 'a'; 'b'; 'l'; 'e'; 'C'; 'o'; 'n'; 'd'; 'i';
               't'; 'i'; 'o'; 'n'; 'V'; 'i'; 'o'; 'l'; 'a'; 't'; 'e'; 'd']
             NotWellFormed);
          (['l'; 'o'; 'o'; 'p'],
            xml_change (loop xml2name)
              (fun (s, (rseq, (a, b))) ->
                Loop (s, map (fun (xa, (y, (_, z))) -> (xa, (y, z))) rseq, a,
                       b)));
          (['r'; 'u'; 'l'; 'e'; 'R'; 'e'; 'm'; 'o'; 'v'; 'a'; 'l'],
            xml2elements ['r'; 'u'; 'l'; 'e'; 'R'; 'e'; 'm'; 'o'; 'v'; 'a'; 'l']
              (xml1element ['t'; 'r'; 's'] (rules xml2name) id)
              (xml2trsDisproof xml2name xml2sname)
              (fun a b -> NTRuleRemoval (a, b)));
          (['d'; 'p'; 'T'; 'r'; 'a'; 'n'; 's'],
            xml3elements ['d'; 'p'; 'T'; 'r'; 'a'; 'n'; 's']
              (xml1element ['d'; 'p'; 's'] (rules xml2sname) id)
              (boola
                ['m'; 'a'; 'r'; 'k'; 'e'; 'd'; 'S'; 'y'; 'm'; 'b'; 'o'; 'l';
                  's'])
              (xml2dpDisproof xml2sname)
              (fun p _ -> (fun a -> NTDPTrans (p, a))));
          (['s'; 't'; 'r'; 'i'; 'n'; 'g'; 'R'; 'e'; 'v'; 'e'; 'r'; 's'; 'a';
             'l'],
            xml2elements
              ['s'; 't'; 'r'; 'i'; 'n'; 'g'; 'R'; 'e'; 'v'; 'e'; 'r'; 's'; 'a';
                'l']
              (xml1element ['t'; 'r'; 's'] (rules xml2name) id)
              (xml2trsDisproof xml2name xml2sname)
              (fun a b -> NTStringReversal (a, b)))])
      id x;;

let rec xml2relTrsDisproof
  xml2name xml2sname x =
    xml1element
      ['r'; 'e'; 'l'; 'a'; 't'; 'i'; 'v'; 'e'; 'N'; 'o'; 'n'; 't'; 'e'; 'r';
        'm'; 'i'; 'n'; 'a'; 't'; 'i'; 'o'; 'n'; 'P'; 'r'; 'o'; 'o'; 'f']
      (xml_options
        [(['v'; 'a'; 'r'; 'i'; 'a'; 'b'; 'l'; 'e'; 'C'; 'o'; 'n'; 'd'; 'i'; 't';
            'i'; 'o'; 'n'; 'V'; 'i'; 'o'; 'l'; 'a'; 't'; 'e'; 'd'],
           xml0elements
             ['v'; 'a'; 'r'; 'i'; 'a'; 'b'; 'l'; 'e'; 'C'; 'o'; 'n'; 'd'; 'i';
               't'; 'i'; 'o'; 'n'; 'V'; 'i'; 'o'; 'l'; 'a'; 't'; 'e'; 'd']
             RelNotWellFormed);
          (['l'; 'o'; 'o'; 'p'],
            xml_change (loop xml2name)
              (fun (s, (rseq, (a, b))) -> RelLoop (s, rseq, a, b)));
          (['t'; 'r'; 's'; 'N'; 'o'; 'n'; 't'; 'e'; 'r'; 'm'; 'i'; 'n'; 'a';
             't'; 'i'; 'o'; 'n'; 'P'; 'r'; 'o'; 'o'; 'f'],
            xml_change (xml2trsDisproof xml2name xml2sname)
              (fun a -> RNotSN a));
          (['r'; 'u'; 'l'; 'e'; 'R'; 'e'; 'm'; 'o'; 'v'; 'a'; 'l'],
            xml3elements ['r'; 'u'; 'l'; 'e'; 'R'; 'e'; 'm'; 'o'; 'v'; 'a'; 'l']
              (xml1element ['t'; 'r'; 's'] (rules xml2name) id)
              (xml1element ['t'; 'r'; 's'] (rules xml2name) id)
              (xml2relTrsDisproof xml2name xml2sname)
              (fun a b c -> NTRelRuleRemoval (a, b, c)))])
      id x;;

let rec xml2relTrsProof _A
  xml2name xml2sname xml2lsname x =
    xml1element
      ['r'; 'e'; 'l'; 'a'; 't'; 'i'; 'v'; 'e'; 'T'; 'e'; 'r'; 'm'; 'i'; 'n';
        'a'; 't'; 'i'; 'o'; 'n'; 'P'; 'r'; 'o'; 'o'; 'f']
      (xml_options
        [(['r'; 'I'; 's'; 'E'; 'm'; 'p'; 't'; 'y'],
           xml0elements ['r'; 'I'; 's'; 'E'; 'm'; 'p'; 't'; 'y'] RelRisEmpty);
          (['s'; 'I'; 's'; 'E'; 'm'; 'p'; 't'; 'y'],
            xml1element ['s'; 'I'; 's'; 'E'; 'm'; 'p'; 't'; 'y']
              (xml2trsProof _A xml2name xml2sname xml2lsname)
              (fun a -> RelSisEmpty a));
          (['u'; 'n'; 'l'; 'a'; 'b'],
            xml3elements ['u'; 'n'; 'l'; 'a'; 'b']
              (xml1element ['t'; 'r'; 's'] (rules xml2name) id)
              (xml1element ['t'; 'r'; 's'] (rules xml2name) id)
              (xml2relTrsProof _A xml2name xml2sname xml2lsname)
              (fun a b c -> RelUnlab (a, b, c)));
          (['s'; 'e'; 'm'; 'l'; 'a'; 'b'],
            xml4elements ['s'; 'e'; 'm'; 'l'; 'a'; 'b'] (sl_inter xml2name)
              (xml1element ['t'; 'r'; 's'] (rules xml2name) id)
              (xml1element ['t'; 'r'; 's'] (rules xml2name) id)
              (xml2relTrsProof _A xml2name xml2sname xml2lsname)
              (fun a ->
                (match a with None -> (fun aa b c -> RelRootlab (aa, b, c))
                  | Some i ->
                    (fun aa b c -> RelSemlab (i, id_labeling, aa, b, c)))));
          (['r'; 'u'; 'l'; 'e'; 'R'; 'e'; 'm'; 'o'; 'v'; 'a'; 'l'],
            xml4elements ['r'; 'u'; 'l'; 'e'; 'R'; 'e'; 'm'; 'o'; 'v'; 'a'; 'l']
              (ordering_constraint_proof xml2name)
              (xml1element ['t'; 'r'; 's'] (rules xml2name) id)
              (xml1element ['t'; 'r'; 's'] (rules xml2name) id)
              (xml2relTrsProof _A xml2name xml2sname xml2lsname)
              (fun a b c d -> RelRuleRemoval (a, b, c, d)))])
      id x;;

let rec xml2certProblem _A
  xml2uname xml2usname xml2name xml2sname xml2lsname
    (Xml (name, egal, cs, texta)) =
    (if eq_list eq_char name
          ['c'; 'e'; 'r'; 't'; 'i'; 'f'; 'i'; 'c'; 'a'; 't'; 'i'; 'o'; 'n'; 'P';
            'r'; 'o'; 'b'; 'l'; 'e'; 'm'] &&
          (is_none texta &&
            less_eq_nat (nat (Big_int.big_int_of_int 3)) (size_list cs))
      then bind (xml2trsInput xml2uname (nth cs Zero_nat))
             (fun (r, s_opt) ->
               bind (text ['c'; 'p'; 'f'; 'V'; 'e'; 'r'; 's'; 'i'; 'o'; 'n']
                      (nth cs one_nat))
                 (fun _ ->
                   (match s_opt
                     with None ->
                       xml1element ['p'; 'r'; 'o'; 'o'; 'f']
                         (xml_options
                           [(['t'; 'r'; 's'; 'T'; 'e'; 'r'; 'm'; 'i'; 'n'; 'a';
                               't'; 'i'; 'o'; 'n'; 'P'; 'r'; 'o'; 'o'; 'f'],
                              xml_change
                                (xml2trsProof _A xml2name xml2sname xml2lsname)
                                (fun a -> TRSProof (r, a)));
                             (['t'; 'r'; 's'; 'N'; 'o'; 'n'; 't'; 'e'; 'r'; 'm';
                                'i'; 'n'; 'a'; 't'; 'i'; 'o'; 'n'; 'P'; 'r';
                                'o'; 'o'; 'f'],
                               xml_change (xml2trsDisproof xml2uname xml2usname)
                                 (fun a -> TRSDisproof (r, a)))])
                         id (nth cs (nat (Big_int.big_int_of_int 2)))
                     | Some s ->
                       xml1element ['p'; 'r'; 'o'; 'o'; 'f']
                         (xml_options
                           [(['r'; 'e'; 'l'; 'a'; 't'; 'i'; 'v'; 'e'; 'T'; 'e';
                               'r'; 'm'; 'i'; 'n'; 'a'; 't'; 'i'; 'o'; 'n'; 'P';
                               'r'; 'o'; 'o'; 'f'],
                              xml_change
                                (xml2relTrsProof _A xml2name xml2sname
                                  xml2lsname)
                                (fun a -> RelTRSProof ((r, s), a)));
                             (['r'; 'e'; 'l'; 'a'; 't'; 'i'; 'v'; 'e'; 'N'; 'o';
                                'n'; 't'; 'e'; 'r'; 'm'; 'i'; 'n'; 'a'; 't';
                                'i'; 'o'; 'n'; 'P'; 'r'; 'o'; 'o'; 'f'],
                               xml_change
                                 (xml2relTrsDisproof xml2uname xml2usname)
                                 (fun a -> RelTRSDisproof ((r, s), a)))])
                         id (nth cs (nat (Big_int.big_int_of_int 2))))))
      else Inl ['c'; 'o'; 'u'; 'l'; 'd'; ' '; 'n'; 'o'; 't'; ' '; 'p'; 'a'; 'r';
                 's'; 'e'; ' '; 'r'; 'o'; 'o'; 't'; ' '; 'e'; 'l'; 'e'; 'm';
                 'e'; 'n'; 't']);;

let rec xmldoc2certProblem
  (Xmldoc (header, xml)) =
    debug ['0']
      ['p'; 'a'; 'r'; 's'; 'i'; 'n'; 'g'; ' '; 'x'; 'm'; 'l'; ' '; 't'; 'o';
        ' '; 'c'; 'e'; 'r'; 't'; 'i'; 'f'; 'i'; 'c'; 'a'; 't'; 'i'; 'o'; 'n';
        ' '; 'p'; 'r'; 'o'; 'b'; 'l'; 'e'; 'm']
      (xml2certProblem (eq_lista eq_char) (text ['n'; 'a'; 'm'; 'e']) sharp_name
        plain_name sharp_lab_name lab_sharp_name xml);;

let rec parseCertProblem s = bind (doc_of_string s) xmldoc2certProblem;;

let rec extract_input_proof
  s = (match
        search_len s ['<'; 'i'; 'n'; 'p'; 'u'; 't'; '>']
          (size_list ['<'; 'i'; 'n'; 'p'; 'u'; 't'; '>'])
        with None -> None
        | Some (_, minput) ->
          (match
            search_len minput ['<'; '/'; 'i'; 'n'; 'p'; 'u'; 't'; '>']
              (size_list ['<'; '/'; 'i'; 'n'; 'p'; 'u'; 't'; '>'])
            with None -> None
            | Some (the_input, sa) ->
              (match
                search_len sa ['<'; 'p'; 'r'; 'o'; 'o'; 'f'; '>']
                  (size_list ['<'; 'p'; 'r'; 'o'; 'o'; 'f'; '>'])
                with None -> None
                | Some (version, prf) -> Some (the_input, (version, prf)))));;

let rec check_wf_rel_trs _A (_B1, _B2)
  (r, s) =
    bind (check_wf_trs _A (_B1, _B2) r)
      (fun _ ->
        (if null r then Inr ()
          else catch (forallm
                       (fun rule ->
                         catch (catch
                                 (check_subseteq _B1
                                   (vars_term_list _B1 (snd rule))
                                   (vars_term_list _B1 (fst rule)))
                                 (fun x ->
                                   Inl (comp
 (shows_string
   ['f'; 'r'; 'e'; 'e'; ' '; 'v'; 'a'; 'r'; 'i'; 'a'; 'b'; 'l'; 'e'; ' '])
 (comp (shows_prec _B2 Zero_nat x)
   (shows_string
     [' '; 'i'; 'n'; ' '; 'r'; 'i'; 'g'; 'h'; 't'; '-'; 'h'; 'a'; 'n'; 'd'; ' ';
       's'; 'i'; 'd'; 'e'; ' '; 'o'; 'f'])))))
                           (fun x ->
                             Inl (comp x
                                   (comp (shows_string
   [' '; 'r'; 'u'; 'l'; 'e'; ' '])
                                     (comp (shows_rule _A _B2 rule)
                                       shows_nl)))))
                       s)
                 (fun x -> Inl (snd x))));;

let rec check_not_wf_rel_trs _A (_B1, _B2)
  rs = check (not (isOK (check_wf_rel_trs _A (_B1, _B2) rs)))
         (comp (shows_string
                 ['T'; 'h'; 'e'; ' '; 'T'; 'R'; 'S'; 's'; ' '; 'R'; ' '; 'a';
                   'n'; 'd'; ' '; 'S'; ' '; 'a'; 'r'; 'e'; ' '; 'w'; 'e'; 'l';
                   'l'; ' '; 'f'; 'o'; 'r'; 'm'; 'e'; 'd'])
           shows_nl);;

let rec shows_pos
  = function PCons (i, Empty) -> shows_prec_nat Zero_nat i
    | PCons (i, PCons (v, va)) ->
        comp (shows_prec_nat Zero_nat i) (shows_pos (PCons (v, va)))
    | Empty -> shows_string ['e'];;

let rec shows_prec_pos d p = shows_pos p;;

let rec instance_rule _A _B
  lr st =
    not (is_none (match_list _A _B [(fst lr, fst st); (snd lr, snd st)]));;

let rec eq_rule_mod_vars _A _B
  lr st = instance_rule _A _B lr st && instance_rule _A _B st lr;;

let rec check_rstep (_A1, _A2) (_B1, _B2)
  ra p r s t =
    let sps = poss_list s in
    let tps = poss_list t in
    bind (check (list_ex (eq_rule_mod_vars _A1 _B1 r) ra)
           (comp (shows_rule _A2 _B2 r)
             (comp (shows_string
                     [' '; 'i'; 's'; ' '; 'n'; 'o'; 't'; ' '; 'a'; ' '; 'r';
                       'u'; 'l'; 'e'; ' '; 'o'; 'f'])
               (comp shows_nl (comp (shows_trs _A2 _B2 ra) shows_nl)))))
      (fun _ ->
        bind (check (member eq_posa sps p)
               (comp (shows_prec_pos Zero_nat p)
                 (comp (shows_string
                         [' '; 'i'; 's'; ' '; 'n'; 'o'; 't'; ' '; 'a'; ' '; 'p';
                           'o'; 's'; 'i'; 't'; 'i'; 'o'; 'n'; ' '; 'o'; 'f';
                           ' '])
                   (comp (shows_prec_term _A2 _B2 Zero_nat s) shows_nl))))
          (fun _ ->
            bind (check (member eq_posa tps p)
                   (comp (shows_prec_pos Zero_nat p)
                     (comp (shows_string
                             [' '; 'i'; 's'; ' '; 'n'; 'o'; 't'; ' '; 'a'; ' ';
                               'p'; 'o'; 's'; 'i'; 't'; 'i'; 'o'; 'n'; ' '; 'o';
                               'f'; ' '])
                       (comp (shows_prec_term _A2 _B2 Zero_nat t) shows_nl))))
              (fun _ ->
                let c = ctxt_of_pos_term p s in
                let d = ctxt_of_pos_term p t in
                let u = subt_at s p in
                let v = subt_at t p in
                (match match_list _A1 _B1 [(u, fst r); (v, snd r)]
                  with None ->
                    Inl (comp (shows_string
                                ['t'; 'h'; 'e'; ' '; 't'; 'e'; 'r'; 'm'; ' '])
                          (comp (shows_prec_term _A2 _B2 Zero_nat t)
                            (comp (shows_string
                                    [' '; 'd'; 'o'; 'e'; 's'; ' '; 'n'; 'o';
                                      't'; ' '; 'r'; 'e'; 's'; 'u'; 'l'; 't';
                                      ' '; 'f'; 'r'; 'o'; 'm'; ' '; 'a'; ' ';
                                      'p'; 'r'; 'o'; 'p'; 'e'; 'r'; ' '; 'a';
                                      'p'; 'p'; 'l'; 'i'; 'c'; 'a'; 't'; 'i';
                                      'o'; 'n'; ' '; 'o'; 'f'; ' '; 'r'; 'u';
                                      'l'; 'e'; ' '])
                              (comp shows_nl
                                (comp (shows_rule _A2 _B2 r)
                                  (comp (shows_string
  [' '; 'a'; 't'; ' '; 'p'; 'o'; 's'; 'i'; 't'; 'i'; 'o'; 'n'; ' '])
                                    (comp (shows_prec_pos Zero_nat p)
                                      shows_nl)))))))
                  | Some _ ->
                    check (eq_ctxt _A1 _B1 c d)
                      (comp (shows_string
                              ['t'; 'h'; 'e'; ' '; 't'; 'e'; 'r'; 'm'; ' '])
                        (comp (shows_prec_term _A2 _B2 Zero_nat t)
                          (comp (shows_string
                                  [' '; 'd'; 'o'; 'e'; 's'; ' '; 'n'; 'o'; 't';
                                    ' '; 'r'; 'e'; 's'; 'u'; 'l'; 't'; ' '; 'f';
                                    'r'; 'o'; 'm'; ' '; 'a'; ' '; 'p'; 'r'; 'o';
                                    'p'; 'e'; 'r'; ' '; 'a'; 'p'; 'p'; 'l'; 'i';
                                    'c'; 'a'; 't'; 'i'; 'o'; 'n'; ' '; 'o'; 'f';
                                    ' '; 'r'; 'u'; 'l'; 'e'; ' '])
                            (comp shows_nl
                              (comp (shows_rule _A2 _B2 r)
                                (comp (shows_string
[' '; 'a'; 't'; ' '; 'p'; 'o'; 's'; 'i'; 't'; 'i'; 'o'; 'n'; ' '])
                                  (comp (shows_prec_pos Zero_nat p)
                                    shows_nl)))))))))));;

let rec check_rrstep (_A1, _A2) (_B1, _B2)
  ra r s t = check_rstep (_A1, _A2) (_B1, _B2) ra Empty r s t;;

let rec check_steps (_A1, _A2) (_B1, _B2)
  p r x2 s u = match p, r, x2, s, u with
    p, r, [], s, u ->
      check (eq_term _A1 _B1 s u)
        (comp (shows_string
                ['t'; 'h'; 'e'; ' '; 'l'; 'a'; 's'; 't'; ' '; 't'; 'e'; 'r';
                  'm'; ' '; 'o'; 'f'; ' '; 't'; 'h'; 'e'; ' '; 'r'; 'e'; 'w';
                  'r'; 'i'; 't'; 'e'; ' '; 's'; 'e'; 'q'; 'u'; 'e'; 'n'; 'c';
                  'e'])
          (comp shows_nl
            (comp (shows_prec_term _A2 _B2 Zero_nat s)
              (comp (shows_string
                      (shows_nl
                        ['d'; 'o'; 'e'; 's'; ' '; 'n'; 'o'; 't'; ' '; 'c'; 'o';
                          'r'; 'r'; 'e'; 's'; 'p'; 'o'; 'n'; 'd'; ' '; 't'; 'o';
                          ' '; 't'; 'h'; 'e'; ' '; 'g'; 'o'; 'a'; 'l'; ' '; 't';
                          'e'; 'r'; 'm']))
                (comp shows_nl
                  (comp (shows_prec_term _A2 _B2 Zero_nat u) shows_nl))))))
    | p, ra, (uu, (r, (true, t))) :: prts, s, u ->
        bind (check_rrstep (_A1, _A2) (_B1, _B2) p r s t)
          (fun _ -> check_steps (_A1, _A2) (_B1, _B2) p ra prts t u)
    | pa, ra, (p, (r, (false, t))) :: prts, s, u ->
        bind (check_rstep (_A1, _A2) (_B1, _B2) ra p r s t)
          (fun _ -> check_steps (_A1, _A2) (_B1, _B2) pa ra prts t u);;

let rec check_rsteps (_A1, _A2) (_B1, _B2)
  r prts s u =
    check_steps (_A1, _A2) (_B1, _B2) [] r
      (map (fun (p, (ra, t)) -> (p, (ra, (false, t)))) prts) s u;;

let rec check_loop (_A1, _A2) (_B1, _B2)
  s rseq sigma c r =
    bind (check (not (null rseq))
           (shows_prec_list show_char Zero_nat
             ['r'; 'e'; 'w'; 'r'; 'i'; 't'; 'e'; ' '; 's'; 'e'; 'q'; 'u'; 'e';
               'n'; 'c'; 'e'; ' '; 'm'; 'u'; 's'; 't'; ' '; 'b'; 'e'; ' '; 'n';
               'o'; 'n'; '-'; 'e'; 'm'; 'p'; 't'; 'y']))
      (fun _ ->
        check_rsteps (_A1, _A2) (_B1, _B2) r rseq s
          (ctxt_apply c (subst_apply_term s (subst_of _B1 sigma))));;

let rec check_dp_loop (_A1, _A2) (_B1, _B2)
  s prseq sigma c p r =
    (if eq_ctxt _A1 _B1 c Hole
      then bind (check (not (null prseq))
                  (shows_prec_list show_char Zero_nat
                    ['r'; 'e'; 'w'; 'r'; 'i'; 't'; 'e'; ' '; 's'; 'e'; 'q'; 'u';
                      'e'; 'n'; 'c'; 'e'; ' '; 'm'; 'u'; 's'; 't'; ' '; 'b';
                      'e'; ' '; 'n'; 'o'; 'n'; '-'; 'e'; 'm'; 'p'; 't'; 'y']))
             (fun _ ->
               check_steps (_A1, _A2) (_B1, _B2) p r prseq s
                 (subst_apply_term s (subst_of _B1 sigma)))
      else check_loop (_A1, _A2) (_B1, _B2) s
             (map (fun (x, (y, (_, z))) -> (x, (y, z))) prseq) sigma c r);;

let rec check_dp_disproof (_A1, _A2) (_B1, _B2)
  i p r x3 = match i, p, r, x3 with
    i, p, r, DPLoop (s, rseq, sigma, c) ->
      debug (i []) ['L'; 'o'; 'o'; 'p']
        (catch (check_dp_loop (_A1, _A2) (_B1, _B2) s rseq sigma c p r)
          (fun x ->
            Inl (comp i
                  (comp (shows_string
                          [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'i'; 'n';
                            ' '; 'l'; 'o'; 'o'; 'p'; ' '; 'p'; 'r'; 'o'; 'o';
                            'f'])
                    (comp shows_nl x)))))
    | i, pa, ra, DPRuleRemoval (p, r, prf) ->
        debug (i [])
          ['R'; 'u'; 'l'; 'e'; ' '; 'R'; 'e'; 'm'; 'o'; 'v'; 'a'; 'l']
          (bind (catch
                  (check_subseteq (eqc (eq_terma _A1 _B1) (eq_terma _A1 _B1)) p
                    pa)
                  (fun x ->
                    Inl (comp i
                          (comp (shows_string
                                  [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'i';
                                    'n'; ' '; 'r'; 'u'; 'l'; 'e'; '-'; 'r'; 'e';
                                    'm'; 'o'; 'v'; 'a'; 'l'; ' '; 'p'; 'r'; 'o';
                                    'o'; 'f'])
                            (comp shows_nl
                              (comp (shows_rule _A2 _B2 x)
                                (comp (shows_string
[' '; 'i'; 's'; ' '; 'a'; ' '; 'n'; 'e'; 'w'; ' '; 'p'; 'a'; 'i'; 'r'; ' '; 'n';
  'o'; 't'; ' '; 'o'; 'c'; 'c'; 'u'; 'r'; 'r'; 'i'; 'n'; 'g'; ' '; 'i'; 'n';
  ' '; 't'; 'h'; 'e'; ' '; 'p'; 'r'; 'e'; 'v'; 'i'; 'o'; 'u'; 's'; ' '; 's';
  'e'; 't'; ' '; 'o'; 'f'; ' '; 'p'; 'a'; 'i'; 'r'; 's'])
                                  shows_nl)))))))
            (fun _ ->
              bind (catch
                     (check_subseteq (eqc (eq_terma _A1 _B1) (eq_terma _A1 _B1))
                       r ra)
                     (fun x ->
                       Inl (comp i
                             (comp (shows_string
                                     [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' ';
                                       'i'; 'n'; ' '; 'r'; 'u'; 'l'; 'e'; '-';
                                       'r'; 'e'; 'm'; 'o'; 'v'; 'a'; 'l'; ' ';
                                       'p'; 'r'; 'o'; 'o'; 'f'])
                               (comp shows_nl
                                 (comp (shows_rule _A2 _B2 x)
                                   (comp (shows_string
   [' '; 'i'; 's'; ' '; 'a'; ' '; 'n'; 'e'; 'w'; ' '; 'r'; 'u'; 'l'; 'e'; ' ';
     'n'; 'o'; 't'; ' '; 'o'; 'c'; 'c'; 'u'; 'r'; 'r'; 'i'; 'n'; 'g'; ' '; 'i';
     'n'; ' '; 't'; 'h'; 'e'; ' '; 'p'; 'r'; 'e'; 'v'; 'i'; 'o'; 'u'; 's'; ' ';
     'T'; 'R'; 'S'])
                                     shows_nl)))))))
                (fun _ ->
                  check_dp_disproof (_A1, _A2) (_B1, _B2)
                    (comp i (shows_string ['.'; '1'])) p r prf)));;

let rec unary_term
  = function Var x -> true
    | Fun (f, [t]) -> unary_term t
    | Fun (v, []) -> false
    | Fun (v, vb :: vd :: ve) -> false;;

let rec check_unary_signature
  r = catch (catch
              (forallm
                (fun x ->
                  (if let (l, ra) = x in
                      unary_term l && unary_term ra
                    then Inr () else Inl x))
                r)
              (fun x -> Inl (snd x)))
        (fun _ ->
          Inl (shows_string
                ['t'; 'h'; 'e'; ' '; 't'; 'r'; 's'; ' '; 'd'; 'o'; 'e'; 's';
                  ' '; 'n'; 'o'; 't'; ' '; 'h'; 'a'; 'v'; 'e'; ' '; 'a'; ' ';
                  'u'; 'n'; 'a'; 'r'; 'y'; ' '; 's'; 'i'; 'g'; 'n'; 'a'; 't';
                  'u'; 'r'; 'e']));;

let rec check_string_rev (_A1, _A2) (_B1, _B2)
  r rR =
    let rev = map rev_rule r in
    bind (check_unary_signature r)
      (fun _ ->
        bind (catch
               (check_subseteq (eqc (eq_terma _A1 _B1) (eq_terma _A1 _B1)) rev
                 rR)
               (fun x ->
                 Inl (comp (shows_string
                             ['t'; 'h'; 'e'; ' '; 'r'; 'u'; 'l'; 'e'; ' '])
                       (comp (shows_rule _A2 _B2 x)
                         (comp (shows_string
                                 [' '; 'i'; 's'; ' '; 'm'; 'i'; 's'; 's'; 'i';
                                   'n'; 'g'])
                           shows_nl)))))
          (fun _ ->
            catch (check_subseteq (eqc (eq_terma _A1 _B1) (eq_terma _A1 _B1)) rR
                    rev)
              (fun x ->
                Inl (comp (shows_string
                            ['t'; 'h'; 'e'; ' '; 'r'; 'u'; 'l'; 'e'; ' '])
                      (comp (shows_rule _A2 _B2 x)
                        (comp (shows_string
                                [' '; 'i'; 's'; ' '; 'n'; 'o'; 't'; ' '; 'a';
                                  ' '; 'r'; 'e'; 'v'; 'e'; 'r'; 's'; 'e'; 'd';
                                  ' '; 'r'; 'u'; 'l'; 'e'])
                          shows_nl))))));;

let rec check_not_wf_trs _A (_B1, _B2)
  r = check (not (isOK (check_wf_trs _A (_B1, _B2) r)))
        (comp (shows_string
                ['T'; 'h'; 'e'; ' '; 'T'; 'R'; 'S'; ' '; 'i'; 's'; ' '; 'w';
                  'e'; 'l'; 'l'; ' '; 'f'; 'o'; 'r'; 'm'; 'e'; 'd'])
          shows_nl);;

let rec checkTRSDisproof (_A1, _A2) (_B1, _B2)
  i r x2 = match i, r, x2 with
    i, r, Loop (s, rseq, sigma, c) ->
      debug (i []) ['L'; 'o'; 'o'; 'p']
        (catch (check_loop (_A1, _A2) (_B1, _B2) s rseq sigma c r)
          (fun x ->
            Inl (comp i
                  (comp (shows_string
                          [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'i'; 'n';
                            ' '; 'l'; 'o'; 'o'; 'p'; ' '; 'p'; 'r'; 'o'; 'o';
                            'f'])
                    (comp shows_nl x)))))
    | i, r, NotWellFormed ->
        debug (i [])
          ['n'; 'o'; 't'; ' '; 'w'; 'e'; 'l'; 'l'; '-'; 'f'; 'o'; 'r'; 'm'; 'e';
            'd']
          (catch (check_not_wf_trs _A2 (_B1, _B2) r)
            (fun x ->
              Inl (comp i
                    (comp (shows_string
                            [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'i'; 'n';
                              ' '; 'n'; 'o'; 't'; '-'; 'w'; 'e'; 'l'; 'l'; '-';
                              'f'; 'o'; 'r'; 'm'; 'e'; 'd'; ' '; 'p'; 'r'; 'o';
                              'o'; 'f'])
                      (comp shows_nl x)))))
    | i, ra, NTRuleRemoval (r, prf) ->
        debug (i [])
          ['r'; 'u'; 'l'; 'e'; ' '; 'r'; 'e'; 'm'; 'o'; 'v'; 'a'; 'l']
          (bind (catch
                  (check_subseteq (eqc (eq_terma _A1 _B1) (eq_terma _A1 _B1)) r
                    ra)
                  (fun x ->
                    Inl (comp i
                          (comp (shows_string
                                  [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'i';
                                    'n'; ' '; 'r'; 'u'; 'l'; 'e'; '-'; 'r'; 'e';
                                    'm'; 'o'; 'v'; 'a'; 'l'; ' '; 'p'; 'r'; 'o';
                                    'o'; 'f'])
                            (comp shows_nl
                              (comp (shows_rule _A2 _B2 x)
                                (comp (shows_string
[' '; 'i'; 's'; ' '; 'a'; ' '; 'n'; 'e'; 'w'; ' '; 'r'; 'u'; 'l'; 'e'; ' '; 'n';
  'o'; 't'; ' '; 'o'; 'c'; 'c'; 'u'; 'r'; 'r'; 'i'; 'n'; 'g'; ' '; 'i'; 'n';
  ' '; 't'; 'h'; 'e'; ' '; 'p'; 'r'; 'e'; 'v'; 'i'; 'o'; 'u'; 's'; ' '; 'T';
  'R'; 'S'])
                                  shows_nl)))))))
            (fun _ ->
              checkTRSDisproof (_A1, _A2) (_B1, _B2)
                (comp i (shows_string ['.'; '1'])) r prf))
    | i, ra, NTStringReversal (r, prf) ->
        debug (i [])
          ['s'; 't'; 'r'; 'i'; 'n'; 'g'; ' '; 'r'; 'e'; 'v'; 'e'; 'r'; 's'; 'a';
            'l']
          (bind (catch (check_string_rev (_A1, _A2) (_B1, _B2) ra r)
                  (fun x ->
                    Inl (comp i
                          (comp (shows_string
                                  [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'i';
                                    'n'; ' '; 's'; 't'; 'r'; 'i'; 'n'; 'g'; ' ';
                                    'r'; 'e'; 'v'; 'e'; 'r'; 's'; 'a'; 'l'; ' ';
                                    'p'; 'r'; 'o'; 'o'; 'f'])
                            (comp shows_nl x)))))
            (fun _ ->
              checkTRSDisproof (_A1, _A2) (_B1, _B2)
                (comp i (shows_string ['.'; '1'])) r prf))
    | i, r, NTDPTrans (p, prf) ->
        debug (i [])
          ['D'; 'P'; ' '; 't'; 'r'; 'a'; 'n'; 's'; 'f'; 'o'; 'r'; 'm'; 'a'; 't';
            'i'; 'o'; 'n']
          (bind (catch (check_DPs (_A1, _A2) (_B1, _B2) r p)
                  (fun x ->
                    Inl (comp i
                          (comp (shows_string
                                  [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'i';
                                    'n'; ' '; 'D'; 'P'; ' '; 't'; 'r'; 'a'; 'n';
                                    's'; 'f'; 'o'; 'r'; 'm'; 'a'; 't'; 'i'; 'o';
                                    'n'])
                            (comp shows_nl
                              (comp (shows_prec_list show_char Zero_nat
                                      ['p'; 'r'; 'o'; 'b'; 'l'; 'e'; 'm'; 'a';
't'; 'i'; 'c'; ' '; 'r'; 'u'; 'l'; 'e'; ' '])
                                (shows_rule (show_shp _A2) _B2 x)))))))
            (fun _ ->
              check_dp_disproof (eq_shpa _A1, show_shp _A2) (_B1, _B2)
                (comp i (shows_string ['.'; '1'])) p (iD_list r) prf));;

let rec check_rel_seq (_A1, _A2) (_B1, _B2)
  r sa x2 s u b = match r, sa, x2, s, u, b with
    r, sa, [], s, u, true ->
      check (eq_term _A1 _B1 s u)
        (comp (shows_string
                ['t'; 'h'; 'e'; ' '; 'l'; 'a'; 's'; 't'; ' '; 't'; 'e'; 'r';
                  'm'; ' '; 'o'; 'f'; ' '; 't'; 'h'; 'e'; ' '; 'r'; 'e'; 'w';
                  'r'; 'i'; 't'; 'e'; ' '; 's'; 'e'; 'q'; 'u'; 'e'; 'n'; 'c';
                  'e'])
          (comp shows_nl
            (comp (shows_prec_term _A2 _B2 Zero_nat s)
              (comp (shows_string
                      (shows_nl
                        ['d'; 'o'; 'e'; 's'; ' '; 'n'; 'o'; 't'; ' '; 'c'; 'o';
                          'r'; 'r'; 'e'; 's'; 'p'; 'o'; 'n'; 'd'; ' '; 't'; 'o';
                          ' '; 't'; 'h'; 'e'; ' '; 'g'; 'o'; 'a'; 'l'; ' '; 't';
                          'e'; 'r'; 'm']))
                (comp shows_nl
                  (comp (shows_prec_term _A2 _B2 Zero_nat u) shows_nl))))))
    | r, sa, [], s, u, false ->
        Inl (shows_prec_list show_char Zero_nat
              ['d'; 'i'; 'd'; ' '; 'n'; 'o'; 't'; ' '; 'f'; 'i'; 'n'; 'd'; ' ';
                's'; 't'; 'r'; 'i'; 'c'; 't'; ' '; 's'; 't'; 'e'; 'p'; ' '; 'i';
                'n'; ' '; 'r'; 'e'; 'w'; 'r'; 'i'; 't'; 'e'; ' '; 's'; 'e'; 'q';
                'u'; 'e'; 'n'; 'c'; 'e'])
    | ra, sa, (p, (r, (true, t))) :: prts, s, u, b ->
        bind (check_rstep (_A1, _A2) (_B1, _B2) ra p r s t)
          (fun _ -> check_rel_seq (_A1, _A2) (_B1, _B2) ra sa prts t u true)
    | ra, sa, (p, (r, (false, t))) :: prts, s, u, b ->
        bind (check_rstep (_A1, _A2) (_B1, _B2) sa p r s t)
          (fun _ -> check_rel_seq (_A1, _A2) (_B1, _B2) ra sa prts t u b);;

let rec check_rel_loop (_A1, _A2) (_B1, _B2)
  sa rseq sigma c r s =
    check_rel_seq (_A1, _A2) (_B1, _B2) r s rseq sa
      (ctxt_apply c (subst_apply_term sa (subst_of _B1 sigma))) false;;

let rec checkRelTRSDisproof (_A1, _A2) (_B1, _B2)
  i x1 x2 = match i, x1, x2 with
    i, (r, sa), RelLoop (s, rseq, sigma, c) ->
      debug (i []) ['L'; 'o'; 'o'; 'p']
        (catch (check_rel_loop (_A1, _A2) (_B1, _B2) s rseq sigma c r sa)
          (fun x ->
            Inl (comp i
                  (comp (shows_string
                          [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'i'; 'n';
                            ' '; 'l'; 'o'; 'o'; 'p'; ' '; 'p'; 'r'; 'o'; 'o';
                            'f'])
                    (comp shows_nl x)))))
    | i, (r, s), RNotSN prf ->
        checkTRSDisproof (_A1, _A2) (_B1, _B2)
          (comp i (shows_string ['.'; '1'])) r prf
    | i, (r, s), RelNotWellFormed ->
        debug (i [])
          ['n'; 'o'; 't'; ' '; 'w'; 'e'; 'l'; 'l'; '-'; 'f'; 'o'; 'r'; 'm'; 'e';
            'd']
          (catch (check_not_wf_rel_trs _A2 (_B1, _B2) (r, s))
            (fun x ->
              Inl (comp i
                    (comp (shows_string
                            [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'i'; 'n';
                              ' '; 'n'; 'o'; 't'; '-'; 'w'; 'e'; 'l'; 'l'; '-';
                              'f'; 'o'; 'r'; 'm'; 'e'; 'd'; ' '; 'p'; 'r'; 'o';
                              'o'; 'f'])
                      (comp shows_nl x)))))
    | i, (ra, sa), NTRelRuleRemoval (r, s, prf) ->
        debug (i [])
          ['r'; 'u'; 'l'; 'e'; ' '; 'r'; 'e'; 'm'; 'o'; 'v'; 'a'; 'l']
          (bind (catch
                  (bind (check_subseteq
                          (eqc (eq_terma _A1 _B1) (eq_terma _A1 _B1)) r ra)
                    (fun _ ->
                      check_subseteq (eqc (eq_terma _A1 _B1) (eq_terma _A1 _B1))
                        s sa))
                  (fun x ->
                    Inl (comp i
                          (comp (shows_string
                                  [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'i';
                                    'n'; ' '; 'r'; 'u'; 'l'; 'e'; '-'; 'r'; 'e';
                                    'm'; 'o'; 'v'; 'a'; 'l'; ' '; 'p'; 'r'; 'o';
                                    'o'; 'f'])
                            (comp shows_nl
                              (comp (shows_rule _A2 _B2 x)
                                (comp (shows_string
[' '; 'i'; 's'; ' '; 'a'; ' '; 'n'; 'e'; 'w'; ' '; 'r'; 'u'; 'l'; 'e'; ' '])
                                  shows_nl)))))))
            (fun _ ->
              checkRelTRSDisproof (_A1, _A2) (_B1, _B2)
                (comp i (shows_string ['.'; '1'])) (r, s) prf));;

let rec shows_arithFun
  = function
    Arg i -> comp (shows_string ['x'; '_']) (shows_prec_nat Zero_nat (Suc i))
    | Const n -> shows_prec_nat Zero_nat n
    | Sum fs -> shows_list_gen shows_arithFun [] [] [' '; '+'; ' '] [] fs
    | Prod fs -> shows_list_gen shows_arithFun [] [] [' '; '*'; ' '] [] fs
    | Min fs ->
        shows_list_gen shows_arithFun [] ['m'; 'i'; 'n'; '('] [','] [')'] fs
    | Max fs ->
        shows_list_gen shows_arithFun [] ['m'; 'a'; 'x'; '('] [','] [')'] fs;;

let rec shows_prec_arithFun d f = shows_arithFun f;;

let rec shows_sl_inter _A _B
  (SL_Inter (n, fnas)) =
    comp (shows_string
           ['c'; 'a'; 'r'; 'r'; 'i'; 'e'; 'r'; ' '; '{'; '0'; ','; '.'; '.';
             '.'; ','])
      (comp (shows_prec_nat Zero_nat n)
        (comp (shows_string ['}'])
          (comp shows_nl
            (shows_map
              (fun (a, b) ->
                let (f, na) = a in
                (fun aa ->
                  comp (shows_string ['['])
                    (comp (shows_prec_lab _A _B Zero_nat f)
                      (comp (shows_string ['/'])
                        (comp (shows_prec_nat Zero_nat na)
                          (comp (shows_string [']'; ' '; '='; ' '])
                            (comp (shows_prec_arithFun Zero_nat aa)
                              shows_nl))))))
                  b)
              fnas))));;

let rec shows_prec_sl_inter _A _B d sli = shows_sl_inter _A _B sli;;

let rec take_default
  def x1 uu = match def, x1, uu with def, [], uu -> def
    | uv, x :: xs, Zero_nat -> x
    | def, uw :: xs, Suc i -> take_default def xs i;;

let rec eval_arithFun_unbound
  nats x1 = match nats, x1 with nats, Arg i -> take_default Zero_nat nats i
    | nats, Const n -> n
    | nats, Sum [] -> Zero_nat
    | nats, Sum (f :: fs) ->
        plus_nat (eval_arithFun_unbound nats f)
          (eval_arithFun_unbound nats (Sum fs))
    | nats, Prod [] -> one_nat
    | nats, Prod (f :: fs) ->
        times_nat (eval_arithFun_unbound nats f)
          (eval_arithFun_unbound nats (Prod fs))
    | nats, Max [f] -> eval_arithFun_unbound nats f
    | nats, Max (f :: v :: va) ->
        max ord_nat (eval_arithFun_unbound nats f)
          (eval_arithFun_unbound nats (Max (v :: va)))
    | nats, Min [f] -> eval_arithFun_unbound nats f
    | nats, Min (f :: v :: va) ->
        min ord_nat (eval_arithFun_unbound nats f)
          (eval_arithFun_unbound nats (Min (v :: va)));;

let rec eval_arithFun c f nats = mod_nat (eval_arithFun_unbound nats f) c;;

let rec sl_inter_to_inter _A _B
  (SL_Inter (c, ls)) fl cs =
    (match lookup (eqc (eq_laba _A _B) eq_nata) (fl, size_list cs) ls
      with None -> Zero_nat | Some f -> eval_arithFun (Suc c) f cs);;

let rec get_largest_element (SL_Inter (n, uu)) = n;;

let rec create_sem_lab_rel_tt (_A1, _A2) (_B1, _B2) (_C1, _C2)
  sli l rs lrs =
    let c = get_largest_element sli in
    let ca = upt Zero_nat (Suc c) in
    let i = sl_inter_to_inter _A1 _B1 sli in
    catch (check_sem_lab_rel_tt _A2 _B2 _C2
            (check_sl_lab_trs (_A1, _A2) (_B1, _B2) (eq_nata, show_nat)
              (_C1, _C2) i l ca)
            (check_sl_model_lab_trs (_A1, _A2) (_B1, _B2) (eq_nata, show_nat)
              (_C1, _C2) i l ca)
            (fun _ -> false) i l rs lrs)
      (fun x ->
        Inl (comp (shows_prec_sl_inter _A2 _B2 Zero_nat sli)
              (comp shows_nl x)));;

let rec unlab_reltrs_tt (_A1, _A2) (_B1, _B2) (_C1, _C2)
  rs rRS =
    catch (bind (check_subseteq
                  (eqc (eq_terma (eq_laba _A1 _B1) _C1)
                    (eq_terma (eq_laba _A1 _B1) _C1))
                  (map_trsI unlab (fst rs)) (fst rRS))
            (fun _ ->
              check_subseteq
                (eqc (eq_terma (eq_laba _A1 _B1) _C1)
                  (eq_terma (eq_laba _A1 _B1) _C1))
                (map_trsI unlab (snd rs)) (snd rRS)))
      (fun x ->
        Inl (comp (shows_string
                    ['c'; 'a'; 'n'; 'n'; 'o'; 't'; ' '; 'f'; 'i'; 'n'; 'd'; ' ';
                      'u'; 'n'; 'l'; 'a'; 'b'; 'e'; 'l'; 'e'; 'd'; ' '; 'r';
                      'u'; 'l'; 'e'; ' '])
              (comp shows_nl (shows_rule (show_lab _A2 _B2) _C2 x))));;

let rec internal_error
  x = comp (shows_string
             ['i'; 'n'; 't'; 'e'; 'r'; 'n'; 'a'; 'l'; ' '; 'e'; 'r'; 'r'; 'o';
               'r'])
        (comp shows_nl
          (comp (shows_string
                  ['p'; 'l'; 'e'; 'a'; 's'; 'e'; ' '; 'c'; 'o'; 'n'; 't'; 'a';
                    'c'; 't'; ' '; 'o'; 'n'; 'e'; ' '; 'o'; 'f'; ' '; 't'; 'h';
                    'e'; ' '; 'C'; 'e'; 'T'; 'A'; ' '; 'm'; 'e'; 'm'; 'b'; 'e';
                    'r'; 's'])
            (comp shows_nl
              (comp (shows_string
                      ['h'; 't'; 't'; 'p'; ':'; '/'; '/'; 'c'; 'l'; '-'; 'i';
                        'n'; 'f'; 'o'; 'r'; 'm'; 'a'; 't'; 'i'; 'k'; '.'; 'u';
                        'i'; 'b'; 'k'; '.'; 'a'; 'c'; '.'; 'a'; 't'; '/'; 's';
                        'o'; 'f'; 't'; 'w'; 'a'; 'r'; 'e'; '/'; 'c'; 'e'; 't';
                        'a'])
                (comp shows_nl
                  (comp (shows_string
                          ['c'; 'e'; 't'; 'a'; '@'; 'i'; 'n'; 'f'; 'o'; 'r';
                            'm'; 'a'; 't'; 'i'; 'k'; '.'; 'u'; 'i'; 'b'; 'k';
                            '.'; 'a'; 'c'; '.'; 'a'; 't'])
                    shows_nl))))))
        x;;

let rec check_relative_rule_removal (_A1, _A2) (_B1, _B2)
  rp (r, s) (rR, rS) =
    catch (let (_, nSr) = partition (fun foo -> isOK (rp_strict rp foo)) r in
           let (_, nSs) = partition (fun foo -> isOK (rp_strict rp foo)) s in
           bind (rp_valid rp)
             (fun _ ->
               bind (catch (rp_mono rp)
                      (fun x ->
                        Inl (comp (shows_string
                                    ['p'; 'r'; 'o'; 'b'; 'l'; 'e'; 'm'; ' ';
                                      'w'; 'i'; 't'; 'h'; ' '; 'm'; 'o'; 'n';
                                      'o'; 't'; 'o'; 'n'; 'i'; 'c'; 'i'; 't';
                                      'y'; ' '; 'o'; 'f'; ' '; 's'; 't'; 'r';
                                      'i'; 'c'; 't'; ' '; 'o'; 'r'; 'd'; 'e';
                                      'r'])
                              (comp shows_nl x))))
                 (fun _ ->
                   bind (catch
                          (catch (forallm (rp_non_strict rp) nSr)
                            (fun x -> Inl (snd x)))
                          (fun x ->
                            Inl (comp (shows_string
['p'; 'r'; 'o'; 'b'; 'l'; 'e'; 'm'; ' '; 'w'; 'h'; 'e'; 'n'; ' '; 'o'; 'r'; 'i';
  'e'; 'n'; 't'; 'i'; 'n'; 'g'; ' '; 'r'; 'u'; 'l'; 'e'; 's'])
                                  (comp shows_nl x))))
                     (fun _ ->
                       bind (catch
                              (catch (forallm (rp_non_strict rp) nSs)
                                (fun x -> Inl (snd x)))
                              (fun x ->
                                Inl (comp (shows_string
    ['p'; 'r'; 'o'; 'b'; 'l'; 'e'; 'm'; ' '; 'w'; 'h'; 'e'; 'n'; ' '; 'o'; 'r';
      'i'; 'e'; 'n'; 't'; 'i'; 'n'; 'g'; ' '; 'r'; 'u'; 'l'; 'e'; 's'])
                                      (comp shows_nl x))))
                         (fun _ ->
                           bind (catch
                                  (check_subseteq
                                    (eqc (eq_terma _A1 _B1) (eq_terma _A1 _B1))
                                    nSs rS)
                                  (fun x ->
                                    Inl (match rp_strict rp x
  with Inl err -> err | Inr _ -> internal_error)))
                             (fun _ ->
                               catch (check_subseteq
                                       (eqc (eq_terma _A1 _B1)
 (eq_terma _A1 _B1))
                                       nSr rR)
                                 (fun x ->
                                   Inl (match rp_strict rp x with Inl err -> err
 | Inr _ -> internal_error))))))))
      (fun x ->
        Inl (comp (shows_string
                    ['c'; 'o'; 'u'; 'l'; 'd'; ' '; 'n'; 'o'; 't'; ' '; 'a'; 'p';
                      'p'; 'l'; 'y'; ' '; 't'; 'h'; 'e'; ' '; 'r'; 'u'; 'l';
                      'e'; ' '; 'r'; 'e'; 'm'; 'o'; 'v'; 'a'; 'l'; ' '; 'p';
                      'r'; 'o'; 'c'; 'e'; 's'; 's'; 'o'; 'r'; ' '; 'w'; 'i';
                      't'; 'h'; ' '; 't'; 'h'; 'e'; ' '; 'f'; 'o'; 'l'; 'l';
                      'o'; 'w'; 'i'; 'n'; 'g'])
              (comp shows_nl (comp (rp_desc rp) (comp shows_nl x)))));;

let rec create_sem_lab_tt (_A1, _A2) (_B1, _B2) (_C1, _C2)
  sli l r lr =
    let c = get_largest_element sli in
    let ca = upt Zero_nat (Suc c) in
    let i = sl_inter_to_inter _A1 _B1 sli in
    catch (check_sem_lab_tt (_A1, _A2) (_B1, _B2) (_C1, _C2)
            (check_sl_lab_trs (_A1, _A2) (_B1, _B2) (eq_nata, show_nat)
              (_C1, _C2) i l ca)
            (check_sl_model_lab_trs (_A1, _A2) (_B1, _B2) (eq_nata, show_nat)
              (_C1, _C2) i l ca)
            (fun _ -> false) i l r lr)
      (fun x ->
        Inl (comp (shows_prec_sl_inter _A2 _B2 Zero_nat sli)
              (comp shows_nl x)));;

let rec unlab_of_trsI _A _B _C
  r = remdups (eqc (eq_terma (eq_laba _A _B) _C) (eq_terma (eq_laba _A _B) _C))
        (map_trsI unlab
          (filter
            (fun (l, ra) ->
              eq_term (eq_laba _A _B) _C l ra ||
                not (eq_term (eq_laba _A _B) _C (map_term unlab l)
                      (map_term unlab ra)))
            r));;

let rec unlab_trs_tt (_A1, _A2) (_B1, _B2) (_C1, _C2)
  r rR =
    let u = unlab_of_trsI _A1 _B1 _C1 r in
    catch (bind (check_subseteq
                  (eqc (eq_terma (eq_laba _A1 _B1) _C1)
                    (eq_terma (eq_laba _A1 _B1) _C1))
                  rR u)
            (fun _ ->
              check_subseteq
                (eqc (eq_terma (eq_laba _A1 _B1) _C1)
                  (eq_terma (eq_laba _A1 _B1) _C1))
                u rR))
      (fun _ ->
        Inl (comp (shows_rules (show_lab _A2 _B2) _C2 rR)
              (comp shows_nl
                (comp (shows_string
                        [' '; 'd'; 'o'; 'e'; 's'; ' '; 'n'; 'o'; 't'; ' '; 'c';
                          'o'; 'r'; 'r'; 'e'; 's'; 'p'; 'o'; 'n'; 'd'; ' '; 't';
                          'o'; ' '; 'u'; 'n'; 'l'; 'a'; 'b'; 'e'; 'l'; 'e'; 'd';
                          ' '; 'T'; 'R'; 'S'; ' '])
                  (comp shows_nl
                    (comp (shows_rules (show_lab _A2 _B2) _C2 u)
                      shows_nl))))));;

let rec check_rule_removal_proc (_A1, _A2) (_B1, _B2)
  rp r rR =
    catch (let (_, nSr) = partition (fun foo -> isOK (rp_strict rp foo)) r in
           bind (rp_valid rp)
             (fun _ ->
               bind (catch (rp_mono rp)
                      (fun x ->
                        Inl (comp (shows_string
                                    ['p'; 'r'; 'o'; 'b'; 'l'; 'e'; 'm'; ' ';
                                      'w'; 'i'; 't'; 'h'; ' '; 'm'; 'o'; 'n';
                                      'o'; 't'; 'o'; 'n'; 'i'; 'c'; 'i'; 't';
                                      'y'; ' '; 'o'; 'f'; ' '; 's'; 't'; 'r';
                                      'i'; 'c'; 't'; ' '; 'o'; 'r'; 'd'; 'e';
                                      'r'])
                              (comp shows_nl x))))
                 (fun _ ->
                   bind (catch
                          (check_subseteq
                            (eqc (eq_terma _A1 _B1) (eq_terma _A1 _B1)) rR r)
                          (fun x ->
                            Inl (comp (shows_string
['n'; 'o'; 't'; ' '; 'a'; 'l'; 'l'; 'o'; 'w'; 'e'; 'd'; ' '; 't'; 'o'; ' '; 'i';
  'n'; 't'; 'r'; 'o'; 'd'; 'u'; 'c'; 'e'; ' '; 'n'; 'e'; 'w'; ' '; 'r'; 'u';
  'l'; 'e'; ' '])
                                  (comp shows_nl (shows_rule _A2 _B2 x)))))
                     (fun _ ->
                       bind (catch
                              (catch (forallm (rp_non_strict rp) nSr)
                                (fun x -> Inl (snd x)))
                              (fun x ->
                                Inl (comp (shows_string
    ['p'; 'r'; 'o'; 'b'; 'l'; 'e'; 'm'; ' '; 'w'; 'h'; 'e'; 'n'; ' '; 'o'; 'r';
      'i'; 'e'; 'n'; 't'; 'i'; 'n'; 'g'; ' '; 'r'; 'u'; 'l'; 'e'; 's'])
                                      (comp shows_nl x))))
                         (fun _ ->
                           catch (check_subseteq
                                   (eqc (eq_terma _A1 _B1) (eq_terma _A1 _B1))
                                   nSr rR)
                             (fun x ->
                               Inl (match rp_strict rp x with Inl err -> err
                                     | Inr _ -> internal_error)))))))
      (fun x ->
        Inl (comp (shows_string
                    ['c'; 'o'; 'u'; 'l'; 'd'; ' '; 'n'; 'o'; 't'; ' '; 'a'; 'p';
                      'p'; 'l'; 'y'; ' '; 't'; 'h'; 'e'; ' '; 'r'; 'u'; 'l';
                      'e'; ' '; 'r'; 'e'; 'm'; 'o'; 'v'; 'a'; 'l'; ' '; 'p';
                      'r'; 'o'; 'c'; 'e'; 's'; 's'; 'o'; 'r'; ' '; 'w'; 'i';
                      't'; 'h'; ' '; 't'; 'h'; 'e'; ' '; 'f'; 'o'; 'l'; 'l';
                      'o'; 'w'; 'i'; 'n'; 'g'])
              (comp shows_nl (comp (rp_desc rp) (comp shows_nl x)))));;

let rec computeRuleMapH _A
  = function [] -> Some []
    | (Fun (f, ts), r) :: rules ->
        let n = size_list ts in
        (match computeRuleMapH _A rules with None -> None
          | Some rm ->
            (match extract (fun (fa, _) -> eqb _A eq_nata fa (f, n)) rm
              with None -> Some (((f, n), [(Fun (f, ts), r)]) :: rm)
              | Some (bef, ((fa, rls), aft)) ->
                Some ((fa, (Fun (f, ts), r) :: rls) :: append bef aft)))
    | (Var uu, uv) :: rules -> None;;

let rec computeRuleMap _A
  rls = (match computeRuleMapH _A rls with None -> None
          | Some rm ->
            Some (fun f ->
                   (match lookup (eqc _A eq_nata) f rm with None -> []
                     | Some rlsa -> rlsa)));;

let rec init_lab f = UnLab f;;

let rec check_no_defined_root _A _B
  rm t =
    check (null (rm (the (root t), num_args t)))
      (comp (shows_string
              ['t'; 'h'; 'e'; ' '; 'r'; 'o'; 'o'; 't'; ' '; 'o'; 'f'; ' '])
        (comp (shows_prec_term _A _B Zero_nat t)
          (shows_string
            [' '; 'i'; 's'; ' '; 'd'; 'e'; 'f'; 'i'; 'n'; 'e'; 'd'])));;

let rec matchCapRMBelow _A _B
  l rm (Fun (f, ts)) = gcMatchI _A _B (HFun (f, map (capRM _A _B rm) ts)) l;;

let rec forallm_index_aux
  p i x2 = match p, i, x2 with p, i, [] -> Inr ()
    | p, i, x :: xs ->
        bind (catch (p x i) (fun xa -> Inl ((x, i), xa)))
          (fun _ -> forallm_index_aux p (Suc i) xs);;

let rec forallm_index p xs = forallm_index_aux p Zero_nat xs;;

let rec check_ur_closed_term_rm_af (_A1, _A2) (_B1, _B2)
  uu uv uw x3 = match uu, uv, uw, x3 with uu, uv, uw, Var x -> Inr ()
    | rm, ur, pi, Fun (f, ts) ->
        let n = size_list ts in
        bind (catch
               (forallm_index
                 (fun t i ->
                   (if pi f n i
                     then check_ur_closed_term_rm_af (_A1, _A2) (_B1, _B2) rm ur
                            pi t
                     else Inr ()))
                 ts)
               (fun x -> Inl (snd x)))
          (fun _ ->
            catch (forallm
                    (fun lr ->
                      check (member (eqc (eq_terma _A1 _B1) (eq_terma _A1 _B1))
                               ur lr ||
                              not (matchCapRMBelow _A1 _B1 (fst lr) (Some rm)
                                    (Fun (f, ts))))
                        (comp (shows_string
                                ['d'; 'u'; 'e'; ' '; 't'; 'o'; ' '; 't'; 'h';
                                  'e'; ' '; 's'; 'u'; 'b'; 't'; 'e'; 'r'; 'm';
                                  ' '])
                          (comp (shows_prec_term _A2 _B2 Zero_nat (Fun (f, ts)))
                            (comp (shows_string
                                    [' '; 'o'; 'f'; ' '; 's'; 'o'; 'm'; 'e';
                                      ' '; 'u'; 's'; 'a'; 'b'; 'l'; 'e'; ' ';
                                      'r'; 'h'; 's'; ','; ' '; 'r'; 'u'; 'l';
                                      'e'; ' '])
                              (comp (shows_rule _A2 _B2 lr)
                                (shows_string
                                  [' '; 's'; 'h'; 'o'; 'u'; 'l'; 'd'; ' '; 'b';
                                    'e'; ' '; 'u'; 's'; 'a'; 'b'; 'l'; 'e';
                                    '.']))))))
                    (rm (f, n)))
              (fun x -> Inl (snd x)));;

let rec check_sct_ur_af_proc (_A1, _A2) (_B1, _B2)
  rp p gs rm rrm ur =
    (match rm with None -> Inr ()
      | Some irm ->
        catch (let ggs =
                 filter
                   (fun g ->
                     member (eqc (eq_terma _A1 _B1) (eq_terma _A1 _B1)) p
                       (fst g))
                   gs
                 in
               let pi = rp_af rp in
               bind (rp_valid rp)
                 (fun _ ->
                   bind (catch
                          (catch
                            (forallm
                              (fun lr ->
                                check_ur_closed_term_rm_af (_A1, _A2) (_B1, _B2)
                                  irm ur pi (snd lr))
                              ur)
                            (fun x -> Inl (snd x)))
                          (fun x ->
                            Inl (comp (shows_string
['e'; 'r'; 'r'; 'o'; 'r'; ' '; 'w'; 'h'; 'e'; 'n'; ' '; 'c'; 'h'; 'e'; 'c'; 'k';
  'i'; 'n'; 'g'; ' '; 'c'; 'l'; 'o'; 's'; 'u'; 'r'; 'e'; ' '; 'p'; 'r'; 'o';
  'p'; 'e'; 'r'; 't'; 'i'; 'e'; 's'; ' '; 'o'; 'f'; ' '; 'r'; 'h'; 's'; ' ';
  'o'; 'f'; ' '; 'u'; 's'; 'a'; 'b'; 'l'; 'e'; ' '; 'r'; 'u'; 'l'; 'e'; 's'])
                                  (comp shows_nl x))))
                     (fun _ ->
                       bind (catch
                              (check_subseteq
                                (eqc (eq_terma _A1 _B1) (eq_terma _A1 _B1)) p
                                (map fst ggs))
                              (fun x ->
                                Inl (comp (shows_string
    ['t'; 'h'; 'e'; 'r'; 'e'; ' '; 'i'; 's'; ' '; 'n'; 'o'; ' '; 's'; 'i'; 'z';
      'e'; '-'; 'c'; 'h'; 'a'; 'n'; 'g'; 'e'; ' '; 'g'; 'r'; 'a'; 'p'; 'h'; ' ';
      'f'; 'o'; 'r'; ' '; 'D'; 'P'; ' '])
                                      (shows_rule _A2 _B2 x))))
                         (fun _ ->
                           bind (catch
                                  (forallm
                                    (fun (a, b) ->
                                      let (s, t) = a in
                                      (fun (stri, nstri) ->
catch (bind (check_no_var _A2 _B2 s)
        (fun _ ->
          bind (check_no_var _A2 _B2 t)
            (fun _ ->
              bind (check_no_defined_root _A2 _B2 irm t)
                (fun _ ->
                  let m = num_args t in
                  let n = num_args s in
                  bind (catch
                         (forallm
                           (fun i ->
                             check (less_eq_nat i n)
                               (comp (shows_string
                                       ['l'; 'e'; 'f'; 't'; '-'; 'i'; 'n'; 'd';
 'e'; 'x'; ' '; 't'; 'o'; ' '; 'l'; 'a'; 'r'; 'g'; 'e'])
                                 (comp (shows_prec_nat Zero_nat i) shows_nl)))
                           (remdups eq_nata (map fst (append stri nstri))))
                         (fun x -> Inl (snd x)))
                    (fun _ ->
                      bind (catch
                             (forallm
                               (fun j ->
                                 check (less_eq_nat j m &&
 isOK (check_ur_closed_term_rm_af (_A1, _A2) (_B1, _B2) irm ur pi
        (get_arg t j)))
                                   (comp (shows_string
   ['r'; 'i'; 'g'; 'h'; 't'; '-'; 'i'; 'n'; 'd'; 'e'; 'x'; ' '; 't'; 'o'; ' ';
     'l'; 'a'; 'r'; 'g'; 'e'; ' '; 'o'; 'r'; ' '; 'a'; 'r'; 'g'; 'u'; 'm'; 'e';
     'n'; 't'; ' '; 'v'; 'i'; 'o'; 'l'; 'a'; 't'; 'e'; 's'; ' '; 'u'; 's'; 'a';
     'b'; 'l'; 'e'; '-'; 'r'; 'u'; 'l'; 'e'; 's'; ' '; 'c'; 'o'; 'n'; 'd'; 'i';
     't'; 'i'; 'o'; 'n'])
                                     (shows_prec_nat Zero_nat j)))
                               (remdups eq_nata (map snd (append stri nstri))))
                             (fun x -> Inl (snd x)))
                        (fun _ ->
                          let _ = args s in
                          let _ = args t in
                          bind (catch
                                 (forallm
                                   (fun (i, j) ->
                                     check (isOK
     (rp_strict rp (get_arg s i, get_arg t j)))
                                       (comp
 (shows_string
   ['p'; 'r'; 'o'; 'b'; 'l'; 'e'; 'm'; ' '; 'w'; 'i'; 't'; 'h'; ' '; 'e'; 'd';
     'g'; 'e'; ' '])
 (comp (shows_prec_nat Zero_nat i)
   (comp (shows_string [' '; '-'; 'S'; '-'; '>'; ' '])
     (shows_prec_nat Zero_nat j)))))
                                   stri)
                                 (fun x -> Inl (snd x)))
                            (fun _ ->
                              catch (forallm
                                      (fun (i, j) ->
check (isOK (rp_non_strict rp (get_arg s i, get_arg t j)))
  (comp (shows_string
          ['p'; 'r'; 'o'; 'b'; 'l'; 'e'; 'm'; ' '; 'w'; 'i'; 't'; 'h'; ' '; 'e';
            'd'; 'g'; 'e'; ' '])
    (comp (shows_prec_nat Zero_nat i)
      (comp (shows_string [' '; '-'; 'N'; 'S'; '-'; '>'; ' '])
        (shows_prec_nat Zero_nat j)))))
                                      nstri)
                                (fun x -> Inl (snd x)))))))))
  (fun x ->
    Inl (comp (shows_string
                ['p'; 'r'; 'o'; 'b'; 'l'; 'e'; 'm'; 's'; ' '; 'w'; 'i'; 't';
                  'h'; ' '; 'D'; 'P'; ' '])
          (comp (shows_rule _A2 _B2 (s, t)) (comp shows_nl x)))))
b)
                                    ggs)
                                  (fun x -> Inl (snd x)))
                             (fun _ ->
                               bind (catch
                                      (catch (forallm (rp_non_strict rp) ur)
(fun x -> Inl (snd x)))
                                      (fun x ->
Inl (comp (shows_string
            ['p'; 'r'; 'o'; 'b'; 'l'; 'e'; 'm'; ' '; 'w'; 'h'; 'e'; 'n'; ' ';
              'o'; 'r'; 'i'; 'e'; 'n'; 't'; 'i'; 'n'; 'g'; ' '; 'u'; 's'; 'a';
              'b'; 'l'; 'e'; ' '; 'r'; 'u'; 'l'; 'e'; 's'])
      (comp shows_nl x))))
                                 (fun _ ->
                                   check (check_SCT
   (eqc (eq_terma _A1 _B1)
     (eqc (eq_terma _A1 _B1) (eqc (eq_hterm _A1) (eq_hterm _A1))))
   eq_nata
   (fun (_, (t, (_, ct))) (u, (_, (cu, _))) ->
     gcMatchI _A1 _B1 ct u && gcMatchI _A1 _B1 cu t)
   (map (fun (a, b) ->
          let (s, t) = a in
          (fun (stri, nstri) ->
            let e = (s, (t, (capRM _A1 _B1 rrm s, capRM _A1 _B1 rm t))) in
            Scg (e, e, stri, nstri))
            b)
     ggs))
                                     (comp (shows_string
     ['s'; 'i'; 'z'; 'e'; '-'; 'c'; 'h'; 'a'; 'n'; 'g'; 'e'; ' '; 'a'; 'n'; 'a';
       'l'; 'y'; 's'; 'i'; 's'; ' '; 'f'; 'a'; 'i'; 'l'; 'e'; 'd'])
                                       shows_nl)))))))
          (fun x ->
            Inl (comp (shows_string
                        ['c'; 'o'; 'u'; 'l'; 'd'; ' '; 'n'; 'o'; 't'; ' '; 'a';
                          'p'; 'p'; 'l'; 'y'; ' '; 't'; 'h'; 'e'; ' '; 's'; 'i';
                          'z'; 'e'; '-'; 'c'; 'h'; 'a'; 'n'; 'g'; 'e'; ' '; 'p';
                          'r'; 'o'; 'c'; 'e'; 's'; 's'; 'o'; 'r'; ' '; 'w'; 'i';
                          't'; 'h'; ' '; 't'; 'h'; 'e'; ' '; 'f'; 'o'; 'l'; 'l';
                          'o'; 'w'; 'i'; 'n'; 'g'; ' '])
                  (comp shows_nl
                    (comp (rp_desc rp)
                      (comp shows_nl
                        (comp (shows_string
                                ['f'; 'o'; 'r'; ' '; 't'; 'h'; 'e'; ' '; 'f';
                                  'o'; 'l'; 'l'; 'o'; 'w'; 'i'; 'n'; 'g'; ' ';
                                  'r'; 'e'; 'a'; 's'; 'o'; 'n'])
                          (comp shows_nl x))))))));;

let rec check_supteq (_A1, _A2) (_B1, _B2)
  s t = check (supteqp _A1 _B1 s t)
          (comp (shows_prec_term _A2 _B2 Zero_nat t)
            (comp (shows_string
                    [' '; 'i'; 's'; ' '; 'n'; 'o'; 't'; ' '; 'a'; ' '; 's'; 'u';
                      'b'; 't'; 'e'; 'r'; 'm'; ' '; 'o'; 'f'; ' '])
              (shows_prec_term _A2 _B2 Zero_nat s)));;

let rec check_supt (_A1, _A2) (_B1, _B2)
  s t = check (suptp _A1 _B1 s t)
          (comp (shows_prec_term _A2 _B2 Zero_nat t)
            (comp (shows_string
                    [' '; 'i'; 's'; ' '; 'n'; 'o'; 't'; ' '; 'a'; ' '; 'p'; 'r';
                      'o'; 'p'; 'e'; 'r'; ' '; 's'; 'u'; 'b'; 't'; 'e'; 'r';
                      'm'; ' '; 'o'; 'f'; ' '])
              (shows_prec_term _A2 _B2 Zero_nat s)));;

let rec check_sct_subterm_proc (_A1, _A2) (_B1, _B2)
  p gs rm rrm =
    (match rm with None -> Inr ()
      | Some irm ->
        catch (bind (catch
                      (check_subseteq
                        (eqc (eq_terma _A1 _B1) (eq_terma _A1 _B1)) p
                        (map fst gs))
                      (fun x ->
                        Inl (comp (shows_string
                                    ['t'; 'h'; 'e'; 'r'; 'e'; ' '; 'i'; 's';
                                      ' '; 'n'; 'o'; ' '; 's'; 'i'; 'z'; 'e';
                                      '-'; 'c'; 'h'; 'a'; 'n'; 'g'; 'e'; ' ';
                                      'g'; 'r'; 'a'; 'p'; 'h'; ' '; 'f'; 'o';
                                      'r'; ' '; 'D'; 'P'; ' '])
                              (comp (shows_rule _A2 _B2 x) shows_nl))))
                (fun _ ->
                  bind (catch
                         (forallm
                           (fun (a, b) ->
                             let (s, t) = a in
                             (fun (stri, nstri) ->
                               catch (bind (check_no_var _A2 _B2 s)
                                       (fun _ ->
 bind (check_no_var _A2 _B2 t)
   (fun _ ->
     bind (check_no_defined_root _A2 _B2 irm t)
       (fun _ ->
         let m = num_args t in
         let n = num_args s in
         bind (catch
                (forallm
                  (fun (i, j) ->
                    check (less_eq_nat i n &&
                            (less_eq_nat j m &&
                              isOK (check_supt (_A1, _A2) (_B1, _B2)
                                     (get_arg s i) (get_arg t j))))
                      (comp (shows_string
                              ['p'; 'r'; 'o'; 'b'; 'l'; 'e'; 'm'; ' '; 'w'; 'i';
                                't'; 'h'; ' '; 'e'; 'd'; 'g'; 'e'; ' '])
                        (comp (shows_prec_nat Zero_nat i)
                          (comp (shows_string [' '; '|'; '>'; ' '])
                            (comp (shows_prec_nat Zero_nat j) shows_nl)))))
                  stri)
                (fun x -> Inl (snd x)))
           (fun _ ->
             catch (forallm
                     (fun (i, j) ->
                       check (less_eq_nat i n &&
                               (less_eq_nat j m &&
                                 isOK (check_supteq (_A1, _A2) (_B1, _B2)
(get_arg s i) (get_arg t j))))
                         (comp (shows_string
                                 ['p'; 'r'; 'o'; 'b'; 'l'; 'e'; 'm'; ' '; 'w';
                                   'i'; 't'; 'h'; ' '; 'e'; 'd'; 'g'; 'e'; ' '])
                           (comp (shows_prec_nat Zero_nat i)
                             (comp (shows_string [' '; '|'; '>'; '='; ' '])
                               (comp (shows_prec_nat Zero_nat j) shows_nl)))))
                     nstri)
               (fun x -> Inl (snd x)))))))
                                 (fun x ->
                                   Inl (comp
 (shows_string
   ['p'; 'r'; 'o'; 'b'; 'l'; 'e'; 'm'; 's'; ' '; 'w'; 'i'; 't'; 'h'; ' '; 'D';
     'P'; ' '])
 (comp (shows_rule _A2 _B2 (s, t)) (comp shows_nl x)))))
                               b)
                           gs)
                         (fun x -> Inl (snd x)))
                    (fun _ ->
                      check (check_SCT
                              (eqc (eq_terma _A1 _B1)
                                (eqc (eq_terma _A1 _B1)
                                  (eqc (eq_hterm _A1) (eq_hterm _A1))))
                              eq_nata
                              (fun (_, (t, (_, ct))) (u, (_, (cu, _))) ->
                                gcMatchI _A1 _B1 ct u && gcMatchI _A1 _B1 cu t)
                              (map (fun (a, b) ->
                                     let (s, t) = a in
                                     (fun (stri, nstri) ->
                                       let e =
 (s, (t, (capRM _A1 _B1 rrm s, capRM _A1 _B1 rm t))) in
                                       Scg (e, e, stri, nstri))
                                       b)
                                gs))
                        (comp (shows_string
                                ['s'; 'i'; 'z'; 'e'; '-'; 'c'; 'h'; 'a'; 'n';
                                  'g'; 'e'; ' '; 'a'; 'n'; 'a'; 'l'; 'y'; 's';
                                  'i'; 's'; ' '; 'f'; 'a'; 'i'; 'l'; 'e'; 'd'])
                          shows_nl))))
          (fun x ->
            Inl (comp (shows_string
                        ['c'; 'o'; 'u'; 'l'; 'd'; ' '; 'n'; 'o'; 't'; ' '; 'a';
                          'p'; 'p'; 'l'; 'y'; ' '; 't'; 'h'; 'e'; ' '; 's'; 'i';
                          'z'; 'e'; '-'; 'c'; 'h'; 'a'; 'n'; 'g'; 'e'; ' '; 'p';
                          'r'; 'o'; 'c'; 'e'; 's'; 's'; 'o'; 'r'; ' '; 'w'; 'i';
                          't'; 'h'; ' '; 's'; 'u'; 'b'; 't'; 'e'; 'r'; 'm'; '-';
                          'r'; 'e'; 'l'; 'a'; 't'; 'i'; 'o'; 'n'; ' '; 'f'; 'o';
                          'r'; ' '; 't'; 'h'; 'e'; ' '; 'f'; 'o'; 'l'; 'l'; 'o';
                          'w'; 'i'; 'n'; 'g'; ' '; 'r'; 'e'; 'a'; 's'; 'o';
                          'n'])
                  (comp shows_nl x))));;

let rec check_weak (_A1, _A2) (_B1, _B2)
  p r = catch (check
                (eq_term _A1 _B1 (proj_term p (fst r)) (proj_term p (snd r)))
                (comp (shows_string
                        ['t'; 'h'; 'e'; ' '; 'p'; 'r'; 'o'; 'j'; 'e'; 'c'; 't';
                          'e'; 'd'; ' '; 'l'; 'h'; 's'; ' '; 'i'; 's'; ' '; 'n';
                          'o'; 't'; ' '; 'e'; 'q'; 'u'; 'a'; 'l'; ' '; 't'; 'o';
                          ' '; 't'; 'h'; 'e'; ' '; 'p'; 'r'; 'o'; 'j'; 'e'; 'c';
                          't'; 'e'; 'd'; ' '; 'r'; 'h'; 's'])
                  shows_nl))
          (fun x ->
            Inl (comp (shows_string
                        ['C'; 'o'; 'u'; 'l'; 'd'; ' '; 'n'; 'o'; 't'; ' '; 'o';
                          'r'; 'i'; 'e'; 'n'; 't'; ' '; 'r'; 'u'; 'l'; 'e';
                          ' '])
                  (comp (shows_rule _A2 _B2 r)
                    (comp (shows_string [','; ' '; 's'; 'i'; 'n'; 'c'; 'e'])
                      (comp shows_nl
                        (comp (shows_prec_term _A2 _B2 Zero_nat
                                (proj_term p (fst r)))
                          (comp (shows_string [' '; '!'; '='; ' '])
                            (comp (shows_prec_term _A2 _B2 Zero_nat
                                    (proj_term p (snd r)))
                              (comp shows_nl x)))))))));;

let rec check_strict (_A1, _A2) (_B1, _B2)
  ra rseqm p r =
    let s = proj_term p (fst r) in
    let t = proj_term p (snd r) in
    (match rseqm r with None -> check_supt (_A1, _A2) (_B1, _B2) s t
      | Some rseq ->
        (if eq_nat (size_list rseq) Zero_nat
          then check_supt (_A1, _A2) (_B1, _B2) s t
          else let u = snd (snd (last rseq)) in
               bind (check_rsteps (_A1, _A2) (_B1, _B2) ra rseq s u)
                 (fun _ -> check_supteq (_A1, _A2) (_B1, _B2) u t)));;

let rec check_subterm_criterion_proc (_A1, _A2) (_B1, _B2)
  pb rseqm pa p r x5 = match pb, rseqm, pa, p, r, x5 with
    pb, rseqm, pa, p, r, None -> Inr ()
    | pb, rseqm, pa, p, r, Some rm ->
        bind (catch
               (forallm
                 (fun (l, ra) ->
                   bind (check_no_var _A2 _B2 l)
                     (fun _ ->
                       bind (check_no_var _A2 _B2 ra)
                         (fun _ -> check_no_defined_root _A2 _B2 rm ra)))
                 pa)
               (fun x -> Inl (snd x)))
          (fun _ ->
            bind (catch
                   (forallm (check_strict (_A1, _A2) (_B1, _B2) r rseqm pb)
                     (list_diff (eqc (eq_terma _A1 _B1) (eq_terma _A1 _B1)) pa
                       p))
                   (fun x -> Inl (snd x)))
              (fun _ ->
                catch (forallm (check_weak (_A1, _A2) (_B1, _B2) pb) p)
                  (fun x -> Inl (snd x))));;

let rec create_rseq_map _A _B
  rseqs r = lookup (eqc (eq_terma _A _B) (eq_terma _A _B)) r rseqs;;

let rec create_subterm_criterion_proc (_A1, _A2) (_B1, _B2)
  pa rseqs p rP r rm =
    let pi = create_proj _A1 pa in
    let rseqm = create_rseq_map _A1 _B1 rseqs in
    check_subterm_criterion_proc (_A1, _A2) (_B1, _B2) pi rseqm p rP r rm;;

let rec create_sem_lab_proc (_A1, _A2) (_B1, _B2) (_C1, _C2)
  sli l r1 r2 r3 r4 =
    let c = get_largest_element sli in
    let ca = upt Zero_nat (Suc c) in
    let i = sl_inter_to_inter _A1 _B1 sli in
    catch (check_sem_lab_proc (_A1, _A2) (_B1, _B2) (_C1, _C2)
            (check_sl_lab_trs (_A1, _A2) (_B1, _B2) (eq_nata, show_nat)
              (_C1, _C2) i l ca)
            (check_sl_model_lab_trs (_A1, _A2) (_B1, _B2) (eq_nata, show_nat)
              (_C1, _C2) i l ca)
            (fun _ -> false) i l r1 r2 r3 r4)
      (fun x ->
        Inl (comp (shows_prec_sl_inter _A2 _B2 Zero_nat sli)
              (comp shows_nl x)));;

let rec check_unlab_proc (_A1, _A2) (_B1, _B2) (_C1, _C2)
  p r ulP ulR =
    catch (let ulr = unlab_of_trsI _A1 _B1 _C1 r in
           bind (check_subseteq
                  (eqc (eq_terma (eq_laba _A1 _B1) _C1)
                    (eq_terma (eq_laba _A1 _B1) _C1))
                  (map_trsI unlab p) ulP)
             (fun _ ->
               bind (check_subseteq
                      (eqc (eq_terma (eq_laba _A1 _B1) _C1)
                        (eq_terma (eq_laba _A1 _B1) _C1))
                      ulr ulR)
                 (fun _ ->
                   check_subseteq
                     (eqc (eq_terma (eq_laba _A1 _B1) _C1)
                       (eq_terma (eq_laba _A1 _B1) _C1))
                     ulR ulr)))
      (fun x ->
        Inl (comp (shows_string
                    ['p'; 'r'; 'o'; 'b'; 'l'; 'e'; 'm'; ' '; 'w'; 'i'; 't'; 'h';
                      ' '; 'r'; 'u'; 'l'; 'e'; ' '])
              (comp (shows_rule (show_lab _A2 _B2) _C2 x) shows_nl)));;

let rec matchCapBelowI _A _B
  l r (Fun (f, ts)) = gcMatchI _A _B (HFun (f, map (capI _A _B r) ts)) l;;

let rec check_ur_closed_term_af (_A1, _A2) (_B1, _B2)
  uu uv uw x3 = match uu, uv, uw, x3 with uu, uv, uw, Var x -> Inr ()
    | r, ur, pi, Fun (f, ts) ->
        let n = size_list ts in
        bind (catch
               (forallm_index
                 (fun t i ->
                   (if pi f n i
                     then check_ur_closed_term_af (_A1, _A2) (_B1, _B2) r ur pi
                            t
                     else Inr ()))
                 ts)
               (fun x -> Inl (snd x)))
          (fun _ ->
            catch (forallm
                    (fun lr ->
                      check (member (eqc (eq_terma _A1 _B1) (eq_terma _A1 _B1))
                               ur lr ||
                              not (matchCapBelowI _A1 _B1 (fst lr) r
                                    (Fun (f, ts))))
                        (comp (shows_string
                                ['d'; 'u'; 'e'; ' '; 't'; 'o'; ' '; 't'; 'h';
                                  'e'; ' '; 's'; 'u'; 'b'; 't'; 'e'; 'r'; 'm';
                                  ' '])
                          (comp (shows_prec_term _A2 _B2 Zero_nat (Fun (f, ts)))
                            (comp (shows_string
                                    [' '; 'o'; 'f'; ' '; 's'; 'o'; 'm'; 'e';
                                      ' '; 'u'; 's'; 'a'; 'b'; 'l'; 'e'; ' ';
                                      'r'; 'h'; 's'; ','; ' '; 'r'; 'u'; 'l';
                                      'e'; ' '])
                              (comp (shows_rule _A2 _B2 lr)
                                (shows_string
                                  [' '; 's'; 'h'; 'o'; 'u'; 'l'; 'd'; ' '; 'b';
                                    'e'; ' '; 'u'; 's'; 'a'; 'b'; 'l'; 'e';
                                    '.']))))))
                    r)
              (fun x -> Inl (snd x)));;

let rec check_ur_P_closed_af (_A1, _A2) (_B1, _B2)
  r ur p pi =
    bind (catch
           (catch
             (forallm
               (fun lr ->
                 check_ur_closed_term_af (_A1, _A2) (_B1, _B2) r ur pi (snd lr))
               ur)
             (fun x -> Inl (snd x)))
           (fun x ->
             Inl (comp (shows_string
                         ['e'; 'r'; 'r'; 'o'; 'r'; ' '; 'w'; 'h'; 'e'; 'n'; ' ';
                           'c'; 'h'; 'e'; 'c'; 'k'; 'i'; 'n'; 'g'; ' '; 'c';
                           'l'; 'o'; 's'; 'u'; 'r'; 'e'; ' '; 'p'; 'r'; 'o';
                           'p'; 'e'; 'r'; 't'; 'i'; 'e'; 's'; ' '; 'o'; 'f';
                           ' '; 'r'; 'h'; 's'; ' '; 'o'; 'f'; ' '; 'u'; 's';
                           'a'; 'b'; 'l'; 'e'; ' '; 'r'; 'u'; 'l'; 'e'; 's'])
                   (comp shows_nl x))))
      (fun _ ->
        catch (catch
                (forallm
                  (fun st ->
                    check_ur_closed_term_af (_A1, _A2) (_B1, _B2) r ur pi
                      (snd st))
                  p)
                (fun x -> Inl (snd x)))
          (fun x ->
            Inl (comp (shows_string
                        ['e'; 'r'; 'r'; 'o'; 'r'; ' '; 'w'; 'h'; 'e'; 'n'; ' ';
                          'c'; 'h'; 'e'; 'c'; 'k'; 'i'; 'n'; 'g'; ' '; 'c'; 'l';
                          'o'; 's'; 'u'; 'r'; 'e'; ' '; 'p'; 'r'; 'o'; 'p'; 'e';
                          'r'; 't'; 'i'; 'e'; 's'; ' '; 'o'; 'f'; ' '; 'r'; 'h';
                          's'; ' '; 'o'; 'f'; ' '; 'D'; 'P'; 's'])
                  (comp shows_nl x))));;

let rec check_ur_P_closed_rm_af (_A1, _A2) (_B1, _B2)
  r rmo ur p pi =
    (match rmo with None -> check_ur_P_closed_af (_A1, _A2) (_B1, _B2) r ur p pi
      | Some rm ->
        bind (catch
               (catch
                 (forallm
                   (fun lr ->
                     check_ur_closed_term_rm_af (_A1, _A2) (_B1, _B2) rm ur pi
                       (snd lr))
                   ur)
                 (fun x -> Inl (snd x)))
               (fun x ->
                 Inl (comp (shows_string
                             ['e'; 'r'; 'r'; 'o'; 'r'; ' '; 'w'; 'h'; 'e'; 'n';
                               ' '; 'c'; 'h'; 'e'; 'c'; 'k'; 'i'; 'n'; 'g'; ' ';
                               'c'; 'l'; 'o'; 's'; 'u'; 'r'; 'e'; ' '; 'p'; 'r';
                               'o'; 'p'; 'e'; 'r'; 't'; 'i'; 'e'; 's'; ' '; 'o';
                               'f'; ' '; 'r'; 'h'; 's'; ' '; 'o'; 'f'; ' '; 'u';
                               's'; 'a'; 'b'; 'l'; 'e'; ' '; 'r'; 'u'; 'l'; 'e';
                               's'])
                       (comp shows_nl x))))
          (fun _ ->
            catch (catch
                    (forallm
                      (fun st ->
                        check_ur_closed_term_rm_af (_A1, _A2) (_B1, _B2) rm ur
                          pi (snd st))
                      p)
                    (fun x -> Inl (snd x)))
              (fun x ->
                Inl (comp (shows_string
                            ['e'; 'r'; 'r'; 'o'; 'r'; ' '; 'w'; 'h'; 'e'; 'n';
                              ' '; 'c'; 'h'; 'e'; 'c'; 'k'; 'i'; 'n'; 'g'; ' ';
                              'c'; 'l'; 'o'; 's'; 'u'; 'r'; 'e'; ' '; 'p'; 'r';
                              'o'; 'p'; 'e'; 'r'; 't'; 'i'; 'e'; 's'; ' '; 'o';
                              'f'; ' '; 'r'; 'h'; 's'; ' '; 'o'; 'f'; ' '; 'D';
                              'P'; 's'])
                      (comp shows_nl x)))));;

let rec check_mono_redpair_ur_proc (_A1, _A2) (_B1, _B2)
  rp p rP r rm rR ur =
    catch (let us = concat_map (comp (funas_term_list _A1) snd) (append p ur) in
           let filt = filter (fun lr -> wf_terms_list _A1 us (fst lr)) in
           let (_, nSp) = partition (fun foo -> isOK (rp_strict rp foo)) p in
           let (_, nSr) = partition (fun foo -> isOK (rp_strict rp foo)) ur in
           bind (rp_valid rp)
             (fun _ ->
               bind (catch (rp_mono rp)
                      (fun x ->
                        Inl (comp (shows_string
                                    ['p'; 'r'; 'o'; 'b'; 'l'; 'e'; 'm'; ' ';
                                      'w'; 'i'; 't'; 'h'; ' '; 'm'; 'o'; 'n';
                                      'o'; 't'; 'o'; 'n'; 'i'; 'c'; 'i'; 't';
                                      'y'; ' '; 'o'; 'f'; ' '; 's'; 't'; 'r';
                                      'i'; 'c'; 't'; ' '; 'o'; 'r'; 'd'; 'e';
                                      'r'])
                              (comp shows_nl x))))
                 (fun _ ->
                   bind (catch
                          (check_ur_P_closed_rm_af (_A1, _A2) (_B1, _B2) r rm ur
                            p pi_full)
                          (fun x ->
                            Inl (comp (shows_string
['p'; 'r'; 'o'; 'b'; 'l'; 'e'; 'm'; ' '; 'w'; 'i'; 't'; 'h'; ' '; 'c'; 'l'; 'o';
  's'; 'u'; 'r'; 'e'; ' '; 'p'; 'r'; 'o'; 'p'; 'e'; 'r'; 't'; 'i'; 'e'; 's';
  ' '; 'o'; 'f'; ' '; 'u'; 's'; 'a'; 'b'; 'l'; 'e'; ' '; 'r'; 'u'; 'l'; 'e';
  's'])
                                  (comp shows_nl x))))
                     (fun _ ->
                       bind (catch
                              (catch (forallm (rp_non_strict rp) nSr)
                                (fun x -> Inl (snd x)))
                              (fun x ->
                                Inl (comp (shows_string
    ['p'; 'r'; 'o'; 'b'; 'l'; 'e'; 'm'; ' '; 'w'; 'h'; 'e'; 'n'; ' '; 'o'; 'r';
      'i'; 'e'; 'n'; 't'; 'i'; 'n'; 'g'; ' '; 'u'; 's'; 'a'; 'b'; 'l'; 'e'; ' ';
      'r'; 'u'; 'l'; 'e'; 's'])
                                      (comp shows_nl x))))
                         (fun _ ->
                           bind (catch
                                  (catch (forallm (rp_non_strict rp) nSp)
                                    (fun x -> Inl (snd x)))
                                  (fun x ->
                                    Inl (comp
  (shows_string
    ['p'; 'r'; 'o'; 'b'; 'l'; 'e'; 'm'; ' '; 'w'; 'h'; 'e'; 'n'; ' '; 'o'; 'r';
      'i'; 'e'; 'n'; 't'; 'i'; 'n'; 'g'; ' '; 'D'; 'P'; 's'])
  (comp shows_nl x))))
                             (fun _ ->
                               bind (catch
                                      (check_subseteq
(eqc (eq_terma _A1 _B1) (eq_terma _A1 _B1)) rR r)
                                      (fun _ ->
Inl (comp (shows_string
            ['p'; 'r'; 'o'; 'b'; 'l'; 'e'; 'm'; ':'; ' '; 'a'; 'd'; 'd'; 'i';
              't'; 'i'; 'o'; 'n'; 'a'; 'l'; ' '; 'r'; 'u'; 'l'; 'e'; '('; 's';
              ')'; ' '; 't'; 'o'; ' '; 'T'; 'R'; 'S'; ' '; 'a'; 'd'; 'd'; 'e';
              'd'])
      shows_nl)))
                                 (fun _ ->
                                   bind (catch
  (check_subseteq (eqc (eq_terma _A1 _B1) (eq_terma _A1 _B1)) (filt nSr) rR)
  (fun x ->
    Inl (match rp_strict rp x with Inl err -> err | Inr _ -> internal_error)))
                                     (fun _ ->
                                       catch
 (check_subseteq (eqc (eq_terma _A1 _B1) (eq_terma _A1 _B1)) (filt nSp) rP)
 (fun x ->
   Inl (match rp_strict rp x with Inl err -> err
         | Inr _ -> internal_error))))))))))
      (fun x ->
        Inl (comp (shows_string
                    ['c'; 'o'; 'u'; 'l'; 'd'; ' '; 'n'; 'o'; 't'; ' '; 'a'; 'p';
                      'p'; 'l'; 'y'; ' '; 't'; 'h'; 'e'; ' '; '('; 'm'; 'o';
                      'n'; 'o'; 't'; 'o'; 'n'; 'i'; 'c'; ')'; ' '; 'r'; 'e';
                      'd'; 'u'; 'c'; 't'; 'i'; 'o'; 'n'; ' '; 'p'; 'a'; 'i';
                      'r'; ' '; 'p'; 'r'; 'o'; 'c'; 'e'; 's'; 's'; 'o'; 'r';
                      ' '; 'w'; 'i'; 't'; 'h'; ' '; 't'; 'h'; 'e'; ' '; 'f';
                      'o'; 'l'; 'l'; 'o'; 'w'; 'i'; 'n'; 'g'])
              (comp shows_nl
                (comp (rp_desc rp)
                  (comp shows_nl
                    (comp (shows_string
                            ['a'; 'n'; 'd'; ' '; 't'; 'h'; 'e'; ' '; 'f'; 'o';
                              'l'; 'l'; 'o'; 'w'; 'i'; 'n'; 'g'; ' '; 'u'; 's';
                              'a'; 'b'; 'l'; 'e'; ' '; 'r'; 'u'; 'l'; 'e'; 's'])
                      (comp (shows_rules _A2 _B2 ur) (comp shows_nl x))))))));;

let rec check_mono_redpair_proc (_A1, _A2) (_B1, _B2)
  rp p rP r rR =
    catch (let (_, nSp) = partition (fun foo -> isOK (rp_strict rp foo)) p in
           let (_, nSr) = partition (fun foo -> isOK (rp_strict rp foo)) r in
           bind (rp_valid rp)
             (fun _ ->
               bind (catch (rp_mono rp)
                      (fun x ->
                        Inl (comp (shows_string
                                    ['p'; 'r'; 'o'; 'b'; 'l'; 'e'; 'm'; ' ';
                                      'w'; 'i'; 't'; 'h'; ' '; 'm'; 'o'; 'n';
                                      'o'; 't'; 'o'; 'n'; 'i'; 'c'; 'i'; 't';
                                      'y'; ' '; 'o'; 'f'; ' '; 's'; 't'; 'r';
                                      'i'; 'c'; 't'; ' '; 'o'; 'r'; 'd'; 'e';
                                      'r'])
                              (comp shows_nl x))))
                 (fun _ ->
                   bind (catch
                          (catch (forallm (rp_non_strict rp) nSr)
                            (fun x -> Inl (snd x)))
                          (fun x ->
                            Inl (comp (shows_string
['p'; 'r'; 'o'; 'b'; 'l'; 'e'; 'm'; ' '; 'w'; 'h'; 'e'; 'n'; ' '; 'o'; 'r'; 'i';
  'e'; 'n'; 't'; 'i'; 'n'; 'g'; ' '; 'T'; 'R'; 'S'])
                                  (comp shows_nl x))))
                     (fun _ ->
                       bind (catch
                              (catch (forallm (rp_non_strict rp) nSp)
                                (fun x -> Inl (snd x)))
                              (fun x ->
                                Inl (comp (shows_string
    ['p'; 'r'; 'o'; 'b'; 'l'; 'e'; 'm'; ' '; 'w'; 'h'; 'e'; 'n'; ' '; 'o'; 'r';
      'i'; 'e'; 'n'; 't'; 'i'; 'n'; 'g'; ' '; 'D'; 'P'; 's'])
                                      (comp shows_nl x))))
                         (fun _ ->
                           bind (catch
                                  (check_subseteq
                                    (eqc (eq_terma _A1 _B1) (eq_terma _A1 _B1))
                                    rR r)
                                  (fun _ ->
                                    Inl (shows_string
  ['p'; 'r'; 'o'; 'b'; 'l'; 'e'; 'm'; ':'; ' '; 'a'; 'd'; 'd'; 'i'; 't'; 'i';
    'o'; 'n'; 'a'; 'l'; ' '])))
                             (fun _ ->
                               bind (catch
                                      (check_subseteq
(eqc (eq_terma _A1 _B1) (eq_terma _A1 _B1)) nSr rR)
                                      (fun x ->
Inl (match rp_strict rp x with Inl err -> err | Inr _ -> internal_error)))
                                 (fun _ ->
                                   catch (check_subseteq
   (eqc (eq_terma _A1 _B1) (eq_terma _A1 _B1)) nSp rP)
                                     (fun x ->
                                       Inl
 (match rp_strict rp x with Inl err -> err | Inr _ -> internal_error)))))))))
      (fun x ->
        Inl (comp (shows_string
                    ['c'; 'o'; 'u'; 'l'; 'd'; ' '; 'n'; 'o'; 't'; ' '; 'a'; 'p';
                      'p'; 'l'; 'y'; ' '; 't'; 'h'; 'e'; ' '; 'r'; 'e'; 'd';
                      'u'; 'c'; 't'; 'i'; 'o'; 'n'; ' '; 'p'; 'a'; 'i'; 'r';
                      ' '; 'p'; 'r'; 'o'; 'c'; 'e'; 's'; 's'; 'o'; 'r'; ' ';
                      'w'; 'i'; 't'; 'h'; ' '; 't'; 'h'; 'e'; ' '; 'f'; 'o';
                      'l'; 'l'; 'o'; 'w'; 'i'; 'n'; 'g'])
              (comp shows_nl (comp (rp_desc rp) (comp shows_nl x)))));;

let rec check_allm_gen_index
  g f n xs =
    snd (foldl (fun (i, m) x -> (g x i, bind m (fun _ -> f x i))) (n, Inr ())
          xs);;

let rec check_dep_graph_proc (_A1, _A2) (_B1, _B2)
  p dps rm rrm =
    bind (catch
           (check_subseteq (eqc (eq_terma _A1 _B1) (eq_terma _A1 _B1)) p
             (concat_map snd dps))
           (fun x ->
             Inl (comp (shows_string
                         ['D'; 'e'; 'p'; 'e'; 'n'; 'd'; 'e'; 'n'; 'c'; 'y'; ' ';
                           'P'; 'a'; 'i'; 'r'; ' '])
                   (comp (shows_rule _A2 _B2 x)
                     (comp (shows_string
                             [' '; 'i'; 's'; ' '; 'm'; 'i'; 's'; 's'; 'i'; 'n';
                               'g'; ' '; 'i'; 'n'; ' '; 'd'; 'e'; 'c'; 'o'; 'm';
                               'p'; 'o'; 's'; 'i'; 't'; 'i'; 'o'; 'n'])
                       shows_nl)))))
      (fun _ ->
        catch (check_graph_decomp
                (comp (shows_preca (show_term _A2 _B2) (show_term _A2 _B2)
                        Zero_nat)
                  fst)
                (fun (a, b) ->
                  let (aa, ba) = a in
                  let (_, t) = aa in
                  (fun (_, ct) (ab, bb) ->
                    let (u, _) = ab in
                    (fun (cu, _) ->
                      gcMatchI _A1 _B1 ct u && gcMatchI _A1 _B1 cu t)
                      bb)
                    ba
                    b)
                (map (fun (real, cs) ->
                       (real,
                         map (fun (s, t) ->
                               ((s, t),
                                 (capRM _A1 _B1 rrm s, capRM _A1 _B1 rm t)))
                           cs))
                  dps))
          (fun x ->
            Inl (comp (shows_string
                        ['o'; 'u'; 'r'; ' '; 'e'; 's'; 't'; 'i'; 'm'; 'a'; 't';
                          'i'; 'o'; 'n'; ' '; '('; 'E'; 'D'; 'G'; '*'; '*'; '*';
                          ')'; ' '; 'c'; 'o'; 'u'; 'l'; 'd'; ' '; 'n'; 'o'; 't';
                          ' '; 's'; 'h'; 'o'; 'w'; ' '; 't'; 'h'; 'a'; 't'; ' ';
                          'y'; 'o'; 'u'; ' '; 'h'; 'a'; 'v'; 'e'; ' '; 'a'; ' ';
                          'v'; 'a'; 'l'; 'i'; 'd'; ' '; 'd'; 'e'; 'c'; 'o'; 'm';
                          'p'; 'o'; 's'; 'i'; 't'; 'i'; 'o'; 'n'; ' '])
                  (comp (shows_string
                          ['d'; 'u'; 'e'; ' '; 't'; 'o'; ' '; 't'; 'h'; 'e';
                            ' '; 'f'; 'o'; 'l'; 'l'; 'o'; 'w'; 'i'; 'n'; 'g';
                            ' '; 'r'; 'e'; 'a'; 's'; 'o'; 'n'])
                    (comp shows_nl x)))));;

let rec check_redpair_ur_af_proc (_A1, _A2) (_B1, _B2)
  rp p rP r rm ur =
    catch (let (_, nSp) = partition (fun foo -> isOK (rp_strict rp foo)) p in
           bind (rp_valid rp)
             (fun _ ->
               bind (catch
                      (check_ur_P_closed_rm_af (_A1, _A2) (_B1, _B2) r rm ur p
                        (rp_af rp))
                      (fun x ->
                        Inl (comp (shows_string
                                    ['p'; 'r'; 'o'; 'b'; 'l'; 'e'; 'm'; ' ';
                                      'w'; 'i'; 't'; 'h'; ' '; 'c'; 'l'; 'o';
                                      's'; 'u'; 'r'; 'e'; ' '; 'p'; 'r'; 'o';
                                      'p'; 'e'; 'r'; 't'; 'i'; 'e'; 's'; ' ';
                                      'o'; 'f'; ' '; 'u'; 's'; 'a'; 'b'; 'l';
                                      'e'; ' '; 'r'; 'u'; 'l'; 'e'; 's'; ' ';
                                      'w'; '.'; 'r'; '.'; 't'; '.'; ' '; 'a';
                                      'r'; 'g'; 'u'; 'm'; 'e'; 'n'; 't'; ' ';
                                      'f'; 'i'; 'l'; 't'; 'e'; 'r'])
                              (comp shows_nl x))))
                 (fun _ ->
                   bind (catch
                          (catch (forallm (rp_non_strict rp) ur)
                            (fun x -> Inl (snd x)))
                          (fun x ->
                            Inl (comp (shows_string
['p'; 'r'; 'o'; 'b'; 'l'; 'e'; 'm'; ' '; 'w'; 'h'; 'e'; 'n'; ' '; 'o'; 'r'; 'i';
  'e'; 'n'; 't'; 'i'; 'n'; 'g'; ' '; 'u'; 's'; 'a'; 'b'; 'l'; 'e'; ' '; 'r';
  'u'; 'l'; 'e'; 's'])
                                  (comp shows_nl x))))
                     (fun _ ->
                       bind (catch
                              (catch (forallm (rp_non_strict rp) nSp)
                                (fun x -> Inl (snd x)))
                              (fun x ->
                                Inl (comp (shows_string
    ['p'; 'r'; 'o'; 'b'; 'l'; 'e'; 'm'; ' '; 'w'; 'h'; 'e'; 'n'; ' '; 'o'; 'r';
      'i'; 'e'; 'n'; 't'; 'i'; 'n'; 'g'; ' '; 'D'; 'P'; 's'])
                                      (comp shows_nl x))))
                         (fun _ ->
                           catch (check_subseteq
                                   (eqc (eq_terma _A1 _B1) (eq_terma _A1 _B1))
                                   nSp rP)
                             (fun x ->
                               Inl (match rp_strict rp x with Inl err -> err
                                     | Inr _ -> internal_error)))))))
      (fun x ->
        Inl (comp (shows_string
                    ['c'; 'o'; 'u'; 'l'; 'd'; ' '; 'n'; 'o'; 't'; ' '; 'a'; 'p';
                      'p'; 'l'; 'y'; ' '; 't'; 'h'; 'e'; ' '; 'r'; 'e'; 'd';
                      'u'; 'c'; 't'; 'i'; 'o'; 'n'; ' '; 'p'; 'a'; 'i'; 'r';
                      ' '; 'p'; 'r'; 'o'; 'c'; 'e'; 's'; 's'; 'o'; 'r'; ' ';
                      'w'; 'i'; 't'; 'h'; ' '; 't'; 'h'; 'e'; ' '; 'f'; 'o';
                      'l'; 'l'; 'o'; 'w'; 'i'; 'n'; 'g'])
              (comp shows_nl
                (comp (rp_desc rp)
                  (comp shows_nl
                    (comp (shows_string
                            ['a'; 'n'; 'd'; ' '; 't'; 'h'; 'e'; ' '; 'f'; 'o';
                              'l'; 'l'; 'o'; 'w'; 'i'; 'n'; 'g'; ' '; 'u'; 's';
                              'a'; 'b'; 'l'; 'e'; ' '; 'r'; 'u'; 'l'; 'e'; 's'])
                      (comp shows_nl
                        (comp (shows_rules _A2 _B2 ur)
                          (comp shows_nl x)))))))));;

let rec check_redpair_proc (_A1, _A2) (_B1, _B2)
  rp p rP r =
    catch (let (_, nSp) = partition (fun foo -> isOK (rp_strict rp foo)) p in
           bind (rp_valid rp)
             (fun _ ->
               bind (catch
                      (catch (forallm (rp_non_strict rp) r)
                        (fun x -> Inl (snd x)))
                      (fun x ->
                        Inl (comp (shows_string
                                    ['p'; 'r'; 'o'; 'b'; 'l'; 'e'; 'm'; ' ';
                                      'w'; 'h'; 'e'; 'n'; ' '; 'o'; 'r'; 'i';
                                      'e'; 'n'; 't'; 'i'; 'n'; 'g'; ' '; 'T';
                                      'R'; 'S'])
                              (comp shows_nl x))))
                 (fun _ ->
                   bind (catch
                          (catch (forallm (rp_non_strict rp) nSp)
                            (fun x -> Inl (snd x)))
                          (fun x ->
                            Inl (comp (shows_string
['p'; 'r'; 'o'; 'b'; 'l'; 'e'; 'm'; ' '; 'w'; 'h'; 'e'; 'n'; ' '; 'o'; 'r'; 'i';
  'e'; 'n'; 't'; 'i'; 'n'; 'g'; ' '; 'D'; 'P'; 's'])
                                  (comp shows_nl x))))
                     (fun _ ->
                       catch (check_subseteq
                               (eqc (eq_terma _A1 _B1) (eq_terma _A1 _B1)) nSp
                               rP)
                         (fun x ->
                           Inl (match rp_strict rp x with Inl err -> err
                                 | Inr _ -> internal_error))))))
      (fun x ->
        Inl (comp (shows_string
                    ['c'; 'o'; 'u'; 'l'; 'd'; ' '; 'n'; 'o'; 't'; ' '; 'a'; 'p';
                      'p'; 'l'; 'y'; ' '; 't'; 'h'; 'e'; ' '; 'r'; 'e'; 'd';
                      'u'; 'c'; 't'; 'i'; 'o'; 'n'; ' '; 'p'; 'a'; 'i'; 'r';
                      ' '; 'p'; 'r'; 'o'; 'c'; 'e'; 's'; 's'; 'o'; 'r'; ' ';
                      'w'; 'i'; 't'; 'h'; ' '; 't'; 'h'; 'e'; ' '; 'f'; 'o';
                      'l'; 'l'; 'o'; 'w'; 'i'; 'n'; 'g'])
              (comp shows_nl (comp (rp_desc rp) (comp shows_nl x)))));;

let rec checkDPProof (_A1, _A2) (_B1, _B2)
  i p r m rm rrm x6 = match i, p, r, m, rm, rrm, x6 with
    i, p, r, m, rm, rrm, PisEmpty ->
      debug (i []) ['P'; ' '; 'i'; 's'; ' '; 'e'; 'm'; 'p'; 't'; 'y']
        (match p with [] -> Inr ()
          | _ :: _ ->
            Inl (comp i
                  (comp (shows_string
                          [':'; ' '; 'P'; ' '; 'i'; 's'; ' '; 'n'; 'o'; 't';
                            ' '; 'e'; 'm'; 'p'; 't'; 'y'; ' '; 'i'; 'n'; ' ';
                            't'; 'h'; 'e'; ' '; 'f'; 'o'; 'l'; 'l'; 'o'; 'w';
                            'i'; 'n'; 'g'; ' '; 'D'; 'P'; '-'; 'p'; 'r'; 'o';
                            'b'; 'l'; 'e'; 'm'; ' '])
                    (comp shows_nl
                      (shows_dpp (show_lab _A2 _B2) (show_list show_char) p
                        r)))))
    | i, p, r, m, rm, rrm, RedPairProc (redp, rP, prf) ->
        debug (i []) ['R'; 'e'; 'd'; 'P'; 'a'; 'i'; 'r'; 'P'; 'r'; 'o'; 'c']
          (bind (catch
                  (check_redpair_proc (eq_laba _A1 _B1, show_lab _A2 _B2)
                    (eq_lista eq_char, show_list show_char)
                    (get_redpair (eq_laba _A1 _B1, show_lab _A2 _B2)
                      (eq_lista eq_char, show_list show_char) redp)
                    p rP r)
                  (fun x ->
                    Inl (comp i
                          (comp (shows_string
                                  [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'w';
                                    'h'; 'e'; 'n'; ' '; 'a'; 'p'; 'p'; 'l'; 'y';
                                    'i'; 'n'; 'g'; ' '; 't'; 'h'; 'e'; ' '; 'r';
                                    'e'; 'd'; 'u'; 'c'; 't'; 'i'; 'o'; 'n'; ' ';
                                    'p'; 'a'; 'i'; 'r'; ' '; 'p'; 'r'; 'o'; 'c';
                                    'e'; 's'; 's'; 'o'; 'r'; ' '; 't'; 'o'; ' ';
                                    's'; 'w'; 'i'; 't'; 'c'; 'h'; ' '; 'f'; 'r';
                                    'o'; 'm'])
                            (comp shows_nl
                              (comp (shows_dpp (show_lab _A2 _B2)
                                      (show_list show_char) p r)
                                (comp shows_nl
                                  (comp (shows_string
  ['t'; 'o'; ' '; 't'; 'h'; 'e'; ' '; 'D'; 'P'; ' '; 'p'; 'r'; 'o'; 'b'; 'l';
    'e'; 'm'])
                                    (comp shows_nl
                                      (comp
(shows_dpp (show_lab _A2 _B2) (show_list show_char) rP r)
(comp shows_nl x)))))))))))
            (fun _ ->
              catch (checkDPProof (_A1, _A2) (_B1, _B2)
                      (comp i (shows_string ['.'; '1'])) rP r m rm rrm prf)
                (fun x ->
                  Inl (comp i
                        (comp (shows_string
                                [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'b';
                                  'e'; 'l'; 'o'; 'w'; ' '; 't'; 'h'; 'e'; ' ';
                                  'r'; 'e'; 'd'; 'u'; 'c'; 't'; 'i'; 'o'; 'n';
                                  ' '; 'p'; 'a'; 'i'; 'r'; ' '; 'p'; 'r'; 'o';
                                  'c'; 'e'; 's'; 's'; 'o'; 'r'])
                          (comp shows_nl (indent x)))))))
    | i, p, r, m, rm, rrm, RedPairUrProc (redp, rP, ur, prf) ->
        debug (i [])
          ['R'; 'e'; 'd'; 'P'; 'a'; 'i'; 'r'; 'P'; 'r'; 'o'; 'c'; ' '; '('; 'u';
            's'; 'a'; 'b'; 'l'; 'e'; ' '; 'r'; 'u'; 'l'; 'e'; 's'; ' '; '+';
            ' '; 'a'; 'f'; ')']
          (bind (catch
                  (check_redpair_ur_af_proc (eq_laba _A1 _B1, show_lab _A2 _B2)
                    (eq_lista eq_char, show_list show_char)
                    (get_redpair (eq_laba _A1 _B1, show_lab _A2 _B2)
                      (eq_lista eq_char, show_list show_char) redp)
                    p rP r rm ur)
                  (fun x ->
                    Inl (comp i
                          (comp (shows_string
                                  [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'w';
                                    'h'; 'e'; 'n'; ' '; 'a'; 'p'; 'p'; 'l'; 'y';
                                    'i'; 'n'; 'g'; ' '; 't'; 'h'; 'e'; ' '; 'r';
                                    'e'; 'd'; 'u'; 'c'; 't'; 'i'; 'o'; 'n'; ' ';
                                    'p'; 'a'; 'i'; 'r'; ' '])
                            (comp (shows_string
                                    ['p'; 'r'; 'o'; 'c'; 'e'; 's'; 's'; 'o';
                                      'r'; ' '; '('; 'w'; 'i'; 't'; 'h'; ' ';
                                      'u'; 's'; 'a'; 'b'; 'l'; 'e'; ' '; 'r';
                                      'u'; 'l'; 'e'; 's'; ' '; 'a'; 'n'; 'd';
                                      ' '; 'a'; 'f'; ')'; ' '; 't'; 'o'; ' ';
                                      's'; 'w'; 'i'; 't'; 'c'; 'h'; ' '; 'f';
                                      'r'; 'o'; 'm'; ' '])
                              (comp shows_nl
                                (comp (shows_dpp (show_lab _A2 _B2)
(show_list show_char) p r)
                                  (comp shows_nl
                                    (comp (shows_string
    ['t'; 'o'; ' '; 't'; 'h'; 'e'; ' '; 'D'; 'P'; ' '; 'p'; 'r'; 'o'; 'b'; 'l';
      'e'; 'm'; ' '])
                                      (comp shows_nl
(comp (shows_dpp (show_lab _A2 _B2) (show_list show_char) rP r)
  (comp shows_nl x))))))))))))
            (fun _ ->
              catch (checkDPProof (_A1, _A2) (_B1, _B2)
                      (comp i (shows_string ['.'; '1'])) rP r m rm rrm prf)
                (fun x ->
                  Inl (comp i
                        (comp (shows_string
                                [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'b';
                                  'e'; 'l'; 'o'; 'w'; ' '; 't'; 'h'; 'e'; ' ';
                                  'r'; 'e'; 'd'; 'u'; 'c'; 't'; 'i'; 'o'; 'n';
                                  ' '; 'p'; 'a'; 'i'; 'r'; ' '; 'p'; 'r'; 'o';
                                  'c'; 'e'; 's'; 's'; 'o'; 'r'])
                          (comp shows_nl (indent x)))))))
    | i, p, r, m, rm, rrm, DepGraphProc edpts ->
        debug (i [])
          ['D'; 'e'; 'p'; 'G'; 'r'; 'a'; 'p'; 'h'; 'P'; 'r'; 'o'; 'c']
          (bind (catch
                  (check_dep_graph_proc (eq_laba _A1 _B1, show_lab _A2 _B2)
                    (eq_lista eq_char, show_list show_char) p
                    (map (fun x ->
                           ((match fst x with None -> false | Some _ -> true),
                             snd x))
                      edpts)
                    rm rrm)
                  (fun x ->
                    Inl (comp i
                          (comp (shows_string
                                  [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'w';
                                    'h'; 'i'; 'l'; 'e'; ' '; 't'; 'r'; 'y'; 'i';
                                    'n'; 'g'; ' '; 't'; 'o'; ' '; 'p'; 'e'; 'r';
                                    'f'; 'o'; 'r'; 'm'; ' '; 'S'; 'C'; 'C'; '-';
                                    'd'; 'e'; 'c'; 'o'; 'm'; 'p'; 'o'; 's'; 'i';
                                    't'; 'i'; 'o'; 'n'; ' '; ' '; 'o'; 'n';
                                    ' '])
                            (comp shows_nl
                              (comp (shows_dpp (show_lab _A2 _B2)
                                      (show_list show_char) p r)
                                (comp shows_nl x)))))))
            (fun _ ->
              catch (check_allm_gen_index
                      (fun rp j ->
                        (match fst rp with None -> j | Some _ -> Suc j))
                      (fun rp j ->
                        (match fst rp with None -> Inr ()
                          | Some a ->
                            checkDPProof (_A1, _A2) (_B1, _B2)
                              (comp i
                                (comp (shows_string ['.'])
                                  (shows_prec_nat Zero_nat j)))
                              (snd rp) r m rm rrm a))
                      one_nat edpts)
                (fun x ->
                  Inl (comp i
                        (comp (shows_string
                                [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'b';
                                  'e'; 'l'; 'o'; 'w'; ' '; 't'; 'h'; 'e'; ' ';
                                  'd'; 'e'; 'p'; 'e'; 'n'; 'd'; 'e'; 'n'; 'c';
                                  'y'; ' '; 'g'; 'r'; 'a'; 'p'; 'h'; ' '; 'p';
                                  'r'; 'o'; 'c'; 'e'; 's'; 's'; 'o'; 'r'])
                          (comp shows_nl (indent x)))))))
    | i, p, r, m, rm, rrm, MonoRedPairProc (redp, rP, rR, prf) ->
        debug (i [])
          ['M'; 'o'; 'n'; 'o'; 'R'; 'e'; 'd'; 'P'; 'a'; 'i'; 'r'; 'P'; 'r'; 'o';
            'c']
          (bind (catch
                  (check_mono_redpair_proc (eq_laba _A1 _B1, show_lab _A2 _B2)
                    (eq_lista eq_char, show_list show_char)
                    (get_redpair (eq_laba _A1 _B1, show_lab _A2 _B2)
                      (eq_lista eq_char, show_list show_char) redp)
                    p rP r rR)
                  (fun x ->
                    Inl (comp i
                          (comp (shows_string
                                  [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'w';
                                    'h'; 'e'; 'n'; ' '; 'a'; 'p'; 'p'; 'l'; 'y';
                                    'i'; 'n'; 'g'; ' '; 't'; 'h'; 'e'; ' '; 'm';
                                    'o'; 'n'; 'o'; 't'; 'o'; 'n'; 'i'; 'c'; ' ';
                                    'r'; 'e'; 'd'; 'u'; 'c'; 't'; 'i'; 'o'; 'n';
                                    ' '; 'p'; 'a'; 'i'; 'r'; ' '; 'p'; 'r'; 'o';
                                    'c'; 'e'; 's'; 's'; 'o'; 'r'; ' '])
                            (comp (shows_string
                                    ['t'; 'o'; ' '; 's'; 'w'; 'i'; 't'; 'c';
                                      'h'; ' '; 'f'; 'r'; 'o'; 'm'; ' '])
                              (comp shows_nl
                                (comp (shows_dpp (show_lab _A2 _B2)
(show_list show_char) p r)
                                  (comp shows_nl
                                    (comp (shows_string
    ['t'; 'o'; ' '; 't'; 'h'; 'e'; ' '; 'D'; 'P'; ' '; 'p'; 'r'; 'o'; 'b'; 'l';
      'e'; 'm'; ' '])
                                      (comp shows_nl
(comp (shows_dpp (show_lab _A2 _B2) (show_list show_char) rP rR)
  (comp shows_nl x))))))))))))
            (fun _ ->
              catch (checkDPProof (_A1, _A2) (_B1, _B2)
                      (comp i (shows_string ['.'; '1'])) rP rR m
                      (computeRuleMap (eq_laba _A1 _B1) rR)
                      (computeRuleMap (eq_laba _A1 _B1) (reverse_trs rR)) prf)
                (fun x ->
                  Inl (comp i
                        (comp (shows_string
                                [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'b';
                                  'e'; 'l'; 'o'; 'w'; ' '; 't'; 'h'; 'e'; ' ';
                                  'm'; 'o'; 'n'; 'o'; 't'; 'o'; 'n'; 'i'; 'c';
                                  ' '; 'r'; 'e'; 'd'; 'u'; 'c'; 't'; 'i'; 'o';
                                  'n'; ' '; 'p'; 'a'; 'i'; 'r'; ' '; 'p'; 'r';
                                  'o'; 'c'; 'e'; 's'; 's'; 'o'; 'r'])
                          (comp shows_nl (indent x)))))))
    | i, p, r, m, rm, rrm, MonoRedPairUrProc (redp, rP, rR, ur, prf) ->
        debug (i [])
          ['M'; 'o'; 'n'; 'o'; 'R'; 'e'; 'd'; 'P'; 'a'; 'i'; 'r'; 'P'; 'r'; 'o';
            'c'; ' '; '('; 'u'; 's'; 'a'; 'b'; 'l'; 'e'; ' '; 'r'; 'u'; 'l';
            'e'; 's'; ')']
          (bind (catch
                  (check_mono_redpair_ur_proc
                    (eq_laba _A1 _B1, show_lab _A2 _B2)
                    (eq_lista eq_char, show_list show_char)
                    (get_redpair (eq_laba _A1 _B1, show_lab _A2 _B2)
                      (eq_lista eq_char, show_list show_char) redp)
                    p rP r rm rR ur)
                  (fun x ->
                    Inl (comp i
                          (comp (shows_string
                                  [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'w';
                                    'h'; 'e'; 'n'; ' '; 'a'; 'p'; 'p'; 'l'; 'y';
                                    'i'; 'n'; 'g'; ' '; 't'; 'h'; 'e'; ' '; 'm';
                                    'o'; 'n'; 'o'; 't'; 'o'; 'n'; 'i'; 'c'; ' ';
                                    'r'; 'e'; 'd'; 'u'; 'c'; 't'; 'i'; 'o'; 'n';
                                    ' '; 'p'; 'a'; 'i'; 'r'; ' '])
                            (comp (shows_string
                                    ['p'; 'r'; 'o'; 'c'; 'e'; 's'; 's'; 'o';
                                      'r'; ' '; '('; 'w'; 'i'; 't'; 'h'; ' ';
                                      'u'; 's'; 'a'; 'b'; 'l'; 'e'; ' '; 'r';
                                      'u'; 'l'; 'e'; 's'; ')'; ' '; 't'; 'o';
                                      ' '; 's'; 'w'; 'i'; 't'; 'c'; 'h'; ' ';
                                      'f'; 'r'; 'o'; 'm'; ' '])
                              (comp shows_nl
                                (comp (shows_dpp (show_lab _A2 _B2)
(show_list show_char) p r)
                                  (comp shows_nl
                                    (comp (shows_string
    ['t'; 'o'; ' '; 't'; 'h'; 'e'; ' '; 'D'; 'P'; ' '; 'p'; 'r'; 'o'; 'b'; 'l';
      'e'; 'm'])
                                      (comp shows_nl
(comp (shows_dpp (show_lab _A2 _B2) (show_list show_char) rP rR)
  (comp shows_nl x))))))))))))
            (fun _ ->
              catch (checkDPProof (_A1, _A2) (_B1, _B2)
                      (comp i (shows_string ['.'; '1'])) rP rR m
                      (computeRuleMap (eq_laba _A1 _B1) rR)
                      (computeRuleMap (eq_laba _A1 _B1) (reverse_trs rR)) prf)
                (fun x ->
                  Inl (comp i
                        (comp (shows_string
                                [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'b';
                                  'e'; 'l'; 'o'; 'w'; ' '; 't'; 'h'; 'e'; ' ';
                                  'm'; 'o'; 'n'; 'o'; 't'; 'o'; 'n'; 'i'; 'c';
                                  ' '; 'r'; 'e'; 'd'; 'u'; 'c'; 't'; 'i'; 'o';
                                  'n'; ' '; 'p'; 'a'; 'i'; 'r'; ' '])
                          (comp (shows_string
                                  ['('; 'w'; 'i'; 't'; 'h'; ' '; 'u'; 's'; 'a';
                                    'b'; 'l'; 'e'; ' '; 'r'; 'u'; 'l'; 'e'; 's';
                                    ')'; ' '; 'p'; 'r'; 'o'; 'c'; 'e'; 's'; 's';
                                    'o'; 'r'])
                            (comp shows_nl (indent x))))))))
    | i, p, r, Suc m, rm, rrm, UnlabProc (ulP, ulR, prf) ->
        debug (i []) ['U'; 'n'; 'l'; 'a'; 'b'; 'P'; 'r'; 'o'; 'c']
          (bind (check_unlab_proc (_A1, _A2) (_B1, _B2)
                  (eq_lista eq_char, show_list show_char) p r ulP ulR)
            (fun _ ->
              catch (checkDPProof (_A1, _A2) (_B1, _B2)
                      (comp i (shows_string ['.'; '1'])) ulP ulR m
                      (computeRuleMap (eq_laba _A1 _B1) ulR)
                      (computeRuleMap (eq_laba _A1 _B1) (reverse_trs ulR)) prf)
                (fun x ->
                  Inl (comp i
                        (comp (shows_string
                                [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'b';
                                  'e'; 'l'; 'o'; 'w'; ' '; 't'; 'h'; 'e'; ' ';
                                  'u'; 'n'; 'l'; 'a'; 'b'; 'e'; 'l'; 'i'; 'n';
                                  'g'; ' '; 'p'; 'r'; 'o'; 'c'; 'e'; 's'; 's';
                                  'o'; 'r'])
                          (comp shows_nl (indent x)))))))
    | i, p, r, Zero_nat, rm, rrm, UnlabProc (ulP, ulR, prf) ->
        Inl (comp (shows_string
                    ['u'; 'n'; 'l'; 'a'; 'b'; 'e'; 'l'; 'i'; 'n'; 'g'; ' '; 'n';
                      'o'; 't'; ' '; 'a'; 'l'; 'l'; 'o'; 'w'; 'e'; 'd'; ' ';
                      'd'; 'u'; 'e'; ' '; 't'; 'o'; ' '; 'l'; 'a'; 'b'; 'e';
                      'l'; '-'; 'd'; 'e'; 'p'; 't'; 'h'; ' '; 'o'; 'f'; ' ';
                      '0'])
              shows_nl)
    | i, p, r, m, rm, rrm, SemlabProc (sli, l, lP, lR, prf) ->
        debug (i []) ['S'; 'e'; 'm'; 'l'; 'a'; 'b'; 'P'; 'r'; 'o'; 'c']
          (bind (catch
                  (create_sem_lab_proc (_A1, _A2) (_B1, _B2)
                    (eq_lista eq_char, show_list show_char) sli l p r lP lR)
                  (fun x ->
                    Inl (comp i
                          (comp (shows_string
                                  [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'w';
                                    'h'; 'e'; 'n'; ' '; 'a'; 'p'; 'p'; 'l'; 'y';
                                    'i'; 'n'; 'g'; ' '; 't'; 'h'; 'e'; ' '; 's';
                                    'e'; 'm'; 'a'; 'n'; 't'; 'i'; 'c'; ' '; 'l';
                                    'a'; 'b'; 'e'; 'l'; 'i'; 'n'; 'g'; ' '; 'p';
                                    'r'; 'o'; 'c'; 'e'; 's'; 's'; 'o'; 'r'])
                            (comp shows_nl x)))))
            (fun _ ->
              catch (checkDPProof (_A1, _A2) (_B1, _B2)
                      (comp i (shows_string ['.'; '1'])) lP lR (Suc m)
                      (computeRuleMap (eq_laba _A1 _B1) lR)
                      (computeRuleMap (eq_laba _A1 _B1) (reverse_trs lR)) prf)
                (fun x ->
                  Inl (comp i
                        (comp (shows_string
                                [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'b';
                                  'e'; 'l'; 'o'; 'w'; ' '; 't'; 'h'; 'e'; ' ';
                                  's'; 'e'; 'm'; 'a'; 'n'; 't'; 'i'; 'c'; ' ';
                                  'l'; 'a'; 'b'; 'e'; 'l'; 'i'; 'n'; 'g'; ' ';
                                  'p'; 'r'; 'o'; 'c'; 'e'; 's'; 's'; 'o'; 'r'])
                          (comp shows_nl (indent x)))))))
    | i, p, r, m, rm, rrm, RootlabProc (lP, lR, prf) ->
        debug (i []) ['R'; 'o'; 'o'; 't'; 'l'; 'a'; 'b'; 'P'; 'r'; 'o'; 'c']
          (bind (catch (rl_proc (_A1, _A2) (_B1, _B2) p r lP lR)
                  (fun x ->
                    Inl (comp i
                          (comp (shows_string
                                  [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'w';
                                    'h'; 'e'; 'n'; ' '; 'a'; 'p'; 'p'; 'l'; 'y';
                                    'i'; 'n'; 'g'; ' '; 't'; 'h'; 'e'; ' '; 'r';
                                    'o'; 'o'; 't'; ' '; 'l'; 'a'; 'b'; 'e'; 'l';
                                    'i'; 'n'; 'g'; ' '; 'p'; 'r'; 'o'; 'c'; 'e';
                                    's'; 's'; 'o'; 'r'])
                            (comp shows_nl x)))))
            (fun _ ->
              catch (checkDPProof (_A1, _A2) (_B1, _B2)
                      (comp i (shows_string ['.'; '1'])) lP lR (Suc m)
                      (computeRuleMap (eq_laba _A1 _B1) lR)
                      (computeRuleMap (eq_laba _A1 _B1) (reverse_trs lR)) prf)
                (fun x ->
                  Inl (comp i
                        (comp (shows_string
                                [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'b';
                                  'e'; 'l'; 'o'; 'w'; ' '; 't'; 'h'; 'e'; ' ';
                                  'r'; 'o'; 'o'; 't'; '-'; 'l'; 'a'; 'b'; 'e';
                                  'l'; 'i'; 'n'; 'g'; ' '; 'p'; 'r'; 'o'; 'c';
                                  'e'; 's'; 's'; 'o'; 'r'])
                          (comp shows_nl (indent x)))))))
    | i, pa, r, m, rm, rrm, SubtermCriterionProc (p, rseq, rP, prf) ->
        debug (i []) ['S'; 'u'; 'b'; 't'; 'e'; 'r'; 'm'; 'P'; 'r'; 'o'; 'c']
          (bind (catch
                  (create_subterm_criterion_proc
                    (eq_laba _A1 _B1, show_lab _A2 _B2)
                    (eq_lista eq_char, show_list show_char) p rseq pa rP r rm)
                  (fun x ->
                    Inl (comp i
                          (comp (shows_string
                                  [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'w';
                                    'h'; 'e'; 'n'; ' '; 'a'; 'p'; 'p'; 'l'; 'y';
                                    'i'; 'n'; 'g'; ' '; 't'; 'h'; 'e'; ' '; 's';
                                    'u'; 'b'; 't'; 'e'; 'r'; 'm'; ' '; 'c'; 'r';
                                    'i'; 't'; 'e'; 'r'; 'i'; 'o'; 'n'; ' '; 'p';
                                    'r'; 'o'; 'c'; 'e'; 's'; 's'; 'o'; 'r'])
                            (comp shows_nl x)))))
            (fun _ ->
              catch (checkDPProof (_A1, _A2) (_B1, _B2)
                      (comp i (shows_string ['.'; '1'])) rP r m rm rrm prf)
                (fun x ->
                  Inl (comp i
                        (comp (shows_string
                                [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'b';
                                  'e'; 'l'; 'o'; 'w'; ' '; 't'; 'h'; 'e'; ' ';
                                  's'; 'u'; 'b'; 't'; 'e'; 'r'; 'm'; ' '; 'c';
                                  'r'; 'i'; 't'; 'e'; 'r'; 'i'; 'o'; 'n'; ' ';
                                  'p'; 'r'; 'o'; 'c'; 'e'; 's'; 's'; 'o'; 'r'])
                          (comp shows_nl (indent x)))))))
    | i, p, r, m, rm, rrm, SizeChangeSubTerm graphs ->
        debug (i [])
          ['S'; 'i'; 'z'; 'e'; 'C'; 'h'; 'a'; 'n'; 'g'; 'e'; 'S'; 'u'; 'b'; 'T';
            'e'; 'r'; 'm']
          (check_sct_subterm_proc (eq_laba _A1 _B1, show_lab _A2 _B2)
            (eq_lista eq_char, show_list show_char) p graphs rm rrm)
    | i, p, r, m, rm, rrm, SizeChangeRedPair (redp, ur, graphs) ->
        debug (i [])
          ['S'; 'i'; 'z'; 'e'; 'C'; 'h'; 'a'; 'n'; 'g'; 'e'; 'R'; 'e'; 'd'; 'P';
            'a'; 'i'; 'r']
          (check_sct_ur_af_proc (eq_laba _A1 _B1, show_lab _A2 _B2)
            (eq_lista eq_char, show_list show_char)
            (get_redpair (eq_laba _A1 _B1, show_lab _A2 _B2)
              (eq_lista eq_char, show_list show_char) redp)
            p graphs rm rrm ur)
    | i, p, r, m, rm, rrm, FccProc (f, fcs, rP, rR, prf) ->
        debug (i []) ['F'; 'c'; 'c'; 'P'; 'r'; 'o'; 'c']
          (bind (catch (fcc_proc (_A1, _A2) (_B1, _B2) p r f fcs rP rR)
                  (fun x ->
                    Inl (comp i
                          (comp (shows_string
                                  [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'w';
                                    'h'; 'e'; 'n'; ' '; 'a'; 'p'; 'p'; 'l'; 'y';
                                    'i'; 'n'; 'g'; ' '; 't'; 'h'; 'e'; ' '; 'c';
                                    'l'; 'o'; 's'; 'u'; 'r'; 'e'; ' '; 'u'; 'n';
                                    'd'; 'e'; 'r'; ' '; 'f'; 'l'; 'a'; 't'; ' ';
                                    'c'; 'o'; 'n'; 't'; 'e'; 'x'; 't'; 's'])
                            (comp shows_nl x)))))
            (fun _ ->
              catch (checkDPProof (_A1, _A2) (_B1, _B2)
                      (comp i (shows_string ['.'; '1'])) rP rR m
                      (computeRuleMap (eq_laba _A1 _B1) rR)
                      (computeRuleMap (eq_laba _A1 _B1) (reverse_trs rR)) prf)
                (fun x ->
                  Inl (comp i
                        (comp (shows_string
                                [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'b';
                                  'e'; 'l'; 'o'; 'w'; ' '; 'f'; 'l'; 'a'; 't';
                                  ' '; 'c'; 'o'; 'n'; 't'; 'e'; 'x'; 't'; ' ';
                                  'c'; 'l'; 'o'; 's'; 'u'; 'r'; 'e'; ' '; 'p';
                                  'r'; 'o'; 'c'; 'e'; 's'; 's'; 'o'; 'r'])
                          (comp shows_nl (indent x)))))));;

let rec checkTRSProof (_A1, _A2) (_B1, _B2)
  i r m x3 = match i, r, m, x3 with
    i, r, m, DPTrans (p, prf) ->
      debug (i []) ['D'; 'P'; ' '; 't'; 'r'; 'a'; 'n'; 's']
        (bind (catch
                (check_DP (eq_laba _A1 _B1, show_lab _A2 _B2)
                  (eq_lista eq_char, show_list show_char) r p)
                (fun x ->
                  Inl (comp i
                        (comp (shows_string
                                [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'w';
                                  'h'; 'e'; 'n'; ' '; 's'; 'w'; 'i'; 't'; 'c';
                                  'h'; 'i'; 'n'; 'g'; ' '; 'f'; 'r'; 'o'; 'm';
                                  ' '; 't'; 'h'; 'e'; ' '; 'T'; 'R'; 'S'])
                          (comp shows_nl
                            (comp (shows_trs (show_lab _A2 _B2)
                                    (show_list show_char) r)
                              (comp shows_nl
                                (comp (shows_string
['t'; 'o'; ' '; 't'; 'h'; 'e'; ' '; 'i'; 'n'; 'i'; 't'; 'i'; 'a'; 'l'; ' '; 'D';
  'P'; ' '; 'p'; 'r'; 'o'; 'b'; 'l'; 'e'; 'm'])
                                  (comp shows_nl
                                    (comp (shows_dpp
    (show_shp (show_lab _A2 _B2)) (show_list show_char) p (iD_list r))
                                      (comp shows_nl x)))))))))))
          (fun _ ->
            catch (checkDPProof
                    (eq_shpa (eq_laba _A1 _B1), show_shp (show_lab _A2 _B2))
                    (_B1, _B2) (comp i (shows_string ['.'; '1']))
                    (map (map_rule init_lab) p)
                    (map (map_rule init_lab) (iD_list r)) Zero_nat
                    (computeRuleMap (eq_laba (eq_shpa (eq_laba _A1 _B1)) _B1)
                      (map (map_rule init_lab) (iD_list r)))
                    (computeRuleMap (eq_laba (eq_shpa (eq_laba _A1 _B1)) _B1)
                      (reverse_trs (map (map_rule init_lab) (iD_list r))))
                    prf)
              (fun x ->
                Inl (comp i
                      (comp (shows_string
                              [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'b'; 'e';
                                'l'; 'o'; 'w'; ' '; 's'; 'w'; 'i'; 't'; 'c';
                                'h'; ' '; 't'; 'o'; ' '; 'd'; 'e'; 'p'; 'e';
                                'n'; 'd'; 'e'; 'n'; 'c'; 'y'; ' '; 'p'; 'a';
                                'i'; 'r'; 's'])
                        (comp shows_nl (indent x)))))))
    | i, r, m, RuleRemoval (rp, rR, prf) ->
        debug (i [])
          ['r'; 'u'; 'l'; 'e'; ' '; 'r'; 'e'; 'm'; 'o'; 'v'; 'a'; 'l']
          (bind (catch
                  (check_rule_removal_proc (eq_laba _A1 _B1, show_lab _A2 _B2)
                    (eq_lista eq_char, show_list show_char)
                    (get_redpair (eq_laba _A1 _B1, show_lab _A2 _B2)
                      (eq_lista eq_char, show_list show_char) rp)
                    r rR)
                  (fun x ->
                    Inl (comp i
                          (comp (shows_string
                                  [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'i';
                                    'n'; ' '; 'r'; 'u'; 'l'; 'e'; ' '; 'r'; 'e';
                                    'm'; 'o'; 'v'; 'a'; 'l'; ' '; 'w'; 'h'; 'e';
                                    'n'; ' '; 's'; 'w'; 'i'; 't'; 'c'; 'h'; 'i';
                                    'n'; 'g'; ' '; 'f'; 'r'; 'o'; 'm'; ' '; 't';
                                    'h'; 'e'; ' '; 'T'; 'R'; 'S'])
                            (comp shows_nl
                              (comp (shows_trs (show_lab _A2 _B2)
                                      (show_list show_char) r)
                                (comp shows_nl
                                  (comp (shows_string
  ['t'; 'o'; ' '; 't'; 'h'; 'e'; ' '; 'T'; 'R'; 'S'])
                                    (comp shows_nl
                                      (comp
(shows_trs (show_lab _A2 _B2) (show_list show_char) rR)
(comp shows_nl x)))))))))))
            (fun _ ->
              catch (checkTRSProof (_A1, _A2) (_B1, _B2)
                      (comp i (shows_string ['.'; '1'])) rR m prf)
                (fun x ->
                  Inl (comp i
                        (comp (shows_string
                                [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'b';
                                  'e'; 'l'; 'o'; 'w'; ' '; 't'; 'h'; 'e'; ' ';
                                  'r'; 'u'; 'l'; 'e'; ' '; 'r'; 'e'; 'm'; 'o';
                                  'v'; 'a'; 'l'; ' '; 'p'; 'r'; 'o'; 'c'; 'e';
                                  's'; 's'; 'o'; 'r'])
                          (comp shows_nl (indent x)))))))
    | i, r, Suc m, Unlab (uR, prf) ->
        debug (i []) ['u'; 'n'; 'l'; 'a'; 'b'; 'e'; 'l']
          (bind (catch
                  (unlab_trs_tt (_A1, _A2) (_B1, _B2)
                    (eq_lista eq_char, show_list show_char) r uR)
                  (fun x ->
                    Inl (comp i
                          (comp (shows_string
                                  [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'i';
                                    'n'; ' '; 'u'; 'n'; 'l'; 'a'; 'b'; 'e'; 'l';
                                    'i'; 'n'; 'g'; ' '; 'o'; 'f'; ' '; 'T'; 'R';
                                    'S'; ' '; 'w'; 'h'; 'e'; 'n'; ' '; 's'; 'w';
                                    'i'; 't'; 'c'; 'h'; 'i'; 'n'; 'g'; ' '; 'f';
                                    'r'; 'o'; 'm'; ' '; 't'; 'h'; 'e'; ' '; 'T';
                                    'R'; 'S'])
                            (comp shows_nl
                              (comp (shows_trs (show_lab _A2 _B2)
                                      (show_list show_char) r)
                                (comp shows_nl
                                  (comp (shows_string
  ['t'; 'o'; ' '; 't'; 'h'; 'e'; ' '; 'T'; 'R'; 'S'])
                                    (comp shows_nl
                                      (comp
(shows_trs (show_lab _A2 _B2) (show_list show_char) uR)
(comp shows_nl x)))))))))))
            (fun _ ->
              catch (checkTRSProof (_A1, _A2) (_B1, _B2)
                      (comp i (shows_string ['.'; '1'])) uR m prf)
                (fun x ->
                  Inl (comp i
                        (comp (shows_string
                                [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'b';
                                  'e'; 'l'; 'o'; 'w'; ' '; 't'; 'h'; 'e'; ' ';
                                  'u'; 'n'; 'l'; 'a'; 'b'; 'e'; 'l'; 'i'; 'n';
                                  'g'])
                          (comp shows_nl (indent x)))))))
    | i, r, Zero_nat, Unlab (uR, prf) ->
        debug (i []) ['u'; 'n'; 'l'; 'a'; 'b'; 'e'; 'l']
          (bind (catch
                  (check_subseteq
                    (eqc (eq_terma (eq_laba _A1 _B1) (eq_lista eq_char))
                      (eq_terma (eq_laba _A1 _B1) (eq_lista eq_char)))
                    (map_trsI unlab r) uR)
                  (fun x ->
                    Inl (comp i
                          (comp (shows_string
                                  [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'i';
                                    'n'; ' '; 'u'; 'n'; 'l'; 'a'; 'b'; 'e'; 'l';
                                    'i'; 'n'; 'g'; ' '; 'o'; 'f'; ' '; 'T'; 'R';
                                    'S'; ' '; 'w'; 'h'; 'e'; 'n'; ' '; 's'; 'w';
                                    'i'; 't'; 'c'; 'h'; 'i'; 'n'; 'g'; ' '; 'f';
                                    'r'; 'o'; 'm'; ' '; 't'; 'h'; 'e'; ' '; 'T';
                                    'R'; 'S'])
                            (comp shows_nl
                              (comp (shows_trs (show_lab _A2 _B2)
                                      (show_list show_char) r)
                                (comp shows_nl
                                  (comp (shows_string
  ['t'; 'o'; ' '; 't'; 'h'; 'e'; ' '; 'T'; 'R'; 'S'])
                                    (comp shows_nl
                                      (comp
(shows_trs (show_lab _A2 _B2) (show_list show_char) uR)
(comp shows_nl
  (comp (shows_string
          ['u'; 'n'; 'l'; 'a'; 'b'; 'e'; 'l'; 'e'; 'd'; ' '; 'r'; 'u'; 'l'; 'e';
            ' '])
    (comp (shows_rule (show_lab _A2 _B2) (show_list show_char) x)
      (shows_string
        [' '; 'i'; 's'; ' '; 'n'; 'o'; 't'; ' '; 'p'; 'r'; 'e'; 's'; 'e'; 'n';
          't']))))))))))))))
            (fun _ ->
              catch (checkTRSProof (_A1, _A2) (_B1, _B2)
                      (comp i (shows_string ['.'; '1'])) uR Zero_nat prf)
                (fun x ->
                  Inl (comp i
                        (comp (shows_string
                                [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'b';
                                  'e'; 'l'; 'o'; 'w'; ' '; 't'; 'h'; 'e'; ' ';
                                  'u'; 'n'; 'l'; 'a'; 'b'; 'e'; 'l'; 'i'; 'n';
                                  'g'])
                          (comp shows_nl (indent x)))))))
    | i, r, m, RisEmpty ->
        debug (i []) ['R'; ' '; 'i'; 's'; ' '; 'e'; 'm'; 'p'; 't'; 'y']
          (check (null r)
            (comp i
              (comp (shows_string
                      [':'; ' '; 'R'; ' '; 'i'; 's'; ' '; 'n'; 'o'; 't'; ' ';
                        'e'; 'm'; 'p'; 't'; 'y'; ','; ' '; 'b'; 'u'; 't'; ' ';
                        'i'; 't'; ' '; 'i'; 's'; ' '; 't'; 'h'; 'e'; ' '; 'T';
                        'R'; 'S'])
                (comp (shows_trs (show_lab _A2 _B2) (show_list show_char) r)
                  shows_nl))))
    | i, r, m, Semlab (sli, l, lR, prf) ->
        debug (i []) ['S'; 'e'; 'm'; 'l'; 'a'; 'b']
          (bind (catch
                  (create_sem_lab_tt (_A1, _A2) (_B1, _B2)
                    (eq_lista eq_char, show_list show_char) sli l r lR)
                  (fun x ->
                    Inl (comp i
                          (comp (shows_string
                                  [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'w';
                                    'h'; 'e'; 'n'; ' '; 'a'; 'p'; 'p'; 'l'; 'y';
                                    'i'; 'n'; 'g'; ' '; 's'; 'e'; 'm'; 'a'; 'n';
                                    't'; 'i'; 'c'; ' '; 'l'; 'a'; 'b'; 'e'; 'l';
                                    'i'; 'n'; 'g'])
                            (comp shows_nl x)))))
            (fun _ ->
              catch (checkTRSProof (_A1, _A2) (_B1, _B2)
                      (comp i (shows_string ['.'; '1'])) lR (Suc m) prf)
                (fun x ->
                  Inl (comp i
                        (comp (shows_string
                                [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'b';
                                  'e'; 'l'; 'o'; 'w'; ' '; 's'; 'e'; 'm'; 'a';
                                  'n'; 't'; 'i'; 'c'; ' '; 'l'; 'a'; 'b'; 'e';
                                  'l'; 'i'; 'n'; 'g'])
                          (comp shows_nl (indent x)))))))
    | i, r, m, Rootlab (lR, prf) ->
        debug (i []) ['R'; 'o'; 'o'; 't'; 'l'; 'a'; 'b']
          (bind (catch (rl_tt (_A1, _A2) (_B1, _B2) r lR)
                  (fun x ->
                    Inl (comp i
                          (comp (shows_string
                                  [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'w';
                                    'h'; 'e'; 'n'; ' '; 'a'; 'p'; 'p'; 'l'; 'y';
                                    'i'; 'n'; 'g'; ' '; 'r'; 'o'; 'o'; 't'; '-';
                                    'l'; 'a'; 'b'; 'e'; 'l'; 'i'; 'n'; 'g'])
                            (comp shows_nl x)))))
            (fun _ ->
              catch (checkTRSProof (_A1, _A2) (_B1, _B2)
                      (comp i (shows_string ['.'; '1'])) lR (Suc m) prf)
                (fun x ->
                  Inl (comp i
                        (comp (shows_string
                                [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'b';
                                  'e'; 'l'; 'o'; 'w'; ' '; 'r'; 'o'; 'o'; 't';
                                  '-'; 'l'; 'a'; 'b'; 'e'; 'l'; 'i'; 'n'; 'g'])
                          (comp shows_nl (indent x)))))))
    | i, r, m, Fcc (fcs, rR, prf) ->
        debug (i []) ['F'; 'c'; 'c']
          (bind (catch (fcc_tt (eq_laba _A1 _B1, show_lab _A2 _B2) r fcs rR)
                  (fun x ->
                    Inl (comp i
                          (comp (shows_string
                                  [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'w';
                                    'h'; 'e'; 'n'; ' '; 'a'; 'p'; 'p'; 'l'; 'y';
                                    'i'; 'n'; 'g'; ' '; 'f'; 'l'; 'a'; 't'; ' ';
                                    'c'; 'o'; 'n'; 't'; 'e'; 'x'; 't'; ' '; 'c';
                                    'l'; 'o'; 's'; 'u'; 'r'; 'e'])
                            (comp shows_nl x)))))
            (fun _ ->
              catch (checkTRSProof (_A1, _A2) (_B1, _B2)
                      (comp i (shows_string ['.'; '1'])) rR m prf)
                (fun x ->
                  Inl (comp i
                        (comp (shows_string
                                [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'b';
                                  'e'; 'l'; 'o'; 'w'; ' '; 'f'; 'l'; 'a'; 't';
                                  ' '; 'c'; 'o'; 'n'; 't'; 'e'; 'x'; 't'; ' ';
                                  'c'; 'l'; 'o'; 's'; 'u'; 'r'; 'e'])
                          (comp shows_nl (indent x)))))))
    | i, r, m, StringReversal (rR, prf) ->
        debug (i [])
          ['S'; 't'; 'r'; 'i'; 'n'; 'g'; ' '; 'R'; 'e'; 'v'; 'e'; 'r'; 's'; 'a';
            'l']
          (bind (catch
                  (check_string_rev (eq_laba _A1 _B1, show_lab _A2 _B2)
                    (eq_lista eq_char, show_list show_char) r rR)
                  (fun x ->
                    Inl (comp i
                          (comp (shows_string
                                  [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'w';
                                    'h'; 'e'; 'n'; ' '; 'a'; 'p'; 'p'; 'l'; 'y';
                                    'i'; 'n'; 'g'; ' '; 's'; 't'; 'r'; 'i'; 'n';
                                    'g'; ' '; 'r'; 'e'; 'v'; 'e'; 'r'; 's'; 'a';
                                    'l'])
                            (comp shows_nl x)))))
            (fun _ ->
              catch (checkTRSProof (_A1, _A2) (_B1, _B2)
                      (comp i (shows_string ['.'; '1'])) rR m prf)
                (fun x ->
                  Inl (comp i
                        (comp (shows_string
                                [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'b';
                                  'e'; 'l'; 'o'; 'w'; ' '; 's'; 't'; 'r'; 'i';
                                  'n'; 'g'; ' '; 'r'; 'e'; 'v'; 'e'; 'r'; 's';
                                  'a'; 'l'])
                          (comp shows_nl (indent x)))))));;

let rec checkRelTRSProof (_A1, _A2) (_B1, _B2)
  i r s x3 = match i, r, s, x3 with
    i, r, s, RelRisEmpty ->
      debug (i []) ['R'; ' '; 'i'; 's'; ' '; 'e'; 'm'; 'p'; 't'; 'y']
        (check (null r)
          (comp i
            (comp (shows_string
                    [':'; ' '; 'R'; ' '; 'i'; 's'; ' '; 'n'; 'o'; 't'; ' '; 'e';
                      'm'; 'p'; 't'; 'y'; ','; ' '; 'b'; 'u'; 't'; ' '; 'i';
                      't'; ' '; 'i'; 's'; ' '; 't'; 'h'; 'e'; ' '; 'T'; 'R';
                      'S'])
              (comp (shows_trs (show_lab _A2 _B2) (show_list show_char) r)
                shows_nl))))
    | i, r, s, RelSisEmpty prf ->
        debug (i []) ['S'; ' '; 'i'; 's'; ' '; 'e'; 'm'; 'p'; 't'; 'y']
          (bind (check (null s)
                  (comp i
                    (comp (shows_string
                            [':'; ' '; 'S'; ' '; 'i'; 's'; ' '; 'n'; 'o'; 't';
                              ' '; 'e'; 'm'; 'p'; 't'; 'y'; ','; ' '; 'b'; 'u';
                              't'; ' '; 'i'; 't'; ' '; 'i'; 's'; ' '; 't'; 'h';
                              'e'; ' '; 'T'; 'R'; 'S'])
                      (comp (shows_trs (show_lab _A2 _B2) (show_list show_char)
                              s)
                        shows_nl))))
            (fun _ ->
              catch (checkTRSProof (_A1, _A2) (_B1, _B2)
                      (comp i (shows_string ['.'; '1'])) r Zero_nat prf)
                (fun x ->
                  Inl (comp i
                        (comp (shows_string
                                [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'b';
                                  'e'; 'l'; 'o'; 'w'; ' '; 't'; 'h'; 'e'; ' ';
                                  'r'; 'u'; 'l'; 'e'; ' '; 'r'; 'e'; 'm'; 'o';
                                  'v'; 'a'; 'l'; ' '; 'p'; 'r'; 'o'; 'c'; 'e';
                                  's'; 's'; 'o'; 'r'])
                          (comp shows_nl (indent x)))))))
    | i, r, s, RelRuleRemoval (rp, rR, rS, prf) ->
        debug (i [])
          ['r'; 'u'; 'l'; 'e'; ' '; 'r'; 'e'; 'm'; 'o'; 'v'; 'a'; 'l']
          (bind (catch
                  (check_relative_rule_removal
                    (eq_laba _A1 _B1, show_lab _A2 _B2)
                    (eq_lista eq_char, show_list show_char)
                    (get_redpair (eq_laba _A1 _B1, show_lab _A2 _B2)
                      (eq_lista eq_char, show_list show_char) rp)
                    (r, s) (rR, rS))
                  (fun x ->
                    Inl (comp i
                          (comp (shows_string
                                  [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'i';
                                    'n'; ' '; 'r'; 'u'; 'l'; 'e'; ' '; 'r'; 'e';
                                    'm'; 'o'; 'v'; 'a'; 'l'; ' '; 'w'; 'h'; 'e';
                                    'n'; ' '; 's'; 'w'; 'i'; 't'; 'c'; 'h'; 'i';
                                    'n'; 'g'; ' '; 'f'; 'r'; 'o'; 'm'; ' '; 't';
                                    'h'; 'e'; ' '; 'T'; 'R'; 'S'; 's'])
                            (comp shows_nl
                              (comp (shows_trs (show_lab _A2 _B2)
                                      (show_list show_char) r)
                                (comp shows_nl
                                  (comp (shows_string [' '; 'a'; 'n'; 'd'; ' '])
                                    (comp shows_nl
                                      (comp
(shows_trs (show_lab _A2 _B2) (show_list show_char) s)
(comp shows_nl
  (comp (shows_string ['t'; 'o'; ' '; 't'; 'h'; 'e'; ' '; 'T'; 'R'; 'S'; 's'])
    (comp shows_nl
      (comp (shows_trs (show_lab _A2 _B2) (show_list show_char) rR)
        (comp shows_nl
          (comp (shows_string [' '; 'a'; 'n'; 'd'; ' '])
            (comp shows_nl
              (comp (shows_trs (show_lab _A2 _B2) (show_list show_char) rS)
                x))))))))))))))))))
            (fun _ ->
              catch (checkRelTRSProof (_A1, _A2) (_B1, _B2)
                      (comp i (shows_string ['.'; '1'])) rR rS prf)
                (fun x ->
                  Inl (comp i
                        (comp (shows_string
                                [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'b';
                                  'e'; 'l'; 'o'; 'w'; ' '; 't'; 'h'; 'e'; ' ';
                                  'r'; 'u'; 'l'; 'e'; ' '; 'r'; 'e'; 'm'; 'o';
                                  'v'; 'a'; 'l'; ' '; 'p'; 'r'; 'o'; 'c'; 'e';
                                  's'; 's'; 'o'; 'r'])
                          (comp shows_nl (indent x)))))))
    | i, r, s, RelUnlab (uR, uS, prf) ->
        debug (i []) ['u'; 'n'; 'l'; 'a'; 'b'; 'e'; 'l']
          (bind (catch
                  (unlab_reltrs_tt (_A1, _A2) (_B1, _B2)
                    (eq_lista eq_char, show_list show_char) (r, s) (uR, uS))
                  (fun x ->
                    Inl (comp i
                          (comp (shows_string
                                  [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'i';
                                    'n'; ' '; 'u'; 'n'; 'l'; 'a'; 'b'; 'e'; 'l';
                                    'i'; 'n'; 'g'; ' '; 'o'; 'f'; ' '; 'T'; 'R';
                                    'S'; ' '; 'w'; 'h'; 'e'; 'n'; ' '; 's'; 'w';
                                    'i'; 't'; 'c'; 'h'; 'i'; 'n'; 'g'; ' '; 'f';
                                    'r'; 'o'; 'm'; ' '; 't'; 'h'; 'e'; ' '; 'T';
                                    'R'; 'S'; ' '; 'R'])
                            (comp shows_nl
                              (comp (shows_trs (show_lab _A2 _B2)
                                      (show_list show_char) r)
                                (comp shows_nl
                                  (comp (shows_string ['a'; 'n'; 'd'; ' '; 'S'])
                                    (comp shows_nl
                                      (comp
(shows_trs (show_lab _A2 _B2) (show_list show_char) s)
(comp (shows_string
        ['t'; 'o'; ' '; 't'; 'h'; 'e'; ' '; 'T'; 'R'; 'S'; 's'; ' '])
  (comp shows_nl
    (comp (shows_trs (show_lab _A2 _B2) (show_list show_char) uR)
      (comp shows_nl
        (comp (shows_trs (show_lab _A2 _B2) (show_list show_char) uS)
          x)))))))))))))))
            (fun _ ->
              catch (checkRelTRSProof (_A1, _A2) (_B1, _B2)
                      (comp i (shows_string ['.'; '1'])) uR uS prf)
                (fun x ->
                  Inl (comp i
                        (comp (shows_string
                                [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'b';
                                  'e'; 'l'; 'o'; 'w'; ' '; 't'; 'h'; 'e'; ' ';
                                  'u'; 'n'; 'l'; 'a'; 'b'; 'e'; 'l'; 'i'; 'n';
                                  'g'])
                          (comp shows_nl (indent x)))))))
    | i, r, s, RelSemlab (sli, l, lR, lS, prf) ->
        debug (i []) ['S'; 'e'; 'm'; 'l'; 'a'; 'b']
          (bind (catch
                  (create_sem_lab_rel_tt (_A1, _A2) (_B1, _B2)
                    (eq_lista eq_char, show_list show_char) sli l (r, s)
                    (lR, lS))
                  (fun x ->
                    Inl (comp i
                          (comp (shows_string
                                  [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'w';
                                    'h'; 'e'; 'n'; ' '; 'a'; 'p'; 'p'; 'l'; 'y';
                                    'i'; 'n'; 'g'; ' '; 's'; 'e'; 'm'; 'a'; 'n';
                                    't'; 'i'; 'c'; ' '; 'l'; 'a'; 'b'; 'e'; 'l';
                                    'i'; 'n'; 'g'])
                            (comp shows_nl x)))))
            (fun _ ->
              catch (checkRelTRSProof (_A1, _A2) (_B1, _B2)
                      (comp i (shows_string ['.'; '1'])) lR lS prf)
                (fun x ->
                  Inl (comp i
                        (comp (shows_string
                                [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'b';
                                  'e'; 'l'; 'o'; 'w'; ' '; 's'; 'e'; 'm'; 'a';
                                  'n'; 't'; 'i'; 'c'; ' '; 'l'; 'a'; 'b'; 'e';
                                  'l'; 'i'; 'n'; 'g'])
                          (comp shows_nl (indent x)))))))
    | i, r, s, RelRootlab (lR, lS, prf) ->
        debug (i []) ['R'; 'o'; 'o'; 't'; 'l'; 'a'; 'b']
          (bind (catch (rl_rel_tt (_A1, _A2) (_B1, _B2) (r, s) (lR, lS))
                  (fun x ->
                    Inl (comp i
                          (comp (shows_string
                                  [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'w';
                                    'h'; 'e'; 'n'; ' '; 'a'; 'p'; 'p'; 'l'; 'y';
                                    'i'; 'n'; 'g'; ' '; 'r'; 'o'; 'o'; 't'; '-';
                                    'l'; 'a'; 'b'; 'e'; 'l'; 'i'; 'n'; 'g'])
                            (comp shows_nl x)))))
            (fun _ ->
              catch (checkRelTRSProof (_A1, _A2) (_B1, _B2)
                      (comp i (shows_string ['.'; '1'])) lR lS prf)
                (fun x ->
                  Inl (comp i
                        (comp (shows_string
                                [':'; ' '; 'e'; 'r'; 'r'; 'o'; 'r'; ' '; 'b';
                                  'e'; 'l'; 'o'; 'w'; ' '; 's'; 'e'; 'm'; 'a';
                                  'n'; 't'; 'i'; 'c'; ' '; 'l'; 'a'; 'b'; 'e';
                                  'l'; 'i'; 'n'; 'g'])
                          (comp shows_nl (indent x)))))));;

let rec certifyCertProblem (_A1, _A2) (_B1, _B2)
  = function
    TRSProof (trs, prf) ->
      (match
        checkTRSProof (_A1, _A2) (_B1, _B2) (shows_string ['1'])
          (map (map_rule init_lab) trs) Zero_nat prf
        with Inl err ->
          Error (comp (shows_string
                        ['t'; 'e'; 'r'; 'm'; 'i'; 'n'; 'a'; 't'; 'i'; 'o'; 'n';
                          ' '; 'p'; 'r'; 'o'; 'o'; 'f'; ' '; 'n'; 'o'; 't'; ' ';
                          'a'; 'c'; 'c'; 'e'; 'p'; 't'; 'e'; 'd'])
                  (comp shows_nl err) [])
        | Inr _ ->
          Certified
            ['<'; 't'; 'r'; 's'; 'T'; 'e'; 'r'; 'm'; 'i'; 'n'; 'a'; 't'; 'i';
              'o'; 'n'; 'P'; 'r'; 'o'; 'o'; 'f'; '>'])
    | TRSDisproof (trs, prf) ->
        (match
          checkTRSDisproof (_A1, _A2) (eq_lista eq_char, show_list show_char)
            (shows_string ['1']) trs prf
          with Inl err ->
            Error (comp (shows_string
                          ['n'; 'o'; 'n'; '-'; 't'; 'e'; 'r'; 'm'; 'i'; 'n';
                            'a'; 't'; 'i'; 'o'; 'n'; ' '; 'p'; 'r'; 'o'; 'o';
                            'f'; ' '; 'n'; 'o'; 't'; ' '; 'a'; 'c'; 'c'; 'e';
                            'p'; 't'; 'e'; 'd'])
                    (comp shows_nl err) [])
          | Inr _ ->
            Certified
              ['<'; 't'; 'r'; 's'; 'N'; 'o'; 'n'; 't'; 'e'; 'r'; 'm'; 'i'; 'n';
                'a'; 't'; 'i'; 'o'; 'n'; 'P'; 'r'; 'o'; 'o'; 'f'; '>'])
    | RelTRSProof ((r, s), prf) ->
        (match
          checkRelTRSProof (_A1, _A2) (_B1, _B2) (shows_string ['1'])
            (map (map_rule init_lab) r) (map (map_rule init_lab) s) prf
          with Inl err ->
            Error (comp (shows_string
                          ['r'; 'e'; 'l'; 'a'; 't'; 'i'; 'v'; 'e'; ' '; 't';
                            'e'; 'r'; 'm'; 'i'; 'n'; 'a'; 't'; 'i'; 'o'; 'n';
                            ' '; 'p'; 'r'; 'o'; 'o'; 'f'; ' '; 'n'; 'o'; 't';
                            ' '; 'a'; 'c'; 'c'; 'e'; 'p'; 't'; 'e'; 'd'])
                    (comp shows_nl err) [])
          | Inr _ ->
            Certified
              ['<'; 'r'; 'e'; 'l'; 'a'; 't'; 'i'; 'v'; 'e'; 'T'; 'e'; 'r'; 'm';
                'i'; 'n'; 'a'; 't'; 'i'; 'o'; 'n'; 'P'; 'r'; 'o'; 'o'; 'f';
                '>'])
    | RelTRSDisproof ((r, s), prf) ->
        (match
          checkRelTRSDisproof (_A1, _A2) (eq_lista eq_char, show_list show_char)
            (shows_string ['1']) (r, s) prf
          with Inl err ->
            Error (comp (shows_string
                          ['r'; 'e'; 'l'; 'a'; 't'; 'i'; 'v'; 'e'; ' '; 'n';
                            'o'; 'n'; '-'; 't'; 'e'; 'r'; 'm'; 'i'; 'n'; 'a';
                            't'; 'i'; 'o'; 'n'; ' '; 'p'; 'r'; 'o'; 'o'; 'f';
                            ' '; 'n'; 'o'; 't'; ' '; 'a'; 'c'; 'c'; 'e'; 'p';
                            't'; 'e'; 'd'])
                    (comp shows_nl err) [])
          | Inr _ ->
            Certified
              ['<'; 'r'; 'e'; 'l'; 'a'; 't'; 'i'; 'v'; 'e'; 'N'; 'o'; 'n'; 't';
                'e'; 'r'; 'm'; 'i'; 'n'; 'a'; 't'; 'i'; 'o'; 'n'; 'P'; 'r'; 'o';
                'o'; 'f'; '>']);;

let rec certificationResult_case
  f1 f2 x2 = match f1, f2, x2 with f1, f2, Error lista -> f2 lista
    | f1, f2, Certified lista -> f1 lista;;

let rec xml_certificationProblem _A _C
  = function
    TRSProof (trs, uu) ->
      Xml (['t'; 'r'; 's'; 'I'; 'n'; 'p'; 'u'; 't'], [],
            [xml_rules _A _C ['t'; 'r'; 's'] trs], None)
    | TRSDisproof (trs, uv) ->
        Xml (['t'; 'r'; 's'; 'I'; 'n'; 'p'; 'u'; 't'], [],
              [xml_rules _A _C ['t'; 'r'; 's'] trs], None)
    | RelTRSProof ((r, s), uw) ->
        Xml (['t'; 'r'; 's'; 'I'; 'n'; 'p'; 'u'; 't'], [],
              [xml_rules _A _C ['t'; 'r'; 's'] r;
                xml_rules _A _C
                  ['r'; 'e'; 'l'; 'a'; 't'; 'i'; 'v'; 'e'; 'R'; 'u'; 'l'; 'e';
                    's']
                  s],
              None)
    | RelTRSDisproof ((r, s), ux) ->
        Xml (['t'; 'r'; 's'; 'I'; 'n'; 'p'; 'u'; 't'], [],
              [xml_rules _A _C ['t'; 'r'; 's'] r;
                xml_rules _A _C
                  ['r'; 'e'; 'l'; 'a'; 't'; 'i'; 'v'; 'e'; 'R'; 'u'; 'l'; 'e';
                    's']
                  s],
              None);;

let rec eqWhiteSpace
  s1 s2 =
    debug ['0']
      ['c'; 'o'; 'm'; 'p'; 'a'; 'r'; 'i'; 'n'; 'g'; ' '; 'w'; 'h'; 'e'; 't';
        'h'; 'e'; 'r'; ' '; 'p'; 'a'; 'r'; 's'; 'e'; 'd'; ' '; 'i'; 'n'; 'p';
        'u'; 't'; ' '; 'c'; 'o'; 'r'; 'r'; 'e'; 's'; 'p'; 'o'; 'n'; 'd'; 's';
        ' '; 't'; 'o'; ' '; 'r'; 'e'; 'a'; 'l'; ' '; 'i'; 'n'; 'p'; 'u'; 't']
      (eq_list eq_char (filter (fun c -> not (member eq_char wspace c)) s1)
        (filter (fun c -> not (member eq_char wspace c)) s2));;

let rec certifyProof
  problemString =
    (match parseCertProblem problemString
      with Inl err ->
        Error (append
                ['e'; 'r'; 'r'; 'o'; 'r'; ' '; 'w'; 'h'; 'i'; 'l'; 'e'; ' ';
                  'p'; 'a'; 'r'; 's'; 'i'; 'n'; 'g']
                (append [newline] err))
      | Inr cp ->
        (match extract_input_proof problemString
          with None ->
            Error ['c'; 'o'; 'u'; 'l'; 'd'; ' '; 'n'; 'o'; 't'; ' '; 'f'; 'i';
                    'n'; 'd'; ' '; 'i'; 'n'; 'p'; 'u'; 't'; ' '; 'a'; 'n'; 'd';
                    ' '; 'p'; 'r'; 'o'; 'o'; 'f'; ' '; 'i'; 'n'; ' '; 's'; 't';
                    'r'; 'i'; 'n'; 'g'; ' '; 'f'; 'o'; 'r'; ' '; 'c'; 'o'; 'm';
                    'p'; 'a'; 'r'; 'i'; 's'; 'o'; 'n'; ' '; 'w'; 'i'; 't'; 'h';
                    ' '; 'p'; 'a'; 'r'; 's'; 'e'; 'd'; ' '; 'r'; 'e'; 's'; 'u';
                    'l'; 't']
          | Some (the_input, (_, the_proof)) ->
            (if eqWhiteSpace the_input
                  (shows_prec_xml Zero_nat
                    (xml_certificationProblem (show_list show_char)
                      (show_list show_char) cp)
                    [])
              then (match
                     certifyCertProblem (eq_lista eq_char, show_list show_char)
                       (eq_lista eq_nata, show_list show_nat) cp
                     with Certified tag ->
                       (if starts_with the_proof tag then Certified tag
                         else Error (append
                                      ['p'; 'r'; 'o'; 'v'; 'e'; 'n'; ' '; 'p';
'r'; 'o'; 'p'; 'e'; 'r'; 't'; 'y'; ' ']
                                      (append tag
(append
  [' '; 'd'; 'o'; 'e'; 's'; ' '; 'n'; 'o'; 't'; ' '; 'c'; 'o'; 'r'; 'r'; 'e';
    's'; 'p'; 'o'; 'n'; 'd'; ' '; 't'; 'o'; ' '; 'p'; 'r'; 'o'; 'o'; 'f'; ' ';
    'i'; 'n'; ' '; 'i'; 'n'; 'p'; 'u'; 't'; ' '; 's'; 't'; 'r'; 'i'; 'n'; 'g';
    ':'; ' ']
  (take (nat (Big_int.big_int_of_int 20)) the_proof)))))
                     | Error a -> Error a)
              else Error (concat
                           [['p'; 'a'; 'r'; 's'; 'e'; 'd'; ' '; 'p'; 'r'; 'o';
                              'b'; 'l'; 'e'; 'm'; ' '; 'd'; 'o'; 'e'; 's'; ' ';
                              'n'; 'o'; 't'; ' '; 'c'; 'o'; 'r'; 'r'; 'e'; 's';
                              'p'; 'o'; 'n'; 'd'; ' '; 't'; 'o'; ' '; 'i'; 'n';
                              'p'; 'u'; 't'];
                             [newline]; ['i'; 'n'; 'p'; 'u'; 't'; ':'];
                             [newline];
                             filter (fun c -> not (member eq_char wspace c))
                               the_input;
                             [newline]; [newline];
                             ['p'; 'a'; 'r'; 's'; 'e'; 'd'; ':']; [newline];
                             filter (fun c -> not (member eq_char wspace c))
                               (shows_prec_xml Zero_nat
                                 (xml_certificationProblem (show_list show_char)
                                   (show_list show_char) cp)
                                 []);
                             [newline]]))));;

end;; (*struct Ceta*)
